Boss = class("Boss",Monster)



function Boss:ctor()

    self._scale=1
end


function Boss.create(x,y,m_id,m_gameScene,type)
    local obj = Boss.new()
    
    copyTable(ActorModifiValues,obj)
    copyTable(ActorCommonValues,obj)
    obj._gamescene = m_gameScene
    obj.role_id = m_id
    obj._actor_type=type
    obj.hit_id_list = {}
    obj.extra_sound_effect = {}
    
    
    if m_id ~= nil then

        --obj.role_id =1 --test
        local isNPC = obj._actor_type > 1

        local attribute=GameDataTransfer.GetRoleAttributes(obj.role_id,isNPC)


        copyTable(GameDataTransfer.GetNPC(obj.role_id),obj)

        if obj.reward_money then
            local tempSoundData = string.split(obj.reward_money,",")

            for i=1,#tempSoundData do
                local soundData = tonumber(tempSoundData[i])
                table.insert(obj.extra_sound_effect,soundData)
                
                if soundData >0 then
                    GameSound.initGamesoundWithMapId(soundData) --预加载音效
                end
            end

        end
        
    
        obj._hp = attribute[res_attribute.BLOOD]
        obj._hp_max = attribute[res_attribute.BLOOD]


        local temp_hp = obj._hp

        cclog("m_id= %d obj._hp=%d",m_id,temp_hp)

        obj.Attack = attribute[res_attribute.POWER]
        obj.Defence = attribute[res_attribute.DEFENCE]
        obj._shieldMax = attribute[res_attribute.ARMOR] or 0
        obj.break_ = attribute[res_attribute.BREAK]
        obj.cri_rate = attribute[res_attribute.CRIT_RATE]
        obj.cri_resis = attribute[res_attribute.CRIT_RESIST]
        obj.cri_damage = attribute[res_attribute.CRIT_DAMAGE]
        obj.cri_reduce = attribute[res_attribute.CRIT_REDUCE]


        obj.now_elementAtt[1]=attribute[res_attribute.DAMAGE_ICE] or 0
        obj.now_elementAtt[2]=attribute[res_attribute.DAMAGE_FIRE] or 0
        obj.now_elementAtt[3]=attribute[res_attribute.DAMAGE_ELECTRICITY] or 0
        obj.now_elementAtt[4]=attribute[res_attribute.DAMAGE_WIND] or 0
        obj.now_elementAtt[5]=attribute[res_attribute.DAMAGE_SOIL] or 0
        obj.now_elementAtt[6]=attribute[res_attribute.DAMAGE_STAR] or 0

        obj.now_elementDef[1]=attribute[res_attribute.RESIST_ICE] or 0
        obj.now_elementDef[2]=attribute[res_attribute.RESIST_FIRE] or 0
        obj.now_elementDef[3]=attribute[res_attribute.RESIST_ELECTRICITY] or 0
        obj.now_elementDef[4]=attribute[res_attribute.RESIST_WIND] or 0
        obj.now_elementDef[5]=attribute[res_attribute.RESIST_SOIL] or 0
        obj.now_elementDef[6]=attribute[res_attribute.RESIST_STAR] or 0


        obj._shield = obj._shieldMax
        
        local skill_temp = string.split(obj.npc_skill,",")
        
        
        
        --skill_temp = string.split(obj.Skills,",")

        obj.skill_list = List.new()
        obj.skill_cd = List.new()

        for i=1,#skill_temp do
            List.pushlast(obj.skill_list,Skill.new(tonumber(skill_temp[i]),1))
            List.pushlast(obj.skill_cd,0) --nowSkill.cd
        end
        --table.print(obj.skill_list)
    end

    --obj.model_id = 42
    obj:initSpine(obj.model_id,obj.scale)

    local function update(dt)
        obj:baseUpdate(dt)
    end
    obj._spine:scheduleUpdateWithPriorityLua(update, 0) 
    
    obj:UpDateResist(obj.Status_Control)

    obj.x=x obj.y=y
    
    --obj:setPosition(cc.p(x,y))
    
    obj._fallTime = obj.Lay_Time/1000
    
    obj._attack_range = 230

    
    
    obj.allground = m_gameScene.all_boundingBoxs
    
    local AIAction = {}
    local dd =AI.typeList[1]
    table.insert(AIAction,AI.typeList[AI.funtionName.randomRun])
    table.insert(AIAction,AI.typeList[AI.funtionName.sws_hitWhenStun])
    table.insert(AIAction,AI.typeList[AI.funtionName.sws_Attack])
    
    obj.AIAction = AIAction
    
    obj.AIActionValue = {}
    table.insert(obj.AIActionValue,1000)
    table.insert(obj.AIActionValue,3)
    table.insert(obj.AIActionValue,3)
    GameManager.updateEnemyName(obj.actor_name,obj)
    obj._is_boss = true
    return obj
end

local mathabs = math.abs

function Boss:UpDateAI(dt,obj)

    local distance=self.x-obj.x
    
   
    local absolute_distance 
    local actionDone = self.AIActionDone
    
    
    if self.AITime > 0 then
        if actionDone == false then  --当行为没有结束的时候
            absolute_distance = mathabs(self.x-obj.x)--获取之间距离
            local isDone = self.AIFunction(self,obj,absolute_distance,self.AIValue)  --一直更新行为
            if isDone == false then
                self.AIActionDone = true
            end
        else  --当行为结束
            self.AITime = self.AITime - dt  --开始计算等待时间

        end
    else
        absolute_distance = mathabs(self.x-obj.x)--获取之间距离
        local pass,tempfun,tempValue
        local count = #self.AIAction
        for i=1,count do  --按顺序判断AI模块
            pass,tempfun,tempValue = self.AIAction[i](self,obj,absolute_distance,self.AIActionValue[i])
            if pass == true then  --选定AI模块就按AI模块走下去
                self.AIFunction = tempfun  --返回当前的行为
                self.AIValue = tempValue   --返回当前行为的参数
                break
            end
        end
       
        self.AITime = 1.5   --设置间隔时间
        self.AIActionDone = false  --行为结束状态为FALSE
    end
    
       
end




--pass,tempfun,tempValue = AI.randomRun(self,obj,1000)
--if pass == false then
--    pass,tempfun,tempValue = AI.hitWhenStun(self,obj,3)
--    if pass == false then
--        pass,tempfun,tempValue = AI.sws_Attack(self,obj,3)
--        if pass == true then
--            self.AIFunction = tempfun
--            self.AIValue = tempValue
--        end
--    else
--        self.AIFunction = tempfun
--        self.AIValue = tempValue
--    end
--else
--    self.AIFunction = tempfun
--    self.AIValue = tempValue
--end     