Monster = class("Monster",Hero)

local AI_move = true
local mathabs = math.abs
local mathMax = math.max
local mathMin = math.min
local mathFloor = math.floor
local rectGetMidX = cc.rectGetMidX
local rectGetMidY = cc.rectGetMidY
local tempGS = 450/ defaultFPS
local maxGS = 1400/ defaultFPS
local addGs = 135/ defaultFPS
local random = Random
local localGetIntersectXY = pGetIntersectXY

function Monster:ctor()
    self._spine=nil
    self.role_effect=nil
    self._target = nil
    self._scale=1
    
end


function Monster.create(x,y,m_id,m_gameScene,type)
    local obj = Monster.new()
    
    copyTable(ActorModifiValues,obj)
    copyTable(ActorCommonValues,obj)
    
    obj._gamescene = m_gameScene
    
    
    obj.role_id = m_id
    obj._actor_type=type
    obj.hit_id_list = {}
    obj.extra_sound_effect = {}
    obj.isNpcRole = true

    if m_id ~= nil then

        --obj.role_id =1 --test
        local isNPC =obj._actor_type > 1

        local attribute=GameDataTransfer.GetNPC(obj.role_id)

        
        copyTable(GameDataTransfer.GetNPC(obj.role_id),obj)
        
        if obj.reward_money then
            local tempSoundData = string.split(obj.reward_money,",")

            for i=1,#tempSoundData do
                local soundData = tonumber(tempSoundData[i])
                table.insert(obj.extra_sound_effect,soundData)
            end

        end
       
        obj.actor_name = GameDataTransfer.GetGameString(obj.npc_name)

        obj._hp = attribute.life
        obj._hp_max = attribute.life
        
        


        local temp_hp = obj._hp

        cclog("m_id= %d obj._hp=%d",m_id,temp_hp)
         
        obj.Attack = attribute.attack
        obj.Defence = attribute.defence
        obj._shieldMax = attribute.armor or 0
        --obj.break_ = attribute.break
        obj.cri_rate = attribute.cri_rate
        obj.cri_resis = 0
        obj.cri_damage = 0
        obj.cri_reduce = 0
        

        obj.now_elementAtt[1]=0
        obj.now_elementAtt[2]=0
        obj.now_elementAtt[3]=0
        obj.now_elementAtt[4]=0
        obj.now_elementAtt[5]=0
        obj.now_elementAtt[6]=0

        obj.now_elementDef[1]=0
        obj.now_elementDef[2]=0
        obj.now_elementDef[3]=0
        obj.now_elementDef[4]=0
        obj.now_elementDef[5]= 0
        obj.now_elementDef[6]= 0

        
        obj._shield = obj._shieldMax
        
        obj.time_box = {passTime = 0}
        if GameManager.FB_Value.is_world_boss == true then
            obj.World_Boss = true
            
            obj._hp = GameManager.FB_Value.world_boss_now_hp

            if obj._hp%300000 == 0 then
                obj._hp_max = obj._hp
            else
                obj._hp_max = (mathFloor(obj._hp/300000)+1) * 300000
            end

            obj.Attack = GameManager.FB_Value.world_boss_att
            obj.Defence = GameManager.FB_Value.world_boss_def
        end
        
        
        local skill_temp = string.split(obj.npc_skill,",")
        
       
        --skill_temp = string.split(obj.Skills,",")

        obj.skill_list = List.new()
        obj.skill_cd = List.new()

        for i=1,#skill_temp do
            if  tonumber(skill_temp[i]) ~= 0 then
                local s = Skill.new(tonumber(skill_temp[i]),1)
                s.Attack_Range = s.Attack_Range + math.random(50, 100) - 50
                s.CD_Time = s.CD_Time + (math.random(300,500) - 300)
                List.pushlast(obj.skill_list,s)
                List.pushlast(obj.skill_cd,0) --nowSkill.cd
            end
        end
        --table.print(obj.skill_list)
    end
    
    --obj.model_id = 38

    obj:initSpine(obj.model_id,obj.scale)
    
    --obj._spine:setVisible(false)

    
    obj:UpDateResist(obj.Status_Control)
    
    obj._fallTime = obj.Lay_Time/1000
    
    obj.x=x
    obj.y=GameManager.getGroundY(x)
        -- 特殊处理那个门柱，往上移动一段距离
    if obj.model_id == 1501 then
        obj.y = obj.y + 2000
    end
    
    obj.allground = m_gameScene.all_boundingBoxs
    
    obj.allground_box = {};

    for i=1,List.getSize(m_gameScene.all_boundingBoxs_big) do
        local temp={}
        copyTable(m_gameScene.all_boundingBoxs_big[i],temp)
        table.insert(obj.allground_box,temp)
    end
    
    -- cclog("monster.counterSkill = %d ",obj.Counter_Skill)
    obj.Counter_Skill_Index = obj:getSkillIndex(obj.Counter_Skill)
    
    obj.AIAction = {}
    
    if obj.World_Boss == true then
        table.insert(obj.AIAction,AI.typeList[AI.funtionName.world_boss_clear])
    end
    table.insert(obj.AIAction,AI.typeList[AI.funtionName.randomRun])
    table.insert(obj.AIAction,AI.typeList[AI.funtionName.sws_hitWhenStun])
    table.insert(obj.AIAction,AI.typeList[AI.funtionName.monster_Attack])

    
    
    
    obj.AIActionValue = {}
    if obj.World_Boss == true then
        table.insert(obj.AIActionValue,45)
    end
    table.insert(obj.AIActionValue,2000)
    table.insert(obj.AIActionValue,3)
    table.insert(obj.AIActionValue,3)
    
    obj.actor_should_drop = Random(1,100) > 75
    
    
    --obj._hp = 1
    
    return obj
end



function Monster:UpDateAI(dt,obj)

    local nowAIValue = self.AIValue
    local nowAItime = self.AITime
    local shoudcheckAI = true
    local absolute_distance 
    
   
    
    if self._ActorState > EnumStateType.run and  self._ActorState < EnumStateType.win then
        if self._ActorState == EnumStateType.couch and self._hp > 0 and self.hit_by_qte == false then 
            self.AIFunction = AI.monster_FightBack   --返回当前的行为
            self.AIValue =  self.Counter_Skill_Index    --返回当前行为的参数
            nowAIValue = self.AIValue
        end
        shoudcheckAI = false
    end
    
    if nowAItime > 0  then   --and self.AIFunction~= nil
        self.AITYPE = 1
        if self.AIActionDone == false then  --当行为没有结束的时候
            if shoudcheckAI == true then
                absolute_distance = math.sqrt((self.x-obj.x) * (self.x-obj.x) + (self.y - obj.y) * (self.y - obj.y))--     mathabs(self.x-obj.x)--获取之间距离
                local isDone,tempAIF,Type = self.AIFunction(self,obj,absolute_distance,nowAIValue,self.time_box,4)  --一直更新行为
                if isDone == false then
                      self.AIActionDone = true
                      self.AIFunction = nil
--                    local ranNum = Random(0,100)
--                    if ranNum > 50 then
--                        self.AIFunction = AI.keepRuning
--                        self.AIValue = ranNum
--                    else
--                        self.AIFunction = nil
--                    end
                elseif Type == 1 then
                    self.AIFunction = AI.monster_moveto
                    local disPosition = 0
                    if self._curFacing > 0  then
                        disPosition = self._target[1].x + self.collideRect[2].width + Random(0,40)
                    elseif self._curFacing < 0 then
                        disPosition = self._target[1].x - (self.collideRect[2].width + Random(0,40))
                    end
                    self.AIValue = disPosition
                end
            end
        else  --当行为结束
            if self.AIFunction ~= nil then
                absolute_distance = mathabs(self.x-obj.x)--获取之间距离
                self.AIFunction(self,obj,absolute_distance,nowAIValue)
            end
            if self._ActorState < EnumStateType.attack then
                self.AITime = nowAItime - dt  --开始计算等待时间
            end

        end
    else
        self.monster_combo = true 
        self.AITYPE = 2
        absolute_distance = mathabs(self.x-obj.x)--获取之间距离
        local pass,tempfun,tempValue=true,nil,0
        local count = #self.AIAction

        for i=1,count do  --按顺序判断AI模块
            pass,tempfun,tempValue = self.AIAction[i](self,obj,absolute_distance,self.AIActionValue[i],self.time_box,4)
            if pass == true then  --选定AI模块就按AI模块走下去
                self.AIFunction = tempfun  --返回当前的行为
                self.AIValue = tempValue   --返回当前行为的参数
                --index = i
                break
            end
        end
        
        if self.AIFunction ~=  nil then
            
            local RNUM =  mathFloor(random(0,self._hp_max))
            local BNUM = mathMax(self._hp,self._hp_max*0.35)
            local delayTime = self._search_range * 0.001   --设置间隔时间
            if RNUM > BNUM then delayTime = 0.01 end
            if self.should_furry == true then
                self.should_furry = false
                delayTime = 0.01 
            end
            self.AITime = delayTime
            self.AIActionDone = false  --行为结束状态为FALSE
            if self.hit_by_qte == true then self.hit_by_qte = false end
        end
        
    end
end

local tt_x =0
local tt_y =0 


function Monster:addDelayDrop(m_time)
    local AddFalseDrop
    local DelayDrop 
    local allCount = m_time

    function AddFalseDrop()
        local tempQty = Random(1,50)
        local tempOffset = Random(-70,70)
        GameManager.addFalseDropItem(true,5007,tempQty,tt_x,tt_y+100,tempOffset,1)
    end

    function DelayDrop()
        allCount = allCount - 1
        AddFalseDrop()
        if allCount > 0 then
            self._spine:runAction(cc.Sequence:create(cc.DelayTime:create(0.02),cc.CallFunc:create(DelayDrop)))
        end
    end

    DelayDrop()
end

function Monster:updateBox(object)

    --local self=object

    local self_collideRect = self.collideRect
    --local self_hitEffectRect = self.hitEffectRect
    
    self_collideRect[1] = self._spine:getBoundingBoxBySlot("box")

    
    self_collideRect[2] = self._spine:getBoundingBoxBySlot("box")

    self.hitEffectRect = self._spine:getBoundingBoxBySlot("box")

    --self.m_CollitionBox = nil
--    local xx = self._spine:getBoundingBoxBySlot("box1")
--    local xx2 = self._spine:getBoundingBoxBySlot("box2")
--
--    local xx3 = self._spine:getBoundingBoxBySlot("box3")
--    
--
--    local _facing = self._curFacing
--
--
--
--    local box01 = self_collideRect[1]
--
--    local box02 = self_collideRect[2]
--
--    
--
--    local box03 = self_hitEffectRect
--
--    box01.x = xx.x
--    box01.y = xx.y
--    box01.width = xx.width
--    box01.height = xx.height
--
--
--
--
--    box02.x = xx2.x
--    box02.y = xx2.y
--    box02.width = xx2.width
--    box02.height = xx2.height
--
--
--
--    box03.x = xx3.x
--    box03.y = xx3.y
--    box03.width = xx3.width
--    box03.height = xx3.height

   
   
    self.m_CollitionBox = self.role_effect:getBoundingBoxBySlot("ATK")
    --local xx3 = self._spine:getBoundingBoxBySlot("ATK")
    --self.m_CollitionBox = self_collideRect[1].tempBox
    --self.m_CollitionBox = self._spine:getBoundingBox()
end

function Monster:AllMonsterAIEnable(m_ai)
    AI_move = m_ai
end

function Monster:baseUpdate(dt)
    
    
    
    if self.isPause == false then
    
        if self.World_Boss == true then
            self.time_box.passTime = self.time_box.passTime + dt
        end
                
        if self._break_time >= self._request_break_time then
            self:updateBuff(dt)
            self:UpDateState(dt)
            self:updateBox(self)
            self:UpdateGravity()
            

            if  self._request_break_time ~= 0 and self._break_time ~=0 then
                self._break_time = 0
                self._request_break_time = 0
                if self._ActorState ~= EnumStateType.freeze then
                    self._spine:resume()
                    self.role_effect:resume()
                   
                end
            end

        elseif self._break_time < self._request_break_time then
            self._break_time = self._break_time + dt

        end

--        if self.light_count > 0 then
--            self.light_count = self.light_count - 1
--            local nowC = self.light_count*25.5
--            if self.light_count >= 5 then
--                self._spine:setColor(cc.c3b(nowC,nowC,nowC))
--            else
--                self._spine:setColor(cc.c3b(self.light_count*51,0,0))
--            end
--            if self.light_count == 0 then self:resetShine() end
--        end
        if self.light_count > 0 then
            self.light_count = self.light_count - 1
            if self.light_count == 0 then self:resetShine() end
        end
        
        if self.gold_count > 0 then
            self.gold_count = self.gold_count - 1
            --            local nowC = self.light_count*17
            --            self._spine:setColor(cc.c3b(nowC,nowC,nowC))
            if self.gold_count == 0 then self:resetGold() end
        end


       if self._is_boss == true then
            if self.low_hp_warnning == false and self._hp / self._hp_max < 0.2  then
                local action2 = cc.TintBy:create(0.5, -70, -212, -226)
                local action2Back = action2:reverse()
                local tintAct = cc.Sequence:create(action2,action2Back)
                local repeatAction = cc.RepeatForever:create(tintAct)
                self._spine:runAction(repeatAction)
                self.low_hp_warnning = true
            end
       end

        local oX = self.x
        local oY = self.y + self._gamescene.offset_y + self.actor_y_offset
        local bX = rectGetMidX(self.collideRect[1])
        local bY = rectGetMidY(self.collideRect[1]) + self._gamescene.offset_y + self.actor_y_offset

        self._spine:setPosition(oX,oY)
        self.role_effect:setPosition(oX,oY)
--        self._Blood_1:setPosition(bX,bY)
--        self._Blood_2:setPosition(bX,bY)
        
--        if self.have_elite_mark == true then
--            self.eliteMark:setPositionY((bY-oY)+50)
--        end


        if self._AIEnabled == true and self._target[1].gameisWin == false and self._hp > 0 then

            local targetSize = List.getSize(self._target)
            
            if self.actor_move == true and AI_move == true then self:UpDateAI(dt,self._target[targetSize]) end
            
        elseif self._AIEnabled == true and self._target[1].gameisWin == false and self._hp <= 0 then    
        
            if self._ActorState == EnumStateType.stand or self._ActorState == EnumStateType.run then
                self:SetSate(EnumStateType.knockout,true,350)
            end
            
        end


       
        self._gamescene.nowShadowList[self._actor_id]:setXY(self.x,self.ground_y + self.actor_y_offset)
        --self:setShadowXY(self.x,self.ground_y,self._actor_id)
        --GameManager.setShadowXY(self.x,self.ground_y,self._actor_id)
    

    end
    
    if ISDEBUG and ISDEBUG == 3 then
            --local box_draw= self.m_CollitionBox
            self.draw:clear()

            for key, var in pairs(self.collideRect) do
                local box_draw = cc.rect(var.x,var.y,var.width,var.height)
                
                local vertices3={}
                local dir=1
                if dir >0 then vertices3 = { cc.p(box_draw.x,box_draw.y), cc.p(box_draw.x,box_draw.y+box_draw.height), cc.p(box_draw.x+box_draw.width,box_draw.y+box_draw.height), cc.p(box_draw.x+box_draw.width,box_draw.y) }
                else
                    vertices3 = { cc.p((box_draw.x+box_draw.width)*-1,box_draw.y), cc.p((box_draw.x+box_draw.width)*-1,box_draw.y+box_draw.height), cc.p((box_draw.x+box_draw.width)*-1+box_draw.width,box_draw.y+box_draw.height), cc.p((box_draw.x+box_draw.width)*-1+box_draw.width,box_draw.y) }
                end
                self.draw:drawSolidPoly( vertices3, 4, cc.c4f(0,0,1,0.3) )
            end
            
            if self._actor_type == 1 or self._actor_type == 2 then
                if self._is_boss == true then
                    local xx =0
                end
                local box_draw = cc.rect(self.m_CollitionBox.x,self.m_CollitionBox.y,self.m_CollitionBox.width,self.m_CollitionBox.height)

                local vertices3={}
                local dir=1
                if dir >0 then vertices3 = { cc.p(box_draw.x,box_draw.y), cc.p(box_draw.x,box_draw.y+box_draw.height), cc.p(box_draw.x+box_draw.width,box_draw.y+box_draw.height), cc.p(box_draw.x+box_draw.width,box_draw.y) }
                else
                    vertices3 = { cc.p((box_draw.x+box_draw.width)*-1,box_draw.y), cc.p((box_draw.x+box_draw.width)*-1,box_draw.y+box_draw.height), cc.p((box_draw.x+box_draw.width)*-1+box_draw.width,box_draw.y+box_draw.height), cc.p((box_draw.x+box_draw.width)*-1+box_draw.width,box_draw.y) }
                end
                self.draw:drawSolidPoly( vertices3, 4, cc.c4f(1,0,0,0.3) )
            end
            
        end

end

local tempPoint1 = {x = 0,y = 0}
local tempPoint2 = {x = 0,y = 0}

local GetIntersectXY = pGetIntersectXY

local function getGroundY(nowX,allground,nowY,height)

    local newInterestx,newInteresty=0,0

    local boxSize = List.getSize(allground)
    local tempY = 0

    for i=1,boxSize do


        if (nowX >= allground[i].a.x and nowX <= allground[i].b.x) or (nowX >= allground[i].b.x and nowX <= allground[i].a.x) then

            tempPoint1.x = nowX
            tempPoint1.y = nowY+height-10

            tempPoint2.x = nowX
            tempPoint2.y = nowY-10

            newInterestx,newInteresty = localGetIntersectXY(tempPoint1,tempPoint2,allground[i].a,allground[i].b)

            if newInteresty > tempY then tempY = newInteresty end

        end
    end
    return tempY+2
end

--function Monster:UpdateGravity()    --重力更新
--    local sX = self.x
--    local ground_y
--
--    ground_y = mathFloor(getGroundY(self.x,self.allground))
--
--
--    self.ground_y = ground_y
--
--    local gS = self.gravity_speed
--
--    if self.enable_gravity == true then
--
--        if self.y > ground_y then
--            self.gravity_speed = mathMin(gS+addGs,maxGS)
--
--            local tempy = self.y-self.gravity_speed *logicSpeed * nowFixTimeScale
--            self.y = mathMax(ground_y,tempy)
--
--
--        else
--            if self.y < ground_y then  self.y = ground_y end
--            if self._ActorState == EnumStateType.inair then self._isHitTheGround = true end
--            self.gravity_speed = tempGS
--        end
--    else
--        self.gravity_speed = tempGS
--    end 
--
--end


function Monster:UpDateState(dt)  

    
    local self_ActorState = self._ActorState
    self:downStop(dt)

    self:shieldRecovery(dt, self._request_hard_time)

--    if self._is_boss == true then
--        if self_ActorState >= EnumStateType.attack then
--            self.all_resist = true
--            self.resist_list.hitMove = 0
--        elseif self_ActorState < EnumStateType.attack then
--            self.all_resist = false
--            self:UpDateResist(self.Status_Control)
--        end
--    end

    if self_ActorState == EnumStateType.stand then
        self:moveTo(dt)
    elseif self._ActorState == EnumStateType.readytodie then
        self:moveTo(dt)
        
        if self.ready_to_play_die == 0 and self._moveto_point.x ~= -1 then
            self._spine:pause()
        elseif self.ready_to_play_die == 0 then
            self.ready_to_play_die = 1
            self._spine:resume()
        end 
        
        if self._actionComplete == true then
            self._actionComplete=false
            self._canChangeState=true
            self._request_hard_time=0
            self._isInvincible=false
            self.hit_id=0  --重置攻击ID
            self.ready_to_play_die = 0
            self:SetSate(EnumStateType.couch,false)
            --GameManager.addDropItem(self.actor_should_drop,self.x,self.y)
            
        end
    elseif self._ActorState == EnumStateType.Show then
        if self._actionComplete == true then
            self._actionComplete=false
            self._canChangeState=true
            self._request_hard_time=0
            self._isInvincible=false
            self.hit_id=0  --重置攻击ID
            self:SetSate(EnumStateType.stand,false)
        end    
    elseif self_ActorState == EnumStateType.dead then
        if self._spine:getOpacity() <=0 then
            self.shouldDeleteAD = true
            GameManager.addDropItem(self.actor_should_drop,self.x,self.y)
        end
    
    elseif self_ActorState == EnumStateType.freeze then
        self:moveTo(dt)
    elseif self_ActorState == EnumStateType.run then
        
        self:moveTo(dt)
        self.lastX = self.x
        
        if self.force_move == true then
            if self._moveto_point.x == -1 then
                self.force_move = false
            end
        else
            local temp_speed = self:checkContrackWithSpeedX(self:AddSpeed(self.speed_x) * self.Actor_motion_speed * logicSpeed * nowFixTimeScale)
            self.x = self.x + temp_speed
        end
        
       

    elseif self_ActorState == EnumStateType.minor_injured then
        self:moveTo(dt)
        self._hard_time = self._hard_time+dt

        if self._actionComplete == true and self._hard_time > self._request_hard_time then --硬直完变状态
            self._actionComplete=false
            self._canChangeState=true
            self._request_hard_time=0
            self.hit_id=0  --重置攻击ID
            if self._hp <= 0 then
                self:SetSate(EnumStateType.knockout,true,200)
                
            else
                self:SetSate(EnumStateType.stand,false)
            end
        end
    elseif self_ActorState == EnumStateType.serious_injured then
        self:moveTo(dt)
        self._hard_time = self._hard_time+dt

        if self._actionComplete == true and self._hard_time > self._request_hard_time then --硬直完变状态
            self._actionComplete=false
            self._canChangeState=true
            self._request_hard_time=0
            self.hit_id=0  --重置攻击ID
            
            if self._hp <= 0 then
                self:SetSate(EnumStateType.knockout,true,200)
            else
                self:SetSate(EnumStateType.stand,false)
            end
        end
    elseif self_ActorState == EnumStateType.breakShield then
        self:moveTo(dt)
        self._hard_time = self._hard_time+dt


        if self._actionComplete == true and self._hard_time > self._request_hard_time then
            self._actionComplete=false
            self._canChangeState=true
            self._request_hard_time=0
            self.hit_id=0  --重置攻击ID
            if self._hp <= 0 then
                self:SetSate(EnumStateType.readytodie,false)
            else
                self:SetSate(EnumStateType.stand,false)
            end
        end
    elseif self_ActorState == EnumStateType.inair then   --在浮空状态中
        self:moveTo(dt)

        if self._isHitTheGround == true then
            self._actionComplete=false
            self._canChangeState=true
            self._request_hard_time=0
            self.hit_id=0  --重置攻击ID
            self:SetSate(EnumStateType.couch,false)
        end
         
    elseif self_ActorState == EnumStateType.knockout then
        self:moveTo(dt)

        if  self._isHitTheGround == true then
            self._canChangeState=true
            self._request_hard_time=0
            self.hit_id=0  --重置攻击ID
            self:SetSate(EnumStateType.couch,false)
        end
    elseif self_ActorState == EnumStateType.stun then
        self:moveTo(dt)
        if self.buffEffectStun ~= nil then
            local tempBox = self.collideRect[1]
            local headY = tempBox.y + tempBox.height 
            self.buffEffectStun:setPositionY(headY+20)
        end
       

    elseif self_ActorState == EnumStateType.knockback then
        self:moveTo(dt)
        self._hard_time = self._hard_time + dt

        if self._actionComplete == true and self._hard_time > self._request_hard_time then --硬直完变状态
            self._actionComplete=false
            self._canChangeState=true
            self._request_hard_time=0
            if self._hp <= 0 then
                self:SetSate(EnumStateType.readytodie,false)
            else
                self:SetSate(EnumStateType.stand,false)
            end
        end
    
    elseif self_ActorState == EnumStateType.skill_1 then  --技能1
        self:updateSkill(1)
    elseif self_ActorState == EnumStateType.skill_2 then
        self:updateSkill(2)
    elseif self_ActorState == EnumStateType.skill_3 then
        self:updateSkill(3)
    elseif self_ActorState == EnumStateType.skill_4 then
        self:updateSkill(4)
    elseif self_ActorState == EnumStateType.skill_5 then
        self:updateSkill(5)
    elseif self_ActorState == EnumStateType.skill_6 then
        self:updateSkill(6)
    elseif self_ActorState == EnumStateType.skill_7 then
        self:updateSkill(7)
    elseif self_ActorState == EnumStateType.skill_8 then
        self:updateSkill(8)
    elseif self_ActorState == EnumStateType.skill_9 then
        self:updateSkill(9)
    elseif self_ActorState == EnumStateType.couch then
        self:moveTo(dt)
        self._fallTime = self._fallTime - dt

        if self._fallTime <= 0 then

            if self._hp >0 then
                self._isInvincible=false

                self._actionComplete=false
                self._canChangeState=true

                if Random(1,100) <= 50 then
                    self.AttTime = 10
                end
                self:setMoveTo(cc.p(-1,-1))
                self:SetSate(EnumStateType.stand,false)
            else
                self._actionComplete=false
                self._canChangeState=true
                self:SetSate(EnumStateType.dead,true)
                self._isInvincible=true
            end
        
        end

    end

end
function Monster:SetSate(m_state,forceChange,m_airForce)
    if self.isPause == true then return end

    if m_state == self._ActorState then   --判断是否可以重复调用同一状态

        if m_state == EnumStateType.run or m_state == EnumStateType.stand or m_state == EnumStateType.roll then return end

    end
    
    
    
    if m_state >= EnumStateType.skill_1 then
        if self._request_hard_time ~= 0 or self._ActorState == EnumStateType.couch or self._ActorState == EnumStateType.inair or self._ActorState == EnumStateType.knockout --防止在硬直存在，倒下及浮空，死亡的时候切换技能或滚动状态
            or self._ActorState == EnumStateType.dead or self._ActorState == EnumStateType.stun or  self._ActorState == EnumStateType.freeze or  self._ActorState == EnumStateType.readytodie then
            
            return
        end
    end
    
    if m_state <= 1 and  self._ActorState == EnumStateType.readytodie then
        return
    end

    if m_state >= EnumStateType.minor_injured and m_state <= EnumStateType.serious_injured and GameManager.FB_Value.SpeacilFb == 1 and self._actor_type ~= 1 then
        tt_x = self.x
        tt_y = self.y
--        local allcount = Random(1,2)
--        self:addDelayDrop(allcount)
--        if self._canChangeState == false then
--            return
--        end
    end
    
    if m_state > EnumStateType.attack and self._ActorState > EnumStateType.attack and self.skillchange == true then
        self._canChangeState = true
    end

    if self._canChangeState == true or forceChange == true then

        
        if self._LastState == EnumStateType.couch then self._isInvincible=false end --以防鞭尸状态无切换
        
        if m_state ~= EnumStateType.inair then self.enable_gravity = true end  --以防移动中途被打断不落地

        self._LastState = self._ActorState
        self._ActorState = m_state


        self.role_effect:setVisible(false)

        if m_state ~= EnumStateType.run then
            self:setMoveTo(cc.p(-10,-10))

        end

    else
        return
    end


    if m_state == EnumStateType.stand then
        --GameManager.ZoomReset()
        if self._LastState == EnumStateType.couch then
            self._spine:addAnimation(0,self._actions.standup, false)
            self._spine:addAnimation(0,self._actions.stand, true)
        else
            self:playAnimation(self._actions.stand,true)
        end

        self._canChangeState=true
        
    elseif self._ActorState == EnumStateType.Show then
        self:playAnimation(self._actions.showUp, false)
        self._canChangeState=false
    elseif self._ActorState == EnumStateType.readytodie then
        local disdie = Random(90,200)
        self:setFacing(self._target[1])
        self:setMoveTo(cc.p(self.x-disdie*self._curFacing,-1),3)
        self.should_play_couch = true
        self:playAnimation(self._actions.die,false)
        self._canChangeState=false
        self._isInvincible=true
        
        self:SetSate(EnumStateType.dead,true)
        self._isInvincible=true
        --cclog("enter EnumStateType.readytodie ")
        
    elseif m_state == EnumStateType.dead then
        --greyNode(self._spine)
        
        self._spine:runAction(cc.Sequence:create(cc.Blink:create(1,5),cc.FadeOut:create(0.01)))
--        if self._is_boss == true then
--            GameManager.addHitEffect(self.x,self.y,107,1,false,0)
--        else
--            GameManager.addHitEffect(self.x,self.y,108,1,false,0)
--        end
        self._actionComplete = true
        self._canChangeState=false
    
    elseif m_state == EnumStateType.run then
        
        self:setMoveTo(cc.p(-1,-10)) --跑动中取消X位移
        
--        self.role_effect:setAnimation(0,"B", true)
--        self.role_effect:setVisible(true)
        

        self:playAnimation(self._actions.run,true)
        self._canChangeState=true

    elseif m_state == EnumStateType.minor_injured then
       
        self._hard_time=0
        self:playAnimation(self._actions.hit,false)
        self._canChangeState=false

    elseif m_state == EnumStateType.serious_injured then
       
        self._hard_time=0
        self:playAnimation(self._actions.hit2,false) 
        self._canChangeState=false
    elseif m_state == EnumStateType.breakShield then
        self:setMoveTo(cc.p(self.x-30*self._curFacing,-1))
        --self.shieldBreak = cc.ParticleSystemQuad:create("effect/particle_break.plist",0)
        --self._gamescene.bg_foreground:addChild(self.shieldBreak,res_gameLayer.LAYER_HITEFFECT)
        
        self._hard_time=0
        self:playAnimation(self._actions.hit2,false)
        self._canChangeState=false 
    elseif m_state == EnumStateType.stun then
        self._hard_time=0
        self._stunTime = 2 
        self:playAnimation(self._actions.stun,true)
        self._canChangeState=false
    elseif m_state == EnumStateType.freeze then
        self._hard_time=0
        self._spine:pause()
        self._canChangeState=false
        
    elseif m_state == EnumStateType.knockback then
    
        if self.resist_list.knockback == 0 and self.all_resist == false then   
            self:setMoveTo(cc.p(self.x-m_airForce*self._curFacing ,-1),8)
        end
        self._hard_time=0
        self:playAnimation(self._actions.beijifei,false)
        self._canChangeState=false 
        if self._hp <= 0 then
            self:SetSate(EnumStateType.dead,true)
            self._isInvincible=true
        end

    elseif m_state == EnumStateType.inair then    --浮空攻击
        self.should_play_couch = true
        self._isHitTheGround=false
        self:setMoveTo(cc.p(-1,self.y+m_airForce),8)
        
        self:playAnimation(self._actions.fly,false)
        self._canChangeState=false
        
    elseif m_state == EnumStateType.knockout then  --被击飞
        self._isHitTheGround=false
        self.should_play_couch = true
        
        if self.resist_list.knockout == 0 and self.all_resist == false then 
            self:setMoveTo(cc.p(-1,self.y+150))
            self:setMoveTo(cc.p(self.x-m_airForce*self._curFacing,-10),8) 
        end

        
        self:playAnimation(self._actions.fly,false)

        self._ActorState=EnumStateType.inair
        self._canChangeState=false
--        if self._hp <= 0 then
--            self:SetSate(EnumStateType.dead,true)
--            self._isInvincible=true
--        end

        
        
    elseif m_state == EnumStateType.skill_1 then  --技能1
        self:setSkillAction(1)
    elseif m_state == EnumStateType.skill_2 then
        self:setSkillAction(2)

    elseif m_state == EnumStateType.skill_3 then
        self:setSkillAction(3)
    elseif m_state == EnumStateType.skill_4 then
        self:setSkillAction(4)
    elseif m_state == EnumStateType.skill_5 then
        self:setSkillAction(5)
    elseif m_state == EnumStateType.skill_6 then
        self:setSkillAction(6)
    elseif m_state == EnumStateType.skill_7 then
        self:setSkillAction(7)
    elseif m_state == EnumStateType.skill_8 then
        self:setSkillAction(8)
    elseif m_state == EnumStateType.skill_9 then
        self:setSkillAction(9)
    elseif m_state == EnumStateType.couch then
    
        self._fallTime = self.Lay_Time/1000
        self._canChangeState=false
        --self:resetHitid()
        if self.should_play_couch == true then
            self:playAnimation(self._actions.laydown,false)
        else 
            self.should_play_couch = true
        end
    end
end

function Monster:updateSkill(skill_list_id)
    self:moveTo()
    local nowskill = self.skill_list[skill_list_id]
--    local enemyCount = List.getSize(self._target)
--    if enemyCount > 0 and self.skill_move_type == 1 then
--        for i=1,enemyCount do
--            local enemy_ActorState = self._target[i]._ActorState
--            if enemy_ActorState < EnumStateType.knockout or enemy_ActorState > EnumStateType.knockback then
--                self:HitWithCollition(0,self._target[i],1,self.temp_hit_type)
--            end
--        end
--    end
    local BA = nowskill.bullet_list[self._skill_hit_step] --tonumber(nowskill.Bullet_Assign)

    if BA and BA > 0 then 

        if self.need_Bullet_Assign == true then
            local now_self= self
            local xx4 = self._spine:getBoundingBoxBySlot("X")
            
            --cclog("self.x = %f self.y = %f",self.x,self.y)
            
            
            GameManager.addBullet(xx4.x,xx4.y,self._curFacing,BA,self._target,nil,nowskill,now_self,self._skill_hit_step)
            self.need_Bullet_Assign=false
        end

    end

    if self.shouldCheckHit==true then
        --local nowSkill_id = nowskill.skill_id
        local hitId = self._ActorState*100+self._skill_hit_step+self._actor_id*10000+self.hit_start_time
        self:setDestination(nowskill,hitId)
        self:CheckHitAll(self._target,nowskill,hitId,false,false,skill_list_id)
    end   

    self:ResetState(EnumStateType.stand)
end

function Monster:ResetState(m_state)
    if self._actionComplete == true then
        self._actionComplete=false
        self._canChangeState=true
        self:SetSate(m_state,false)
    end
end

function Monster:forceToDeadth()
    self._hp = 0
    self._request_hard_time = 2
    --obj:setFacing(self)
    self:SetSate(EnumStateType.knockout,true,10)
    self:deleteBuff()
end

function Monster:setSkillAction(skill_num)
    local nowChooseSkill =  self.skill_list[skill_num]
    if skill_num <= List.getSize(self.skill_list) then
        self.Last_skill_release = skill_num
        self.soundControl.now_skill_sound_list = self.skill_list[skill_num].sound_list
        local nowActionId = self.skill_list[skill_num].ActionId
        self.attRange = self.skill_list[skill_num].Attack_Range
        self.skill_move_type =  nowChooseSkill.hit_offset_list[1]
        local ationName = "E_"..nowActionId
        local eType = self.element_type
        if self.skill_list[skill_num].ActionId == 6 then eType = 0 end
        local ationEffectName = ationName.."_"..eType

        self:playAnimation(ationName,false)
        
        self.role_effect:setVisible(true)
        self.role_effect:setToSetupPose()
        self.role_effect:setAnimation(0,ationEffectName, false)
        

        self.now_skill_id = Time_GetCurrentTime()+ self.skill_list[skill_num].skill_id
                
        self._canChangeState=false
        
        if self._is_boss == true then
            self:setGold()
        end
        
    else 
        self._ActorState = self._LastState
        self._canChangeState=true
        
    end
end



function Monster:setEliteMark()
    self.eliteMark = CreateSpineRes("effect/effect_role_stand")
    
    self._gamescene.nowShadowList[self._actor_id]._sprite:addChild(self.eliteMark)
    self.eliteMark:setAnimation(0,"animation", true)
    self.have_elite_mark = true
end