QTE = class("QTE")



local mathabs = math.abs
local mathMax = math.max
local mathMin = math.min
local mathFloor = math.floor
local mathFloor = math.floor
local mathCeil = math.ceil
local rectGetMidX = cc.rectGetMidX
local rectGetMidY = cc.rectGetMidY
local mRandom = Random

function QTE:ctor()

    self.x = 0
    self.y = 0
    self.dir = 1
    self.collideRect = 0
    self.isOver = false 
    self._spine = 0

    self._scale = 0
    
    self._target = 0

end

function QTE:delete() --删除共有指针


    self._spine:removeFromParent()
    self._spine = nil
    self._target = nil
    GameManager.cameraForceFollow(false)
    GameManager.exit_Qte()
end

function QTE.create(mm_x,mm_y,m_id,dir,m_scale,targetLayer,zorder,targetObj)
    local base = QTE.new()
    
    base.dir = dir
    base._scale = m_scale
    base._target = targetObj
    
    base.x = mm_x
    base.y = mm_y
    
    local m_path = string.format("Spine/QTE_%d",m_id)
    
    base:initPreLoadSpine(m_path,false,targetLayer,zorder)
    
    GameManager.cameraForceFollow(true)
    --GameManager.setCarmeraFollowPoint(m_point)
    --GameManager.setHeroCameraDir(dir)
    return base
end

function QTE:initPreLoadSpine(m_path,loop,targetLayer,zorder)

    local settingScale = 1
    
    
    
    self._spine = CreateSpineRes(m_path,nil,self._scale)
    
    targetLayer:addChild(self._spine,zorder)

    self._spine:setAnimation(0,"animation", loop)
    
    self._spine:setScaleX(self.dir * self._scale)
    
    self._spine:setPosition(self.x,self.y)
    
    self.collideRect = {}

    self.collideRect[1] = cc.rect(0,0,2,2)  --被QTE人
    self.collideRect[2] = cc.rect(0,0,2,2)  --攻击方

    self._spine:registerSpineEventHandler(function (event)

         self:spine_ActionEndEvent(event)
    end, sp.EventType.ANIMATION_COMPLETE)


    self._spine:registerSpineEventHandler(function (event)
        self:spine_ActionStartEvent(event)
    end, sp.EventType.ANIMATION_START)

    self._spine:registerSpineEventHandler(function (event)
        self:spine_ActionSpecialEvent(event)
    end, sp.EventType.ANIMATION_EVENT)

end

function QTE:spine_ActionEndEvent(event)
    self.isOver = true
end

function QTE:spine_ActionStartEvent(event)
end

function QTE:spine_ActionSpecialEvent(event)
    if event.eventData.name == "shock" then
        GameManager.getMain():creatShock(0.5,18)
    elseif event.eventData.name == "position" then
        
        local box_1 = self.collideRect[2]
        local box_2 = self.collideRect[1]
        
        nowPlayer[1].x = rectGetMidX(box_2)
        nowPlayer[1].y = box_2.y
        
        nowPlayer[1]:setMoveTo({x=-1,y=-1})
        nowPlayer[1]:SetSate(EnumStateType.stand,true)
        
        self._target.x = rectGetMidX(box_1)
        self._target.y = box_1.y
        self._target:setMoveTo({x=-1,y=-1})
        self._target:resumeLogic()
        self._target:SetSate(EnumStateType.couch,true)
        self._target.isPause = false
        self._target.hit_by_qte = true
    end
end

function QTE:updateBox()


    local self_collideRect = self.collideRect

    local xx = self._spine:getBoundingBoxBySlot("box1")
    local xx2 = self._spine:getBoundingBoxBySlot("box2")


    local box01 = self_collideRect[1]

    local box02 = self_collideRect[2]


    box01.x = xx.x
    box01.y = xx.y
    box01.width = xx.width
    box01.height = xx.height
    
    box02.x = xx2.x
    box02.y = xx2.y
    box02.width = xx2.width
    box02.height = xx2.height
    

end

function QTE:baseUpdate(dt)
    self:updateBox()
    
    if self.collideRect[1].x ~= -999 then
        GameManager.setCarmeraFollowPoint({x = rectGetMidX(self.collideRect[2]),y = self.y})
    end
    
end