SActor = class("SActor",Monster)

local mathabs = math.abs
local mathMax = math.max
local mathMin = math.min
local mathFloor = math.floor

function SActor.create(x,y,m_id,m_gameScene,type)
    local obj = SActor.new()

    copyTable(ActorModifiValues,obj)
    copyTable(ActorCommonValues,obj)
    
    obj._gamescene = m_gameScene
    obj.role_id = m_id
    obj._actor_type=type
    obj.hit_id_list = {}



    if m_id ~= nil then

        --obj.role_id =1 --test
        local isNPC =obj._actor_type > 1

        local attribute=GameDataTransfer.GetRoleAttributes(obj.role_id,isNPC)


        copyTable(GameDataTransfer.GetNPC(obj.role_id),obj)

        obj.actor_name = GameDataTransfer.GetGameString(obj.npc_name)

        obj._hp = attribute[res_attribute.BLOOD]
        obj._hp_max = attribute[res_attribute.BLOOD]


        local temp_hp = obj._hp

        cclog("m_id= %d obj._hp=%d",m_id,temp_hp)

        obj.Attack = attribute[res_attribute.POWER]
        obj.Defence = attribute[res_attribute.DEFENCE]
        obj._shieldMax = attribute[res_attribute.ARMOR] or 0
        obj.break_ = attribute[res_attribute.BREAK]
        obj.cri_rate = attribute[res_attribute.CRIT_RATE]
        obj.cri_resis = attribute[res_attribute.CRIT_RESIST]
        obj.cri_damage = attribute[res_attribute.CRIT_DAMAGE]
        obj.cri_reduce = attribute[res_attribute.CRIT_REDUCE]


        obj.now_elementAtt[1]=attribute[res_attribute.DAMAGE_ICE] or 0
        obj.now_elementAtt[2]=attribute[res_attribute.DAMAGE_FIRE] or 0
        obj.now_elementAtt[3]=attribute[res_attribute.DAMAGE_ELECTRICITY] or 0
        obj.now_elementAtt[4]=attribute[res_attribute.DAMAGE_WIND] or 0
        obj.now_elementAtt[5]=attribute[res_attribute.DAMAGE_SOIL] or 0
        obj.now_elementAtt[6]=attribute[res_attribute.DAMAGE_STAR] or 0

        obj.now_elementDef[1]=attribute[res_attribute.RESIST_ICE] or 0
        obj.now_elementDef[2]=attribute[res_attribute.RESIST_FIRE] or 0
        obj.now_elementDef[3]=attribute[res_attribute.RESIST_ELECTRICITY] or 0
        obj.now_elementDef[4]=attribute[res_attribute.RESIST_WIND] or 0
        obj.now_elementDef[5]=attribute[res_attribute.RESIST_SOIL] or 0
        obj.now_elementDef[6]=attribute[res_attribute.RESIST_STAR] or 0


        obj._shield = obj._shieldMax

        local skill_temp = string.split(obj.npc_skill,",")


        --skill_temp = string.split(obj.Skills,",")

        obj.skill_list = List.new()
        obj.skill_cd = List.new()

        for i=1,#skill_temp do
            List.pushlast(obj.skill_list,Skill.new(tonumber(skill_temp[i]),1))
            List.pushlast(obj.skill_cd,0) --nowSkill.cd
        end
        --table.print(obj.skill_list)
    end

    --obj.model_id = 38
    obj:initSpine(obj.model_id,obj.scale)

    --obj._spine:setVisible(false)


    obj:UpDateResist(obj.Status_Control)

    obj._fallTime = obj.Lay_Time/1000

    obj.x=x obj.y=y

    --obj:setPosition(cc.p(x,y))

    
    
    obj.allground = m_gameScene.all_boundingBoxs

    cclog("monster.counterSkill = %d ",obj.Counter_Skill)
    obj.Counter_Skill_Index = obj:getSkillIndex(obj.Counter_Skill)

    obj.AIAction = {}

    table.insert(obj.AIAction,AI.typeList[AI.funtionName.randomRun])
    table.insert(obj.AIAction,AI.typeList[AI.funtionName.sws_hitWhenStun])
    table.insert(obj.AIAction,AI.typeList[AI.funtionName.monster_Attack])




    obj.AIActionValue = {}
    table.insert(obj.AIActionValue,1000)
    table.insert(obj.AIActionValue,3)
    table.insert(obj.AIActionValue,3)

    return obj
end

function SActor:UpDateAI(dt,obj)

    local nowAIValue = self.AIValue
    local nowAItime = self.AITime
    local shoudcheckAI = true
    local absolute_distance 


    if self._ActorState > EnumStateType.run and  self._ActorState < EnumStateType.win then
        if self._ActorState == EnumStateType.couch then 
            self.AIFunction = AI.monster_FightBack   --返回当前的行为
            self.AIValue =  self.Counter_Skill_Index    --返回当前行为的参数
        end
        shoudcheckAI = false
    end

    if nowAItime > 0 then
        if self.AIActionDone == false then  --当行为没有结束的时候
            if shoudcheckAI == true then
                absolute_distance = mathabs(self.x-obj.x)--获取之间距离
                local isDone = self.AIFunction(self,obj,absolute_distance,nowAIValue)  --一直更新行为
                if isDone == false then
                    self.AIActionDone = true
                    local ranNum = Random(0,100)
                    if ranNum > 50 then
                        self.AIFunction = AI.keepRuning
                        self.AIValue = ranNum
                    else
                        self.AIFunction = nil
                    end
                end
        end
        else  --当行为结束
            if self.AIFunction ~= nil then
                absolute_distance = mathabs(self.x-obj.x)--获取之间距离
                self.AIFunction(self,obj,absolute_distance,nowAIValue)
        end
        self.AITime = nowAItime - dt  --开始计算等待时间

        end
    else
        absolute_distance = mathabs(self.x-obj.x)--获取之间距离
        local pass,tempfun,tempValue=true,nil,0
        local count = 3

        for i=1,count do  --按顺序判断AI模块
            pass,tempfun,tempValue = self.AIAction[i](self,obj,absolute_distance,self.AIActionValue[i])
            if pass == true then  --选定AI模块就按AI模块走下去
                self.AIFunction = tempfun  --返回当前的行为
                self.AIValue = tempValue   --返回当前行为的参数
                --index = i
                break
            end
        end

        local delayTime = self._search_range * 0.001   --设置间隔时间
        self.AITime = delayTime
        self.AIActionDone = false  --行为结束状态为FALSE
    end
end