TreeActor = class("TreeActor",Monster)

TreeActor._actions = {
    attack="E_2",  
    beijifei="H", --被击飞
    fly="G_1", --浮空攻击第一下
    fangun="C",  --翻滚
    hit="F_1", --受击2
    hit2="F_2", --受击1
    run="B", --跑步
    stand="A",  --待机
    airhit="G_2",  --浮空受击
    laydown="G_3",  --倒地
    standup="G_4",  --待机
    stun = "K", --眩晕
    win="J",  --待机
    skill_1="E_1",
    skill_2="E_2",
    skill_3="E_3",
    skill_4="E_4",
    skill_5="E_5",
    skill_6="E_6",
    skill_7="E_7",
    skill_8="E_8",
    skill_9="E_9",

}

local mathabs = math.abs
local mathMax = math.max
local mathMin = math.min
local mathFloor = math.floor
local rectGetMidX = cc.rectGetMidX
local rectGetMidY = cc.rectGetMidY
local needName = 0
local GroupIndex = 1
local LastGroupIndex = 1 

function TreeActor:ctor()
    self._spine=nil
    self._Blood_1 = nil
    self._Blood_2 = nil
    self._scale=1

end

function TreeActor.create(x,y,m_id,m_gameScene,type)
    local obj = TreeActor.new()
    
    
    
    
    copyTable(ActorModifiValues,obj)
    copyTable(ActorCommonValues,obj)
    obj._gamescene = m_gameScene
    obj.role_id = m_id
    obj._actor_type=type
    obj.hit_id_list = {}
    obj.waitActionEnd = 0
    obj.extra_sound_effect = {}

    if m_id ~= nil then

        --obj.role_id =1 --test
        local isNPC =obj._actor_type > 1

        local attribute=GameDataTransfer.GetNPC(obj.role_id)


        copyTable(GameDataTransfer.GetNPC(obj.role_id),obj)
        
        if obj.reward_money then
            local tempSoundData = string.split(obj.reward_money,",")

            for i=1,#tempSoundData do
                local soundData = tonumber(tempSoundData[i])
                table.insert(obj.extra_sound_effect,soundData)

                if soundData >0 then
                    GameSound.initGamesoundWithMapId(soundData) --预加载音效
                end
            end

        end

        obj.actor_name = GameDataTransfer.GetGameString(obj.npc_name)

        obj._hp = attribute.life
        obj._hp_max = attribute.life




        local temp_hp = obj._hp

        cclog("m_id= %d obj._hp=%d",m_id,temp_hp)

        obj.Attack = attribute.attack
        obj.Defence = attribute.defence
        obj._shieldMax = attribute.armor or 0
        --obj.break_ = attribute.break
        obj.cri_rate = attribute.cri_rate
        obj.cri_resis = 0
        obj.cri_damage = 0
        obj.cri_reduce = 0


        obj.now_elementAtt[1]=0
        obj.now_elementAtt[2]=0
        obj.now_elementAtt[3]=0
        obj.now_elementAtt[4]=0
        obj.now_elementAtt[5]=0
        obj.now_elementAtt[6]=0

        obj.now_elementDef[1]=0
        obj.now_elementDef[2]=0
        obj.now_elementDef[3]=0
        obj.now_elementDef[4]=0
        obj.now_elementDef[5]= 0
        obj.now_elementDef[6]= 0


        obj._shield = obj._shieldMax

        local skill_temp = string.split(obj.npc_skill,",")


        --skill_temp = string.split(obj.Skills,",")

        obj.skill_list = List.new()
        obj.skill_cd = List.new()

        for i=1,#skill_temp do
            if tonumber(skill_temp[i]) ~= 0 then
                List.pushlast(obj.skill_list,Skill.new(tonumber(skill_temp[i]),1))
                List.pushlast(obj.skill_cd,0) --nowSkill.cd
            end
        end
        --table.print(obj.skill_list)
    end

    --obj.model_id = 38
    obj:reSetActionDir()
    
    obj:initSpine(obj.model_id,obj.scale)

    --obj._spine:setVisible(false)


    obj:UpDateResist(obj.Status_Control)

    obj._fallTime = obj.Lay_Time/1000

    obj.x=x obj.y=GameManager.getGroundY(x)

    --obj:setPosition(cc.p(x,y))

    
    
    obj.allground = m_gameScene.all_boundingBoxs
    obj.allground_box = {};

    for i=1,List.getSize(m_gameScene.all_boundingBoxs_big) do
        local temp={}
        copyTable(m_gameScene.all_boundingBoxs_big[i],temp)
        table.insert(obj.allground_box,temp)
    end

    cclog("monster.counterSkill = %d ",obj.Counter_Skill)
    obj.Counter_Skill_Index = obj:getSkillIndex(obj.Counter_Skill)

    obj.AIAction = {}

    table.insert(obj.AIAction,AI.typeList[AI.funtionName.randomRun])
    table.insert(obj.AIAction,AI.typeList[AI.funtionName.sws_hitWhenStun])
    table.insert(obj.AIAction,AI.typeList[AI.funtionName.monster_Attack])




    obj.AIActionValue = {}
    table.insert(obj.AIActionValue,1000)
    table.insert(obj.AIActionValue,3)
    table.insert(obj.AIActionValue,3)
   
    obj._is_boss = true
    obj._AIEnabled = false
    needName = 1 
    return obj
end



function TreeActor:reSetActionDir()
    GroupIndex = 1
    LastGroupIndex = 1
    self._actions.stand = "A1" --待机
    self._actions.hit = "F1" --受击2
    self._actions.hit2 = "F1" --受击1
    self._actions.fly="F1" --浮空攻击第一下
    self._actions.laydown="F1"  --倒地
    self._actions.standup="I1"
end

function TreeActor:UpdateActionGroud()
    local hp_percent = mathFloor(self._hp/self._hp_max *100)
    local nowIndex = 1 
    
    if hp_percent >80 then nowIndex = 1 
    elseif hp_percent >60 then nowIndex = 2 
    elseif hp_percent >40 then nowIndex = 3
    elseif hp_percent >20 then nowIndex = 4
    elseif hp_percent >0  then nowIndex = 5
    elseif hp_percent <=0  then nowIndex = 6
    end
    
    if GroupIndex ~= nowIndex then
        LastGroupIndex = GroupIndex
        GroupIndex =  nowIndex
        
        
        local SA = "A"..nowIndex
        local SU = "I"..math.min(6,nowIndex)-1
        self._actions.stand = SA
        self._actions.standup = SU
        
        if nowIndex <= 5 then
            local HA = "F"..math.min(5,nowIndex)
            self._actions.hit = HA
            self._actions.hit2 = HA
            self._actions.fly = HA
            self._actions.laydown = HA
        end
        
        self:SetSate(EnumStateType.stand,true)
    end
    
end

function TreeActor:initSpine(m_id,m_scale)
    self.Buff_List ={}

    if self._actor_type == 1 then
        local rolePath = "Spine/ROLE_"..m_id
        local atlasPath = "Spine/ROLE_"..m_id.."_01"
        self._spine = CreateSpineRes(rolePath,atlasPath)
    else 
        self._spine = CreatePreloadSpine(m_id)
    end

    local now_scale = 1
    if m_scale and m_scale~= 100 then now_scale = m_scale/100 self._spine:setScale(now_scale) end 

   
    self._spine:registerSpineEventHandler(function (event)
        self:spine_ActionComplete(event)
    end, sp.EventType.ANIMATION_COMPLETE)

    self._spine:registerSpineEventHandler(function (event)
        self:spine_ActionStartEvent(event)
    end, sp.EventType.ANIMATION_START)

    self._spine:registerSpineEventHandler(function (event)
        self:spine_ActionSpecialEvent(event)
    end, sp.EventType.ANIMATION_EVENT)


    self._gamescene.bg_foreground:addChild(self._spine,res_gameLayer.LAYER_PLAYER1)



    if ISDEBUG and ISDEBUG == 3 then
        self.draw = cc.DrawNode:create()
        self:addChild(self.draw,10)
    end
    
    

    self.collideRect = {}

    self.collideRect[1] = cc.rect(0,0,2,2)
    self.collideRect[2] = cc.rect(0,0,2,2)


    self:playAnimation(self._actions.stand, true)

    self._Blood_1 = CreateSpineRes("effect/E_gu_1")
    self._Blood_2 = CreateSpineRes("effect/E_gu_2")

    self._gamescene.bg_foreground:addChild(self._Blood_1,res_gameLayer.LAYER_HITEFFECT)
    self._gamescene.bg_foreground:addChild(self._Blood_2,res_gameLayer.LAYER_HITEFFECT)

    self._Blood_1:setVisible(false)
    self._Blood_2:setVisible(false)

    --    if ISDEBUG and ISDEBUG ==true then
    --        
    --    end

    self._Blood_1:registerSpineEventHandler(function (event)
        self._Blood_1:setVisible(false)
    end, sp.EventType.ANIMATION_COMPLETE)

    self._Blood_2:registerSpineEventHandler(function (event)
        self._Blood_2:setVisible(false)
    end, sp.EventType.ANIMATION_COMPLETE)


    local offsetY=Random(-5,5)


    local dd=0

    self.allground = GameManager.battleScenes.all_boundingBoxs

end

function TreeActor:playAnimation(name, loop)

    --self.role_effect:setVisible(true)
    
    --string.format("%",...) 
    --self._spine:setToSetupPose()
    
    self._spine:setAnimation(0,name, loop)

    cclog(("Action is "..name))

    self._curAnimation = name

end

function TreeActor:updateBox(object)


     local self_collideRect = self.collideRect
    local self_hitEffectRect = self.hitEffectRect


    local xx = self._spine:getBoundingBoxBySlot("box")
    local xx2 = self._spine:getBoundingBoxBySlot("box")

    local xx3 = self._spine:getBoundingBoxBySlot("box")

    local _facing = self._curFacing

    local nowX_1 = xx.x
    local nowX_2 = xx2.x
    local nowX_3 = xx3.x



    local box01 = self_collideRect[1]
    local box01temp =self_collideRect[1].tempBox
    local box02 = self_collideRect[2]
    local box02temp =self_collideRect[2].tempBox
    local box03 = self_hitEffectRect

    box01.x = xx.x
    box01.y = xx.y
    box01.width = xx.width
    box01.height = xx.height




    box02.x = xx2.x
    box02.y = xx2.y
    box02.width = xx2.width
    box02.height = xx2.height



    box03.x = nowX_3+self.x
    box03.y = xx3.y+self.y
    box03.width = xx3.width
    box03.height = xx3.height


    
    --local xx3 = self._spine:getBoundingBoxBySlot("ATK")
    --self.m_CollitionBox = self_collideRect[1].tempBox
    --self.m_CollitionBox = self._spine:getBoundingBox()
end
function TreeActor:UpDateState(dt)  

    local self_ActorState = self._ActorState
    self:downStop(dt)

    self:shieldRecovery(dt, self._request_hard_time)



    if self_ActorState == EnumStateType.stand then
        self:moveTo(dt)
        if self._actionComplete == true and self._canChangeState == false then
            self.waitActionEnd = self.waitActionEnd + 1
            if  self.waitActionEnd == 2 then
                self.waitActionEnd = 0
                self._canChangeState=true
            end
        end
    elseif self._ActorState == EnumStateType.readytodie then
        if self._actionComplete == true then
            self._actionComplete=false
            self._canChangeState=true
            self._request_hard_time=0
            self._isInvincible=false
            self.hit_id=0  --重置攻击ID
            self:SetSate(EnumStateType.couch,false)
           
        end
    elseif self_ActorState == EnumStateType.dead then
        if self._actionComplete == true then --硬直完变状态
            self._actionComplete=false
            self._canChangeState=true
            self._request_hard_time=0
            self.hit_id=0  --重置攻击ID
            self:SetSate(EnumStateType.Bossdead,true)
        end
    elseif self_ActorState == EnumStateType.freeze then
        self:moveTo(dt)
    elseif self_ActorState == EnumStateType.run then
        self:setMoveTo(cc.p(-1,-10))
        self:moveTo(dt)
        self.x = self.x + self:AddSpeed(self.speed_x)


    elseif self_ActorState == EnumStateType.minor_injured then
        self:moveTo(dt)
        self._hard_time = self._hard_time+dt

        if self._actionComplete == true and self._hard_time > self._request_hard_time then --硬直完变状态
            self._actionComplete=false
            self._canChangeState=true
            self._request_hard_time=0
            self.hit_id=0  --重置攻击ID
            self:SetSate(EnumStateType.stand,false)
        end
    elseif self_ActorState == EnumStateType.serious_injured then
        self:moveTo(dt)
        self._hard_time = self._hard_time+dt

        if self._actionComplete == true and self._hard_time > self._request_hard_time then --硬直完变状态
            self._actionComplete=false
            self._canChangeState=true
            self._request_hard_time=0
            self.hit_id=0  --重置攻击ID
            self:SetSate(EnumStateType.stand,false)
        end
    elseif self_ActorState == EnumStateType.breakShield then
        self:moveTo(dt)
        self._hard_time = self._hard_time+dt


        if self._actionComplete == true and self._hard_time > self._request_hard_time then
            self._actionComplete=false
            self._canChangeState=true
            self._request_hard_time=0
            self.hit_id=0  --重置攻击ID
            self:SetSate(EnumStateType.stand,false)
        end
    elseif self_ActorState == EnumStateType.inair then   --在浮空状态中
        self:moveTo(dt)

        if self._isHitTheGround == true then
            self._actionComplete=false
            self._canChangeState=true
            self._request_hard_time=0
            self.hit_id=0  --重置攻击ID
            self:SetSate(EnumStateType.couch,false)
        end

    elseif self_ActorState == EnumStateType.knockout then
        self:moveTo(dt)

        if  self._isHitTheGround == true then
            self._canChangeState=true
            self._request_hard_time=0
            self.hit_id=0  --重置攻击ID
            self:SetSate(EnumStateType.couch,false)
        end
    elseif self_ActorState == EnumStateType.stun then
        self:moveTo(dt)
        if self.buffEffectStun ~= nil then
            local tempBox = self.collideRect[1]
            local headY = tempBox.y + tempBox.height 
            self.buffEffectStun:setPositionY(headY+20)
        end


    elseif self_ActorState == EnumStateType.knockback then
        self:moveTo(dt)
        self._hard_time = self._hard_time+dt

        if self._actionComplete == true and self._hard_time > self._request_hard_time then --硬直完变状态
            self._actionComplete=false
            self._canChangeState=true
            self._request_hard_time=0
            self:SetSate(EnumStateType.stand,false)
        end

    elseif self_ActorState == EnumStateType.couch then
        self:moveTo(dt)
        self._fallTime = self._fallTime - dt

        if self._fallTime <= 0 then

            if self._hp >0 then
                self._isInvincible=false

                self._actionComplete=false
                self._canChangeState=true

                if Random(1,100) <= 50 then
                    self.AttTime = 10
                end
                self:setMoveTo(cc.p(-1,-1))
                self:SetSate(EnumStateType.stand,false)
            else
                self._actionComplete=false
                self._canChangeState=true
                self:SetSate(EnumStateType.dead,false)
                self._isInvincible=true
            end

        end

    end

end
function TreeActor:spine_ActionStartEvent(event)
    --print(string.format("[spine] %s complete: %d", event.animation,event.loopCount))
    self._actionComplete = false
    self.shouldCheckHit=false
    self._skill_hit_step = 0
    self.skillchange=false
    self.need_Bullet_Assign=false
    --self._spine:setToSetupPose()
end
function TreeActor:spine_ActionComplete(event)
    --print(string.format("[spine] %s complete: %d", event.animation,event.loopCount))
    
    self._actionComplete = true
end
local tt_x =0
local tt_y =0 


function TreeActor:addDelayDrop(m_time)
    local AddFalseDrop
    local DelayDrop 
    local allCount = m_time
    
    function AddFalseDrop()
        local tempQty = Random(1,200)
        local tempOffset = Random(-700,700)
        GameManager.addFalseDropItem(true,3,tempQty,tt_x,tt_y+100,tempOffset,1)
    end
    
    function DelayDrop()
        allCount = allCount - 1
        AddFalseDrop()
        if allCount > 0 then
            self._spine:runAction(cc.Sequence:create(cc.DelayTime:create(0.02),cc.CallFunc:create(DelayDrop)))
        end
    end
    
    DelayDrop()
end
function TreeActor:SetSate(m_state,forceChange,m_airForce)


    if m_state == self._ActorState then   --判断是否可以重复调用同一状态

        if m_state == EnumStateType.run or m_state == EnumStateType.stand or m_state == EnumStateType.roll then return end

    end

    if m_state >= EnumStateType.skill_1 then
        if self._request_hard_time ~= 0 or self._ActorState == EnumStateType.couch or self._ActorState == EnumStateType.inair --防止在硬直存在，倒下及浮空，死亡的时候切换技能或滚动状态
            or self._ActorState == EnumStateType.dead or self._ActorState == EnumStateType.stun or  self._ActorState == EnumStateType.freeze then
            return
        end
    end
    
    
    if m_state >= EnumStateType.minor_injured and m_state <= EnumStateType.serious_injured then
        tt_x = self.x
        tt_y = self.y
        local allcount = Random(4,10)
        self:addDelayDrop(allcount)
        self:UpdateActionGroud()
        
        if LastGroupIndex ~= GroupIndex then
            self._canChangeState = true
            m_state = EnumStateType.stand
        end
        if self._canChangeState == false then
            return
        end
    end


    if self._canChangeState == true or forceChange == true then


        if self._LastState == EnumStateType.couch then self._isInvincible=false end --以防鞭尸状态无切换

        if m_state ~= EnumStateType.inair then self.enable_gravity = true end  --以防移动中途被打断不落地

        self._LastState = self._ActorState
        self._ActorState = m_state



        if m_state ~= EnumStateType.run then
            self:setMoveTo(cc.p(-10,-10))

        end
        
        self:UpdateActionGroud()

    else
        return
    end


    if m_state == EnumStateType.stand then
        --GameManager.ZoomReset()
        
        if LastGroupIndex ~= GroupIndex then
            
            self._spine:addAnimation(0,self._actions.standup, false)
            cclog("nowIndex = %d leaf lost Action add  = %s",GroupIndex,self._actions.standup)
            self._spine:addAnimation(0,self._actions.stand, true)
            cclog("nowIndex = %d stand action  = %s",GroupIndex,self._actions.stand)
            LastGroupIndex = GroupIndex
            self._canChangeState=false
        else
            self._canChangeState=true
            cclog("nowIndex = %d stand action  = %s",GroupIndex,self._actions.stand)
            self:playAnimation(self._actions.stand,true)
        end

        
    elseif self._ActorState == EnumStateType.readytodie then
        self._actionComplete = true
        self._canChangeState=false
    elseif m_state == EnumStateType.dead then
        greyNode(self._spine)
        self._actionComplete = true
        self._canChangeState=false
        self:playAnimation(self._actions.stand,false)
        --self:SetSate(EnumStateType.stand,true,1)
    elseif m_state == EnumStateType.Bossdead then
        GameEventManager.SetBossWaveComplete()

    elseif m_state == EnumStateType.run then

        self:setMoveTo(cc.p(-1,-10)) --跑动中取消X位移

        --        self.role_effect:setAnimation(0,"B", true)
        --        self.role_effect:setVisible(true)


        self:playAnimation(self._actions.run,true)
        self._canChangeState=true

    elseif m_state == EnumStateType.minor_injured then

        self._hard_time=0
        self:playAnimation(self._actions.hit2,false)
        self._canChangeState=false

    elseif m_state == EnumStateType.serious_injured then

        self._hard_time=0
        self:playAnimation(self._actions.hit2,false) 
        self._canChangeState=false
    elseif m_state == EnumStateType.breakShield then
        self:setMoveTo(cc.p(self.x-30*self._curFacing,-1))
       

        self._hard_time=0
        self:playAnimation(self._actions.hit2,false)
        self._canChangeState=false 
    elseif m_state == EnumStateType.stun then
        self._hard_time=0
        self._stunTime = 2 
        self:playAnimation(self._actions.stun,true)
        self._canChangeState=false
    elseif m_state == EnumStateType.freeze then
        self._hard_time=0
        self._spine:pause()
        self._canChangeState=false

    elseif m_state == EnumStateType.knockback then

        if self.resist_list.knockback == 0 and self.all_resist == false then   
            self:setMoveTo(cc.p(self.x-m_airForce*self._curFacing,-1),8)
        end
        self._hard_time=0
        self:playAnimation(self._actions.beijifei,false)
        self._canChangeState=false 

    elseif m_state == EnumStateType.inair then    --浮空攻击
        self._isHitTheGround=false
        self:setMoveTo(cc.p(-1,self.y+m_airForce),8)

        self:playAnimation(self._actions.fly,false)
        self._canChangeState=false

    elseif m_state == EnumStateType.knockout then  --被击飞
        self._isHitTheGround=false

        if self.resist_list.knockout == 0 and self.all_resist == false then 
            self:setMoveTo(cc.p(-1,self.y+50))
            self:setMoveTo(cc.p(self.x-m_airForce*self._curFacing,-10),8) 
        end


        self:playAnimation(self._actions.fly,false)

        self._ActorState=EnumStateType.inair

        self._canChangeState=false

    elseif m_state == EnumStateType.skill_1 then  --技能1
        self:setSkillAction(1)
    elseif m_state == EnumStateType.skill_2 then
        self:setSkillAction(2)

    elseif m_state == EnumStateType.skill_3 then
        self:setSkillAction(3)
    elseif m_state == EnumStateType.skill_4 then
        self:setSkillAction(4)
    elseif m_state == EnumStateType.skill_5 then
        self:setSkillAction(5)
    elseif m_state == EnumStateType.skill_6 then
        self:setSkillAction(6)
    elseif m_state == EnumStateType.skill_7 then
        self:setSkillAction(7)
    elseif m_state == EnumStateType.skill_8 then
        self:setSkillAction(8)
    elseif m_state == EnumStateType.skill_9 then
        self:setSkillAction(9)
    elseif m_state == EnumStateType.couch then

        self._fallTime = self.Lay_Time/1000
        self._canChangeState=false
        --self:resetHitid()
        
        --self:playAnimation(self._actions.standup,false)
    end
end
function TreeActor:setFacing(obj)
    

end

function TreeActor:setFacingLR(dir)
    
end
function TreeActor:requestBreak(m_time)
    self._spine:pause()
   
    self._break_time = 0
    self._request_break_time = m_time
end

function TreeActor:Pause()
    self.isPause = true
    self._spine:pause()
   


end
function TreeActor:delete() --删除共有指针


    self.role_test=nil
    self._target=nil
    self._gamescene = nil
    self:resetHitid()
    List.removeAll(self.skill_list)
    List.removeAll(self.skill_cd)
    if self.normal_att_list~= nil then List.removeAll(self.normal_att_list) end
    self.normal_att_list=nil
    self.skill_list=nil
    self.skill_cd=nil
    self._spine:removeFromParent()
    self._spine = nil
    self._Blood_1:removeFromParent()
    self._Blood_2:removeFromParent()

    self._Blood_1 = nil
    self._Blood_2 = nil
   

    GameManager.delShadow(self._actor_id)
end
function TreeActor:resume()
    self.isPause = false
    self._spine:resume()

   
end
function TreeActor:baseUpdate(dt)
    if  needName < 5 then
        needName = needName + 1
    elseif needName == 5 then
        local selfObj = self
        GameManager.updateEnemyName(selfObj.actor_name,selfObj)
        needName = needName +1
    end
   
    self:UpdateActionGroud()
    
    if self.isPause == false then

        if self._break_time >= self._request_break_time then
            self:updateBuff(dt)
            self:UpDateState(dt)
            self:UpdateGravity()
            self:updateBox(self)

            if  self._request_break_time ~= 0 and self._break_time ~=0 then
                self._break_time = 0
                self._request_break_time = 0
                if self._ActorState ~= EnumStateType.freeze then
                    self._spine:resume()

                end
            end

        elseif self._break_time < self._request_break_time then
            self._break_time = self._break_time + dt

        end


        if self.light_count > 0 then
            self.light_count = self.light_count - 1
            if self.light_count == 0 then self:resetShine() end
        end





        local oX = self.x
        local oY = self.y + self._gamescene.offset_y + self.actor_y_offset
        local bX = rectGetMidX(self.collideRect[1])
        local bY = rectGetMidY(self.collideRect[1]) + self._gamescene.offset_y + self.actor_y_offset

        self._spine:setPosition(oX,oY)
        self._Blood_1:setPosition(bX,bY)
        self._Blood_2:setPosition(bX,bY)





        if self._AIEnabled == true then



            self:UpDateAI(dt,self._target[1])


        end

       

        self._gamescene.nowShadowList[self._actor_id]:setXY(self.x,self.ground_y)
        --self:setShadowXY(self.x,self.ground_y,self._actor_id)
        --GameManager.setShadowXY(self.x,self.ground_y,self._actor_id)



    end
    if ISDEBUG and ISDEBUG == 3 then
        --local box_draw= self.m_CollitionBox
        self.draw:clear()

        for key, var in pairs(self.collideRect) do
            local box_draw = cc.rect(var.x,var.y,var.width,var.height)

            local vertices3={}
            local dir=1
            if dir >0 then vertices3 = { cc.p(box_draw.x,box_draw.y), cc.p(box_draw.x,box_draw.y+box_draw.height), cc.p(box_draw.x+box_draw.width,box_draw.y+box_draw.height), cc.p(box_draw.x+box_draw.width,box_draw.y) }
            else
                vertices3 = { cc.p((box_draw.x+box_draw.width)*-1,box_draw.y), cc.p((box_draw.x+box_draw.width)*-1,box_draw.y+box_draw.height), cc.p((box_draw.x+box_draw.width)*-1+box_draw.width,box_draw.y+box_draw.height), cc.p((box_draw.x+box_draw.width)*-1+box_draw.width,box_draw.y) }
            end
            self.draw:drawSolidPoly( vertices3, 4, cc.c4f(0,0,1,0.3) )
        end

        if self._actor_type == 1 or self._actor_type == 2 then
            local box_draw = cc.rect(self.m_CollitionBox.x,self.m_CollitionBox.y,self.m_CollitionBox.width,self.m_CollitionBox.height)

            local vertices3={}
            local dir=1
            if dir >0 then vertices3 = { cc.p(box_draw.x,box_draw.y), cc.p(box_draw.x,box_draw.y+box_draw.height), cc.p(box_draw.x+box_draw.width,box_draw.y+box_draw.height), cc.p(box_draw.x+box_draw.width,box_draw.y) }
            else
                vertices3 = { cc.p((box_draw.x+box_draw.width)*-1,box_draw.y), cc.p((box_draw.x+box_draw.width)*-1,box_draw.y+box_draw.height), cc.p((box_draw.x+box_draw.width)*-1+box_draw.width,box_draw.y+box_draw.height), cc.p((box_draw.x+box_draw.width)*-1+box_draw.width,box_draw.y) }
            end
            self.draw:drawSolidPoly( vertices3, 4, cc.c4f(1,0,0,0.3) )
        end

    end

end

function TreeActor:setShine()
--    self.light_count = 15
--    lightNode(self._spine,false)
end

function TreeActor:resetShine()
--    self.light_count = 0
--    defaultNode(self._spine,false)
end