
LoadingScene = {}

LoadingScene = class("LoadingScene",function()
    return cc.Scene:create()
end)

LoadingScene.nextScene=nil

function LoadingScene:ctor()
    self.visibleSize = cc.Director:getInstance():getVisibleSize()
    self.origin = cc.Director:getInstance():getVisibleOrigin()
    
    local function onNodeEvent(event)
        if event == "enter" then
            self:onEnter()
        elseif event=="exit" then
            self:onExit()
        end
    end

    self:registerScriptHandler(onNodeEvent)
end

function LoadingScene:onEnter()
	cclog("Loading Scene onEnter")
end

function LoadingScene:onExit()
    self:removeAllChildren()
    cc.Director:getInstance():getTextureCache():removeUnusedTextures()
end

function LoadingScene.setNextScene(target)
    LoadingScene.nextScene=target
end

str_systring = enum{
	"STRING_LOADING_RESOURCE=1",
	"STRING_LOADING_UPGRADE",
	"STRING_AREA",
	"STRING_SERVER_NO_CONNECT",
	"STRING_SERVER_MAINTAIN",
    "STRING_GAME_EXIT",
    "STRING_INPUT_EMPYT_ERROR",
    "STRING_INPUT_PASSWARD_ERROR",
    "STRING_INPUT_LOGIN_ERROR",
    "STRING_REGISTER_ERROR",
    "STRING_INPUT_KEYWORD_ERROR",
    "STRING_GAMEEXIT",
}

function LoadingScene.GetSysString(key)
	local systemString = LoadingScene.systemString
	if not systemString then
		local filedata = GameDataReader.readFromAppFile("systring")
		systemString = string.split(filedata,"\r\n")
		LoadingScene.systemString=systemString
	end
	return systemString[key] or "Nil"
end

function LoadingScene.create()

    local scene = LoadingScene.new()

	local layerFarm,loadingItem = scene.createUpgradeLayer()
	
    scene:addChild(layerFarm,0,1)

    local loading_percent=0
    loadingItem:setPercent(loading_percent)
    
    local function update(delta)
        loading_percent = loading_percent + 2        
        loadingItem:setPercent(math.min(100,loading_percent))        
        if loading_percent > 100 and cc.Director:getInstance():getRunningScene() then
            if LoadingScene.nextScene then
				NowSceneTransition(LoadingScene.nextScene) LoadingScene.setNextScene()
            end
        end
    end

    scene:scheduleUpdateWithPriorityLua(update,1)

    return scene
end

function LoadingScene.createUpgradeLayer()

	local layerFarm = cc.Layer:create()

    local rootNode = cc.CSLoader:createNode("Loading.csb")
    layerFarm:addChild(rootNode)

	local loadingBar = rootNode:getChildByTag(1)
    local loadingItem = loadingBar:getChildByTag(2)

	return layerFarm,loadingItem
end
