Bullet = class ("Bullet") 

BulletMoveType = {
    "straight",  --直线
    "Fixed",     --定点  
    "Parabola",  --抛物线
    "once",  --一次性特殊效果& --刀光特效型子弹
}
BulletMoveType = CreateEnumTable(BulletMoveType,0)

BulletCollionType = {
    "Consumption", --命中消失
    "penetrate",    --穿透
    "Push", --推动
    "Effect",  --刀光特效型子弹   
}
BulletCollionType = CreateEnumTable(BulletCollionType,0)

function Bullet:ctor()

    self._spine_bullet=nil   --继承基本属性
   
end

local mathabs = math.abs
local mathMax = math.max
local mathMin = math.min
local mathFloor = math.floor
local mathFloor = math.floor
local mathCeil = math.ceil
local AWBD = GameManager.addWorldBossDamage
local rectGetMidX = cc.rectGetMidX
local rectGetMidY = cc.rectGetMidY
local mRandom = Random
local rectIntersectsRect =  cc.rectIntersectsRect
local ccpAdd = cc.pAdd

function Bullet.creat(mm_x,mm_y,dir,m_id,m_target,m_ground,m_skill,m_shooter,m_hit_step,targetLayer,zorder,fixDamage)
    local base = Bullet.new()

    copyTable(BulletValue,base)
    local b_id=tonumber(m_id)
    local tempBulletData = GameData_List.Game_Bullet[b_id] --GameDataTransfer.GetGameBullet(b_id)
    copyTable(tempBulletData,base)
    
    local nowLv = 1
    --if m_shooter.weaponLv and m_shooter.weaponLv>0 then nowLv = m_shooter.weaponLv end
--    if m_skill.skill_level and  m_skill.skill_level >0 then 
--        --nowLv =  m_skill.skill_level
--        local maxLv = #GameDataTransfer.GetBulletValueDataList(b_id)
--        
--        if m_skill.skill_level <= maxLv then
--            nowLv = m_skill.skill_level
--        else
--            nowLv = maxLv
--        end
--        
--    end
    
    local LvData = GameDataTransfer.GetBulletValue(b_id,nowLv)
    
    copyTable(LvData,base)
    
    base.ExtraDamage = LvData.Attack2
    base.SkillDamageRate = LvData.Attack_rate
    base.BuffId =  base.BUFF_ID  --获取BUFF id
    base.BuffRate = LvData.Buff_rate --获取BUFF 几率
    base.PauseTime = base.pause
    
    base.interval = base.Hit_Times/1000
    
    if m_skill and m_skill ~= nil then 
        base.nowSkillData = m_skill
        base:setShooter(m_shooter)
        
    end
    
    local now_Path = nil
    
    --local nowElementType = 1
    --if m_shooter.element_type and m_shooter.element_type>0 then nowElementType = m_shooter.element_type end
   
    now_Path= string.format("effect/E_%d_%d",base.Effect_id,base.Element) --矫正远程子弹资源路径
    
    local shouldLoop = true
    if base.Fire_type == BulletMoveType.once then
        shouldLoop = false
    end
    
    GameSound.playGameEffectAttack(base.Sound)
    
    base.checkUpdate = true
    
    base:initPreLoadSpine(now_Path,m_shooter.actor_now_scale,shouldLoop,targetLayer,zorder)
    
    base:setXY(mm_x,mm_y)
    base:setSpeed(base.Speed)
    base:setAngle(base.Degree)
    base:setFacing(dir)
    base:setTarget(m_target)
   
    base:setGround(m_ground)
    
    if base.Life_Time ~= 0 then
        base.Life_Time = base.Life_Time/1000
    end
    
    if fixDamage and fixDamage > 0 then
        base.fixDamage = fixDamage/100
    end

    
    return base
end

function Bullet.creatEffect(mm_x,mm_y,effect_path,targetLayer,zorder)
    local base = Bullet.new()

    copyTable(BulletValue,base)
   
   
    base.is_hit_effect = true
    base.checkUpdate = false
    base:initPreLoadSpine(effect_path,1,false,targetLayer,zorder)
    
    base:setXY(mm_x,mm_y)
    base.Fire_type = BulletMoveType.once
    --p.SkeletonAnimation:setTimeScale(scale)
    


    return base
end

function Bullet.creatEffect_csb(mm_x,mm_y,effect_path,dir,shouldRotate,targetLayer,zorder)
    local base = Bullet.new()

    copyTable(BulletValue,base)



    base:initPreLoadSpine(effect_path,1,false,targetLayer,zorder)
    
    base._spine_bullet:setScaleX(dir*base.actor_now_scale)
    base.effect_dir = dir
    base.path = effect_path
    
    base.is_hit_effect = true
    base.checkUpdate = false
    
    base.is_not_rotate = false
    
    if shouldRotate == false then 
        base.is_not_rotate = true
    end
    
    --base._spine_bullet:setTimeScale(0.5)
    base:setXY(mm_x,mm_y)
    base.Fire_type = BulletMoveType.once



    return base
end

function Bullet:initPreLoadSpine(m_path,m_scale,loop,targetLayer,zorder)
    local settingScale = 1
    if self.Scale ~= nil then settingScale = self.Scale*0.01 end
    self._spine_bullet = CreateSpineRes(m_path,nil,m_scale*settingScale)
    self.actor_now_scale = m_scale*settingScale
    self.updateType = 0
    
    targetLayer:addChild(self._spine_bullet,zorder)
    
    if m_path == "effect/cutback" then
        GameManager.ForegoundShow(false)
    end
    
    local nowType = self.Hit_type
    
    --self._spine_bullet:setToSetupPose()
    self._spine_bullet:setAnimation(0,"animation", loop)
    local isInBullet = false
    
    local function actionDone(event)
       
        if loop == false then
            if m_path == "effect/cutback" or  m_path == "effect/cutback3" then
                GameManager.ForegoundShow(true)
                nowPlayer[1]:showShadowMode(false)
           end
           self.isDead=true
           
--           if self.warning_tips_end == true then
--                GameManager.BossShowContinue()
--           end
            if m_path == "effect/BossTip" then
                GameManager.ResumeGame()
                GameManager.BossShowUpEnd()
            end 
       end
        
    end
    
    self._spine_bullet:registerSpineEventHandler(function (event)
        
        actionDone(event)
    end, sp.EventType.ANIMATION_COMPLETE)
    --self.draw = cc.DrawNode:create()
    --self:addChild(self.draw,10)
end

function Bullet:initSpine(m_path)
    --self._spine_bullet = sp.SkeletonAnimation:create(Enum_Actor[m_id]..".json", Enum_Actor[m_id]..".atlas", 1)
    self._spine_bullet = cc.CSLoader:createNode(m_path)
    self.tl = cc.CSLoader:createTimeline(m_path)
    
    self.updateType = 1
    
--    local function actionDone()
--        
--        self.isDead=true
--    end
    
    
    --local m_action = cc.Sequence:create(tl,cc.CallFunc:creat(actionDone))
--    self._spine_bullet:registerSpineEventHandler(function (event)
--        self:spine_ActionSpecialEvent(event)
--    end, sp.EventType.ANIMATION_EVENT)
    
    --self:addChild(self._spine_bullet)
    
    self._spine_bullet:runAction(self.tl)
    self.tl:gotoFrameAndPlay(0,false)
    
    
    --self._spine_bullet:setAnimation(0,"dao", true)
    --self.draw = cc.DrawNode:create()
    --self:addChild(self.draw,10)
end

--function Bullet:spine_ActionSpecialEvent(event)
--    
--    if event.eventData.name == "hit" then
--        
--    elseif event.eventData.name == "hit_end" then
--       
--    elseif event.eventData.name == "can_change" then
--        
--    end
--
--
--end


function Bullet:Pause()
    self.isPause = true
    self._spine_bullet:pause()
   
end

function Bullet:resume()
    self.isPause = false
    self._spine_bullet:resume()


end

function Bullet:baseUpdate(dt)
    if self.isPause == true then return end
    
    if self.checkUpdate == true then
        if self.BulletShow == true then
            --self:setSquarePoint()
            self.BulletShow = false
        end
        
        self:moveUpdate(dt)
        
        if self.Life_Time > 0 then
            if self.pass_time < self.Life_Time then
                self.pass_time = self.pass_time + dt
            else
                self.isDead=true
            end
        end
        
        if self.Life_Distance > 0 then
            if self.live_distance > self.Life_Distance then
                self.isDead=true
            end
        end
    end
    
    
    
    self._float_count = self._float_count + 1 
    
    self._spine_bullet:setPosition({x = self.x,y = self.y})

    --if (self.x < G.activearea.left-100 or self.x >G.activearea.right+100) or (self.y < -100 or self.y >920) then self.isDead=true end
    
--    if self.updateType == 1 and self.tl:isPlaying() == false then
--        self.isDead=true
--    end
    
    
    if self.is_hit_effect == true then 
        local temp = -45 * self.effect_dir
        if self.is_not_rotate == false then
            --self._spine_bullet:setRotation(temp)
            --self._spine_bullet:setRotation(temp + self._float_count * self.effect_dir*8)  --+ self._float_count * self.effect_dir*5
        end
    end
    
    
    
--    self.draw:clear()
--    
--    local box_tl,box_tr,box_bl,box_br
--    local dir=self.dir
--    
--    box_tl,box_tr,box_bl,box_br = self:getSquarePoint(cc.p(0,0))
--   
--    local vertices3={}
--    
--    if  dir == 1 then
--        vertices3 = {box_bl,box_tl,box_tr,box_br}
--    elseif dir == -1 then
--        vertices3 = {cc.p(box_br.x*-1,box_br.y),cc.p(box_tr.x*-1,box_tr.y),cc.p(box_tl.x*-1,box_tl.y),cc.p(box_bl.x*-1,box_bl.y)}
--    end
--    
--    self.draw:drawSolidPoly( vertices3, 4, cc.c4f(0,0,1,0.3))
end

function Bullet:setXY(m_x,m_y)
    self.x = m_x
    self.y = m_y
    
    self._spine_bullet:setPositionX(m_x)
    self._spine_bullet:setPositionY(m_y)
   
end

function Bullet:setAngle(m_angle)
    self.angle=m_angle
    self._spine_bullet:setRotation(-1*m_angle)
    self:setSquarePoint()
end

function Bullet:setSpeed(m_Speed)
    self.speed=m_Speed
end

function Bullet:setFacing(m_LR)
    self.dir = m_LR 
    self._spine_bullet:setScaleX(self.dir*self.actor_now_scale)
end

function Bullet:flipX()
    self.dir=-1*self.dir
    self._spine_bullet:setScaleX(self.dir*self.actor_now_scale)
end



function Bullet:delete()
    self._spine_bullet:removeFromParent()
    self._spine_bullet=nil
    self.target=nil
    self.ground=nil
end

function Bullet:setTarget(m_target)
    self.target = m_target
end 

function Bullet:setShooter(m_Shooter)
    self.Shooter = m_Shooter
    self.Attack = m_Shooter.Attack
    self.break_ = m_Shooter.break_
    self.attUp = m_Shooter.attUp
    self.attDown = m_Shooter.attDown
    self.level = m_Shooter.level
    self.cri_rate =  m_Shooter.cri_rate
    self.cri_damage =  m_Shooter.cri_damage
    self.cirtEx =  m_Shooter.cirtEx
    self._actor_type = m_Shooter._actor_type
    self.BulletShow = false
end 
function Bullet:setGround(m_ground)
    self.ground=m_ground
end 
function Bullet:updateCamera(x,y)
    self.camera_x=x
    self.camera_y=y
end

function Bullet:setSquarePoint()
    local tempBox = self._spine_bullet:getBoundingBoxBySlot("ATK")
    tempBox.x = tempBox.x - self.x
    tempBox.y = tempBox.y - self.y
    self.point_tl,self.point_tr,self.point_bl,self.point_br = boundingPoint(tempBox,self.dir,self.angle,cc.p(0,0))
    
    
end

function Bullet:getSquarePoint(m_positon)
    return ccpAdd(m_positon,self.point_tl),ccpAdd(m_positon,self.point_tr),ccpAdd(m_positon,self.point_bl),ccpAdd(m_positon,self.point_br)
end



function Bullet:moveUpdate(dt)
    local shouldHit = false 
    if self._break_time >= self._request_break_time then

        if self.interval >0 then 
            if self.now_interval < self.interval then
                if self.now_interval == 0  then
                    shouldHit = true
                    self.bullet_hit_step = 1
                end
                self.now_interval = self.now_interval + dt
            elseif self.now_interval >= self.interval then
                self.now_interval = dt
                shouldHit=true
                self.bullet_hit_step = self.bullet_hit_step + 1
            end
        else

            shouldHit = true
        end

        if self.Fire_type ==  BulletMoveType.straight then 
            self.x,self.y=self:moveCheckCollionsWithStraight(shouldHit)
        elseif self.Fire_type ==  BulletMoveType.Fixed then

            self:CheckCollionsWithEffect(shouldHit,self.interval)

        elseif self.Fire_type ==  BulletMoveType.Parabola then 
            self.x,self.y=self:moveCheckCollionsWithAngle()
        elseif self.Fire_type == BulletMoveType.once then
            self:CheckCollionsWithEffect(shouldHit,self.interval)
            if self.Shooter and self.Shooter.role_id == 1 then
                local addDis = 20*self.dir*nowFixTimeScale
                self.x = self.x +addDis
            end
        end

        if  self._request_break_time ~= 0 and self._break_time~=0 then
            self._break_time = 0
            self._request_break_time = 0
            self._spine_bullet:resume()
        end
    elseif self._break_time < self._request_break_time then
        self._break_time = self._break_time + dt

    end
end

function Bullet:moveCheckCollionsWithStraight(shouldHit) 
    local addDis = self.speed*self.dir*nowFixTimeScale
    local startPoint=cc.p(self.x,self.y)
    local endPoint=cc.p(self.x+addDis,self.y)
    
    local tempBox = self._spine_bullet:getBoundingBoxBySlot("ATK")
    
    local cs_tl,cs_tr,cs_bl,cs_br = self:getSquarePoint(startPoint)
    local ce_tl,ce_tr,ce_bl,ce_br = self:getSquarePoint(endPoint)
    
    
    local newRect = tempBox
    
    if self.dir == 1 then 
        newRect.width = newRect.width + addDis
    else 
        newRect.x = newRect.x + addDis
        newRect.width = newRect.width + (addDis*self.dir)
    end
    
--    if self.dir == 1 then newRect = cc.rect(cs_bl.x,cs_bl.y,ce_br.x-cs_bl.x,cs_tl.y-cs_bl.y)
--    else newRect = cc.rect(ce_bl.x,ce_bl.y,cs_br.x-ce_bl.x,cs_tl.y-cs_bl.y)  end
    local result=cc.p(endPoint.x,endPoint.y)
    
    
    
    if self.x <= -500 or self.x > 8040 then
        self.isDead=true 
        return result.x,result.y
    end
    
    self.live_distance = self.live_distance + mathabs(self.speed)
    
    local lastIndex = 0
    if self.target and List.getSize(self.target)>0  then
        local addHitEffect = GameManager.addHitEffect
        
        for i=1,List.getSize(self.target) do
            if self.target[i]._isInvincible == false then
                local isIntersects = false
                local m_box = self.target[i].collideRect[1]
                if rectIntersectsRect(newRect,m_box) == true then
                    isIntersects = true
                elseif rectIntersectsRect(newRect,self.target[i].collideRect[2]) == true then
                    m_box = self.target[i].collideRect[2]
                    isIntersects = true
                end
                
                if isIntersects == true and  self._actor_type ~= self.target[i]._actor_type then
                
                    if self.Hit_type == BulletCollionType.Push then
                        local nowEnemy = self.target[i]
                        local moveDis =  nowEnemy:AddSpeed(addDis)
                        if self.dir == 1 then
                            moveDis = mathMax(0,moveDis)
                        else
                            moveDis = mathMin(0,moveDis)
                        end
                        result.x = self.x + moveDis
                     
                        if nowEnemy.resist_list.hitMove == 0 and nowEnemy.isPlayerRole ~= true then
                            nowEnemy.x = nowEnemy.x + moveDis
                            nowEnemy:setMoveTo({x= -1 , y= -10})
                        end
                       
                        if shouldHit == true then
                            self:addDamage(self.target[i],
                                self.DamageType,
                                1,
                                self.ExtraDamage,
                                self.SkillDamageRate,
                                self.nowSkillData.break_power,
                                self.hard_times/1000,
                                self.flight_highs)
                            GameSound.playGameEffectHurt(self.Sound)
                            self:checkCombo(self.Shooter)   
                            addHitEffect(m_box.x+m_box.width/2,m_box.y+m_box.height,self.Element,self.dir)
                        end
                    elseif self.Hit_type == BulletCollionType.penetrate then
                        
                        if shouldHit == true and  self.temp_Hit_list[self.target[i]._actor_id] ~= 1 then
                            self:addDamage(self.target[i],
                                self.DamageType,
                                1,
                                self.ExtraDamage,
                                self.SkillDamageRate,
                                self.nowSkillData.break_power,
                                self.hard_times/1000,
                                self.flight_highs)
                            GameSound.playGameEffectHurt(self.Sound)
                            self:checkCombo(self.Shooter)  
                            addHitEffect(m_box.x+m_box.width/2,m_box.y+m_box.height,self.Element,self.dir)
                            self.temp_Hit_list[self.target[i]._actor_id] = 1
                        end
                    elseif self._actor_type ~= self.target[i]._actor_type then
                        self.live_distance = self.live_distance + mathabs(self.speed)
                        if shouldHit == true then
                            if self.dir == 1 then
                                local offsetCP = cc.p(m_box.x ,result.y)
                                if offsetCP.x <= result.x then
                                    result.x=offsetCP.x
                                    result.y=offsetCP.y
                                    
                                end
                                lastIndex = i
                            else
                                local offsetCP = cc.p(m_box.x,result.y)
                                if offsetCP.x >= result.x then
                                    result.x=offsetCP.x 
                                    result.y=offsetCP.y
                                    
                                end
                                lastIndex = i
                            end
                        end
                    end
                end
            end
        end
    end
    
    if lastIndex > 0 then
        local m_box = self.target[lastIndex].collideRect[1]
        self:addDamage(self.target[lastIndex],
            self.DamageType,
            1,
            self.ExtraDamage,
            self.SkillDamageRate,
            self.nowSkillData.break_power,
            self.hard_times/1000,
            self.flight_highs)
            
        local addHitEffect = GameManager.addHitEffect
        GameSound.playGameEffectHurt(self.Sound)
        self:checkCombo(self.Shooter)          
        addHitEffect(m_box.x+m_box.width/2,m_box.y+m_box.height,self.Element,self.dir)
        self.isDead=true
    end
--    self.draw:clear()
--    
--    local box_tl,box_tr,box_bl,box_br
--    local dir=self.dir
--    
--    box_tl,box_tr,box_bl,box_br = self:getSquarePoint(cc.p(0,0))
--   
--    local vertices3={}
--    
--    if  dir == 1 then
--        vertices3 = {box_bl,box_tl,box_tr,box_br}
--    elseif dir == -1 then
--        vertices3 = {cc.p(box_br.x*-1,box_br.y),cc.p(box_tr.x*-1,box_tr.y),cc.p(box_tl.x*-1,box_tl.y),cc.p(box_bl.x*-1,box_bl.y)}
--    end
--    
--    self.draw:drawSolidPoly( vertices3, 4, cc.c4f(0,0,1,0.3))
    return result.x,result.y,lastIndex
end

function Bullet:checkCombo(m_self)
    if m_self == nil then return end
    if m_self._actor_type == 1 then
        GameManager.setHeroHit()

        local isInCombo = m_self.can_add_combo
        local comboHit = m_self.hit_combo_value

        if isInCombo == false and comboHit == 0 then
            m_self.hit_combo_time = 2 
            m_self.hit_combo_value = 1
        elseif isInCombo == true and comboHit == 1 then 
            m_self.hit_combo_time = 2
            local tempValue = comboHit + 1
            m_self.hit_combo_value = tempValue

            GameManager.showCombo()
            GameManager.changeComboNum(m_self,tempValue )
        elseif isInCombo == true and comboHit >= 2 then
            m_self.hit_combo_time = 2
            local tempValue = comboHit + 1
            m_self.hit_combo_value = tempValue
            GameManager.changeComboNum(m_self,tempValue )
        end

    end
end
function Bullet:moveCheckCollionsWithAngle()

    local startPoint=cc.p(self.x,self.y)
    local endPoint=pointNextPos(startPoint,self.angle,self.speed,self.dir)
    
    local cs_tl,cs_tr,cs_bl,cs_br = self:getSquarePoint(startPoint)
    local ce_tl,ce_tr,ce_bl,ce_br = self:getSquarePoint(endPoint)
    
    
    
    local result=cc.p(endPoint.x,endPoint.y)
    
    if self.target and List.getSize(self.target)>0 then
    
        local isHit,newX,newY,line_id
        
        for i=1,List.getSize(self.target) do
            --local m_box=cc.rect(self.target[i].collideRect.x,self.target[i].collideRect.y,self.target[i].collideRect.width,self.target[i].collideRect.height)
            local m_box=self.target[i]._spine:getBoundingBox()
            m_box.x=m_box.x+self.target[i].x
            m_box.y=m_box.y+self.target[i].y
            
            --cs_tr,ce_tl,cs_br,ce_bl
            isHit,newX,newY,line_id=self:checkWithBox(cs_tl,ce_tr,cs_bl,ce_br,m_box)
            
            if isHit == true then
                --self.isDead=true
                --cclog("touch the target")
                
                local offsetCP=self:getCCP(cc.p(newX,newY),line_id)
                if self.dir == 1 then
                    if offsetCP.x <= result.x then result.x=offsetCP.x  result.y=offsetCP.y end
                else
                    if offsetCP.x >= result.x then result.x=offsetCP.x  result.y=offsetCP.y end
                end
                
            end
        end
        
        
    end
    --cclog("final result.x=%f result.y=%f",result.x,result.y)
    return result.x,result.y
    
end

function Bullet:CheckCollionsWithEffect(isCheckHit,m_Type)
    local hitOnce = false
    if m_Type ~= 0 then
        if isCheckHit == false then 

            for i=1,List.getSize(self.target) do
                local obj = self.target[i]

                if obj.type and obj.type >= 4 then
                elseif self.DamageType == EnumHitType.knockBack and obj._hp > 0 then
                    obj:setFacingLR(self.dir*-1)
                    obj:setMoveTo(cc.p(obj.x-self.flight_highs*obj._curFacing ,-1),8)
                end
            end

            return 
        end
    elseif m_Type == 0 then
        hitOnce = true
    end
    
    local nowTempBox =  self._spine_bullet:getBoundingBoxBySlot("ATK")
    
    -- nowTempBox.x = nowTempBox.x - 1500
    -- nowTempBox.width = nowTempBox.width + 5000
    -- nowTempBox.y = nowTempBox.y - 50
    -- nowTempBox.height = nowTempBox.height + 100

    local addHitEffect = GameManager.addHitEffect
     if self.target and List.getSize(self.target)>0 then

         for i=1,List.getSize(self.target) do
            local nowTarget = self.target[i]
            
            if self._actor_type ~= nowTarget._actor_type  and self.temp_Hit_list[nowTarget._actor_id] ~= 1 then           
                local isHit,_,enemyIndex = self:hitboxCheck(nowTempBox,nowTarget.collideRect)
                
                if isHit == true  then
                    local m_box=nowTarget.collideRect[enemyIndex]

                    self:addDamage(nowTarget,
                        self.DamageType,
                        1,
                        self.ExtraDamage,
                        self.SkillDamageRate,
                        self.nowSkillData.break_power,
                        self.hard_times/1000,
                        self.flight_highs)
                    self:checkCombo(self.Shooter)
                    addHitEffect(m_box.x+m_box.width/2,m_box.y+m_box.height,self.Element,self.dir)
                    GameSound.playGameEffectHurt(self.Sound)
                    
                    if hitOnce == true then
                        self.temp_Hit_list[nowTarget._actor_id] = 1
                    end
                end
            end
            
         end
     end
    
end


function Bullet:getCCP(contact_point,line_id)
    if self.dir == 1 then
        if line_id == 1 then return cc.pSub(contact_point,self.point_tr)
        elseif line_id == 2 then return cc.pSub(contact_point,self.point_br) end
    elseif self.dir == -1 then
        if line_id == 1 then return cc.pSub(contact_point,self.point_tr)
        elseif line_id == 2 then return cc.pSub(contact_point,self.point_br) end
    end
end

function Bullet:checkWithBox(L1_s,L1_end,L2_s,L2_end,m_bb)
    local isHit,newX,newY,line_id
    
    isHit,newX,newY=LineIntersectionRect(L2_s,L2_end,m_bb)
    if isHit==true then return isHit,newX,newY,2  end

    isHit,newX,newY=LineIntersectionRect(L1_s,L1_end,m_bb)
    
    if isHit==true then return isHit,newX,newY,1 end
    
    return false
end


function Bullet:countDamage(obj,type,each_ratio,damage,skilldamege,shieldDamage)
   
    local perfectAT = self.Attack
    local selfAttUP = 0/100
    local selfAttDown = 0/100
    local skillAttRate =  skilldamege/1000
    local weaponElementType=1
    local weaponElementAtt=0

    local nowDamageReduce= (100 - mathMin(90,obj.damage_reduce_percent))*0.01
    --（1 + 攻击方攻击力提升% – 攻击方攻击方下降%）) * 技能攻击力–角色界面显示的防御力 * max(0,（1 + 防御方防御力提升% – 防御方防御方下降%）+总额外伤害

    local attRate = (1+(self.attUp-self.attDown)) 
    local enemyDef  = obj.Defence *mathMax(0,(1+(obj.defUp - obj.defDown)))
    local exDamage =  mathMax(weaponElementAtt - obj.now_elementDef[weaponElementType], weaponElementAtt*0.05)
    local realDamage= perfectAT * mathMax(0,attRate) * skillAttRate - enemyDef 

    local levelDistance = mathMin(mathMax(self.level - obj.level,0),10)

    local levelCrush = 1 +  levelDistance*0.05


    --  [1 + (攻击方等级-防御方等级）* 0.05 ）]
    local maxAT= nowDamageReduce * mathMax(perfectAT*0.05, (realDamage + exDamage) *  levelCrush ) 

    --local each_Max=math.ceil(maxAT*0.2+math.max(maxAT-obj.Defence,0)*0.8)
    local randomRate=(mRandom(95,105)/100)

    if each_ratio == nil then
        local xx= 10
    end

    local realAT = mathCeil(maxAT * each_ratio * randomRate)  + damage
    local realBp = mathCeil((self.break_+ shieldDamage)*each_ratio* randomRate) 

    return realAT,realBp
    
   
end

function Bullet:countCrit(reatAT,obj)
    local rd=reatAT
    
    local realCritPercent = 0.1 + mathMax(0.000035 * self.cri_rate - 0.00003*obj.cri_resis,0)*100
    local canCrit =  mRandom(0,100) <= realCritPercent
    if canCrit == true then
        local exCritDamage = mathMax((self.cri_damage-obj.cri_reduce)*0.0001,0)
        local realCritDamage = reatAT * (1.5 + exCritDamage)+ (self.cirtEx - obj.cirtExMinus)
        rd= mathCeil(realCritDamage)
    end
    

    return rd,canCrit
end

function Bullet:addDamage(obj,type,each_ratio,damage,damageRate,shieldDamage,hardTime,airForce) -- 对OBJ对象制造伤害

--    local maxAT=self.Attack+damage
--    local each_Max=math.ceil(maxAT*0.2+math.max(maxAT-obj.Defence,0)*0.8)
--    local realAT=math.ceil(each_Max*each_ratio)
--    local realBp=math.ceil((self.break_+ shieldDamage)*each_ratio)
    
    
    if obj._ActorState == EnumStateType.defens then
        GameSound.PlayEffect(SoundEffect.EF_DEFEN)
        local m_actortempy=obj.y+50
        LableString.addGDString(obj.x,m_actortempy,obj.camera_x,self.dir)
        return
    end
    local shouldCountKill = true
    if obj._hp <=0 and obj.hit_affter_dead <6 then
        obj.hit_affter_dead = obj.hit_affter_dead + 1
        shouldCountKill = false
    elseif obj._hp <=0 then
        obj._isInvincible = true
        shouldCountKill = false
    end


    local tempAT,realBp = self:countDamage(obj,type,each_ratio,damage,damageRate,shieldDamage)
    local realAT,isCrit= self:countCrit(tempAT,obj)
    
    local FixrealAT = mathCeil(realAT * self.fixDamage)
    
--    if  obj._is_boss == true then
--        cclog("bullet boss is hit tempAT ="..tempAT.." realAT ="..realAT.."boss HP="..obj._hp.." bossHPMAX = "..obj._hp_max.." FixrealAT = "..obj.FixrealAT)
--    end
    
    local inDefens = false
    
    if obj._ActorState == EnumStateType.defens then
        inDefens = true 
    end
    
    local buffId = self.BuffId   --获取BUFF id
    local buffrate = self.BuffRate --获取BUFF 几率
    

    if buffId > 0 then
        local canAddBuff = mRandom(0,100)< buffrate
        if canAddBuff == true and inDefens == false and obj.power_time == 0 then
            GameManager.addBuff(self.Shooter,obj,buffId)
        end
    end


    if self.Shooter ~= nil then
        local sself = self.Shooter
        if sself._actor_type == 1 then
            sself.hit_npc_count = sself.hit_npc_count + 1
            sself.MAX_HIT_TIME = sself.MAX_HIT_TIME + 1
            if FixrealAT > sself.MAX_ATTACK_DAMAGE then sself.MAX_ATTACK_DAMAGE = FixrealAT end
    
        else 
             
            if sself._actor_type < 20 and obj._actor_type == 1 then
                obj.MAX_LOST_HP = obj.MAX_LOST_HP + FixrealAT
            end
        end
    end
    
    obj.continue_hit_count = obj.continue_hit_count + 1  
    
    obj:setShine()
    local nowState = obj._ActorState
    local addRalDamage = 0
    if nowState  == EnumStateType.inair  then

        addRalDamage = self:checkDamageWithoutShieldInAir(obj,type,FixrealAT,realBp,hardTime,airForce,isCrit)
    elseif nowState  == EnumStateType.stun then
        if obj._shield > 0 then
            addRalDamage = self:checkDamageWithShield(obj,type,mathCeil(realAT * 0.8 * self.fixDamage),realBp,hardTime,airForce,isCrit)
        else 
            addRalDamage = self:checkDamageWithoutShield(obj,type,FixrealAT,realBp,hardTime,airForce,isCrit)
        end
    elseif nowState == EnumStateType.couch then
        addRalDamage = self:checkDamageInCouch(obj,type,FixrealAT,realBp,hardTime,airForce,isCrit)
    elseif nowState == EnumStateType.freeze then
        addRalDamage = self:checkDamageInFreeze(obj,type,FixrealAT,realBp,hardTime,airForce,isCrit)
    else
        if obj._shield > 0 or obj._isPowerUp == true then
            addRalDamage = self:checkDamageWithShield(obj,type,mathCeil(realAT * 0.8 * self.fixDamage),realBp,hardTime,airForce,isCrit)
        elseif obj._shield <= 0 and obj._isPowerUp == false then
            addRalDamage = self:checkDamageWithoutShield(obj,type,FixrealAT,realBp,hardTime,airForce,isCrit)
            --cclog("normal HIT")
        end
    end
    
    if obj.World_Boss == true then AWBD(addRalDamage) end
    
    if self.PauseTime ~= 0 then
        local nowPauseTime = self.PauseTime * 0.001
        self:requestBreak(nowPauseTime)
        obj:requestBreak(nowPauseTime)
    end

    if self.Shooter ~= nil then
        local nowShooterType = self.Shooter._actor_type
        local m_nowSkill = self.nowSkillData
        local TargetHp = obj._hp
        
        if self.made_Damage == false then
            self.made_Damage = true
            if nowShooterType == 1 or nowShooterType > 20 then
                
                local m_type = 1 
                if nowShooterType > 20 then m_type = 2 end
--                if m_nowSkill.energy_grain >0 then
--                    self.Shooter.nowAddEnergyTime = self.Shooter.nowAddEnergyTime + 1
--                    LableString.addTraceEnergy(obj.x,obj.y+mRandom(50,170),obj.camera_x,obj._curFacing,m_nowSkill.energy_grain,m_type)
--                    
--                end
            end
        end
        
        if TargetHp <= 0 and (nowShooterType < 2 or nowShooterType>20 ) and self.Shooter.gameisWin == false then
            if obj.extra_sound_effect[2] >0 then
                GameSound.playGameEffectAttack(obj.extra_sound_effect[2])
            end
            
            if shouldCountKill== true then
                self.Shooter.now_kill_npc = self.Shooter.now_kill_npc + 1
            end
            
            if GameManager.FB_Value.isPvP == true then
                self.Shooter.gameisWin = true
                GameControlLayer.StopCountDown_pvp()
                setMotionSpeed(0.45) --设置快慢动作
                GameManager.Zoom(1.3,10)
                GameManager.KillThemAll()
                GameManager.DisableAttackButton()
                local tX = rectGetMidX(obj.collideRect[1])
                local tY = rectGetMidY(obj.collideRect[1])
                GameManager.addHitEffect(tX-self.Shooter.camera_x,tY,100,1,false,1)
    
                local function endSlowMotionFirst()
                    setMotionSpeed(1) --设置快慢动作
                    GameManager.Zoom(1,20)
                    local win = 1
                    if self._actor_type > 20 then win = 0 end

                    BalanceValues.isWin = win == 1
                    BalanceValues.pvp_winner = self.Shooter
                    self.Shooter:SetSate(EnumStateType.win,true,0)
                    self.Shooter:sendPvPGameEndRequest(win)
                end
    
                self.Shooter._spine:runAction(cc.Sequence:create(cc.DelayTime:create(0.9),cc.CallFunc:create(endSlowMotionFirst)))
            elseif GameManager.FB_Value.is_3v3 == true then
                self.Shooter.gameisWin = true
                GameControlLayer.StopCountDown_pvp()
                setMotionSpeed(0.45) --设置快慢动作
                GameManager.Zoom(1.3,10)
                --GameManager.KillThemAll()
                GameManager.DisableAttackButton()
                local tX = rectGetMidX(obj.collideRect[1])
                local tY = rectGetMidY(obj.collideRect[1])
                GameManager.addHitEffect(tX-self.Shooter.camera_x,tY,100,1,false,1)
    
                local function endSlowMotionFirst()
                    setMotionSpeed(1) --设置快慢动作
                    GameManager.Zoom(1,20)
                    local win = 1
                    if self.Shooter._actor_type > 20 then win = 0 end
                    GameManager.FB_Value.pvp_win_relation = win
                    
                    self.Shooter:SetSate(EnumStateType.win,true,0)
    
                    if win == 1 and GameManager.FB_Value.now_Party_index < GameManager.FB_Value.max_Party_index then
    
                    elseif win == 0  and GameManager.FB_Value.Hero_now_Party_index < GameManager.FB_Value.Hero_max_Party_index then
                    
                    else
                        BalanceValues.isWin = win == 1
                        BalanceValues.pvp_winner = self.Shooter
                        
                        if GameManager.FB_Value.is_Ladder_PvP == true then
                            self.Shooter:sendPvPLadderGameEndRequest(win)
                        else
                            GameManager.addGameBalance(1)
                        end
                    end
                end
                GameControlLayer.playReadyGo("ko")
                self.Shooter._spine:runAction(cc.Sequence:create(cc.DelayTime:create(0.9),cc.CallFunc:create(endSlowMotionFirst)))
            else
                self.Shooter:GameCheckIsEnd(obj)
            end
        elseif TargetHp <= 0 and (nowShooterType > 1 and nowShooterType < 21 )then
            if obj.first_die == true then
                obj.first_die = false
                if obj.extra_sound_effect[2] >0 then
                    GameSound.playGameEffectAttack(obj.extra_sound_effect[2])
                end
            end
            
        elseif TargetHp >0 then
--            local self_euip_pets = self.Shooter.equip_pets
--            local target_euip_pets = obj.equip_pets
--    
--            if #self_euip_pets == 2 then  --判断受击人和被击人身上是否要触发宠物技能
--                for i=1,2 do
--                    if self_euip_pets[i].id ~=0 and self_euip_pets[i].buff_effect_type == 1 and self_euip_pets[i].Buff_Id~= 0 then
--                        if mRandom(1,100) < self_euip_pets[i].Activate_Rate then
--                            self.Shooter:petAttack(self_euip_pets[i].spine,obj,i)
--                            GameManager.addBuff(self.Shooter,obj,self_euip_pets[i].Buff_Id)
--                        end
--                    end
--            end
--            elseif #target_euip_pets == 2 then
--                for i=1,2 do
--                    if target_euip_pets[i].id ~=0 and target_euip_pets[i].buff_effect_type == 2 and target_euip_pets[i].Buff_Id~= 0 then
--                        if mRandom(1,100) < target_euip_pets[i].Activate_Rate then
--                            GameManager.addBuff(obj,self.Shooter,target_euip_pets[i].Buff_Id)
--                        end
--                    end
--                end
--            end
        end
    end
    
   
end

function Bullet:checkDamageInFreeze(obj,type,damage,shieldDamage,hardTime,airForce,isCrit)
    if obj._no_hurt ~= true then
        obj._hp=obj._hp-damage
    else
        obj._hp = math.max(1,obj._hp-damage)
    end

    --obj._fallTime = 1
    --cclog("type = %d damage=%d shieldDamage=%d hardTime=%f airForce=%d ",type,damage,shieldDamage,hardTime,airForce)
    if obj._hp <= 0 then
        obj._isInvincible=true
        obj:SetSate(EnumStateType.knockout,true,200)
        obj:deleteBuff()
        --setMotionSpeed(0.3)

    end

    obj._shield_hit_count = obj._shield_hit_count + 1

    local tempy=obj.y+50
    
    if isCrit and isCrit == true then
        LableString.addHurtString(obj.x,tempy,obj.camera_x,damage,res_color.YELLOW,self.Shooter._curFacing)
    else
        LableString.addHurtString(obj.x,tempy,obj.camera_x,damage,nil,self.Shooter._curFacing)
    end
    return damage
end

function Bullet:checkDamageInCouch(obj,type,damage,shieldDamage,hardTime,airForce,isCrit)
    if obj._no_hurt ~= true then
        obj._hp=obj._hp-damage
    else
        obj._hp = math.max(1,obj._hp-damage)
    end

    local can_fly = true

    if obj.isPlayerRole == true then can_fly = false end --躺倒状态不吃浮空只有BOSS才能挑空
    --obj._fallTime = 1
    --cclog("type = %d damage=%d shieldDamage=%d hardTime=%f airForce=%d ",type,damage,shieldDamage,hardTime,airForce)

    if obj._hp <= 0 then
        obj._isInvincible=true
        --obj:SetSate(EnumStateType.dead,true,10)
        --setMotionSpeed(0.3)

    elseif type == EnumHitType.knock then

        if obj.resist_list.knockout == 0 and obj.all_resist == false and can_fly == true then
            obj._request_hard_time = hardTime
            --obj:setFacing(self)
            obj:SetSate(EnumStateType.knockout,true,airForce)
        end
    elseif type == EnumHitType.airHit then
        if obj.resist_list.inair == 0 and obj.all_resist == false and can_fly == true then
            --obj:setFacing(self)
            obj:SetSate(EnumStateType.inair,true,airForce)
        end
    end

    obj._shield_hit_count = obj._shield_hit_count + 1

    local tempy=obj.y+50

    if isCrit and isCrit == true then
        LableString.addHurtString(obj.x,tempy,obj.camera_x,damage,res_color.YELLOW,self.Shooter._curFacing)
    else
        LableString.addHurtString(obj.x,tempy,obj.camera_x,damage,nil,self.Shooter._curFacing)
    end
    return damage
end

function Bullet:checkDamageWithShield(obj,type,damage,shieldDamage,hardTime,airForce,isCrit)   --有盾情况下伤害计算
    obj._shield = obj._shield - shieldDamage
    --if obj._actor_id ~= 1 then obj._hp=obj._hp-damage end
    if obj._no_hurt ~= true then
        obj._hp = obj._hp-damage
    else
        obj._hp = math.max(1,obj._hp-damage)
    end
    local noChange = false
    local forceDie = false
    local inPower = obj.all_resist
    local shouldPlaySB = false

    if self.Shooter.isNpcRole == true then
        if self.Shooter._is_boss == true or self.Shooter.World_Boss == true or self.Shooter.resist_list.strike > 0 then
            shouldPlaySB = true
        end
    elseif self.Shooter.isPlayerRole == true then
        shouldPlaySB = true
    end

    if (self.Shooter._is_boss == true and self.Shooter.resist_list.strike > 0) and obj.power_time == 0 then inPower = false end

    if obj._shield <= 0 and (obj._ActorState < EnumStateType.inair or obj._ActorState > EnumStateType.win ) and shouldPlaySB == true then
        --obj:setFacing(self)

        obj:SetSate(EnumStateType.breakShield,true)
    else
        if type == EnumHitType.minor or type == EnumHitType.serious or type == EnumHitType.airHit then
            if not inPower then obj:requestBreak(0.1) end
            noChange = true


        elseif type == EnumHitType.knock then
            if obj.resist_list.knockout == 0 and inPower == false then            
                obj._request_hard_time = hardTime
                obj:setFacingLR(self.dir*-1)
                obj:SetSate(EnumStateType.knockback,true,airForce)
                
            else
                noChange = true
            end
        elseif type == EnumHitType.knockBack then
            if obj.resist_list.knockBack == 0 and inPower == false then
                obj._request_hard_time = hardTime
                obj:setFacingLR(self.dir*-1)
                obj:SetSate(EnumStateType.knockback,true,airForce)
                
            else
                noChange = true
            end
        elseif type == EnumHitType.stun then
        elseif type == EnumHitType.Nothing then
            noChange = true
        end
    end

    if obj._hp <= 0 then
        --        obj._request_hard_time = hardTime
        --        

        obj:deleteBuff()

        if obj.actor_should_drop == true then
            obj:setMoveTo(cc.p(-1,-1))
            obj:SetSate(EnumStateType.knockout,true,200)
        elseif noChange == true or forceDie == true or obj.isPlayerRole == true then
            obj:setMoveTo(cc.p(-1,-1))
            obj:SetSate(EnumStateType.knockout,true,200)
        end
    end

    local tempy=obj.y+50

    if isCrit and isCrit == true then
        LableString.addHurtString(obj.x,tempy,obj.camera_x,damage,res_color.YELLOW,self.Shooter._curFacing)
    else
        LableString.addHurtString(obj.x,tempy,obj.camera_x,damage,nil,self.Shooter._curFacing)
    end
    return damage
end

function Bullet:checkDamageWithoutShield(obj,type,damage,shieldDamage,hardTime,airForce,isCrit)   --无盾伤害计算
    if obj._no_hurt ~= true then
        obj._hp=obj._hp-damage
    else
        obj._hp = math.max(1,obj._hp-damage)
    end

    local noChange = false
    local forceDie = false
    local inPower = obj.all_resist

    if (self.Shooter._is_boss == true and self.Shooter.resist_list.strike > 0) and obj.power_time == 0 then inPower = false end

    if type == EnumHitType.minor then

    if obj.resist_list.minor_injured == 0 and inPower == false then
            obj:SetSate(EnumStateType.minor_injured,true)
            --obj:setFacing(self)
            obj._request_hard_time = hardTime
            forceDie=true
        else
            noChange = true
        end
    elseif type == EnumHitType.serious then
        if obj.resist_list.serious_injured == 0 and inPower == false then
            obj._request_hard_time = hardTime
            --obj:setFacing(self)
            obj:SetSate(EnumStateType.serious_injured,true)
            forceDie=true
        else
            noChange = true
        end
    elseif type == EnumHitType.knock then
        if obj.resist_list.knockout == 0 and inPower == false then
            obj._request_hard_time = hardTime
        obj:setFacingLR(self.dir*-1)
            obj:SetSate(EnumStateType.knockout,true,airForce)
        else
            noChange = true
        end
    elseif type == EnumHitType.knockBack then
        if obj.resist_list.knockback == 0 and inPower == false then
            obj._request_hard_time = hardTime
            obj:setFacingLR(self.dir*-1)
            obj:SetSate(EnumStateType.knockback,true,airForce)
            forceDie=true
        else
            noChange = true
        end
    elseif type == EnumHitType.stun then
    elseif type == EnumHitType.Nothing then
        noChange = true
    elseif type == EnumHitType.airHit then
        if obj.resist_list.inair == 0 and inPower == false then
            --obj:setFacing(self)
            obj:SetSate(EnumStateType.inair,true,airForce)
        else
            noChange = true
        end
    end

    if obj._hp <= 0 then
        
        obj:deleteBuff()

        if obj.actor_should_drop == true then
            obj:setMoveTo(cc.p(-1,-1))
            obj:SetSate(EnumStateType.knockout,true,200)
        elseif noChange == true or forceDie == true or obj.isPlayerRole == true then
            obj:setMoveTo(cc.p(-1,-1))
            obj:SetSate(EnumStateType.knockout,true,200)
        end

    end

    obj._shield_hit_count = obj._shield_hit_count + 1

    local tempy=obj.y+50

    if isCrit and isCrit == true then
        LableString.addHurtString(obj.x,tempy,obj.camera_x,damage,res_color.YELLOW,self.Shooter._curFacing)
    else
        LableString.addHurtString(obj.x,tempy,obj.camera_x,damage,nil,self.Shooter._curFacing)
    end
    return damage
end

function Bullet:checkDamageWithoutShieldInAir(obj,type,damage,shieldDamage,hardTime,airForce,isCrit)    --浮空状态下伤害计算
    
    if obj.isPlayerRole == true and obj.in_PVE == true then
        if obj.in_air_count < 15 then
            obj.in_air_count = obj.in_air_count + 1
        else
            obj.in_air_count = 0 
            obj._isInvincible = true
        end
    end
    
    obj._hp = obj._hp-damage

--    if obj._no_hurt ~= true then
--        obj._hp = obj._hp-damage
--    else
--        obj._hp = math.max(1,obj._hp-damage)
--    end

    obj._AirHitState = type
--cclog("obj:getPositionY()=%f  obj.y=%f  airForce=%d",obj:getPositionY(),obj.y,airForce)

--    local actionUp = cc.JumpBy:create(1, cc.p(0,0), airForce, 1)
--    obj:runAction(actionUp)
--obj:setMoveTo(cc.p(-1,obj.y+airForce))

    if type == EnumHitType.minor or type == EnumHitType.serious or type == EnumHitType.stun or type == EnumHitType.Nothing then
        --obj:setMoveTo(cc.p(obj.x+airForce*self.dir,obj.y+airForce))
        obj:setMoveTo(cc.p(-10,obj.y+airForce))
    --obj:setMoveTo(cc.p(obj.x+30*self.dir,-10))
        obj._float_time=airForce/100
        obj:playAnimation(obj._actions.airhit,false)

    elseif type == EnumHitType.airHit then
        --obj:setMoveTo(cc.p(obj.x+airForce*self.dir,obj.y+airForce)) 
        obj:setMoveTo(cc.p(-10,obj.y+airForce))
    --obj:setMoveTo(cc.p(obj.x+30*self.dir,-10))

        obj:playAnimation(obj._actions.airhit,false)
    elseif type == EnumHitType.knock then
    --obj:setMoveTo(cc.p(-10,-10))
        obj:setMoveTo(cc.p(obj.x+airForce*self.dir,-10))
    --obj._float_time=airForce/100
        obj:playAnimation(obj._actions.airhit,false)

    elseif type == EnumHitType.knockback then
        obj._float_time=airForce/100
        obj:setMoveTo(cc.p(obj.x+airForce*self.dir,-10))
    --obj:setMoveTo(cc.p(obj.x+30*self.dir,-10))
        obj:playAnimation(obj._actions.airhit,false)

    end

    if obj._hp <= 0 then
    
        obj:deleteBuff()
    --setMotionSpeed(0.3)
    end

    obj._shield_hit_count = obj._shield_hit_count + 1

    local tempy=obj.y+50

    if isCrit and isCrit == true then
        LableString.addHurtString(obj.x,tempy,obj.camera_x,damage,res_color.YELLOW,self.Shooter._curFacing)
    else
        LableString.addHurtString(obj.x,tempy,obj.camera_x,damage,nil,self.Shooter._curFacing)
    end
    return damage
end

function Bullet:requestBreak(m_time)
    self._spine_bullet:pause()
    self._break_time = 0
    self._request_break_time = m_time
end

function Bullet:hitboxCheck(box_1,box_list_2)
    local iscollison = false
    local selfIndex = 1
    local enemyIndex = 0
   
    local RectCompare = cc.rectIntersectsRect

    

    for key2, var2 in pairs(box_list_2) do

        local tempBox_2 = var2
        if RectCompare(box_1,tempBox_2) == true then
            iscollison = true
            enemyIndex = key2
            break
        end
    end

    return iscollison,selfIndex,enemyIndex
end