Skill = {}

SkillDefaultValues =
{
   skill_level=1,
   att_power = 0,
   break_power = 0,
   accept_time = 0,
   Attack_Rate=0,
   at_list = nil,
   bp_list = nil,
   ht_list = nil,
   ap_list = nil,
   sbuff_list = nil,
   sbuff_rate = nil,
   pause_list = nil,
   shock_list = nil,
   offset_List = nil,
   airForce_list = nil,
   sound_list = nil,
   skill_ex_buffid = 0,
   skill_ex_buffRate= 0,
   hit_offset_list=nil
}


function Skill.new(skill_id,m_lv,roleLv)

    local m_skill= {}
    
    if GameData_List.skill[skill_id] == nil then
        cclog("can't not find the skill data with skill = %d",skill_id)
    end
    
    copyTable(SkillDefaultValues,m_skill)
    copyTable(GameData_List.skill[skill_id],m_skill)
    
    --local tempData = SkillAllLevelData.all_data_list[skill_id][m_skill.skill_level]
    local tempData = nil
    
    if m_lv > 0 then
        m_skill.skill_level = m_lv
        tempData = GameDataTransfer.GetSkillValue(skill_id,m_lv)
    elseif roleLv and roleLv >0 then
        local allvalue = GameDataTransfer.SkillValue[skill_id]
        local nowMaxLevel = 0
        for i=1,#allvalue do
            if roleLv >= allvalue[i].Unlock_Level then
                nowMaxLevel = nowMaxLevel + 1
            else
                break
            end
        end
        
        tempData = GameDataTransfer.GetSkillValue(skill_id,nowMaxLevel)
    end
    
    if tempData == nil then cclog("ERROR  skill_id = %d skill_lv = %d  skill value data is empty ",skill_id,m_lv)  end
    
    m_skill.att_power   = tempData.Attack2
    m_skill.break_power = tempData.break_
    m_skill.Attack_Rate = tempData.Attack_rate
    m_skill.Buff_Id    = tempData.Buff_Id
    m_skill.Buff_rate  = tempData.Buff_rate
    
    if m_skill.Wait ~= 0 and m_skill.Wait>0 then
        m_skill.accept_time = m_skill.Wait/1000
    elseif m_skill.Wait ~= 0 and m_skill.Wait<0 then
        m_skill.accept_time = m_skill.Wait
    end
    
    
    m_skill.ap_list         = Skill.StrA2AttackList(string.split(m_skill.Damage_Ratio,","),m_skill.Wait)
    m_skill.bp_list         = Skill.StrA2AttackList(string.split(m_skill.Damage_Ratio,","),m_skill.Wait)
    m_skill.ht_list         = Skill.StrA2TimeList(string.split(m_skill.hard_times,","))
    m_skill.pause_list      = Skill.StrA2TimeList(string.split(m_skill.pause,","))
    m_skill.airForce_list   = Skill.StrA2NumberList(string.split(m_skill.flight_highs,","))
    m_skill.at_list         = Skill.StrA2NumberList(string.split(m_skill.attack_types,","))
    m_skill.shock_list      = Skill.StrA2NumberList(string.split(m_skill.Vibration,","))
    m_skill.offset_List     = Skill.StrA2OffsetList(string.split(m_skill.offset,"|"))
    m_skill.hit_offset_list = Skill.StrA2NumberList(string.split(m_skill.Hit_Offset,",")) --
    m_skill.sbuff_list      = Skill.StrA2NumberList(string.split(m_skill.Buff_Id,","))
    m_skill.sbuff_rate      = Skill.StrA2NumberList(string.split(m_skill.Buff_rate,","))
    m_skill.sound_list      = Skill.StrA2NumberList(string.split(m_skill.sounds,","))
    m_skill.bullet_list      = Skill.StrA2NumberList(string.split(m_skill.Bullet_Assign,","))
    --table.print(m_skill)
    
    m_skill.can_use = true
    
    return m_skill
end

function Skill:changeData(m_type,m_value)
    if m_type == res_attribute.POWER then
        self.att_power = self.att_power + m_value
    elseif m_type == res_attribute.BREAK then
        self.break_power = self.break_power + m_value
    end
    
--    obj.Defence = attribute[res_attribute.DEFENCE]
--    obj._shieldMax = attribute[res_attribute.ARMOR]
--    obj.break_ = attribute[res_attribute.BREAK]
--    obj.cri_rate = attribute[res_attribute.CRIT_RATE]
--    obj.cri_resist = attribute[res_attribute.CRIT_RESIST]
--    obj.cri_damage = attribute[res_attribute.CRIT_DAMAGE]
--    obj.cri_reduce = attribute[res_attribute.CRIT_REDUCE]
end

function Skill:changeBuff(m_Buff)

end

function Skill.StrA2OffsetList(str_array)

    local tempList = List.new()
    local total_Weight=0

    for i=1,#str_array do
        local tempXY = string.split(str_array[i],",")
        local tempX  = tonumber(tempXY[1])
        local tempY  = tonumber(tempXY[2])
        local tempZ  = tonumber(tempXY[3])
        local tempshift = tonumber(tempXY[4])
        local tempPoint = cc.vec4(tempX,tempY,tempZ,tempshift)
        List.pushlast(tempList,tempPoint)
    end

    return tempList
end

function Skill.StrA2AttackList(str_array,delayTime)
    
    local tempList = List.new()
    local total_Weight=0
    
    for i=1,#str_array do
        local temp_number = tonumber(str_array[i])
        total_Weight = total_Weight + temp_number
        List.pushlast(tempList,temp_number)
    end
    
    if delayTime == 0  then    --如果有等待时间就是普通攻击，不需要分段，直接获取攻击比例
        for i=1,List.getSize(tempList) do
            if tempList[i] == 0 then
                tempList[i]=1
            else
                tempList[i]=(tempList[i]/total_Weight)
            end
        end
    end
    return tempList
end

function Skill.StrA2TimeList(str_array)
    local tempList = List.new()
    
    for i=1,#str_array do
        local temp_number = tonumber(str_array[i])
        List.pushlast(tempList,temp_number*0.001)
    end
    return tempList
end

function Skill.StrA2NumberList(str_array)
    local tempList = List.new()
    for i=1,#str_array do
        List.pushlast(tempList,tonumber(str_array[i]))
    end
    return tempList

end