
CutsceneManager={}

CutsceneManager.fontSize = 28
CutsceneManager.last_Time = 5

EnumCutsceneZorder={
    layout = 50,
    bottomSprite=1,
    Actor = 2,
    ActorName = 3,
    topSprite=4,
    txt=5
}

EnumCutsceneTag={
    layout = 3000,
    leftActor = 3001,
    leftActorName = 3002,
    rightActor = 3003,
    rightActorName = 3004,
    bottomSprite=3005,
    topSprite=3006
}

CutsceneManager.JumpOverBtnTag = 60001

local PlotTable = {}
local CommonActionTime = 0.5
local HeightFactor = 0.2
local JuQingStringList = nil

-----------------------------------未写完--------------------------------------------------

function CutsceneManager.createLayout(opacity)
    local scene = cc.Director:getInstance():getRunningScene()
    local layout = GameAssistor.CreateMaskLayout(cc.c3b(0,0,0),opacity)
    scene:addChild(layout,EnumCutsceneZorder.layout,EnumCutsceneTag.layout)
    return layout
end


--返回两个action的反动作
function CutsceneManager.showUDBlackBorder(layout,topSprite,bottomSprite,ActionTime,funCallBack)
    local visibleSize = layout:getContentSize()
    if nil == topSprite then
         topSprite = cc.Sprite:create("juqing/d.png")
    end
    if nil == bottomSprite then
        bottomSprite = cc.Sprite:create("juqing/e.png")
    end
    
    local size1 = topSprite:getContentSize()
    local size2 = bottomSprite:getContentSize()

    topSprite:setAnchorPoint(0.0,0.0)
    bottomSprite:setAnchorPoint(0.0,0.0)

    topSprite:setPosition(cc.p(0,visibleSize.height))
    bottomSprite:setPosition(cc.p(0,-size2.height))
    
    local moveTo1 = cc.MoveTo:create(ActionTime,cc.p(0,visibleSize.height-size1.height))
    local moveTo2 = cc.MoveTo:create(ActionTime,cc.p(0,0))
    topSprite:runAction(moveTo1)
    
    local ationFinished = false
    local function ActionFinished()
       if nil ~= funCallBack then
            funCallBack()
       end
    end
    bottomSprite:runAction(cc.Sequence:create(moveTo2,cc.CallFunc:create(ActionFinished)))
    --
    layout:addChild(bottomSprite,EnumCutsceneZorder.bottomSprite,EnumCutsceneTag.bottomSprite)
    --layout:addChild(topSprite,EnumCutsceneZorder.topSprite,EnumCutsceneTag.topSprite)
end

function CutsceneManager.removeUDBlackBorder(ActionTime,funCallBack)
    local scene = cc.Director:getInstance():getRunningScene()
    local layout = scene:getChildByTag(EnumCutsceneTag.layout)
    if nil ~= layout then
        local visibleSize = layout:getContentSize()
        local bottomSprite = nil
        local topSprite = nil
        bottomSprite = layout:getChildByTag(EnumCutsceneTag.bottomSprite)
        --topSprite = layout:getChildByTag(EnumCutsceneTag.topSprite)
        if  nil ~= bottomSprite then
            --local size1 = topSprite:getContentSize()
            local size2 = bottomSprite:getContentSize()
            local moveTo1= cc.MoveTo:create(ActionTime,cc.p(0,visibleSize.height))
            local moveTo2 = cc.MoveTo:create(ActionTime,cc.p(0,-size2.height))
            local function ActionFinished()
                if nil ~= funCallBack then
                    funCallBack()
                end
            end
            --topSprite:runAction(moveTo1)
            bottomSprite:runAction(cc.Sequence:create(moveTo2,cc.CallFunc:create(ActionFinished)))
        end
    end
end

function CutsceneManager.closeCosmic(nowindex)
    if nowindex <2 then return end
    local pTable = PlotTable[nowindex - 1]
    if pTable.cosmic == nil or pTable.cosmic == 0 then return end
    
    local moveTo1 = cc.Spawn:create(cc.MoveTo:create(0.5,{x = pTable.endX,y = pTable.endY}),cc.FadeTo:create(0.5,100))
    pTable.cosmic:runAction(moveTo1)
end

function CutsceneManager.showComsic(actionTime,layout,actorName,cosmic_id,mode,defaultPoint,startPoint,endPoint,pTable,funCallBack)
    local cosmic_spr = nil
    local visibleSize = layout:getContentSize()
    
    cosmic_spr = cc.Sprite:create("juqing/"..cosmic_id..".png")
    
    layout:addChild(cosmic_spr)
    
    cosmic_spr:setOpacity(0)
    cosmic_spr:setColor(cc.c3b(0,0,0))
    cosmic_spr:setPosition(defaultPoint)
    
    pTable.cosmic = cosmic_spr
    pTable.endX = endPoint.x
    pTable.endY = endPoint.y
    
    local moveTo1 = cc.Spawn:create(cc.MoveTo:create(tonumber(actionTime),startPoint),cc.TintTo:create(tonumber(actionTime),255,255,255),cc.FadeTo:create(tonumber(actionTime),255))
    
    local function actionFinished2()
        CutsceneManager.index = CutsceneManager.index + 1
        CutsceneManager.actionFinished = true
    end
    
    cosmic_spr:runAction(cc.Sequence:create(moveTo1,cc.CallFunc:create(actionFinished2)))
end

--设置从左边或右边出现 图片是否反
function CutsceneManager.showJuQingActor(layout,sprtActorPath,actorName,factor,isRoll,isLeft,ActionTime,funCallBack)
    local visibleSize = layout:getContentSize()
    if CutsceneManager.sprtActor then
        CutsceneManager.sprtActor:removeFromParent()
    end

    CutsceneManager.sprtActor = nil

    local moveTo1 = nil
    local moveTo2 = nil
    --参数检查
    if nil == layout then
        cclog("CutsceneManager.showJuQingActor nil==layout")
        return
    end
    if nil == sprtActorPath then
        sprtActor = cc.Sprite:create("juqing/1.png")
    else
        sprtActor = cc.Sprite:create(sprtActorPath)
    end
    
    local txtNameText = ccui.Text:create()
    txtNameText:setFontName("Number/Number-ty3.ttf")
    txtNameText:setFontSize(32)
    txtNameText:setString(actorName or "Nothing")
    sprtActor:addChild(txtNameText)
    txtNameText:setAnchorPoint(0.5,0.5)

    if nil == factor then
        factor = 0.2
    end

    local size1 = sprtActor:getContentSize()
    txtNameText:setPositionX(size1.width / 2)
    if false == isLeft then
        txtNameText:setScaleX(-1)
    end
    if false == isRoll then
        if true == isLeft then
            --从左边出现
            sprtActor:setAnchorPoint(1.0,0.5)
            sprtActor:setPosition(cc.p(0,visibleSize.height/2.0))
            moveTo1 = cc.MoveTo:create(ActionTime,cc.p(size1.width,visibleSize.height/2.0))
        else
            --从右边出现
            sprtActor:setAnchorPoint(0.0,0.5)
            sprtActor:setPosition(cc.p(visibleSize.width,visibleSize.height/2.0))
            moveTo1 = cc.MoveTo:create(ActionTime,cc.p(visibleSize.width-size1.width,visibleSize.height/2.0))
        end
    else
        sprtActor:setScaleX(-1)
        if true == isLeft then
            --从左边出现
            sprtActor:setAnchorPoint(0.0,0.5)
            sprtActor:setPosition(cc.p(0,visibleSize.height/2.0)) 
            moveTo1 = cc.MoveTo:create(ActionTime,cc.p(size1.width,visibleSize.height/2.0))
            
        else
            --从右边出
            sprtActor:setAnchorPoint(0.0,0.5)
            sprtActor:setPosition(cc.p(visibleSize.width+size1.width,visibleSize.height/2.0))
            moveTo1 = cc.MoveTo:create(ActionTime,cc.p(visibleSize.width,visibleSize.height/2.0))
        end
    end
    --添加动作
    local function actionFinished()
        if nil ~= funCallBack then
            funCallBack()
        end
    end
    layout:addChild(sprtActor,EnumCutsceneZorder.Actor)
    sprtActor:runAction(cc.Sequence:create(moveTo1,cc.CallFunc:create(actionFinished)))
    CutsceneManager.sprtActor = sprtActor
end

function CutsceneManager.removeJuQingActor(isRoll,isLeft,ActionTime,factor,cosmic,nowIndex,funCallBack)
    cclog("remove juqing")
    local scene = cc.Director:getInstance():getRunningScene()
    local layout = scene:getChildByTag(EnumCutsceneTag.layout)
    local sprtActor = CutsceneManager.sprtActor
    if  nil == sprtActor then
        cclog("CutsceneManager.removeJuQingActor nil == sprtActor or nil == sprtName ")
        if cosmic ~= nil then
            if nil ~= funCallBack then
                CutsceneManager.closeCosmic(nowIndex)
                funCallBack()
            end
        end
        return 
    end
    local visibleSize = layout:getContentSize()
    local size1 = nil
    local size2 = nil
    local moveTo1 = nil
    local moveTo2 = nil
    
    local function actionFinished2()
        if nil ~= funCallBack then
            CutsceneManager.closeCosmic(nowIndex)
            funCallBack()
        end
    end
    
    CutsceneManager.sprtActor = nil

    if nil ~= sprtActor then 
        size1 = sprtActor:getContentSize()
       if false == isRoll then
            if true == isLeft then
                moveTo1 = cc.MoveTo:create(ActionTime,cc.p(-600,visibleSize.height/2.0))
            else
                moveTo1 = cc.MoveTo:create(ActionTime,cc.p(visibleSize.width + 800,visibleSize.height/2.0))
            end
       else
            if true == isLeft then
                moveTo1 = cc.MoveTo:create(ActionTime,cc.p(-600,visibleSize.height/2.0))
            else
                moveTo1 = cc.MoveTo:create(ActionTime,cc.p(visibleSize.width+800,visibleSize.height/2.0))
            end
       end

       sprtActor:runAction(cc.Sequence:create(moveTo1,cc.CallFunc:create(actionFinished2)))
    end
end

function CutsceneManager.createActionTxt(layout,isLeft,txt,txtSpeed,fontSize,c4b,funCallBack)
    local scene = cc.Director:getInstance():getRunningScene()
    local layoutChild = GameAssistor.CreateMaskLayout(cc.c3b(0,0,0),0)
    local txtText = ccui.Text:create()
    txtText:setFontName("Number/Number-ty3.ttf")
    if nil == c4b then
        txtText:setTextColor(cc.c4b(255,255,255,255))
    else
        txtText:setTextColor(c4b)
    end
    txtText:setAnchorPoint(0.0,0.5)
    if nil == fontSize then
        txtText:setFontSize(CutsceneManager.fontSize)
    else
        txtText:setFontSize(fontSize)
    end
    txtText:enableShadow()
    
    local tempTxt = ""
    local length = string.len(txt)
    local index = 1
    local function update(dt)
        index = index+1
        if index <= length then
            tempTxt = string.sub(txt,1,index)
            txtText:setString(tempTxt)
        else
            if CutsceneManager.ActionTxtLayout then
                CutsceneManager.ActionTxtLayout:removeFromParent()
            end

            cclog("CutsceneManager.createActionTxt  finish")
            txtText:unscheduleUpdate()
            if nil ~= funCallBack then
               funCallBack()
            end 
        end
    end
    if nil == txtSpeed then
        txtSpeed = 0.02
    end

    if length <= 75 then
        txtText:ignoreContentAdaptWithSize(false)
        txtText:setTextAreaSize(cc.size(600,60))
    elseif length > 75 and length <= 150 then
        txtText:ignoreContentAdaptWithSize(false)
        txtText:setTextAreaSize(cc.size(600,90))
    else
        txtText:ignoreContentAdaptWithSize(false)
        txtText:setTextAreaSize(cc.size(600,110))
    end
    txtText:setTextColor(cc.c4b(255,255,255,255))
    txtText:setAnchorPoint(0.5,0.5)
    txtText:setFontSize(CutsceneManager.fontSize)
    txtText:enableShadow()

    local visibleSize = cc.Director:getInstance():getVisibleSize()
    if true == isLeft then
        txtText:setPosition(cc.p(visibleSize.width*0.68,80))
    else
        txtText:setPosition(cc.p(visibleSize.width*0.32,80))
    end
    
    CutsceneManager.removeFromParent(layout,998)
    layout:addChild(txtText,EnumCutsceneZorder.txt,998)
    
    txtText:unscheduleUpdate()
    txtText:scheduleUpdateWithPriorityLua(update,0)
    layoutChild:addTouchEventListener(function(sender,eventType)
            if eventType== ccui.TouchEventType.ended then
                txtText:setString(txt)   
                if CutsceneManager.ActionTxtLayout then
                    CutsceneManager.ActionTxtLayout:removeFromParent()
                end    
                txtText:unscheduleUpdate()            
                -- layoutChild:removeFromParent()
                -- CutsceneManager.removeFromParent(scene,10008)
                if nil ~= funCallBack then
                    funCallBack()
                end
            end
        end)
    scene:addChild(layoutChild,EnumCutsceneZorder.layout+1,10008)
    CutsceneManager.ActionTxtLayout = layoutChild
    return txtText
end

function CutsceneManager.removeTxtAtionTable(txtCtrlTableTemp,txtSpeed,funCallBack)
    
    if nil ~= CutsceneManager.ScheduleIdRemoveTxt then
        cc.Director:getInstance():getScheduler():unscheduleScriptEntry(CutsceneManager.ScheduleIdRemoveTxt)
        CutsceneManager.ScheduleIdRemoveTxt = nil
    end 
    local index = 1
    local actionFinished = true
    local tblTempSize = table.getn(txtCtrlTableTemp)
    
    local function  updateRemoveTxt()
        if  actionFinished == false then
            return 
        end
        if index <= tblTempSize then
            local function fadeInActionFinished()
                actionFinished = true
                txtCtrlTableTemp[index]:removeFromParent()
                index = index + 1
            end
            local fadeIn = cc.FadeIn:create(0.1)
            txtCtrlTableTemp[index]:runAction(cc.Sequence:create(fadeIn,cc.CallFunc:create(fadeInActionFinished)))
        else
             if nil ~= CutsceneManager.ScheduleIdRemoveTxt then
                cc.Director:getInstance():getScheduler():unscheduleScriptEntry(CutsceneManager.ScheduleIdRemoveTxt)
                CutsceneManager.ScheduleIdRemoveTxt = nil
                if nil ~= funCallBack then
                    funCallBack()
                end
            end
        end
    end
    if nil == CutsceneManager.ScheduleIdRemoveTxt then
        CutsceneManager.ScheduleIdRemoveTxt = cc.Director:getInstance():getScheduler():scheduleScriptFunc(updateRemoveTxt,txtSpeed,false)
    end
end

function CutsceneManager.ShowTxtAtionTable(layout,isLeft,txtSpeed,fontSize,c4b,txtVerticalSpace,txtTable,funCallBack)
    local txtTableSize = table.getn(txtTable)
    if txtTableSize <= 0 then
        txtAtionFinished = true
        if funCallBack then
            funCallBack()
        end
        return 
    end
    local index = 1
    local oldIndex = 0
    local actionFinished = false
    local txtSize = cc.size(100,100)
    local txtCtrl = nil
    local txtAtionFinished = false
    
    local function createActionTxtCallback()
        txtAtionFinished = true
        index = index + 1
    end
    
    
    local nodeTemp = cc.Node:create()
    local function update(dt)
        if index ~= oldIndex then
            if index <= txtTableSize then
                oldIndex = index
                txtAtionFinished = false
                CutsceneManager.createActionTxt(layout,isLeft,txtTable[index],txtSpeed,fontSize,c4b,createActionTxtCallback)            
            else
                nodeTemp:unscheduleUpdate()
                if nil ~= funCallBack then
                    funCallBack()
                end
            end
        end
    end
    
    nodeTemp:unscheduleUpdate()
    nodeTemp:scheduleUpdateWithPriorityLua(update,0)
    layout:addChild(nodeTemp,0,9909)

    CutsceneManager.textLayout = layout
    --
    local flagCtrol = false
    layout:addTouchEventListener(function(sender,eventType)
        if eventType== ccui.TouchEventType.ended then
            if txtAtionFinished == true then
                index = index + 1
            end
            if index > txtTableSize then
               
                CutsceneManager.removeActionText()
                if nil ~= funCallBack and false == flagCtrol then
                    flagCtrol = true
                    funCallBack()
                end
            end 
        end
    end)
end

function CutsceneManager.removeActionText()
    CutsceneManager.skipTimeInner = 0
    if not CutsceneManager.textLayout then
        return 
    end

    local nodeChild = CutsceneManager.textLayout:getChildByTag(9909)
    if nil ~= nodeChild then
        nodeChild:removeFromParent()
        nodeChild = nil
    end
        
    CutsceneManager.removeFromParent(CutsceneManager.textLayout,998)
end


function CutsceneManager.getSprtActorOrActorName(isActor,isLeft)
    local scene = cc.Director:getInstance():getRunningScene()
    local layout = scene:getChildByTag(EnumCutsceneTag.layout)
    local sprt = nil
    if nil ~= layout then
        local sprtName = nil
        if true == isLeft then
            if true == isActor then
                sprt = layout:getChildByTag(EnumCutsceneTag.leftActor)
            else
                sprt = layout:getChildByTag(EnumCutsceneTag.leftActorName)
            end
        else
             if true == isActor then
                 sprt = layout:getChildByTag(EnumCutsceneTag.rightActor)
             else
                 sprt = layout:getChildByTag(EnumCutsceneTag.rightActorName)
             end
        end
    end
    return sprt
end

function CutsceneManager.addPlotTable(plotTable)
    table.clear(PlotTable)
    table.copy(plotTable,PlotTable)
end

--把一个字符串拆分成字符串表
--按字个数进行拆分 true 按&字符拆分 false
function CutsceneManager.txtToTable(txt,Split)
    if nil == txt or "" == txt then
        return {}
    end
    return string.split(txt,"\\n")
end

function CutsceneManager.getSprtPath(ID)
    local sID = string.format("%d",ID)
    return "juqing/"..sID..".png" --根据id找图片
end

function  CutsceneManager.getJuQingStringList()
    local filedata = GameDataReader.readFromAppFile("juqing")
    return string.split(filedata,"\r\n")
end

function CutsceneManager.removeFromParent(parentNode,tag)
    local childNode = parentNode:getChildByTag(tag)
    if nil ~= childNode then
        childNode:removeFromParent()
    end
end

--显示剧情组合
-- plotTable 剧情表表结构
--actorID 角色ID:根据该ID可以找到该图片的
--actorNameID 角色名ID:根据该ID可以找到对应图片
--actionTime 动作时间
--isLeft 出现方式:即是从屏幕左边出现还是右边出现，现在的规则是，凡是从左边出现，角色图片都不需要翻转，右边则要
function CutsceneManager.runCutsceneManager(plotTable,callBack,txtIsRight)
    table.clear(PlotTable)
    table.copy(plotTable,PlotTable)
    --
    --参数初始化
    local txtSpeed = 0.02
    local fontSize = CutsceneManager.fontSize --23
    local txtVerticalSpace = 20
    local c4b = cc.c4b(255,255,255,255)
    local isRoll = false
    CutsceneManager.sprtActor = nil
    local isLeft = true
    local topSprite = nil
    local bottomSprite = nil
    local sprtActorPath = nil 
    local sprtNamePath = nil
    local actionTime = CommonActionTime
    local layout = CutsceneManager.createLayout(150)
    local PlotTableSize=table.getn(PlotTable)
    CutsceneManager.index = 1
    CutsceneManager.actionFinished = true
    local scene = cc.Director:getInstance():getRunningScene()
    

    local function JuqingOver()
        local function removeUDBlackBorderCallBack()
            layout:unscheduleUpdate()
            layout:removeFromParent()
            CutsceneManager.removeFromParent(scene,10008)
            if nil ~= callBack then
                callBack()
            end
        end
        CutsceneManager.removeFromParent(scene,10008)
        CutsceneManager.removeFromParent(scene,CutsceneManager.JumpOverBtnTag)
        CutsceneManager.removeUDBlackBorder(actionTime,removeUDBlackBorderCallBack)
    end

    local isFirtEnter = true
    local function removeJuQingActorCallBack()
        if false == CutsceneManager.actionFinished then
            CutsceneManager.removeActionText()
            CutsceneManager.actionFinished = true
            isFirtEnter = true
            CutsceneManager.index = CutsceneManager.index+1
        end
    end
    -- require('mobdebug').start('localhost')
    
    CutsceneManager.skipTimeInner = CutsceneManager.last_Time
    CutsceneManager.needCheckTime = false
    local function update(dt)
        local index = CutsceneManager.index
        if false == isFirtEnter and CutsceneManager.needCheckTime then
            local delayTime = os.clock() - CutsceneManager.m_startTime
            if delayTime > CutsceneManager.skipTimeInner then
                --文字消失
                CutsceneManager.m_startTime =  os.clock()
                isFirtEnter = true
                CutsceneManager.removeJuQingActor(isRoll,isLeft,actionTime,HeightFactor,PlotTable[index].cosmic,index,removeJuQingActorCallBack)
            end
        end
        if false == CutsceneManager.actionFinished then
            return 
        end

        if index <= PlotTableSize then
            
            isFirtEnter = false
            CutsceneManager.m_startTime =  os.clock()
                -- if nil == txtIsRight then
            isLeft = PlotTable[index].isLeft

            actionTime = PlotTable[index].actionTime --动作时间

            local txtID =  PlotTable[index].txtID  --文字ID 或 key
            local txt = GameDataTransfer.GetGameString(txtID)
            local txtTable = CutsceneManager.txtToTable(txt) --把字符串转换为 字符串表（& 分割符）
            local actorID = PlotTable[index].actorID  --角色任务ID
            CutsceneManager.skipTimeInner = PlotTable[index].Lasttime or CutsceneManager.last_Time
            sprtActorPath = CutsceneManager.getSprtPath(actorID) --寻找图片
            --local roleNPCInfo = GameDataTransfer.GetNPC(actorID)
            local actorName = GameDataTransfer.GetGameString(PlotTable[index].actorNameID)
            if actionTime == nil then
                actionTime = 0.2
            end

            if true == isLeft then
                --左边出来，图片不需要翻转
                isRoll = false
            else
                --右边出来，图片需要翻转
                isRoll = true
            end

            local function ShowTxtAtionTableCallBack()
                CutsceneManager.needCheckTime = true
                CutsceneManager.m_startTime = os.clock()
            end

            local function showJuQingActorCallBack()
                CutsceneManager.ShowTxtAtionTable(layout,isLeft,txtSpeed,fontSize,c4b,txtVerticalSpace,txtTable,ShowTxtAtionTableCallBack)  
            end
            
            if actorID ~=0 then
                CutsceneManager.actorID = actorID
                CutsceneManager.showJuQingActor(layout,sprtActorPath,actorName,HeightFactor,isRoll,isLeft,actionTime,showJuQingActorCallBack)
                CutsceneManager.actionFinished = false
            else
                CutsceneManager.actorID = 0
                local dp = string.split(PlotTable[index].defaultXY,",")
                local sp = string.split(PlotTable[index].startXY,",")
                local ep = string.split(PlotTable[index].endXY,",")
                CutsceneManager.closeCosmic(index)
                if dp[2] == nil or sp[2] == nil or ep[2] == nil then
                    
                    PlotTable[index].cosmic = 0
                    cclog("剧情第"..index.."句里的漫画坐标有问题!")
                    CutsceneManager.index = CutsceneManager.index + 1
                else
                    CutsceneManager.showComsic(actionTime,layout,actorName,PlotTable[index].cosmic_id,PlotTable[index].mode,cc.p(tonumber(dp[1]),tonumber(dp[2])),cc.p(tonumber(sp[1]),tonumber(sp[2])),cc.p(tonumber(ep[1]),tonumber(ep[2])),PlotTable[index])
                end
                CutsceneManager.actionFinished = false
            end
        else
            ----定时器该停止了!
            JuqingOver()
            CutsceneManager.actionFinished = false
        end
    end

    local function showUDBlackBorderCallBack()
        layout:unscheduleUpdate()
        layout:scheduleUpdateWithPriorityLua(update,0)
        CutsceneManager.JumpOverBtnToRunningScene(function() 
            JuqingOver()
         end)
    end
    CutsceneManager.showUDBlackBorder(layout,topSprite,bottomSprite,actionTime,showUDBlackBorderCallBack)
end

function CutsceneManager.JumpOverBtnToRunningScene(callBack)
    local scene = cc.Director:getInstance():getRunningScene()
    local size = cc.Director:getInstance():getVisibleSize()
    local nodeChild = scene:getChildByTag(CutsceneManager.JumpOverBtnTag)
    if nil == nodeChild then
        --添加跳过按钮功能
        local csbjumpOver = cc.CSLoader:createNode("zy-4.csb")
        csbjumpOver:setPosition(cc.p(size.width-85,size.height-75))
        scene:addChild(csbjumpOver,101,CutsceneManager.JumpOverBtnTag)
        --监听
        local btn = csbjumpOver:getChildByTag(13)
        btn:setPressedActionEnabled(true)
        btn:addTouchEventListener(function(sender,eventType)
            if eventType== ccui.TouchEventType.began then
                csbjumpOver:removeFromParent()
                if nil ~= callBack then
                    callBack()
                end
            end
        end)
    end
end

