local BalanceScene = class("BalanceScene",function()
    return cc.Layer:create()
end)

local mathMax = math.max
local mathMin = math.min
local mathabs = math.abs
local mathFloor = math.floor
local mathCeil = math.ceil
local children={}
local instance = nil

BalanceValues =
    {
        relive_choose = 1,
        before_lv = 0,
        now_lv =0,
        before_pro ={att = 0,def =0,hp=0,cri = 0},
        now_pro ={att = 0,def =0,hp=0,cri = 0},
        can_ReStart = false,
        isUpgrade = false,
        isWin = false,
        isInBalance = false,
        star_count=1,
        actor_count=1,
        start_money=0,
        money_get = 0,
        actor_orginal_level =0,
        actor_next_level=0,
        actor_start_exp=0,
        actor_orginal_exp=0,
        actor_exp_list=0,
        actor_head_list=nil,
        item_list = nil,
        shouldAutoChangeScene = true,
        already_press = false,
        scene_child_index = 0,
        pvp_winner = 0,
        pvp_data = 0,
        role_list ={
            1,
            3,
            2
        },
        star_list ={
            [1] = 0,
            [2] = 0,
            [3] = 0
        }
    }
 
function BalanceScene:ctor()
        
    local function onNodeEvent(event)
        if event == "enter" then
            self:sceneEnter()
        elseif event=="exit" then
            self:sceneExit()
        end
    end
    
    self:registerScriptHandler(onNodeEvent)
end

function  BalanceScene:sceneEnter()
    cclog("BalanceScene sceneEnter")

end

function BalanceScene:sceneExit()
    cclog("BalanceScene sceneExit")
    self:removeAllChildren()
    table.clear(children)
    --cc.SpriteFrameCache:getInstance():removeUnusedSpriteFrames()
    cc.Director:getInstance():getTextureCache():removeUnusedTextures()
    BalanceValues.isInBalance = false
    
end


function BalanceScene.createChallenge()

    BalanceValues.start_money = 0
    BalanceValues.actor_start_exp = 0
    BalanceValues.already_press = false
    
    local scene = BalanceScene.new()
    children.FBJS = cc.CSLoader:createNode("YZJM-tzsl.csb")
    local confirm = children.FBJS:getChildByTag(2):getChildByTag(1)
    local winNode = children.FBJS:getChildByTag(2):getChildByTag(2):getChildByTag(1)
    local loseNode = children.FBJS:getChildByTag(2):getChildByTag(2):getChildByTag(2)
    
    local EventWinNode = children.FBJS:getChildByTag(3)--胜利NOTE

    
    local moneyNode = EventWinNode:getChildByTag(1)--奖励金钱NOTE
    local expNode = EventWinNode:getChildByTag(2)--奖励经验NOTE
    local prestigeNode = EventWinNode:getChildByTag(3)--奖励声望NOTE
    local yuanbaoNode = EventWinNode:getChildByTag(4)--奖励元宝NOTE

    
    moneyNode:setVisible(false)
    expNode:setVisible(false)
    prestigeNode:setVisible(false)
    yuanbaoNode:setVisible(false)

    moneyNode:setPositionX(0)
    expNode:setPositionX(0)
    prestigeNode:setPositionX(0)
    yuanbaoNode:setPositionX(0)
    
    local win = 1
    if BalanceValues.isWin == true then
        winNode:setVisible(true)
        loseNode:setVisible(false)
        
        if GameManager.FB_Value.isPvP == true then
            BalanceValues.money_get = BalanceValues.pvp_data.MyData.getCoins
            moneyNode:setVisible(true)
            BalanceScene:countMoney(moneyNode:getChildByTag(2))
        end
    else
        win = 0
        loseNode:setVisible(true) 
        winNode:setVisible(false)
    end
    
    local function refreshPress()
        BalanceValues.already_press = false
    end
    
    local function button(sender,eventType)------选择难度选项卡
        local index = sender:getTag()
        GameManager.setFBState(false)

        if eventType== ccui.TouchEventType.ended and BalanceValues.already_press == false then
            GameManager.FB_Value.is_power_over = false
            if BalanceValues.shouldAutoChangeScene == true then
                if GameManager.FB_Value.isPvP == false and GameManager.FB_Value.is_3v3 == false then
                    if GameManager.FB_Value.fb_type >89 and GameManager.FB_Value.fb_type < 96 then
                        NowSceneReplace(ExpeditionScene,true)
                        
                    end
                elseif GameManager.FB_Value.is_Fishing_PvP == true then
                    
                    GameNetwork.Game_Request(request_num.NETWORK_REQUEST_FISHING_LOOTEND,win)
                elseif GameManager.FB_Value.is_Ladder_PvP == true then

                    GameNetwork.Game_Request(request_num.NETWORK_REQUEST_LADDER_BALANCE,win)
                else
                    
                    GameManager.ShowPvP(BalanceValues.pvp_data)
                    BalanceValues.pvp_data = 0
                    --BalanceValues.pvp_winner:sendPvPGameEndRequest(win)
                    BalanceValues.pvp_winner = 0
                end
            end 
            
            BalanceValues.already_press = true
            sender:stopAllActions()
            sender:runAction(cc.Sequence:create(cc.DelayTime:create(2),cc.CallFunc:create(refreshPress)))
            return true
        end
    end


    confirm:addTouchEventListener(button)
    
    scene:addChild(children.FBJS,1,1000)
    children.FBJS:setPosition(640,400)
    BalanceValues.isInBalance = true
    instance = scene
    return scene
end

function BalanceScene.create()

    local scene = BalanceScene.new()

    instance = scene
    
    
    scene.update_time = 0
    scene.count = 0
    
    BalanceValues.start_money = 0
    BalanceValues.actor_start_exp = 0
    BalanceValues.already_press = false
    
    local function refreshPress()
        BalanceValues.already_press = false
    end

    if GameManager.FB_Value.is_infinite == true then


        local itemString = GameData_List.Game_box[1]
        if not itemString then 
            return
        end

        local layerFarm = GameAssistor.GetRunningScene()
        local background = GameAssistor.CreateBackMaskLayout(180)

        -- local zOrder=GameMainScene.pageZOrder.PAGE_WARNING
        layerFarm:addChild(background,10000,10000)

        local obstructLayout = GameAssistor.CreateBackMaskLayout()
        background:addChild(obstructLayout)
        background.obstructLayout=obstructLayout

        obstructLayout:setAnchorPoint(cc.p(0.5,0.5))
        GameAssistor.SetToSceneCenter(obstructLayout)

       
        
        local function HidePage()
            GameMainScene.HidePageScaleToAction(obstructLayout,RemovePage)
        end

        local page_layer = cc.CSLoader:createNode("UI_tankuangjiesuan.csb")
        GameAssistor.SetToSceneCenter(page_layer)
        obstructLayout:addChild(page_layer)

        local scrollview = page_layer:getChildByName("ScrollView_1")
        for i = 1, 13 do
            local item = scrollview:getChildByName("wupin" .. i)
            item:setVisible(false)
        end
     
        local its = {}


        -- cclog("-------------->")
        if GameManager.FB_Value.dropList_getList then
            for _,v in pairs(GameManager.FB_Value.dropList_getList) do
                print_lua_table(v)
                if its[v.ID] then
                    its[v.ID].num = its[v.ID].num + v.qty
                else
                    its[v.ID] = {}
                    its[v.ID].id = v.ID
                    its[v.ID].num = v.qty
                end
            end
        end

        local i = 1
        for _, v in pairs(its) do
            local item = scrollview:getChildByName("wupin"..i)
            i = i + 1
            local icon = item:getChildByTag(1):getChildByTag(1)
            local itemData = GameDataTransfer.GetItemData(tonumber(v.id))
            local icont = item:getChildByTag(1):getChildByTag(1)
            icont:loadTexture(GameDataTransfer.GetIconPath(itemData.IconID))
            local texNum = item:getChildByTag(1):getChildByTag(3)
            texNum:setString("x" .. v.num)
            local txName=item:getChildByTag(1):getChildByTag(2)
            local name=GameDataTransfer.GetGameString(itemData.Equip_Name)
            StageScene.SetQualityNameText(txName,name,itemData.Quality)
            txName:setVisible(true)
            texNum:setVisible(true)
            item:setVisible(true)
            GameRecorder.ItemGain(tonumber(v.id), tonumber(v.num))
        end

        local btn_lingqu = page_layer:getChildByName("anniu_lingqu")
        btn_lingqu:addTouchEventListener(
            function(sender,eventType)
                if eventType== ccui.TouchEventType.ended then
                    GameMainScene.HidePageScaleToAction(obstructLayout,function()
                        layerFarm:removeChild(background)
                        GameManager.ExitFB()       
                    end)
                end
        end)      
        GameMainScene.PlayPageScaleToAction(obstructLayout)     
        
        return
    end



    children.FBJS = cc.CSLoader:createNode("ZD-WIN.csb")   
    
--    local lose_node =  bg_scene:getChildByTag(3)
--    local back_node = bg_scene:getChildByTag(1):getChildByTag(1)
--    local star_node =  FBJS:getChildByTag(3):getChildByTag(1)
--    local Light_node = win_node:getChildByTag(1):getChildByTag(3)  --胜利背光
--    local tip_node = win_node:getChildByTag(4):getChildByTag(85)   --
--    local actor_node =  win_node:getChildByTag(3)                  --角色头像

-----------------------------------胜利相关-----------------------------------------
    
    local win_node
    local EventWinNode
    
    
    if BalanceValues.isWin == true then
    
        win_node =  children.FBJS:getChildByTag(1)--胜利NOTE
        
        local win_button_node =  win_node:getChildByTag(2)--按钮NOTE

        local use_time_node = win_node:getChildByTag(1):getChildByTag(0)
        local button_choose_next = win_button_node:getChildByTag(2)--下一关
        --button_choose_next:setVisible(false)



        
        local is_show_next = true
        
        if BalanceValues.shouldAutoChangeScene == false or 
        (GameManager.FB_Value.fb_id < 11 or (GameManager.FB_Value.fb_id > 100 and GameManager.FB_Value.fb_id <103))
        or GameManager.FB_Value.fb_type == 7 then
        
            is_show_next = false
        end
        
        button_choose_next:setVisible(is_show_next)
        
        local effectPath="e-WIN.csb"
        children.effect_Win = cc.CSLoader:createNode(effectPath)
        children.tl = cc.CSLoader:createTimeline(effectPath)
        
        
        local button_getAward = win_button_node:getChildByTag(1)--再玩一次
        --button_getAward:setVisible(false)
        
        use_time_node:setString(GameManager.getUseTimeString())
        
        win_button_node:setVisible(true)
        
        local function button(sender,eventType)------选择难度选项卡
            local index = sender:getTag()
            GameManager.setFBState(false)

            if eventType== ccui.TouchEventType.ended and BalanceValues.already_press == false then

                SoundMG_PlayMusic("Sounds/Effects/anniu.mp3", false)
                --if BalanceValues.shouldAutoChangeScene == true then
                if index == 1 then
                    GameManager.ExitFB()

                elseif index ==  2 then


                    local fbData = GameDataTransfer.GetGameFB(GameManager.FB_Value.fb_id+1)

                    if fbData then
                        GameManager.GameBalanceVisible(false)
                        --math.max(FbEventData[1].maxWin-playData.WinTimes,0)
                        GameEventManager.Shutdown()
                        GameManager.battleScenes.m_Restart = true
                        StageScene.ChallengeWinnerAwards(GameManager.FB_Value.fb_id,GameManager.FB_Value.fb_exp,GameManager.FB_Value.dropList_getList,GameManager.FB_Value.starGetList)
                        GameManager.startFB(GameManager.FB_Value.fb_id+1)
                    end
                end
                --end

                BalanceValues.already_press = true
                sender:stopAllActions()
                sender:runAction(cc.Sequence:create(cc.DelayTime:create(2),cc.CallFunc:create(refreshPress)))

                return true

            end
        end



        button_getAward:addTouchEventListener(button)
        button_choose_next:addTouchEventListener(button)
        if GameManager.FB_Value.isPvP == true or GameManager.FB_Value.is_3v3 == true then
            -- 星星
            win_node:getChildByTag(1):setVisible(false)
            -- 额外奖励
            win_node:getChildByTag(3):setVisible(false)
            -- 金币经验
            win_node:getChildByTag(4):setVisible(false)
            -- 奖励
            win_node:getChildByTag(5):setVisible(false)
            -- button_getAward:setString("返回")

            local screenSize = cc.Director:getInstance():getWinSize()
            local resfont={
                        outlineSize=1,fontSize=30,fontFilePath="Fonts/Number-ty3.ttf"
                    }
            local strLable=cc.Label:createWithTTF(resfont,"恭喜你排名上升至" .. GameManager.FB_Value.rivalPro.rank .. "名")
            strLable:setAlignment(cc.TEXT_ALIGNMENT_LEFT,cc.TEXT_ALIGNMENT_CENTER)
            strLable:setWidth(screenSize.width)
            strLable:setAnchorPoint(cc.p(0,1))
            strLable:setPositionX(-150)
            -- strLable:setString()-- .. GameManager.FB_Value.rivalPro.rank .. "名")
            win_node:addChild(strLable)
            --strLable:setColor(color or cc.c3b(255,0,0))
            --nowScene:addChild(strLable,SCREEN_STRING_LABLE_TAG,SCREEN_STRING_LABLE_TAG)
            -- return
            ArenaScene.ChallengeWinner(GameManager.FB_Value.rivalPro.rank)
        end
        
        local Pass_note1 = win_node:getChildByTag(3):getChildByTag(1)
        local Pass_note2 = win_node:getChildByTag(3):getChildByTag(2)
        local Pass_note3 = win_node:getChildByTag(3):getChildByTag(3)
        
        local fbData = GameDataTransfer.GetGameFB(GameManager.FB_Value.fb_id)--获取副本信息 


        Pass_note1:getChildByTag(2):setString("顺利通过副本")

        local displayStr=GameDataTransfer.GetSysString(str_system.STRING_TIPS_FB_CONDITION2)
        displayStr = string.gsub(displayStr,"A",math.floor(fbData.ConditionValue2/60))
        displayStr = string.gsub(displayStr,"B",math.floor(fbData.ConditionValue2)%60)
        Pass_note2:getChildByTag(2):setString(displayStr)  

        local displayStr=GameDataTransfer.GetSysString(str_system.STRING_TIPS_FB_CONDITION3)
        displayStr = string.gsub(displayStr,"A",fbData.ConditionValue3)
        Pass_note3:getChildByTag(2):setString(displayStr)  

        BalanceValues.star_count = GameManager.getFBStarNum()


        for i=1, 3 do
            if BalanceValues.star_list[i] == 0 then
                win_node:getChildByTag(3):getChildByTag(i):getChildByTag(1):setVisible(false)
            end
        end

        scene:setStar(0)

        local coincount = 0
        local Diamondcount =0 

        local normalItemList ={}

        local nowGetItem = GameManager.FB_Value.dropList_getList

        if nowGetItem and nowGetItem ~= 0 then
            for i=1,#nowGetItem do
                local iData=GameDataTransfer.GetItemData(nowGetItem[i].ID)
                if res_item_type.DIAMOND == iData.Type then
                    Diamondcount = Diamondcount + nowGetItem[i].qty
                elseif res_item_type.COINS == iData.Type then
                    coincount = coincount + nowGetItem[i].qty
                else
                    local tempVar = {ID = nowGetItem[i].ID ,qty = nowGetItem[i].qty}
                    table.insert(normalItemList,tempVar)
                end
            end
        end


        for i=1,3 do
            local ndItem = win_node:getChildByTag(5):getChildByTag(i):getChildByTag(1)
            ndItem:setVisible(false)
            if normalItemList[i] then

                local iData=GameDataTransfer.GetItemData(normalItemList[i].ID)
                if iData then
                    --outputString("ID:"..iData.Equip_Id.." : ".."IconID:"..iData.IconID.." Quality:"..iData.Quality)
                    local icon=ndItem:getChildByTag(1)
                    icon:loadTexture(GameDataTransfer.GetIconPath(iData.IconID))
                    local txName=ndItem:getChildByTag(2)
                    local name=GameDataTransfer.GetGameString(iData.Equip_Name)
                    local txNum = ndItem:getChildByTag(3)
                    txNum:setString(""..normalItemList[i].qty)
                    txNum:setVisible(true)
                    --name=(name.."x"..normalItemList[i].qty)
                    StageScene.SetQualityNameText(txName,name,iData.Quality)
                    txName:setVisible(true)
                    ndItem:setVisible(true)
                end
            end
        end

        local firstPlayNoticeNode = win_node:getChildByTag(5):getChildByTag(0)

        if GameManager.FB_Value.First_Play_Fb ~= true then
            firstPlayNoticeNode:setVisible(false)
        end

        local nowLv = GameRecorder.GetBasicData("level")
        win_node:getChildByTag(4):getChildByTag(1):getChildByTag(1):setString(""..nowLv)

        local diamondNode = win_node:getChildByTag(4):getChildByTag(2)
        local coinNode = win_node:getChildByTag(4):getChildByTag(3)
        
        
        
        local expcount = GameManager.FB_Value.fb_exp
        
        if coincount > 0 and expcount >0 then
            diamondNode:getChildByTag(1):setString(""..expcount)
            coinNode:getChildByTag(1):setString(""..coincount)
        elseif coincount > 0 then
            diamondNode:setVisible(false)
            coinNode:getChildByTag(1):setString(""..coincount)
        elseif expcount > 0 then
            coinNode:setVisible(false)
            diamondNode:getChildByTag(1):setString(""..expcount)
        else
            diamondNode:setVisible(false)
            coinNode:setVisible(false)
        end
        
        BalanceScene.reFreshPro(BalanceValues.before_pro)
        
        if GameManager.FB_Value.speacil_fb_type ~= 0 then
            if GameManager.FB_Value.speacil_fb_type == 1 then
                RuinExplorers.ChallengeWinner_WithCoins(coincount)
            elseif GameManager.FB_Value.speacil_fb_type == 2 then
                RuinExplorers.ChallengeWinner_WithExp(expcount)
            elseif GameManager.FB_Value.speacil_fb_type == 3 then
            end
        
        else
            if GameManager.FB_Value.dropList_getList and GameManager.FB_Value.dropList_getList ~= 0 then
                StageScene.ChallengeWinnerAwards(GameManager.FB_Value.fb_id,expcount,GameManager.FB_Value.dropList_getList,GameManager.FB_Value.starGetList)
            end
        end
        
        BalanceValues.before_lv = nowPlayer[1].lv
        BalanceValues.now_lv = GameRecorder.GetBasicData("level")
        BalanceValues.isUpgrade =  BalanceValues.now_lv > BalanceValues.before_lv
        
        if BalanceValues.isUpgrade == true then
            BalanceScene.reFreshPro(BalanceValues.now_pro)

        end

    end
    

-----------------------------------------------失败界面--------------------------------
    local lose_node =  children.FBJS:getChildByTag(2)--失败NOTE
    
    if BalanceValues.isWin == false then 
        
        local lose_button_node =  lose_node:getChildByTag(2)--按钮NOTE
        
        local button_back = lose_button_node:getChildByTag(2)--下一关
        --button_back:setVisible(false)
        local button_relive = lose_button_node:getChildByTag(1)--再玩一次
        
        
        local lb = button_relive:getChildByTag(1)
        lb:setString("30")
        if GameManager.FB_Value.isPvP == true or GameManager.FB_Value.is_3v3 == true or GameManager.FB_Value.is_infinite == true then
            button_relive:setVisible(false)

            lose_node:getChildByTag(1):setVisible(false)
            lose_node:getChildByTag(4):setVisible(false)
            local screenSize = cc.Director:getInstance():getWinSize()
            local resfont={
                        outlineSize=1,fontSize=30,fontFilePath="Fonts/Number-ty3.ttf"
                    }
            local strLable=cc.Label:createWithTTF(resfont,"你的排名保持不变")
            strLable:setAlignment(cc.TEXT_ALIGNMENT_LEFT,cc.TEXT_ALIGNMENT_CENTER)
            strLable:setWidth(screenSize.width)
            strLable:setAnchorPoint(cc.p(0,1))
            strLable:setPositionX(-150)
            -- strLable:setString()-- .. GameManager.FB_Value.rivalPro.rank .. "名")
            lose_node:addChild(strLable)
        else
            button_relive:setVisible(true)
        
            lose_node:getChildByTag(1):setVisible(true)
            lose_node:getChildByTag(4):setVisible(true)
        end
        
        local relifeChoose = {2524,2525,2526}
        local relifeChoose2 = {"攻击+5%","防御+5%","血量+5%"}
        for i=1,3 do
        
            local ndItem = lose_node:getChildByTag(1):getChildByTag(i):getChildByTag(1)
            ndItem:setVisible(false)
            
            if relifeChoose[i] then
                --outputString("ID:"..iData.Equip_Id.." : ".."IconID:"..iData.IconID.." Quality:"..iData.Quality)
                local icon=ndItem:getChildByTag(1)
                icon:loadTexture(GameDataTransfer.GetIconPath(relifeChoose[i]))
                local txName=ndItem:getChildByTag(2)
                local name=relifeChoose2[i]
                --local txNum = ndItem:getChildByTag(3)
                --txNum:setString(""..normalItemList[i].qty)
                --txNum:setVisible(true)
                --name=(name.."x"..normalItemList[i].qty)
                StageScene.SetQualityNameText(txName,name,1)
                txName:setVisible(true)
                ndItem:setVisible(true)
            end
        end
        
        local function chooseRLbutton(sender,eventType)
        
            local nowIndex =  sender:getParent():getTag()
            
            
            if eventType== ccui.TouchEventType.ended then
                
            elseif eventType== ccui.TouchEventType.began then
                --sender:reorderChild(sender:getChildByTag(4),20)
                for i=1,3 do
                    if i == nowIndex then
                        lose_node:getChildByTag(1):getChildByTag(i):getChildByTag(1):getChildByTag(4):setVisible(true)
                    else
                        lose_node:getChildByTag(1):getChildByTag(i):getChildByTag(1):getChildByTag(4):setVisible(false)
                    end
                end
                if nowIndex == 1 then
                    BalanceValues.relive_choose = 1
                elseif nowIndex == 2 then
                    BalanceValues.relive_choose = 2
                elseif nowIndex == 3 then
                    BalanceValues.relive_choose = 3
                end
                
            end
        end
        
        BalanceValues.relive_choose = 1
        lose_node:getChildByTag(1):getChildByTag(1):getChildByTag(1):getChildByTag(4):setVisible(true)
        
        for i=1,3 do
            lose_node:getChildByTag(1):getChildByTag(i):getChildByTag(1):addTouchEventListener(chooseRLbutton)
            
        end
        
        lose_button_node:setVisible(true)

        local function button(sender,eventType)------选择难度选项卡
            local index = sender:getTag()
            GameManager.setFBState(false)

            if eventType== ccui.TouchEventType.ended and BalanceValues.already_press == false then


                local retry = function() 
                    GameManager.ReliveResult()
                    local p = nowPlayer[1]
                    if p then
                        for j = 1, 3 do
                            p.skill_list[j].can_use = true
                            p.skill_cd[j] = 0
                        end
                        GameManager.setSkillIcon(p.skill_list)
                    end
                end


                if index == 1 then 
                    if PlayerDataList.Basic.diamond < 30 then
                        StoreScene.CharageRMB(GameData_List.Game_Shop[24], retry, true)
                        return
                    else

                        PlayerDataList.Basic.diamond = PlayerDataList.Basic.diamond - 30
                        GameRecorder.SaveBasicData()
                        GameMainScene.RefreshPlayerStateBar()
                    end

                    retry()
                    

                elseif index ==  2 then
                    GameManager.ExitFB()
                end

                BalanceValues.already_press = true
                sender:stopAllActions()
                sender:runAction(cc.Sequence:create(cc.DelayTime:create(2),cc.CallFunc:create(refreshPress)))

                return true

            end
        end



        button_relive:addTouchEventListener(button)
        button_back:addTouchEventListener(button)
    end
    
    
    if BalanceValues.isWin == false then 
        
        lose_node:setVisible(true)
    else
        win_node:setVisible(true)
    end
    
    scene:addChild(children.FBJS,1,1000) 
    
    if children.FBJS and win_node then
        children.FBJS:addChild(children.effect_Win)
        if children.tl then
            children.effect_Win:runAction(children.tl)
            children.tl:gotoFrameAndPlay(0,false)
        end
    end
     
    GameAssistor.SetToSceneCenter(children.FBJS)
    
    
    if BalanceValues.isWin == true then
        if GameManager.FB_Value.isPvP ~= true and GameManager.FB_Value.is_3v3 ~= true and GameManager.FB_Value.is_infinite ~= true then
            local rewardsString = GameDataTransfer.GetGameFB(GameManager.FB_Value.fb_id).reward_list
            local rewardList = string.split(rewardsString, ",")
            -- print_lua_table(rewardList)
            -- CommonAssistor.ShowWinBox(tonumber(rewardList[math.random(1,#rewardList)]))        
        end
    end

    BalanceValues.isInBalance = true
    
    return scene
end

function BalanceScene.getInstance()
    return instance
end

local pro1,pro2,pro3,pro4
local showSJ = false

function BalanceScene.addLevelUpPage()
    if children.SJBack ~= nil then return end

    local mainScene = BalanceScene.getInstance()
    showSJ = true
    children.SJBack = GameAssistor.CreateMaskLayout(cc.c3b(0,0,0),200)
    children.SJfont = GameAssistor.CreateMaskLayout(cc.c3b(0,0,0),0)
    children.SJfont:addTouchEventListener(
        function(sender,eventType)
            if eventType== ccui.TouchEventType.ended then 
                if children.SJBack ~= nil and showSJ == false then
                    children.SJBack:removeFromParent()
                    children.SJBack = nil
                    children.SJfont = nil
                    children.FBSJ = nil
                end
            end
        end)
    children.FBSJ = cc.CSLoader:createNode("ZJ-sj.csb")
    
    children.FBSJ:getChildByTag(0):getChildByTag(2):setString(""..BalanceValues.now_lv)
    children.FBSJ:getChildByTag(1):getChildByTag(1):setString(""..BalanceValues.before_pro.att)
    children.FBSJ:getChildByTag(1):getChildByTag(3):setString(""..BalanceValues.before_pro.att)
    children.FBSJ:getChildByTag(2):getChildByTag(1):setString(""..BalanceValues.before_pro.def)
    children.FBSJ:getChildByTag(2):getChildByTag(3):setString(""..BalanceValues.before_pro.def)
    children.FBSJ:getChildByTag(3):getChildByTag(1):setString(""..BalanceValues.before_pro.hp)
    children.FBSJ:getChildByTag(3):getChildByTag(3):setString(""..BalanceValues.before_pro.hp)
    children.FBSJ:getChildByTag(4):getChildByTag(1):setString(""..BalanceValues.before_lv)
    children.FBSJ:getChildByTag(4):getChildByTag(3):setString(""..BalanceValues.now_lv)
    
    pro1 = BalanceValues.before_pro.att
    pro2 = BalanceValues.before_pro.def
    pro3 = BalanceValues.before_pro.hp
    
    children.sj_spine = CreateSpineRes("effect/shengji","effect/shengji")
    children.FBSJ:addChild(children.sj_spine)
    children.sj_spine:setAnimation(0,"animation", false)
    
    children.sj_spine:registerSpineEventHandler(function (event)
           children.sj_spine:setVisible(false)
    end, sp.EventType.ANIMATION_COMPLETE)
    
    children.SJBack:addChild(children.FBSJ)
    
    children.FBSJ:setScaleX(0.1)
    children.FBSJ:setScaleY(0.1)
    
    children.SJBack:addChild(children.SJfont)
    GameAssistor.SetToSceneCenter(children.FBSJ)
    
    
    mainScene:addChild(children.SJBack,1001)
    
    
    
    
    local change1,change2,change3
    
    function change1()
        if pro1 < BalanceValues.now_pro.att then
            pro1 = pro1 + mathMax(1,mathCeil((BalanceValues.now_pro.att - pro1)*0.2))
            children.FBSJ:getChildByTag(1):getChildByTag(3):setString(""..pro1)
            children.FBSJ:getChildByTag(1):getChildByTag(3):runAction(cc.Sequence:create(cc.DelayTime:create(0.02),cc.CallFunc:create(change1)))
        end
    end
    
    function change2()
        if pro2 < BalanceValues.now_pro.def then
            pro2 = pro2 + mathMax(1,mathCeil((BalanceValues.now_pro.def - pro2)*0.2))
            children.FBSJ:getChildByTag(2):getChildByTag(3):setString(""..pro2)
            children.FBSJ:getChildByTag(2):getChildByTag(3):runAction(cc.Sequence:create(cc.DelayTime:create(0.02),cc.CallFunc:create(change2)))
        end
    end
    
    function change3()
        if pro3 < BalanceValues.now_pro.hp then
            pro3 = pro3 + mathMax(1,mathCeil((BalanceValues.now_pro.hp - pro3)*0.2))
            children.FBSJ:getChildByTag(3):getChildByTag(3):setString(""..pro3)
            children.FBSJ:getChildByTag(3):getChildByTag(3):runAction(cc.Sequence:create(cc.DelayTime:create(0.02),cc.CallFunc:create(change3)))
        end
    end
    
    children.FBSJ:runAction(cc.Sequence:create(cc.ScaleTo:create(0.2,1.0),cc.CallFunc:create(function()
        change1()
        change2()
        change3()
        showSJ = false 
    end)))
end


function BalanceScene.reFreshPro(m_Temp)
    m_Temp.att =0
    m_Temp.def =0
    m_Temp.hp =0
    m_Temp.cri =0
    for i=1,3 do
        local a,b,c,d = GameRecorder.GetRoleAttributes(i)
        m_Temp.att = m_Temp.att + a
        m_Temp.def = m_Temp.def + b
        m_Temp.hp = m_Temp.att + c
        m_Temp.cri = m_Temp.cri + d
    end
end

function BalanceScene.setRoleIcon(icon_node,ID)
--    local icon =  icon_node:getChildByTag(2)
--    local imagePath = string.format("Icons/poto/%d.png",ID)
--    icon:loadTexture(imagePath,ccui.TextureResType.localType)
--    icon:setScaleX(0.8)
--    icon:setScaleY(0.8)
end

function BalanceScene.SaveRoleLevelUpData(isUp,roleID,lastLv,level,newSkill)

    children.isUp = isUp
    children.roleID = roleID
    children.lastLv = lastLv
    children.level = level
    children.newSkill = newSkill
end


function BalanceScene:setWin(obj)

    obj:setVisible(true)

    
end
function BalanceScene:updateLayer(dt)
    self.update_time = self.update_time + dt
    self.count = self.count + 1 

    self:setExp()
    self:setMoney()

   
    
end

function BalanceScene:setStar(m_time)
    local time = m_time
    local win_node =  children.FBJS:getChildByTag(1)--胜利NOTE
    local star_node =  win_node:getChildByTag(1)
    --local star_Back_node =  win_node:getChildByTag(3):getChildByTag(1):getChildByTag(1) 
    local star_1 = star_node:getChildByTag(1):getChildByTag(1)
    local star_2 = star_node:getChildByTag(2):getChildByTag(1)
    local star_3 = star_node:getChildByTag(3):getChildByTag(1)
    
    
    star_1:setVisible(false)
    star_2:setVisible(false)
    star_3:setVisible(false)
    
    star_1:setScale(10.5)
    star_2:setScale(10.5)
    star_3:setScale(10.5)
    
    
    --star_1:setScale(float,float)
    
    local showStar
    local starIndex = 1
    local endIndex = 1
    
    function showStar()
        if BalanceValues.star_count < starIndex then
            if BalanceValues.isUpgrade == true then 
                BalanceScene.addLevelUpPage()
            end
            return 
        end
        
        local scale_action = cc.ScaleTo:create(0.3,1.0)
        local m_star = star_node:getChildByTag(starIndex):getChildByTag(1)
        local back_start = star_node:getChildByTag(starIndex):getChildByTag(0)
        
        m_star:setVisible(false)
        m_star:setPosition(((starIndex-1)*300)-300,266)
        local bx = back_start:getPositionX()
        local by = back_start:getPositionY()
        
        local startAction
        
        
        function startAction()
            m_star:setVisible(true)
--            local tempRoot = star_Back_node:getChildByTag(endIndex)
--            local tempshine = cc.CSLoader:createNode("FBJS-3e.csb")
--            local t_tempshine=  cc.CSLoader:createTimeline("FBJS-3e.csb")
--            m_star:addChild(tempshine)
--            tempshine:setPosition(65,61)
--            tempshine:runAction(t_tempshine)
--            t_tempshine:gotoFrameAndPlay(0,false)
            GameSound.PlayEffect(SoundEffect.UI_DRAW_STAR)
--            endIndex = endIndex + 1
            --GameManager.getMain():creatShock(0.2,10)
        end
        
        local a1 = cc.Sequence:create(cc.CallFunc:create(startAction),cc.EaseBounceOut:create(scale_action))
        local a3 = cc.MoveTo:create(0.2,{x = bx,y = by})
        local a2 = cc.Sequence:create(cc.DelayTime:create(0.2),cc.CallFunc:create(showStar))
        
        if starIndex < 4 then
            m_star:runAction(cc.Spawn:create(a1,a2,a3))
        end
        
        starIndex = starIndex + 1
    end
    
    showStar()
--    
--   
--    if time == 15 and star_1:isVisible() == false then
--        if BalanceValues.star_count >= 1 then
--            local scale_action = cc.ScaleTo:create(0.2,1.0)
--            star_1:setVisible(true)
--            star_1:runAction(cc.EaseBounceOut:create(scale_action))
--            GameSound.PlayEffect(SoundEffect.UI_CLICK)
--        end
--        
--    elseif time ==30 and star_2:isVisible() == false then
--        if BalanceValues.star_count >= 2 then
--            local scale_action = cc.ScaleTo:create(0.2,1.0)
--            star_2:setVisible(true)
--            star_2:runAction(cc.EaseBounceOut:create(scale_action))
--            --star_2:runAction(scale_action)
--            GameSound.PlayEffect(SoundEffect.UI_CLICK)
--        end
--        
--    elseif time ==45 and star_3:isVisible() == false then
--        if BalanceValues.star_count >= 3 then
--            local scale_action = cc.ScaleTo:create(0.2,1.0)
--            star_3:setVisible(true)
--            star_3:runAction(cc.EaseBounceOut:create(scale_action))
--            --star_3:runAction(scale_action)
--            GameSound.PlayEffect(SoundEffect.UI_CLICK)
--
--
--        end
--        
--    elseif time ==200 then
--        
--    end
--    
    
    
end

function BalanceScene:setExp()
    
    if  BalanceValues.actor_start_exp < BalanceValues.actor_exp_list then
    
        local win_node =  children.FBJS:getChildByTag(1)--胜利NOTE
        children.Exp_node =  win_node:getChildByTag(3):getChildByTag(2):getChildByTag(1)   --金钱

        local tempStep = math.max(1,math.ceil((BalanceValues.actor_exp_list - BalanceValues.actor_start_exp)/5))
        BalanceValues.actor_start_exp = BalanceValues.actor_start_exp + tempStep
        local nowDisplayExp = math.min(BalanceValues.actor_exp_list,BalanceValues.actor_start_exp)


        local exp_string = string.format("+%d",nowDisplayExp)
        children.Exp_node:setString(exp_string)
    end
end


function BalanceScene:setActorState(actor_node,money)
    
end

function BalanceScene:setMoney()
    if  BalanceValues.start_money < BalanceValues.money_get then
    
        local tempStep = math.max(1,math.ceil((BalanceValues.money_get - BalanceValues.start_money)/5))
        BalanceValues.start_money = BalanceValues.start_money + tempStep
        local nowDisplayMoney = math.min(BalanceValues.money_get,BalanceValues.start_money)
        
        local win_node =  children.FBJS:getChildByTag(1)--胜利NOTE
        children.money_node =  win_node:getChildByTag(3):getChildByTag(2):getChildByTag(2)   --金钱
        children.money_node:setString(tostring(nowDisplayMoney))
        
    end
end


function BalanceScene:countMoney(m_root)
    GameAssistor.SetBlackOutlineNoSpace(m_root)
    local count
    function count()
        local tempStep = math.max(1,math.ceil((BalanceValues.money_get - BalanceValues.start_money)/25))
        BalanceValues.start_money = BalanceValues.start_money + tempStep
        local nowDisplayMoney = math.min(BalanceValues.money_get,BalanceValues.start_money)
        m_root:setString("+"..tostring(nowDisplayMoney))
        
        if nowDisplayMoney ~= BalanceValues.money_get then
            m_root:runAction(cc.Sequence:create(cc.DelayTime:create(0.01),cc.CallFunc:create(count)))
        end
    end
    
    count()
end

function BalanceScene:countExp(m_root)
    GameAssistor.SetBlackOutlineNoSpace(m_root)
    local count
    function count()
        local tempStep = math.max(1,math.ceil((BalanceValues.actor_exp_list - BalanceValues.actor_start_exp)/25))
        BalanceValues.actor_start_exp = BalanceValues.actor_start_exp + tempStep
        local nowDisplayExp = math.min(BalanceValues.actor_exp_list,BalanceValues.actor_start_exp)
        m_root:setString("+"..tostring(nowDisplayExp))

        if nowDisplayExp ~= BalanceValues.actor_exp_list then
            m_root:runAction(cc.Sequence:create(cc.DelayTime:create(0.01),cc.CallFunc:create(count)))
        end
    end

    count()
end

function BalanceScene.getNextBtn()
    if children.FBJS == nil then return nil end
    return children.FBJS:getChildByTag(1):getChildByTag(2):getChildByTag(1)
end

function BalanceScene:setQuality(m_root,m_quality)
    if m_quality >5 then m_quality = 5 end
    
	for i=2,5 do
        local tempQ = m_root:getChildByTag(i)
        tempQ:setVisible(false)
	end
	
    
    
	if m_quality > 1 then
        local qx =m_root:getChildByTag(m_quality)
        qx:setVisible(true)
	end
end
function BalanceScene:setItem(item_list,i_scrollview)
    
    --table.print(item_list)
    local tipsNode = i_scrollview:getParent():getChildByTag(2):getChildByTag(3)
    local m_width=50
    local count = 1 
    if item_list ~= nil then
        local item_count = List.getSize(item_list)
        local MoneyCount =0
        local MoneyInList = 0
        for i=1,item_count do
            if item_list[i].equip_id == 1 then
                MoneyCount = MoneyCount + 1
                MoneyInList = MoneyInList + item_list[i].equip_qty
            end
        end
        
        if item_count - MoneyCount >0 then tipsNode:setVisible(false) end
        
        BalanceValues.money_get = BalanceValues.money_get + MoneyInList
        
        StagesScene.AddAwardWithMotion(item_list,item_count,i_scrollview,nil,1)
        
--        for i=1,item_count do
--            
--            
--            
--                local item_layer = cc.CSLoader:createNode("ICON-F80.csb")
--
--                
--                GameDataTransfer.SetCommonAwardIcon(item_list[i].equip_id,item_layer)
--                GameDataTransfer.SetCommonAwardCounter(item_layer,item_list[i].equip_id,item_list[i].equip_qty,true)
--               
--                local button=item_layer:getChildByTag(1)
--                local name = item_layer:getChildByTag(4)--获取按钮
--                --local gameItem=GameDataTransfer.GetGameItem(item_list[i].equip_id)
--                --name:setString(GameDataTransfer.GetGameString(gameItem.Equip_Name))
--                button:removeFromParent()
--                --local image_node=item_layer:getChildByTag(6)
--
--
--                i_scrollview:addChild(button)
--
--
--                button:setPositionX((count-1)*100+50)
--                button:setPositionY(120/2+3)
--                m_width=m_width+100
--                
--                count = count + 1
--           
--        
--        end
         
    end

    if m_width>i_scrollview:getInnerContainerSize().width then
        i_scrollview:setInnerContainerSize(cc.size(m_width,i_scrollview:getInnerContainerSize().height))
    end
end

return BalanceScene