
GameCommonBox={}

GameCommonBox.JumpOverBtnTag = 60001

function GameCommonBox.GetRunningScene()
    return cc.Director:getInstance():getRunningScene()
end

function GameCommonBox.CreateMaskLayout(color,opacity)

    local layout = ccui.Layout:create()
    layout:setTouchEnabled(true)
    
    
    layout:setContentSize(cc.Director:getInstance():getVisibleSize())
    layout:setBackGroundColor(color)
    layout:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
    layout:setOpacity(opacity)
    return layout
end

--title 标题
--txt   内容
--funOk 确定回调
--funCancel 取消回调
-- param 参数
--CBObj  回调对象
--注：参数可传可不传
function GameCommonBox.ShowBox(title,txt,funOk,funCancel,Obj,param,filename)
    local nowScene = GameCommonBox.GetRunningScene()
    local layerFarm = cc.Layer:create()

    local layout = GameCommonBox.CreateMaskLayout(cc.c3b(0,0,0),100)
    layerFarm:addChild(layout)
    
    local nodeRoot = cc.CSLoader:createNode("tp-1.csb")
    local nodeTY2 = nodeRoot:getChildByTag(3)
    nodeTY2:setVisible(true)
    
    layerFarm:addChild(nodeRoot)

    local screenSize = cc.Director:getInstance():getWinSize()

    nodeRoot:setPosition(screenSize.width/2,screenSize.height/2)
    
    --背景图
    --diban
    local diban = nodeTY2:getChildByTag(1)
    local imgBg = diban:getChildByTag(1)
    if nil ~= filename then
        imgBg:loadTexture(filename,ccui.TextureResType.localType)
    end
    --
    --标题
    --bt 
    local nodebt = nodeTY2:getChildByTag(1)
    local textTitleLabel = nodebt:getChildByTag(2)
    textTitleLabel:setString(title)
    
    --内容
    local textTxtLabel = nodeTY2:getChildByTag(2)
    textTxtLabel:setString(txt)
    
    --取消
    local buttonCancel = nodeTY2:getChildByTag(4)
    buttonCancel:addTouchEventListener(
        function(sender,eventType)
            if eventType== ccui.TouchEventType.ended then 
                nowScene:removeChild(layerFarm,true)
                if nil == Obj then
                    funCancel(param)
                else
                    if nil ~= funCancel then
                        funCancel(Obj,param)
                    end
                end
                
                
            end
        end)
        
    --确定
    local buttonOk = nodeTY2:getChildByTag(3)
    buttonOk:addTouchEventListener(
        function(sender,eventType)
            if eventType== ccui.TouchEventType.ended then 
                nowScene:removeChild(layerFarm,true)
                if nil == Obj then
                    funOk(param)
                else
                    if nil ~= funOk then
                        funOk(Obj,param)
                    end
                end
            end
        end)
    nowScene:addChild(layerFarm)
end

function GameCommonBox.mainSceneHasChildPageShow()
    local result = false
    for pageZOrderChild = GameMainScene.pageZOrder.SUBPAGE_ROLEEQUIP,GameMainScene.pageZOrder.SUBPAGE_VIP do
        if true == GameMainScene.CheckSubFuncPageShowing(pageZOrderChild) then
            return true
        end
    end
    if true == GameMainScene.GetFirstChargePageShowing() then
        return true
    end
    if false == ReChargeFirstWard.getNetDataIsCallBacked() then
        return true
    end
    if true == GameCommonBox.AwardJieMianIsVisible() then
        return true
    end
    if false == SevenLoginScene.getNetDataIsCallBacked() then
        return true
    end
    return false
end

function GameCommonBox.AwardJieMianIsVisible()
    local nowScene = cc.Director:getInstance():getRunningScene()
    if nil ~= nowScene then
       local layerChild = nowScene:getChildByTag(10086)
       if nil ~= layerChild then
           return layerChild:isVisible()
       end
    end
    return false
end
--
function GameCommonBox.createTipBox(title,txt)

    local root = cc.CSLoader:createNode("tp-1.csb")
    
    --TY-1
    local nodeTY1 = root:getChildByTag(3)
    nodeTY1:setVisible(true)
    
    --背景图
    local imgBg = root:getChildByTag(1):getChildByTag(1)
    imgBg:setScale(0.3)
    
    --标题
    local nodebt1 = nodeTY1:getChildByTag(1)
    nodebt1:setScale(0.7)
    nodebt1:setPositionY(nodebt1:getPositionY()-130)
    --Text_3
    local Text = nodebt1:getChildByTag(2)
    Text:setString(title)
    
    --node2 内容
    local node2 = nodeTY1:getChildByTag(2)
    local txt1 = node2:getChildByTag(1)
    txt1:ignoreContentAdaptWithSize(false)
    txt1:setTextAreaSize(cc.size(300,30))
    txt1:setColor(cc.c3b(0,0,0))
    txt1:setFontSize(20)
    txt1:setString(txt)
    
    local txt2 = node2:getChildByTag(2)
    local txt3 = node2:getChildByTag(3)
    txt2:setVisible(false)
    txt3:setVisible(false)
    
    --隐藏 确定和取消按钮
    local Button_1 = nodeTY1:getChildByTag(3)
    Button_1:setVisible(false)
    local Button_2 = nodeTY1:getChildByTag(4)
    Button_2:setVisible(false)
    
    return root
end

--提示框 按钮控件 按下显示，松下开隐藏
function GameCommonBox.ShowTipBox(button,title,txt)
    button:addTouchEventListener(function(sender,eventType)
        local sence = GameCommonBox.GetRunningScene()
        if eventType== ccui.TouchEventType.began then
            local localPosition = sender:getWorldPosition()
            local contxtsize = sender:getContentSize()
            local txtCSB = GameCommonBox.createTipBox(title,txt)
            local pos = cc.p(100,100)
            if nil ~= button:getParent() then
                pos = button:getParent():convertToWorldSpace(cc.p(button:getPosition()))
            end
            local btnPos = sence:convertToNodeSpace(cc.p(pos.x,pos.y))
            txtCSB:setPosition(cc.p(btnPos.x-contxtsize.width,btnPos.y))
            sence:addChild(txtCSB,100,1009)
        elseif  eventType == ccui.TouchEventType.canceled or eventType ==  ccui.TouchEventType.ended then
            local nodeChild = sence:getChildByTag(1009)
            nodeChild:removeFromParent()
        end
    end
    )
end

function GameCommonBox.ClippingNode(btn,img,scale,isInverted)
    local nowIcon = cc.ClippingNode:create()
    local tempcs = btn:getCustomSize()
    local progress = cc.Sprite:create("roleImage/zhizhao.png")
    progress:setScale(scale)
    nowIcon:setAlphaThreshold(0)
    nowIcon:setStencil(progress)
    img:setPositionX(tempcs.width/2)
    img:setPositionY(tempcs.height/2)
    progress:setPositionX(tempcs.width/2)
    progress:setPositionY(tempcs.height/2)
    if nil ~= isInverted then
        nowIcon:setInverted(isInverted)
    end
    nowIcon:addChild(img)
    return nowIcon
end

function GameCommonBox.setBtnStatus(btnTable,btn,callBack)
    if type(btnTable)== "table" then
        for key,value in pairs(btnTable) do
            if nil ~= value then
                value:setEnabled(true)
                value:setBright(true)
                if nil ~= callBack then
                    callBack(value)
                end
            end
        end
    end
    if nil ~= btn then
        btn:setEnabled(false)
        btn:setBright(false)
    end
end

function GameCommonBox.setBtnColor(btn,c4bColor,isOutLine,outLinec4bColor,space)
    local txtCtrl = btn:getTitleRenderer()
    if nil ~= txtCtrl and nil ~= c4bColor then
        --txtCtrl:setColor(color)
        txtCtrl:setTextColor(c4bColor)
    end
    if isOutLine then
        GameCommonBox.enableOutline(txtCtrl,space or 2 ,outLinec4bColor or cc.c4b(255,255,255,255))
    end
end

function GameCommonBox.setNodeVisible(node,isVisible)
    if nil ~= node then
        node:setVisible(isVisible)
    end
end

--秒转化为时间
function GameCommonBox.secondToTimestring(second)
    local hour = second/3600
    local minute = (second%3600)/60
    local second = (second%60)
    return string.format("%02d:%02d:%02d",math.floor(hour),math.floor(minute),math.floor(second))
end
--秒转换为table obj
function GameCommonBox.secondToTimeTable(second)
    local time={}
    time.hour = string.format("%02d",math.floor(second/3600))
    time.minute = string.format("%02d",math.floor((second%3600)/60))
    time.second = string.format("%02d",math.floor(second%60))
    return time
end

--秒转换为table obj
function GameCommonBox.secondToDayTimeTable(second)
    local time={}
    time.day = string.format("%02d",math.floor(second/(3600*24)))
    time.hour = string.format("%02d",math.floor((second/3600)%24))
    time.minute = string.format("%02d",math.floor((second%3600)/60))
    time.second = string.format("%02d",math.floor(second%60))
    return time
end


function GameCommonBox.updateTimeDecrease(txtCtrl,totalSeconds,isToTime,callBack)
    --更新时间
    local TotalSeconds = tonumber(totalSeconds)
    local startTime = Time_GetCurrentTime()
    local showTime = 1
    local function update()
        if showTime > 0 then
            local delay = Time_GetDelayTime(startTime)
            showTime = TotalSeconds-delay
            if true == isToTime then
                -- 秒转时间字符串
                local time = GameCommonBox.secondToTimestring(showTime)
                txtCtrl:setString(time)
            else
                txtCtrl:setString(showTime)
            end
        else
            --时间到,更新
           if nil ~= callBack then
                callBack()
           end
            txtCtrl:setString("")
           txtCtrl:unscheduleUpdate()
        end
    end 
    txtCtrl:unscheduleUpdate()
    txtCtrl:scheduleUpdateWithPriorityLua(update,0)
end

function GameCommonBox.updateTimeAdd(txtCtrl,totalSeconds,overTime,isToTime,callBack)
    --更新时间
    local TotalSeconds = tonumber(totalSeconds)
    local OverTime = tonumber(overTime)
    local startTime = Time_GetCurrentTime()
    local showTime = 1
    local function update()
        if showTime < OverTime then
            local delay = Time_GetDelayTime(startTime)
            showTime = TotalSeconds+delay
            if true == isToTime then
                -- 秒转时间字符串
                local time = GameCommonBox.secondToTimestring(showTime)
                txtCtrl:setString(time)
            else
                txtCtrl:setString(showTime)
            end
        else
            --时间到,更新
            if nil ~= callBack then
                callBack()
            end
            txtCtrl:unscheduleUpdate()
        end
    end 
    txtCtrl:unscheduleUpdate()
    txtCtrl:scheduleUpdateWithPriorityLua(update,0)
end

---定时器
function GameCommonBox.update(scheduleId,update,interval,paused)
    if nil == interval then
        interval = 1.0
    end
    if nil == paused then
        paused = false
    end
    if nil ~= scheduleId then
        cc.Director:getInstance():getRunningScene():getScheduler():unscheduleScriptEntry(scheduleId)
        scheduleId = nil
    end
    if nil == scheduleId then
        scheduleId = cc.Director:getInstance():getRunningScene():getScheduler():scheduleScriptFunc(scheduleId,interval,paused)
    end
    return scheduleId
end

--适配两个节点在父点中的位置，并且他们都具有范围(即宽、高) 如：btn 下的图标加 txt distance 为两个child之间的距离
function GameCommonBox.adapterPos(parentNode,childNodeLeft,childNodeRight,scaleLeft,distance,offSetX)
    ---参数检查
    if nil == parentNode or nil == childNodeLeft or nil == childNodeRight then
        return
    end
    if nil == distance then
        distance = 0
    end
    ------------------
    local size = parentNode:getContentSize()
    local size1 = childNodeLeft:getContentSize()
    local size2 = childNodeRight:getContentSize()
    if size.width ~= 0 and 0 ~= size.height and size1.width ~= 0 and 0 ~= size1.height and size2.width ~= 0 and 0 ~= size2.height then
        local leftVisible =  childNodeLeft:isVisible()
        local rightVisible = childNodeRight:isVisible()
        if true == leftVisible and  true == rightVisible then
            local childWidth = size1.width+size2.width
            --计算两 child 之间的 相对于 父节点的 X 坐标
            local width1 = size1.width*scaleLeft
            local leftPosX = (size.width-childWidth)/2.0
            local rightPosX = leftPosX + width1
            leftPosX = leftPosX - distance/2.0 + offSetX
            rightPosX = rightPosX + distance/2.0 + offSetX
            --设置两 child 锚点
            childNodeLeft:setAnchorPoint(0,0.5)
            childNodeRight:setAnchorPoint(0,0.5)
            --
            childNodeLeft:setPosition(cc.p(leftPosX,size.height/2.0))
            childNodeRight:setPosition(cc.p(rightPosX,size.height/2.0))
        elseif true == leftVisible and false == rightVisible then
            childNodeLeft:setAnchorPoint(0.5,0.5)
            childNodeLeft:setPosition(size.width/2.0,size.height/2.0)
        elseif false == leftVisible and true == rightVisible then
            childNodeRight:setAnchorPoint(0.5,0.5)
            childNodeRight:setPosition(size.width/2.0,size.height/2.0)
        end
    end
end

function GameCommonBox.runScaleAtion(node,scale,time,funCallBack)
    if nil == node or nil == scale or nil == time then
        if nil ~= funCallBack then
            funCallBack()
        end
        return
    end
   -----------------------------------
    local function ationFinished()
        if nil ~= funCallBack then
            funCallBack()
        end
    end
    local ScaleTo = cc.ScaleTo:create(time,scale)
    node:runAction(cc.Sequence:create(cc.EaseBackInOut:create(ScaleTo),cc.CallFunc:create(ationFinished)))
end

function GameCommonBox.runActionSecondJiemian(node,time,actionCallBack)
    node:setScale(0.0)
    local scale_action = cc.ScaleTo:create(time,1.0)
    local function  actionFinished()
        if nil ~= actionCallBack then
            actionCallBack()
        end
    end    
    node:runAction( cc.Sequence:create(cc.EaseBackInOut:create(scale_action),cc.CallFunc:create(actionFinished)))
end

--执行延迟动作
function GameCommonBox.runDelayTime(delayTime,funCallBack)
    local function actionFinished()
        if nil ~= funCallBack then
            funCallBack()
        end
    end
    cc.Director:getInstance():getRunningScene():runAction(cc.Sequence:create(cc.DelayTime:create(delayTime),cc.CallFunc:create(actionFinished)))
end

--顺序显示节点
function GameCommonBox.orderShowNode(nodeTable,delayTime,callBack,isAtion)
    if nil == nodeTable or 0 == table.getn(nodeTable) then
        if nil ~= callBack then
            callBack()
        end
        return
    end
    local nodeTempTable = {}
    table.copy(nodeTable,nodeTempTable)
    local function ationFinished()
        if nil == nodeTable or 1 == table.getn(nodeTable) then
            if nil ~= callBack then
                callBack()
                return
            end
        end
        nodeTempTable = {}
        for i=2,table.getn(nodeTable) do
            table.insert(nodeTempTable,table.getn(nodeTempTable)+1,nodeTable[i])
        end
        GameCommonBox.orderShowNode(nodeTempTable,delayTime,callBack)
    end
    
    if nil == isAtion or false == isAtion then
      nodeTable[1]:setVisible(true)
      nodeTable[1]:setScale(0.0)
      local scaleTo1 = cc.ScaleTo:create(0.1,1.0)
      nodeTable[1]:runAction(cc.Sequence:create(cc.EaseBackInOut:create(scaleTo1)))
    else
        GameCommonBox.nodeScaleAction(nodeTable[1],0.2,2.0,nil)
    end
    GameCommonBox.runDelayTime(delayTime,ationFinished)
end

--一个节点放大，然后缩小
function GameCommonBox.nodeScaleAction(node,delayTime,maxScale,callBack)
    node:setVisible(true)
    node:setScale(1.0)
    --local scaleTo1 = cc.ScaleTo:create(delayTime,0.5)
    local scaleTo2 = cc.ScaleTo:create(delayTime,maxScale)
    local scaleTo3 = cc.ScaleTo:create(delayTime,1.0)
    local function actionFinished() 
        if nil ~= callBack then
            callBack()
        end
    end
    node:runAction(cc.Sequence:create(cc.EaseBackInOut:create(scaleTo2),cc.EaseBackInOut:create(scaleTo3),cc.CallFunc:create(actionFinished)))
end

--隐藏表所有的节点
function GameCommonBox.hideNodes(nodeTable)
    if type(nodeTable) == "table" then
        for key,value in pairs(nodeTable) do
            value:setVisible(false)
        end
    end
end

--显示表所有的节点
function GameCommonBox.showNodes(nodeTable)
    if type(nodeTable) == "table" then
        for key,value in pairs(nodeTable) do
            value:setVisible(true)
        end
    end
end


function GameCommonBox.AddObstructProtectLayout(delayTime)
    local scene = cc.Director:getInstance():getRunningScene()
    local layout = GameAssistor.CreateBackMaskLayout()
    layout:setVisible(true)
    scene:addChild(layout,50)

    local function RemovePage()
        layout:removeFromParent()
    end
    local actionTo = cc.Sequence:create(cc.DelayTime:create(delayTime),cc.CallFunc:create(RemovePage))
    layout:runAction(actionTo)
end

function GameCommonBox.tableIsEmpty(infoTable)
    if nil ~= infoTable then
        for key,value in pairs(infoTable) do
           return false
        end
    end
    return true
end

--根据品质获取颜色
function GameCommonBox.getColorForClass(class)
    local c3bColor = cc.c3b(255,255,255) --白
    if 1 == class then
        c3bColor = cc.c3b(255,255,255) --白
    elseif 2 == class then
        c3bColor = cc.c3b(31,112,20) --绿
    elseif 3 == class then
        c3bColor = cc.c3b(5,70,131) -- 蓝
    elseif 4 == class then
        c3bColor = cc.c3b(131,5,127) --紫
    elseif 5 == class then
        c3bColor = cc.c3b(116,88,4) --橙
    end
    return c3bColor
end

--播放特效
function GameCommonBox.createEffective(fileName,loop)
    local efNode = nil
    if true == cc.FileUtils:getInstance():isFileExist(fileName) then
        efNode = cc.CSLoader:createNode(fileName)
        local tl = cc.CSLoader:createTimeline(fileName)
        efNode:runAction(tl)
        tl:gotoFrameAndPlay(0,loop)
    else
        outputString(fileName.."不存在")
    end
    return efNode
end

function GameCommonBox.removeFromParent(parentNode,tag)
    local childNode = parentNode:getChildByTag(tag)
    if nil ~= childNode then
        childNode:removeFromParent()
    end
end

--节点坐标转换为 running Scene 坐标
function GameCommonBox.nodeToRunningScenePos(node)
    local pos = cc.p(0,0)
    if nil ~= node:getParent() then
        pos = node:getParent():convertToWorldSpace(cc.p(node:getPosition()))
    end
    local scene = cc.Director:getInstance():getRunningScene()
    if nil ~= scene then
        pos = scene:convertToNodeSpace(cc.p(pos.x,pos.y))
    end
    return pos
end

--执行延迟动作
function GameCommonBox.runDelayTime(delayTime,funCallBack)
    local function actionFinished()
        if nil ~= funCallBack then
            funCallBack()
        end
    end
    cc.Director:getInstance():getRunningScene():runAction(cc.Sequence:create(cc.DelayTime:create(delayTime),cc.CallFunc:create(actionFinished)))
end

--判断一个值是否在一个表中
function GameCommonBox.valueIsAtTableInfo(value,tableInfo)
    if type(tableInfo) == "table" then
        for key,vle in pairs(tableInfo) do
            if tonumber(vle) == tonumber(value) then
                return true
            end
        end
    end
    return false
end

--显示二次确认框 
function GameCommonBox.showOkOrCancel(parentNode,txtPrompt,callBack)
    local scence = cc.Director:getInstance():getRunningScene()
    local visibleSize = cc.Director:getInstance():getVisibleSize()
    local layout = GameCommonBox.CreateMaskLayout(cc.c3b(0,0,0),180)
    layout:setContentSize(visibleSize)
    local nodetp1 = cc.CSLoader:createNode("tp-1.csb")
    nodetp1:setPosition(visibleSize.width/2.0,visibleSize.height/2.0)

    --diban
    local nodediban = nodetp1:getChildByTag(1)
    nodediban:setScaleY(0.5)

    --TY-2
    local nodeTY2 = nodetp1:getChildByTag(3)
    nodeTY2:setVisible(true)

    --bt
    local nodebt = nodeTY2:getChildByTag(1)
    nodebt:setVisible(false)
    --2
    local node2 = nodeTY2:getChildByTag(2)
    local txt21 = node2:getChildByTag(1)
    local txt22 = node2:getChildByTag(2)
    local txt23 = node2:getChildByTag(3)
    ------
    txt21:setFontSize(50)
    txt22:setVisible(false)
    txt23:setVisible(false)

    --
    local length = string.len(txtPrompt)
    txt21:setColor(cc.c3b(0,0,0))
    if length > 50 and length <= 82 then
        txt21:ignoreContentAdaptWithSize(false)
        txt21:setTextAreaSize(cc.size(800,150))
        txt21:setPositionY(txt21:getPositionY()-15)
    elseif length > 82 then
        txt21:ignoreContentAdaptWithSize(false)
        txt21:setTextAreaSize(cc.size(800,200))
    end
    txt21:setString(txtPrompt)
    

    --btn3 确定
    local btn3 = nodeTY2:getChildByTag(3)
    --btn4 取消
    local btn4 = nodeTY2:getChildByTag(4)
    local btnCallBack = function(sender,eventType)
        if eventType== ccui.TouchEventType.ended then
            layout:removeFromParent()
            if nil ~= callBack then
                if 3 == sender:getTag() then
                    callBack(true)
                elseif 4 == sender:getTag() then
                    callBack(false)
                end

            end
        end
    end
    btn3:addTouchEventListener(btnCallBack)
    btn4:addTouchEventListener(btnCallBack)
    GameAssistor.SetButtonTitleBlackOutline(btn3)
    GameAssistor.SetButtonTitleBlackOutline(btn4)
    layout:addChild(nodetp1)
    parentNode:addChild(layout,50)
    GameCommonBox.runActionSecondJiemian(nodetp1,0.3,nil)
end

--上下浮动
function GameCommonBox.actionUpDown(node,swing,time)
    local orginX,orignY = node:getPosition()
    local flagControl = false
    local function callFunc()
        flagControl = false
    end     
    local function update()
        if false == flagControl then
            flagControl = true
            local moveTo1 = cc.MoveTo:create(time,cc.p(orginX,orignY+swing))
            local moveTo2 = cc.MoveTo:create(time,cc.p(orginX,orignY-swing))
            local sequence = cc.Sequence:create(moveTo1,moveTo2,cc.CallFunc:create(callFunc))
            node:runAction(sequence)
        end
    end 
    node:unscheduleUpdate()
    node:scheduleUpdateWithPriorityLua(update,0)
--    local orginX,orignY = node:getPosition()
--    local moveTo1 = cc.MoveTo:create(time,cc.p(orginX,orignY+swing))
--    local moveTo2 = moveTo1:reverse()
--    local sequence = cc.Sequence:create(moveTo1,moveTo2)
--    node:runAction(cc.RepeatForever:create(sequence))
end

--添加跳过按钮功能
function GameCommonBox.JumpOverBtnToRunningScene(callBack)
    local scene = cc.Director:getInstance():getRunningScene()
    local size = cc.Director:getInstance():getVisibleSize()
    local nodeChild = scene:getChildByTag(GameCommonBox.JumpOverBtnTag)
    if nil == nodeChild then
        --添加跳过按钮功能
        local csbjumpOver = cc.CSLoader:createNode("zy-4.csb")
        csbjumpOver:setPosition(cc.p(size.width-85,size.height-75))
        scene:addChild(csbjumpOver,101,GameCommonBox.JumpOverBtnTag)
        --监听
        local btn = csbjumpOver:getChildByTag(13)
        btn:setPressedActionEnabled(true)
        btn:addTouchEventListener(function(sender,eventType)
            if eventType== ccui.TouchEventType.began then
                csbjumpOver:removeFromParent()
                if nil ~= callBack then
                    callBack()
                end
            end
        end)
    end
end




function GameCommonBox.createAwardIcon(awardID,acount,csbName,scale,showName,outline)
    --local item_layer = cc.CSLoader:createNode("ICON-F80.csb")
    local item_layer = cc.CSLoader:createNode(csbName)
    GameDataTransfer.SetCommonAwardIcon(tonumber(awardID),item_layer)
    if nil == showName then
        showName = true
    end
    if nil == outline then
        outline = true
    end
--    local weapon = GameDataTransfer.GetGameWeapon(awardID)
--    if nil ~= weapon then
--        acount = 0
--    end
--    --如果是武器，去掉数量
    GameDataTransfer.SetCommonAwardCounter(item_layer,tonumber(awardID),tonumber(acount),showName,outline)
    local button_bouns = item_layer:getChildByTag(1)--获取按钮
    if nil ~= scale then
        button_bouns:setScale(scale)
    end
    button_bouns:removeFromParent()
    return button_bouns
end

--显示通用奖励框
function GameCommonBox.showDailyAward(scene,awardStr,midTitleTip,removeCallBack)
    GameManager.showAwardDes(1,awardStr,removeCallBack)
end




function GameCommonBox.setAwardScrollView(nowScrollView,awardTable,itemInfoCallBack,scale,showName,outline,XOffset,YOffset,iconName,widthDistance)
    local scrollViewSize = nowScrollView:getContentSize()
    nowScrollView:removeAllChildren()
    local  allStrSize = table.getn(awardTable)
    local distance = widthDistance or 140
    local width = distance
    local index = 0
    for i = 1,allStrSize,2 do
        local button_bounsLeft = GameCommonBox.createAwardIcon(awardTable[i],awardTable[i+1],iconName or "ICON-F120.csb",scale or 0.8,showName,outline)
        button_bounsLeft:setTag(index+1)
        button_bounsLeft:addTouchEventListener(itemInfoCallBack)
        button_bounsLeft:setPosition(cc.p(distance*index+(XOffset or 50),scrollViewSize.height/2.0+(YOffset or 10)))
        nowScrollView:setInnerContainerSize(cc.size(width,scrollViewSize.height))
        nowScrollView:addChild(button_bounsLeft)
        width = width + distance
        index =  index + 1
    end
end

function GameCommonBox.tableToIndexTable(tableInfo)
    local tempTable = {}
    local index = 1
    if type(tableInfo) == "table" then
       for key,value in pairs(tableInfo) do
            table.insert(tempTable,index,value)
            index = index+1
       end
    end
    return tempTable
end

function GameCommonBox.enableOutline(txt,space,c4bColor)
    if nil == space then
        space = 2
    end
    if nil ~= txt then
        txt:enableOutline(c4bColor or cc.c4b(0,0,0,255),space)
    end
end

function GameCommonBox.GetPlayTopLevel()
    local topLevel = 0 
    for key,value in pairs(GamePlayer.GetRoleList()) do
        if value.lv > topLevel then
            topLevel = value.lv
        end
    end
    return topLevel
end

function GameCommonBox.containerAddtoScrollview(scrollview,container,callBack)
    local nowParameter = ccui.LinearLayoutParameter:create()
    nowParameter:setGravity(ccui.LinearGravity.left)
    container:setLayoutParameter(nowParameter)
    scrollview:addChild(container)
    scrollview:forceDoLayout()
    if nil ~= callBack then
        callBack(container)
    end
end

function GameCommonBox.getCellFromCache(cache,csbName)
    if "table" == type(cache) then
        for key,value in pairs(cache) do
            if nil == value:getParent() then
                return value,true
            end
        end
    end
    local cell = cc.CSLoader:createNode(csbName)
    local tempItem = cell:getChildByTag(1)
    tempItem:removeFromParent()
    if "table" == type(cache) then
        tempItem:retain()
        table.insert(cache,1,tempItem)
    end
    return tempItem,false
end

function GameCommonBox.releseCellCache(cache)
    for key,value in pairs(cache) do     
        value:release()
    end
end

function GameCommonBox.senderEventDelayTime(sender,time)
    if nil == time then
        time = 1.0
    end
    sender:setEnabled(false)
    sender:setBright(false)
    GameCommonBox.runDelayTime(time,function()
            sender:setEnabled(true)
            sender:setBright(true)
        end)
end

function GameCommonBox.AwardToString(GameTask)
    local awardStr = "-1"
    --处理数据
    if nil ~= GameTask.Award_Type1 and nil ~= GameTask.Award_Value1 and 0 ~= GameTask.Award_Type1 and 0 ~= GameTask.Award_Value1 then
        awardStr = GameTask.Award_Type1..","..GameTask.Award_Value1
    end
    if nil ~= GameTask.Award_Type2 and nil ~= GameTask.Award_Value2 and 0 ~= GameTask.Award_Type2 and 0 ~= GameTask.Award_Value2 then
        awardStr =awardStr..","..GameTask.Award_Type2..","..GameTask.Award_Value2
    end
    if nil ~= GameTask.Award_Type3 and nil ~= GameTask.Award_Value3 and 0 ~= GameTask.Award_Type3 and 0 ~= GameTask.Award_Value3 then
        awardStr = awardStr..","..GameTask.Award_Type3..","..GameTask.Award_Value3
    end
    if nil ~= GameTask.Award_Type4 and nil ~= GameTask.Award_Value4 and 0 ~= GameTask.Award_Type4 and 0 ~= GameTask.Award_Value4 then
        awardStr = awardStr..","..GameTask.Award_Type4..","..GameTask.Award_Value4
    end
    if nil ~= GameTask.Award_Type5 and nil ~= GameTask.Award_Value5 and 0 ~= GameTask.Award_Type5 and 0 ~= GameTask.Award_Value5 then
        awardStr = awardStr..","..GameTask.Award_Type5..","..GameTask.Award_Value5
    end
    if nil ~= GameTask.Award_Type6 and nil ~= GameTask.Award_Value6 and 0 ~= GameTask.Award_Type6 and 0 ~= GameTask.Award_Value6 then
        awardStr = awardStr..","..GameTask.Award_Type6..","..GameTask.Award_Value6
    end
    return awardStr
end

function GameCommonBox.showDailyAwardAndVIP(scene,award,awardVip,midTitleTip)
    local award_string = award
    if nil ~= awardVip then
        award_string = award_string..","..awardVip
    end
    GameManager.showAwardDes(1,award_string,nil)
end

function GameCommonBox.swallowTouchesAllChild(rootNode,isEnable)
    if nil ~= rootNode["setSwallowTouches"] then
        rootNode:setSwallowTouches(isEnable)
    end
    local childTable = rootNode:getChildren()
    if "table"==string.format(type(childTable)) then
        for key,value in pairs(childTable) do
            GameCommonBox.swallowTouchesAllChild(value,isEnable)
        end
    end
end

function GameCommonBox.UIJump(UI_Links)
    local linkIDTable = string.split(UI_Links,",")
    if 2 == table.getn(linkIDTable) then
        local linkType = tonumber(linkIDTable[1])
        local linkID = tonumber(linkIDTable[2])
        if 1==linkType then
            --跳副本
            cclog("跳副本")
            if GamePlayer.IsFBOpen(linkID) then
                GameMainScene.AddSceneToSubFuncPage(GameMainScene.pageZOrder.SUBPAGE_MAINFB)
                StagesScene.LoadStageValueID(linkID)
            else
                GameAssistor.AddWarningTips("副本未开放")
            end
        elseif 2 == linkType then
            --跳界面
            cclog("跳界面")
            --JumpList.JumpToInterface(linkID)
            GameMainScene.PageGoTo(linkID,nil)
        else
            cclog("跳转类型不对")
            cclog(UI_Links)
        end
    else
        cclog("跳转Id格式不对")
        cclog(UI_Links)
    end
end

function GameCommonBox.unscheduleUpdate(node,callBack)
    local function update() 
        if nil ~= callBack then
            callBack()
        end
    end 
    node:unscheduleUpdate()
    node:scheduleUpdateWithPriorityLua(update,0)
end

function GameCommonBox.setActivityTime(txtCtrl,Start_Date,End_Date)
     --活动时间
    local StartDate = os.date("*t",Start_Date)
    local EndDate = os.date("*t",End_Date)
    local tip = ""
    if nil ~= StartDate then
        tip = StartDate.month.."月"..StartDate.day.."日"
    end
    tip = tip.."-"
    if  nil ~= EndDate then
        tip = tip..EndDate.month.."月"..EndDate.day.."日"
    end
    txtCtrl:setString(tip)
end

function GameCommonBox.getKeyTableFromDataTable(dataTable)
    local indexTable = {}
    for key,value in pairs(dataTable) do
        table.insert(indexTable,table.getn(indexTable)+1,key)
    end
    table.sort(indexTable,function(first,second)
        if first < second then
            return true
        end
    end)
    return indexTable
end

function GameCommonBox.sortTableReturnMax(infoTable,nameMember)
    local max = 0
    for key,value in pairs(infoTable) do
        if 0 == max then
            max = key
        end   
        if key > max then
            max = key
        end
    end

    local result = {}
    local index = 1
    for key,value in pairs(infoTable) do
        if key ~= max then
            result[index] = value
            index = index + 1
        end

    end
    table.sort(result,function(first,second)
        if nil == nameMember then 
            if first.Task_id < second.Task_id then
                return true
            end
        else
            if first[nameMember] < second[nameMember] then
                return true
            end
        end
    end)
    return result,infoTable[max]
end

function GameCommonBox.sortTableReturnMix(infoTable,nameMember)
    local mix = 0
    for key,value in pairs(infoTable) do
        if 0 == mix then
            mix = key
        end   
        if key < mix then
            mix = key
        end
    end

    local result = {}
    local index = 1
    for key,value in pairs(infoTable) do
        if key ~= mix then
            result[index] = value
            index = index + 1
        end

    end
    table.sort(result,function(first,second)
        if nil == nameMember then
            if first.storeID < second.storeID then
                return true
            end
        else
            if first[nameMember] < second[nameMember] then
                return true
            end
        end
    end)
    return result,infoTable[mix]
end

function GameCommonBox.sortTaskData(infoTable,nameMember1,nameMember2,cmpType)
    if type(infoTable) == "table" then
        if nil == cmpType or 1 == cmpType then
            table.sort(infoTable,function(first,second)
                if nil ~= first[nameMember1] and nil ~= second[nameMember1] 
                and nil ~= first[nameMember2] and nil ~= second[nameMember2] then
                    --1-- 可领 <=> 未领
                     if 1 == first[nameMember1] and  0 == first[nameMember2] 
                     and   0 == second[nameMember1] and 0 == second[nameMember2] then
                         return true
                     end
                    --2 可领  <=>  已领
                    if 1 == first[nameMember1] and  0 == first[nameMember2] 
                        and   1 == second[nameMember1] and 1 == second[nameMember2] then
                        return true
                    end 
                    --3  未领 <=> 已领
                     if 0 == first[nameMember1] and  0 == first[nameMember2] 
                     and   1 == second[nameMember1] and  1 == second[nameMember2] then
                         return true
                     end
                     --相同状态
                     if first[nameMember1]== second[nameMember1] and first[nameMember2] == second[nameMember2] then
                        if nil ~= first.Task_id and nil ~= second.Task_id and first.Task_id < second.Task_id then
                            return true
                        end
                     end  
                end
            end)
        end
    end
end

function GameCommonBox.sortVIPLiBaoData(infoTable,nameMember1,nameMember2,cmpType)
    if type(infoTable) == "table" then
        if nil == cmpType or 1 == cmpType then
            table.sort(infoTable,function(first,second)
                if nil ~= first[nameMember1] and nil ~= second[nameMember1] and
                   nil ~= first[nameMember2] and nil ~= second[nameMember2] 
                then
                    if 0 == first[nameMember1] and 1 == second[nameMember1] then
                        return true
                    end
                    if first[nameMember1] == second[nameMember1] then
                        if  first[nameMember2] < second[nameMember2] then
                            return true
                        end
                    end
                end
            end)
        end
    end
end



function GameCommonBox.hideNextChildNode(node,isVisible)
    if nil ~= node then
        local childTable = node:getChildren()
        for key,value in pairs(childTable) do
            value:setVisible(isVisible or false)
        end
    end
end

function GameCommonBox.addRankData(scrollview,dataTable,startIndex,endIndex,status,cache,csbName,CellInfoCallBack)
    local startIndex_1 = startIndex
    local endIndex_1 = endIndex
    for i = startIndex_1,endIndex_1,1 do
        local container,isCache = GameCommonBox.getCellFromCache(cache,csbName)
        GameCommonBox.containerAddtoScrollview(scrollview,container, function(container)
            if nil ~= CellInfoCallBack then
                CellInfoCallBack(container,dataTable[i],status,isCache)
            end
        end)
        local cellSize = container:getContentSize()
        scrollview:setInnerContainerSize(cc.size(scrollview:getInnerContainerSize().width,cellSize.height*endIndex))
    end
end

function GameCommonBox.updateScrollview(nowScrollview,ServerData,cache,csbName,CellInfoCallBack,onetime,status)
    local scrollViewSize = nowScrollview:getContentSize()
    --scrollview:removeAllChildren()
    local oneTime = onetime or 5
    nowScrollview:setLayoutType(ccui.LayoutType.VERTICAL)
    local totalNum = table.getn(ServerData)
    local loadedNum = 0
    local status = status
    local function getScrollviewStates(sender,eventType)
        if  eventType == ccui.ScrollviewEventType.scrollToBottom then
            if loadedNum < totalNum then
                if loadedNum+ oneTime > totalNum then
                    local distanceNum = totalNum-loadedNum
                    GameCommonBox.addRankData(nowScrollview,ServerData,loadedNum+1,loadedNum+distanceNum,status,cache,csbName,CellInfoCallBack)
                    loadedNum = loadedNum + distanceNum
                else
                    GameCommonBox.addRankData(nowScrollview,ServerData,loadedNum+1,loadedNum+oneTime,status,cache,csbName,CellInfoCallBack)
                    loadedNum = loadedNum + oneTime
                end
                GameCommonBox.swallowTouchesAllChild(nowScrollview,false)
            end
        end
    end

    local function remmoveScrollviewStates(sender,eventType)

    end

    if totalNum > oneTime then
        local cellCount = nowScrollview:getChildrenCount()
        if oneTime == cellCount then
            local cellTable = nowScrollview:getChildren()
            for i = 1,cellCount do
                if nil ~= CellInfoCallBack then
                    CellInfoCallBack(cellTable[i],ServerData[i],status)
                end
            end
        else
            nowScrollview:removeAllChildren()
            GameCommonBox.addRankData(nowScrollview,ServerData,1,oneTime,status,cache,csbName,CellInfoCallBack)
        end
        nowScrollview:addEventListener(getScrollviewStates)
        loadedNum = oneTime
    else
        nowScrollview:addEventListener(remmoveScrollviewStates)
        local cellCount = nowScrollview:getChildrenCount()
        if totalNum == cellCount then
            local cellTable = nowScrollview:getChildren()
            for i = 1,cellCount do
                if nil ~= CellInfoCallBack then
                    CellInfoCallBack(cellTable[i],ServerData[i],status)
                end
            end
        else
            nowScrollview:removeAllChildren()
            GameCommonBox.addRankData(nowScrollview,ServerData,1,totalNum,status,cache,csbName,CellInfoCallBack)
        end
    end
    GameCommonBox.swallowTouchesAllChild(nowScrollview,false)
    nowScrollview:jumpToTop()
end

function GameCommonBox.addMemberToTable(ServerDataTable,index)
    for i=1,table.getn(ServerDataTable) do
        local GameTask = nil
        if 1 == index or 2 == index then
            GameTask = GameDataTransfer.GetGameTaskDaily(ServerDataTable[i].Task_id)
        elseif 3 == index or 4 == index then
            GameTask = GameDataTransfer.GetGameTask(ServerDataTable[i].Task_id)
        end
        if nil ~= GameTask then
            if 1 == index then
                ServerDataTable[i].Condition_value2 = GameTask.Condition_value2
            elseif 2 == index or 3 == index or 4 == index then
                ServerDataTable[i].Condition_value2 = GameTask.Condition_value2 
            end
        end
    end
end

function GameCommonBox.sort_data(ServerDataTable,index)
    local size = table.getn(ServerDataTable)
    for i=1,size do
        for j=i+1,size do
            local flag = false
            if  --分组
                ((ServerDataTable[i].Is_award == 0 and ServerDataTable[i].Is_done == 0) --未达到领取
                and (ServerDataTable[j].Is_award == 0 and ServerDataTable[j].Is_done == 1)) --能领取
                or
                ((ServerDataTable[i].Is_award == 1 and ServerDataTable[i].Is_done == 1) --已领取
                and (ServerDataTable[j].Is_award == 0 and ServerDataTable[j].Is_done == 1)) --能领取
                or
                ((ServerDataTable[i].Is_award == 1 and ServerDataTable[i].Is_done == 1) --已领取
                and (ServerDataTable[j].Is_award == 0 and ServerDataTable[j].Is_done == 0)) --未能达到领取
            then
                flag = true
            end

            if --组内
                ((ServerDataTable[i].Is_award == 0 and ServerDataTable[i].Is_done == 1) --能领取
                and (ServerDataTable[j].Is_award == 0 and ServerDataTable[j].Is_done == 1)) --能领取
                or
                ((ServerDataTable[i].Is_award == 0 and ServerDataTable[i].Is_done == 0) --未领过领取
                and (ServerDataTable[j].Is_award == 0 and ServerDataTable[j].Is_done == 0)) --未领过领取
                or
                ((ServerDataTable[i].Is_award == 1 and ServerDataTable[i].Is_done == 1) --已经领过的
                and (ServerDataTable[j].Is_award == 1 and ServerDataTable[j].Is_done == 1)) --已经领过的
            then
                if 1 == index then
                    if nil ~= ServerDataTable[i].Condition_value2 and nil ~= ServerDataTable[j].Condition_value2 
                        and (ServerDataTable[i].Condition_value2 > ServerDataTable[j].Condition_value2) then
                        flag = true
                    end
                elseif 2 == index or 3 == index or 4 == index then
                    if nil ~= ServerDataTable[i].Condition_value2 and nil ~= ServerDataTable[j].Condition_value2 
                        and (ServerDataTable[i].Condition_value2 > ServerDataTable[j].Condition_value2) then
                        flag = true
                    end    
                    --                    elseif 2 == index then
                    --                        if ServerDataTable[i].Progress > ServerDataTable[j].Progress then
                    --                            flag = true
                    --                        end
                end
            end
            if flag == true then
                local tempObj = ServerDataTable[i]
                ServerDataTable[i] = ServerDataTable[j]
                ServerDataTable[j] = tempObj
                flag = false
            end
        end
    end
end

function GameCommonBox.removeEffectiveToBtn(btn)
    local childNode = btn:getChildByTag(777)
    if nil ~= childNode then
        childNode:removeFromParent()
    end
end

function GameCommonBox.addEffectiveToBtn(btn,effectiveName,scaleX,scaleY)
    GameCommonBox.removeEffectiveToBtn(btn)
    local FLXTICONe = GameCommonBox.createEffective(effectiveName or "FLXT-ICON-e.csb",true)
    if nil ~= FLXTICONe then
        local size = btn:getContentSize()
        FLXTICONe:setPosition(cc.p(size.width/2.0,size.height/2.0))
        FLXTICONe:setScaleX(scaleX or 1.0/btn:getScaleX())
        FLXTICONe:setScaleY(scaleY or 1.0/btn:getScaleY())
        btn:addChild(FLXTICONe,0,777)
    end
end

function GameCommonBox.isTaskAward(serverTask)
    if "table" == type(serverTask) then
        if nil == serverTask.Is_done then
            for key,value in pairs(serverTask) do 
                if "number" == type(key) and 0 == value.Is_award and 1 == value.Is_done then
                    return true
                end
            end
        else
            if 0 == serverTask.Is_award and 1 == serverTask.Is_done then
                return true
            end
        end
    end
    return false
end

function GameCommonBox.SetMainButtonRedPoint(btnTable,btnKey,redTag)
    if nil == redTag then
        redTag = 1
    end
    local redIsVisible = false
    if "table" == type(btnTable) then
        for key,value in pairs(btnTable) do
            local redSprt = value:getChildByTag(redTag)
            if nil ~= redSprt then
                if true == redSprt:isVisible() then
                    redIsVisible = true
                end
            end
        end
    end
    GameMainScene.SetMainButtonRedPoint(btnKey,redIsVisible)
end

function GameCommonBox.Data1IsIncludeData2(data1,data2,CallBackResult)
    if "table" == type(data1) and "table" == type(data2) then
        for key,value in pairs(data2) do
            if "table" == type(value) then
                --GameCommonBox.compareData(data1[key],value,CallBackResult)
                GameCommonBox.Data1IsIncludeData2(data1[key],value,CallBackResult)
            else
                if type(data1[key]) == type(value) then
                    if data1[key] ~= value then
                        if nil ~= CallBackResult then
                            CallBackResult(false)
                            return
                        end
                    end
                else
                    CallBackResult(false)
                    return
                end
            end
        end
    else
        if type(data1) == type(data2) then
            if data1 ~= data2 then
                CallBackResult(false)
                return
            end
        else
            CallBackResult(false)
            return
        end
    end
end

function GameCommonBox.compareData(data1,data2,CallBackResult)
    GameCommonBox.Data1IsIncludeData2(data1,data2,CallBackResult)
    GameCommonBox.Data1IsIncludeData2(data2,data1,CallBackResult)
end


-- 每日充值
-- 在线
-- 累计
-- 等级
--体力领取
function GameCommonBox.networkDataCallBack2(InfoTable,index)
    if 1 == index then
    
    elseif 2 == index then
        ActivityCenter.networkDataCallBack2(InfoTable,5)
    elseif 3 == index then
    
    elseif 4 == index then
        --等级礼包
        BusinessCenter.networkDataCallBack2(InfoTable,index)
    elseif 5 == index then
        --体力领取
        BusinessCenter.networkDataCallBack2(InfoTable,index)
    end
end

function GameCommonBox.GetAwardCallBack(award_string,index)
    if 1 == index then
        --每日充值
        
    elseif 2 == index then
        --在线领奖
        ActivityCenter.GetAwardCallBack(award_string,index)
    elseif 3 == index then
    
    elseif 4 == index then
        --等级礼包
        BusinessCenter.GetAwardCallBack(award_string,index)
    elseif 5 == index then
        --体力领取
        BusinessCenter.GetAwardCallBack(award_string,index)
    end
end

--网络回调信息
function GameCommonBox.CallBack_Task_InitOtherList(InfoTable,showType,taskType) --taskType 1.一般任务  2.日常任务
    if 12 == showType then --用于天天充值
        --EveryDayRecharge.networkDataCallBack(InfoTable,taskType)
        ActivityCenter.networkDataCallBack(InfoTable,showType,taskType)
    elseif 13 == showType then --特惠礼包
        --ExGratiaPackage.networkDataCallBack(InfoTable,0)
        ActivityCenter.networkDataCallBack(InfoTable,showType,taskType)
    elseif 11 == showType then --章节章节奖励
        table.foreach(InfoTable,function(i,v)
            GamePlayer.Tasks[i]= v
        end)
    elseif 15 == showType then --七天登录
        SevenLoginScene.networkDataCallBack(InfoTable,taskType)
    elseif 17 == showType then --福利中心
        BusinessCenter.networkDataCallBack(InfoTable,showType,taskType)
    elseif 18 == showType or 19 == showType or 20 == showType 
    or 21 == showType or 22 == showType or 23 == showType or 24 == showType 
    or 25 == showType or 26 == showType
    then --
        ActivityCenter.networkDataCallBack(InfoTable,showType,taskType)
    end
end

function GameCommonBox.CallBack_TaskAward(award,showType)
    if 12 == showType then --用于天天充值
        --EveryDayRecharge.GetAwardCallBack(award)
        ActivityCenter.GetAwardCallBack(award)
    elseif 13 == showType then --特惠礼包
        --ExGratiaPackage.GetAwardCallBack(award)
        ActivityCenter.GetAwardCallBack(award)
    elseif 11 == showType then --章节章节奖励
        local scene = cc.Director:getInstance():getRunningScene()
        GameCommonBox.showDailyAward(scene,award,nil)
    elseif 15 == showType then --七天登录
        SevenLoginScene.GetAwardCallBack(award)
    elseif 17 == showType then --福利中心
        BusinessCenter.GetAwardCallBack(award,1)
    elseif 18 == showType or 19 == showType or 20 == showType
     or 21 == showType or 22 == showType or 23 == showType or 24 == showType
     or 25 == showType or 26 == showType
     then --
        ActivityCenter.GetAwardCallBack(award)
    end
end

function GameCommonBox.reGetGameTipsData()
    GameCommonBox.TipsDataList = GameDataTransfer.GetTipsDataList(4)
    GameCommonBox.stringList = GameDataTransfer.GetGameStringList()
end

--主事件号  mainTutorialEventID
--子事件号  subTutorialEventID
--教程类型 tutorialType  1.强制 2.触发
function GameCommonBox.getGameTipsData(mainTutorialEventID,subTutorialEventID,tutorialType)
    if nil == tutorialType then
        tutorialType = 1
    end
    if nil == GameCommonBox.TipsDataList or nil == GameCommonBox.stringList then
        GameCommonBox.reGetGameTipsData()
    end
    if "table" == type(GameCommonBox.TipsDataList) then
        for key,value in pairs(GameCommonBox.TipsDataList) do
            if value.Tips_Type_2 == mainTutorialEventID and value.End_Lv == subTutorialEventID and value.Start_Lv == tutorialType then
                return value
            end
        end
    end
    return nil
end

--取出描述
function GameCommonBox.getGameTipsDataDiscription(GameTipsData)
    if nil ~= GameTipsData then
        local discription = GameCommonBox.stringList[GameTipsData.String_ID]
        if nil == discription then
            discription = "has GameData,but no string discription"
        end
        return discription
    end
    return "No GameData"
end


function GameCommonBox.getGameTipsDataWindowID(GameTipsData)
    if nil ~= GameTipsData then
        return GameTipsData.Tips_Type_3
    end
    return nil
end

function GameCommonBox.getGameTipsDataOffsetPos(GameTipsData)
    local x = 0
    local y = 0
    if nil ~= GameTipsData then
         x = GameTipsData.ModelId
         y = GameTipsData.Direction
    end
    return cc.p(x,y)
end

function GameCommonBox.getWorldPos(btn)
    local posTemp = btn:getParent():convertToWorldSpace(cc.p(btn:getPosition()))
    local scene = cc.Director:getInstance():getRunningScene()
    local posTemp  = scene:convertToNodeSpace(cc.p(posTemp.x,posTemp.y))
    local GesturePos = cc.p(btn:getPosition())
    local size = btn:getContentSize()
    local anchor = btn:getAnchorPoint()
    GesturePos.x = posTemp.x-size.width*anchor.x+size.width/2.0
    GesturePos.y = posTemp.y-size.height*anchor.y+size.height/2.0
    return GesturePos
end

function GameCommonBox.JieMianToScale(node,OrignPos,CallBack)
    local visibleSize = cc.Director:getInstance():getVisibleSize()
    local btn = GameMainScene.GetPageButton(main_buttons.SEVENDAYS)
    local pos = GameCommonBox.getWorldPos(btn)
    local scaleTo = cc.ScaleTo:create(0.5,0.0)
    local MoveTo = cc.MoveTo:create(0.5,pos)
    local Spawn = cc.Spawn:create(scaleTo,MoveTo)
    node:runAction(cc.Sequence:create(Spawn,cc.CallFunc:create(function()
        if nil == CallBack then
            GameMainScene.HideSceneFromSubFuncPage()
            node:setPosition(OrignPos or cc.p(visibleSize.width/2.0,visibleSize.height/2.0))
            node:setScale(1.0)
        else
            CallBack()
        end
    end)))
end

function GameCommonBox.getPlayRoleIDForMaxLevel()
    local baseLevel = 0
    local data = nil
    local RoleList = GamePlayer.GetRoleList()
    for key,value in pairs(RoleList) do
        if value.lv > baseLevel then
            data = value
            baseLevel = value.lv
        end
    end
    return data.role_id
end

function GameCommonBox.getPlayRoleMaxLevel()
    local baseLevel = 0
    local RoleList = GamePlayer.GetRoleList()
    for key,value in pairs(RoleList) do
        if value.lv > baseLevel then
            baseLevel = value.lv
        end
    end
    return baseLevel
end

function GameCommonBox.getStoreItemInfo(price)
    local GameVipTopUp = GameDataTransfer.GetGameVipTopUp()
    if "table" == type(GameVipTopUp) then
        for key,value in pairs(GameVipTopUp) do
            if value.RMB == price then
                return value
            end
        end
    end
end

function GameCommonBox.isClippingNodeRunning()
    local scene = cc.Director:getInstance():getRunningScene()
    local clippingNode1 = scene:getChildByTag(TeachAssistor.clippingNodeTag1)
    local clippingNode2 = scene:getChildByTag(TeachAssistor.clippingNodeTag2)
    local transparentMaskTagNode = scene:getChildByTag(TeachAssistor.transparentMaskTag)
    local transparentMaskTipTagNode = scene:getChildByTag(TeachAssistor.transparentMaskTipTag)
    local transparentMaskTip2TagNode = scene:getChildByTag(TeachAssistor.transparentMaskTip2Tag)
    if nil ~= clippingNode1 or nil ~= clippingNode2 
        or nil ~= transparentMaskTipTagNode or nil ~= transparentMaskTipTagNode or nil ~= transparentMaskTip2TagNode then
        return true
    end
    return false
end

function GameCommonBox.getFBZD_tips1Txt(mainTutorialEventID,subTutorialEventID,tutorialType)
    local FBZD_tips1Txt = nil 
    local FBZD_tips1Tpye = nil
    local FBZD_tips1Pos = nil
    if nil ~= subTutorialEventID then
        local GameTipsData = GameCommonBox.getGameTipsData(mainTutorialEventID,subTutorialEventID,tutorialType)
        FBZD_tips1Txt = GameCommonBox.getGameTipsDataDiscription(GameTipsData)
        FBZD_tips1Tpye = GameCommonBox.getGameTipsDataWindowID(GameTipsData)
        FBZD_tips1Pos = GameCommonBox.getGameTipsDataOffsetPos(GameTipsData)
        --做良好提示
        if TeachAssistor.IsHideExtraTips == true then
            if nil == GameTipsData then
                FBZD_tips1Txt = nil
            end
        else
            if nil == GameTipsData then
                FBZD_tips1Txt = "没有主事件ID:"..mainTutorialEventID..",子事件ID:"..subTutorialEventID..",教程类型:"..tutorialType
            else
                FBZD_tips1Txt = "主事件ID:"..mainTutorialEventID..",子事件ID:"..subTutorialEventID..",教程类型:"..tutorialType.." "..FBZD_tips1Txt 
            end
        end
    end
    return FBZD_tips1Txt,FBZD_tips1Pos,FBZD_tips1Tpye
end

function GameCommonBox.createBtnTip(btn,mainTutorialEventID,subTutorialEventID,tutorialType,userFBZD_tips1Tpye,delayTime,funCallBack)
    --添加冒泡提示
    local FBZD_tips1csb = nil
    local FBZD_tips1Txt,FBZD_tips1Pos,FBZD_tips1Tpye = GameCommonBox.getFBZD_tips1Txt(mainTutorialEventID,1,2)
    if nil ~= FBZD_tips1Pos and nil ~= FBZD_tips1Txt then
        FBZD_tips1csb = TeachAssistor.createFBZD_tips1(FBZD_tips1Txt)
        if 0 == FBZD_tips1Tpye then 
            FBZD_tips1Tpye = 1
        end
        TeachAssistor.setFBZD_tips1Type(FBZD_tips1csb,FBZD_tips1Tpye or userFBZD_tips1Tpye or 1)
        local size = btn:getContentSize()
        if 0 == FBZD_tips1Pos.x  and 0 == FBZD_tips1Pos.y then
            FBZD_tips1csb:setPosition(cc.p(size.width/2.0,size.height/2.0))
        else
            FBZD_tips1csb:setPosition(FBZD_tips1Pos)
        end
        if nil ~= btn then
            btn:addChild(FBZD_tips1csb,0,809)
        end
    end
    local function delayTimeFunCallBack()
        GameCommonBox.removeFromParent(btn,809)
        if nil ~= funCallBack then
            funCallBack()
        end
    end
    if nil ~= FBZD_tips1Txt then
        GameCommonBox.runDelayTime(delayTime,delayTimeFunCallBack)
    else
       if nil ~= funCallBack then
            funCallBack()
       end
    end
end


