require("tools.timerquest")
local GameControlLayer = class("GameControlLayer",function()
    return cc.Layer:create()
end) 

GameControlLayer.NodeEnum={
    "pause",   --暂停按钮
    "direction",   --方向
    "button", --技能按钮
    "roleBar",  --主角血条
    "changeButton",  --切换角色按钮
    "time", --时间栏
    "bossBar", --BOSS血条
    "gotips", --移动提示
    "combo", --连击提示
    "drinkButton",  --喝血按钮
    "enemyBar"
    

}
GameControlLayer.NodeEnum = CreateEnumTable(GameControlLayer.NodeEnum,-1)



GameControlLayer.enumTouchEvent = {
    LeftButtonTouch = 0,
    RightButtonTouch = 0,
    AttackTouch = 0,
    RollTouch = 0,
    Skill1Touch = 0,
    Skill2Touch = 0,
    Skill3Touch = 0,
    Skill4Touch = 0,
    Skill5Touch = 0,
    Skill6Touch = 0,
    Skill7Touch = 0,
    Skill8Touch = 0,
    DrinkTouch = 0,
    change1Touch =0,
    change2Touch =0,
    shoulePressLeft = 1,
    shoulePressRight = 1,
    PauseGame = 1 ,
    isLockRight = false,
    isLockLeft = false

}
local mathabs = math.abs
local pauseMenu = nil
local NAttack_button = nil
local skill_button   = nil
local skill2_button  = nil
local skill3_button  = nil
local skill4_button  = nil
local Roll_button    = nil
local drink_button   = nil
local drink_count    = nil
local joystick_node = nil
local black_mask = nil
local Boss_Sheild_node = nil
local ready_title = nil
local joystick_left_button = nil
local joystick_right_button = nil
local Hero_shield_sprite = nil     --普通护甲状态
local Hero_shield_sprite_T = nil

local Hero_break_shield_sprite = nil  --破甲状态
local Hero_break_shield_sprite_T = nil

local Enemy_shield_sprite = nil     --普通护甲状态
local Enemy_shield_sprite_T = nil
local Enemy_break_shield_sprite = nil  --破甲状态
local Enemy_break_shield_sprite_T = nil

local Boss_shield_sprite_s = nil     --普通护甲状态
local Boss_shield_sprite_s_T = nil
local Boss_break_shield_sprite = nil  --破甲状态
local Boss_break_shield_sprite_T = nil
local hero = nil
local pvp_count_down_node = nil

local skill_effect={{0,0},{0,0},{0,0},{0,0}}

function GameControlLayer:ctor()

    local function onNodeEvent(event)
        if event == "enter" then
            self:f_onEnter()
        elseif event=="exit" then
            self:f_onExit()
        end
    end

    self:registerScriptHandler(onNodeEvent)
end

function  GameControlLayer:f_onEnter()
    cclog("GameControlLayer f_onEnter")
end

function  GameControlLayer:f_onExit()
  
    cclog("GameControlLayer f_onExit")
    NAttack_button = nil
    skill_button   = nil
    skill2_button  = nil
    skill3_button  = nil
    skill4_button  = nil
    Roll_button    = nil
    joystick_node = nil
    black_mask = nil
    ready_title = nil
    skill_effect = {{0,0},{0,0},{0,0},{0,0}}
    self:removeAllChildren()
    GameControlLayer.enumTouchEvent.LeftButtonTouch = 0
    GameControlLayer.enumTouchEvent.RightButtonTouch = 0
    --self:getChildByTag(110)
    cc.SpriteFrameCache:getInstance():removeUnusedSpriteFrames()
    cc.Director:getInstance():getTextureCache():removeUnusedTextures()
end

function GameControlLayer.setProgress(button_node,sprite_path,tag,isComboSkill)

    local defaultPic =  button_node:getChildByTag(1):getChildByTag(1)
    local defaultScaleX = defaultPic:getScaleX()
    local defaultScaleY = defaultPic:getScaleY()
    
    local backImg =cc.Sprite:create()   --模板图片
    backImg:setSpriteFrame(sprite_path)
    local progress =cc.ProgressTimer:create(backImg)
    local tempcs = button_node:getCustomSize()
    
    if not isComboSkill or isComboSkill == false then
        progress:setType(cc.PROGRESS_TIMER_TYPE_RADIAL)
        progress:setMidpoint(cc.p(0.5,0.5))
        progress:setPositionX(tempcs.width/2)
        progress:setPositionY(tempcs.height/2)
        progress:setOpacity(180)
    elseif  isComboSkill and isComboSkill == true then
        progress:setType(cc.PROGRESS_TIMER_TYPE_BAR)
        progress:setMidpoint(cc.p(0.5,1))
        progress:setPositionX(tempcs.width/2)
        progress:setPositionY(tempcs.height/2)
        progress:setOpacity(180)
        progress:setBarChangeRate(cc.p(0, 1))
        --progress:setReverseDirection(true)
        progress:setPercentage(100)
        
    end
    progress:setScale(defaultScaleX,defaultScaleY)
    --progress:setReverseDirection(true)
    --progress.setPercentage(self,percentage)
    button_node:addChild(progress,3,tag)
    button_node:reorderChild(button_node:getChildByTag(10),5)

    
end

function GameControlLayer.setIcon(button_node,icon_path,sprite_path,tag)
    local nowIcon = cc.ClippingNode:create()
    
    local tempcs = button_node:getCustomSize() 
    local tempScale = button_node:getScaleX()
    local backIcon =cc.Sprite:create(icon_path)  --底板图片
    
    local progress =cc.Sprite:create()   --模板图片
    progress:setSpriteFrame(sprite_path)
    --local progress =cc.Sprite:create(sprite_path,ccui.TextureResType.plistType)   --模板图片
    
    nowIcon:addChild(backIcon,1,1)
    
    nowIcon:setAlphaThreshold(0.2)
    nowIcon:setStencil(progress)
    
    local defaultPic =  button_node:getChildByTag(1)
    local defaultScaleX = defaultPic:getScaleX()
    local defaultScaleY = defaultPic:getScaleY()
    
    backIcon:setPositionX(tempcs.width/2)
    backIcon:setPositionY(tempcs.height/2)
    
    progress:setPositionX(tempcs.width/2)
    progress:setPositionY(tempcs.height/2)
    progress:setScale(defaultScaleX,defaultScaleY)
    backIcon:setScale(defaultScaleX,defaultScaleY)
    --progress:setReverseDirection(true)
    --progress.setPercentage(self,percentage)
    
    defaultPic:removeFromParent() -- 移除节点一
    button_node:addChild(nowIcon,1,tag)
    local countDown = button_node:getChildByTag(3)
--    local countDown =  cc.LabelAtlas:_create(0,"Number/number-LJ.png",540/12,70,46)
--    
--    countDown:setAnchorPoint({x=0.5,y=0.5})
--    --countDown:setAnchorX(0.5)
--    countDown:setPositionX(tempcs.width/2)
--    countDown:setPositionY(tempcs.height/2)
--    countDown:setScaleX(defaultScaleX)
--    countDown:setScaleY(defaultScaleY)
    
    countDown:setVisible(false)
    
    button_node:reorderChild(countDown,4)
    
    button_node:reorderChild(button_node:getChildByTag(2) ,2)
end



function GameControlLayer.setBigIcon(button_node,icon_path,sprite_path,tag)
    local nowIcon = cc.ClippingNode:create()
    local tempcs = button_node:getCustomSize()
    local tempScale = button_node:getScaleX()
    local backIcon =cc.Sprite:create(icon_path)  --底板图片
    
    local progress =cc.Sprite:create()   --模板图片
    progress:setSpriteFrame(sprite_path)
    --progress:loadTexture(sprite_path,ccui.TextureResType.plistType)

    nowIcon:addChild(backIcon,1,1)

    nowIcon:setAlphaThreshold(0.8)
    nowIcon:setStencil(progress)

    backIcon:setPositionX(tempcs.width/2-2)
    backIcon:setPositionY(tempcs.height/2+2)

    progress:setPositionX(tempcs.width/2 - 1 )
    progress:setPositionY(tempcs.height/2 + 2)
    progress:setScale(1,1)
    backIcon:setScale(1,1)
    --progress:setReverseDirection(true)
    --progress.setPercentage(self,percentage)
    button_node:addChild(nowIcon,1,tag)
    button_node:reorderChild(button_node:getChildByTag(2) ,2)
    
end
function GameControlLayer.setSkillEffect(main_Node)
    skill_effect = {{0,0},{0,0},{0,0},{0,0}}
    local button_node = main_Node:getChildByTag(GameControlLayer.NodeEnum.button)
    for i=1,4 do
        local tempButtonNode = button_node:getChildByTag(i+2):getChildByTag(1)
        local nowPath = "FBZD-4jn-1e.csb"
        if i == 4 then nowPath = "FBZD-4jn-2e.csb" end
        skill_effect[i][1] = cc.CSLoader:createNode(nowPath)
        skill_effect[i][2] = cc.CSLoader:createTimeline(nowPath)
        
        tempButtonNode:addChild(skill_effect[i][1],8,8)
        skill_effect[i][1]:setPosition(55,55)
        skill_effect[i][1]:runAction(skill_effect[i][2])
        skill_effect[i][2]:gotoFrameAndPlay(0,true)
    end
    GameControlLayer.showSkillEffect(4,false)
end

function GameControlLayer.showSkillEffect(skill_index,m_show)
    if skill_index == 1 then
        if skill_button then
            skill_button:getChildByTag(10):setVisible(m_show)
        end
    elseif skill_index == 2 then
        if skill2_button then
            skill2_button:getChildByTag(10):setVisible(m_show)
        end
    elseif skill_index == 3 then
        if skill3_button then
            skill3_button:getChildByTag(10):setVisible(m_show)
        end
    elseif skill_index == 4 then
        if skill4_button then
            skill4_button:getChildByTag(10):setVisible(m_show)
        end
    end
   
    --skill_effect[skill_index][1]:setVisible(m_show)
end

function GameControlLayer.setEnergy(Hero_Bar_node,sprite_path,m_type)
    
    --local Hero_Bar_node = main_Node:getChildByTag(GameControlLayer.NodeEnum.roleBar):getChildByTag(2)
    local Hero_Energybar_node  = Hero_Bar_node:getChildByTag(2)
    
    if m_type and m_type == 2 then
        Enemy_shield_sprite = cc.CSLoader:createNode("FBZD-2e.csb")
        Enemy_shield_sprite_T = cc.CSLoader:createTimeline("FBZD-2e.csb")

        Enemy_break_shield_sprite = cc.CSLoader:createNode("FBZD-1e.csb")
        Enemy_break_shield_sprite_T = cc.CSLoader:createTimeline("FBZD-1e.csb")
    else
        Hero_shield_sprite = cc.CSLoader:createNode("FBZD-2e.csb")
        Hero_shield_sprite_T = cc.CSLoader:createTimeline("FBZD-2e.csb")
        
        Hero_break_shield_sprite = cc.CSLoader:createNode("FBZD-1e.csb")
        Hero_break_shield_sprite_T = cc.CSLoader:createTimeline("FBZD-1e.csb")
    end
    
    local backImg =cc.Sprite:create()   --模板图片
    backImg:setSpriteFrame(sprite_path)
    
    local progress =cc.ProgressTimer:create(backImg)
    
    local tempX,tempY = Hero_Energybar_node:getPosition()
    local tempAngle = Hero_Energybar_node:getRotation()

    progress:setType(cc.PROGRESS_TIMER_TYPE_RADIAL)
    
    progress:setMidpoint(cc.p(0.5,0.5))
    progress:setPositionX(tempX)
    progress:setPositionY(tempY)
    
    
    --progress:setReverseDirection(true)
    progress:setPercentage(80)
    progress:setRotation(tempAngle)
    if m_type and m_type == 2 then
        progress:setScaleY(-1)
    end
    Hero_Energybar_node:removeFromParent() -- 移除节点一
    Hero_Bar_node:addChild(progress,2,2)
    
    if m_type and m_type == 2 then
        Hero_Bar_node:addChild(Enemy_shield_sprite,3,3)
        Enemy_shield_sprite:setPosition(-84,-81)


        Hero_Bar_node:addChild(Enemy_break_shield_sprite,4,4)
        Enemy_break_shield_sprite:setPosition(-84,-81)


        Enemy_shield_sprite:setVisible(false)
        Enemy_break_shield_sprite:setVisible(false)
        Enemy_shield_sprite:runAction(Enemy_shield_sprite_T)
        Enemy_shield_sprite_T:gotoFrameAndPlay(0,false)
        Enemy_break_shield_sprite:runAction(Enemy_break_shield_sprite_T)
        Enemy_break_shield_sprite_T:gotoFrameAndPlay(0,false)
    else
        Hero_Bar_node:addChild(Hero_shield_sprite,3,3)
        Hero_shield_sprite:setPosition(84,-81)
        
        
        Hero_Bar_node:addChild(Hero_break_shield_sprite,4,4)
        Hero_break_shield_sprite:setPosition(84,-81)
        
        
        Hero_shield_sprite:setVisible(false)
        Hero_break_shield_sprite:setVisible(false)
        Hero_shield_sprite:runAction(Hero_shield_sprite_T)
        Hero_shield_sprite_T:gotoFrameAndPlay(0,false)
        Hero_break_shield_sprite:runAction(Hero_break_shield_sprite_T)
        Hero_break_shield_sprite_T:gotoFrameAndPlay(0,false)
    end
end

function GameControlLayer.playShieldAct()
    
    Hero_break_shield_sprite:setVisible(false)
    Hero_shield_sprite:setVisible(true)
    
    Hero_shield_sprite_T:gotoFrameAndPlay(0,true)
end

function GameControlLayer.playShieldBreakAct()
    
    do return end
    Hero_shield_sprite:setVisible(false)
    Hero_break_shield_sprite:setVisible(true)

    Hero_break_shield_sprite_T:gotoFrameAndPlay(0,false)
end

function GameControlLayer.playBossShieldStart()
    
    Boss_shield_sprite_s:setVisible(true)
    Boss_break_shield_sprite:setVisible(false)
    
    Boss_shield_sprite_s_T:gotoFrameAndPlay(0,true)
    
    local function startend()
        Boss_shield_sprite_s:setVisible(false)
        Boss_Sheild_node:getChildByTag(1):setVisible(true)
        Boss_Sheild_node:getChildByTag(2):setVisible(true)
    end
    
    Boss_shield_sprite_s:runAction(cc.Sequence:create(cc.DelayTime:create(0.5),cc.CallFunc:create(startend)))
end

function GameControlLayer.playBossShieldBreakAct()
    Boss_shield_sprite_s:setVisible(false)
    Boss_break_shield_sprite:setVisible(true)
    
    Boss_break_shield_sprite_T:gotoFrameAndPlay(0,false)
    Boss_Sheild_node:getChildByTag(1):setVisible(false)
    Boss_Sheild_node:getChildByTag(2):setVisible(false)
end

function GameControlLayer.showBlack(m_show)
    black_mask:setVisible(m_show)
end

function GameControlLayer.playReadyGo(name)
    if ready_title ~= nil then
        if name == "ko" then
            ready_title:setVisible(true)
            ready_title:setToSetupPose()
            ready_title:setAnimation(0,name,false)
        else
            TimerQuest:Instance():AddDelayQuest(function() 
                ready_title:setVisible(true)
                ready_title:setToSetupPose()
                ready_title:setAnimation(0,name,false)
            end, 1)
        end
    else
        return
    end
    
end

function GameControlLayer.BlackFadeIn(m_time,endFunction)
    black_mask:stopAllActions()
    if endFunction and endFunction ~= nil then
        black_mask:runAction(cc.Sequence:create(cc.FadeIn:create(m_time),cc.CallFunc:create(endFunction)))
    else
        black_mask:runAction(cc.FadeIn:create(m_time))
    end
end

function GameControlLayer.BlackFadeOut(m_time,endFunction)
    black_mask:stopAllActions()
    if endFunction and endFunction ~= nil then
        black_mask:runAction(cc.Sequence:create(cc.FadeOut:create(m_time),cc.CallFunc:create(endFunction)))
    else
        black_mask:runAction(cc.FadeOut:create(m_time))
    end
end



function GameControlLayer.startCountDown_pvp(m_function)
    if pvp_count_down_node == nil then return end

    local countPvP

    function countPvP()
        if GameManager.FB_Value.PVP_Count_Down > 0 then
            pvp_count_down_node:setVisible(true)
            GameManager.FB_Value.PVP_Count_Down = GameManager.FB_Value.PVP_Count_Down - 1
            if GameManager.FB_Value.PVP_Count_Down < 10 then
                pvp_count_down_node:setString("0"..GameManager.FB_Value.PVP_Count_Down)
            else
                pvp_count_down_node:setString(""..GameManager.FB_Value.PVP_Count_Down)
            end
        end
        
        if GameManager.FB_Value.PVP_Count_Down > 0 then
            pvp_count_down_node:runAction(cc.Sequence:create(cc.DelayTime:create(1),cc.CallFunc:create(countPvP)))
        elseif GameManager.FB_Value.PVP_Count_Down == 0  and m_function and m_function ~= nil then
            pvp_count_down_node:setVisible(false)
            m_function()
        end

    end

    pvp_count_down_node:runAction(cc.Sequence:create(cc.DelayTime:create(1),cc.CallFunc:create(countPvP)))     
end

function GameControlLayer.ResetCountDown_pvp()
    if pvp_count_down_node == nil then return end
    pvp_count_down_node:stopAllActions()
    pvp_count_down_node:setString(""..GameManager.FB_Value.PVP_Count_Down)
end

function GameControlLayer.StopCountDown_pvp()
    if pvp_count_down_node == nil then return end
    pvp_count_down_node:stopAllActions()
end

function GameControlLayer.setDrinkCount(m_count)
    drink_count:setString(""..m_count)
end

function GameControlLayer.getDrinkButton()
    return drink_button
end

function GameControlLayer.RefreshRollButtonEnergy(m_energy)
    local rootNode = Roll_button:getParent():getChildByTag(0):getChildByTag(2)
    
    for i=1,6 do
        local eachNode = rootNode:getChildByTag(i)
        if m_energy >= i*50 then
            eachNode:setVisible(true)
        else
            eachNode:setVisible(false)
        end
    end
    
end

function GameControlLayer.setHero(m_hero)
    hero = m_hero
end

function GameControlLayer.UpdateJiantou(d)

    if not GameControlLayer.lastSetJiantouTm then
        GameControlLayer.lastSetJiantouTm = Time_GetCurrentTime()
    end

    if Time_GetCurrentTime() - GameControlLayer.lastSetJiantouTm < 2 then
        return 
    end

    GameControlLayer.lastSetJiantouTm = Time_GetCurrentTime()

    GameControlLayer.jiantou:setScale(d)
    GameControlLayer.jiantou:setPositionX(640 + 500 * d)
end


function GameControlLayer.createUILayer()
    hero = nowPlayer[1]
    
    cc.Director:getInstance():getTextureCache():addImage("Number/Number-lj1.png")

    local layerFarm = GameControlLayer.new()
    
    local node_ui = cc.CSLoader:createNode("ZD.csb")
    local direction = node_ui:getChildByTag(1)
    local control_node = node_ui:getChildByTag(GameControlLayer.NodeEnum.roleBar)

    
    local back_g = control_node:getChildByTag(1):getChildByTag(1):getChildByTag(0)
    local node_hp = control_node:getChildByTag(1):getChildByTag(1):getChildByTag(1)
    --local node_shield = control_node:getChildByTag(2):getChildByTag(2)
    local node_head = control_node:getChildByTag(1):getChildByTag(1):getChildByTag(3)
    
    local BOSS_Bar_node = node_ui:getChildByTag(GameControlLayer.NodeEnum.bossBar)
    local Time_node     = node_ui:getChildByTag(GameControlLayer.NodeEnum.time)
    --local Time_Progess_node = Time_node:getChildByTag(1):getChildByTag(1)
    local Time_FBName_node  = Time_node:getChildByTag(1):getChildByTag(1)
    local Time_Time_node    = Time_node:getChildByTag(1):getChildByTag(2)
    local Time_Pause_button = node_ui:getChildByTag(GameControlLayer.NodeEnum.pause)
    local Combo_node        = node_ui:getChildByTag(GameControlLayer.NodeEnum.combo)
    local Drink_node        = node_ui:getChildByTag(GameControlLayer.NodeEnum.drinkButton)
    local ZDL               = node_ui:getChildByTag(3):getChildByTag(1):getChildByTag(2):getChildByTag(2)

    local ZDL               = node_ui:getChildByTag(3):getChildByTag(1):getChildByTag(2):getChildByTag(2)
    ZDL:setString(GameRecorder.GetAmountCombatPower())


    -- GameManager.FB_Value.rivalPro.combatPower
    --Boss_Sheild_node       = node_ui:getChildByTag(12)
    
    if (GameManager.FB_Value.fb_id < 11 or (GameManager.FB_Value.fb_id > 100 and GameManager.FB_Value.fb_id <103)) then
        Time_Pause_button:setVisible(false)
    end
    
    pauseMenu = cc.CSLoader:createNode("ZD-ZT.csb")
    local continueGameButton = pauseMenu:getChildByTag(1):getChildByTag(1):getChildByTag(1)
    local exitGameButton = pauseMenu:getChildByTag(1):getChildByTag(1):getChildByTag(2)
    
    node_ui:getChildByTag(GameControlLayer.NodeEnum.changeButton):setVisible(false)
    
    local lowHp = cc.Sprite:create("Image/lowHp.png")
    
    Time_Time_node:setAnchorPoint(0,0.5)
    Time_Time_node:setPositionX(-59)
    drink_button = Drink_node:getChildByTag(1)
    -- drink_button:setVisible(false)
    drink_count  = drink_button:getChildByTag(11)
    drink_count:setVisible(true)
    -- GameManager.FB_Value.FB_drinkcount = 10
    drink_count:setString(""..GameManager.FB_Value.FB_drinkcount)
    -- cclog("fb_id = " .. GameManager.FB_Value.fb_id)
    -- if --[[GameManager.FB_Value.FB_CanDrink == true and]] GameManager.FB_Value.fb_id > 11 then
        -- cclog("test test test test test test test test test test test test test ")
        Drink_node:setVisible(true)

        local drinkCount = 0
        for _,v in pairs(GameRecorder.GetStorageList()) do
            if v.ID == 1 then
                drinkCount = v.qty
            end
        end

        hero.drink_count = drinkCount
        hero.can_drink = true
        hero.drink_button = drink_button
        
        drink_count:setVisible(true)
        drink_count:setString(""..drinkCount)
        drink_button:reorderChild(drink_count,10)
    -- else
    --     Drink_node:setVisible(false)
    --     hero.drink_button = drink_button
    --     hero.can_drink = false
    --     drink_count:setVisible(false)
    --     hero.drink_count = 0
    -- end
    
    for i=1,#nowWaitPlay do
        local waitPlayer = nowWaitPlay[i]
        waitPlayer.drink_button =  hero.drink_button 
        waitPlayer.can_drink = hero.can_drink 
        
        waitPlayer.drink_count = hero.drink_count 
        
    end

    
    joystick_node =node_ui:getChildByTag(GameControlLayer.NodeEnum.direction)
    joystick_left_button = node_ui:getChildByTag(GameControlLayer.NodeEnum.direction):getChildByTag(1)
    joystick_right_button = node_ui:getChildByTag(GameControlLayer.NodeEnum.direction):getChildByTag(2)
    
    black_mask = GameAssistor.CreateMaskLayout(cc.c3b(0,0,0),0)
    
    joystick_node:setVisible(true)
    
    BOSS_Bar_node:setVisible(false)
    --Time_Progess_node:setVisible(false)
    Combo_node:setVisible(true)
    Combo_node:setPositionX(1240)
    
    --GameControlLayer.setEnergy(node_ui:getChildByTag(GameControlLayer.NodeEnum.roleBar):getChildByTag(2),"3-FBZD/ZJD1-2.png")
    
    if GameManager.FB_Value.isPvP == true or GameManager.FB_Value.is_3v3 == true then
        node_ui:getChildByTag(10):setVisible(true)
        Time_node:setVisible(false)
        -- cclog("jjjjjjjjjjjjjjjjjjj")
         -- 竞技场
        local enemyZDL = node_ui:getChildByTag(10):getChildByTag(1):getChildByTag(2):getChildByTag(2)
        enemyZDL:setString(GameManager.FB_Value.rivalPro.combatPower)--GameManager.FB_Value.rivalPro.combatPower)    
--        GameControlLayer.setEnergy(node_ui:getChildByTag(0):getChildByTag(2),"3-FBZD/ZJD1-2.png",2)
--        
        pvp_count_down_node = node_ui:getChildByTag(11) --PVP 时间倒数
        pvp_count_down_node:setString(""..GameManager.FB_Value.PVP_Count_Down)
        pvp_count_down_node:setVisible(true)
    else
        Time_node:setVisible(true)
        node_ui:getChildByTag(10):setVisible(false)
    end
    
--    Boss_shield_sprite_s = cc.CSLoader:createNode("FBZD-dun1e.csb")
--    Boss_shield_sprite_s_T = cc.CSLoader:createTimeline("FBZD-dun1e.csb")
--
--    Boss_break_shield_sprite = cc.CSLoader:createNode("FBZD-dun2e.csb")
--    Boss_break_shield_sprite_T = cc.CSLoader:createTimeline("FBZD-dun2e.csb")
--    
--    node_ui:addChild(Boss_shield_sprite_s)
--    node_ui:addChild(Boss_break_shield_sprite)
--    Boss_shield_sprite_s:setPosition(950,600)
--    
--    Boss_shield_sprite_s:runAction(Boss_shield_sprite_s_T)
--    Boss_shield_sprite_s_T:gotoFrameAndPlay(0,false)
--    
--    Boss_break_shield_sprite:setPosition(950,600)
--    
--    Boss_break_shield_sprite:runAction(Boss_break_shield_sprite_T)
--    Boss_break_shield_sprite_T:gotoFrameAndPlay(0,false)
--    
--    Boss_shield_sprite_s:setVisible(false)
--    Boss_break_shield_sprite:setVisible(false)
--    greyNodeWithCCUI(Boss_Sheild_node:getChildByTag(1),false,false)
    
    local tempRange =10
    
    layerFarm:addChild(pauseMenu,2,999)
    pauseMenu:setVisible(false)

    local jiantou = cc.Sprite:create("Image/jiantou.png")
    jiantou:setPosition(640,500)
    jiantou:setScale(0)
    jiantou:runAction(cc.RepeatForever:create(cc.Blink:create(1,1)))
    GameControlLayer.jiantou = jiantou
    layerFarm:addChild(jiantou,100,0)
    --layerFarm:replaceTPB(Time_Progess_node)
    layerFarm:addChild(lowHp,0,109)
    lowHp:setPosition(640,360)
    local fi = cc.FadeIn:create(0.4)
    local fo = cc.FadeOut:create(0.4)
    local rep = cc.RepeatForever:create(cc.Sequence:create(fi,fo))
    lowHp:setVisible(false)
    lowHp:runAction(rep)
    layerFarm:addChild(node_ui,1,110)
    layerFarm:addChild(black_mask,3,120)
    
    
    
    black_mask:setVisible(false)
    
    --GameControlLayer.playShieldAct()
    --ping_addTestButtons(gameScene,layerFarm)
    
   
    
    if GameManager.FB_Value.isPvP == true or GameManager.FB_Value.is_3v3 == true then
        -- startCountDown_pvp
        ready_title = CreateSpineRes("Spine/effect/daojishi")
        layerFarm:addChild(ready_title,2,115)
        ready_title:setPosition(640,360)
        ready_title:setVisible(false)
        
        local endFight
        
        function endFight()
            GameManager.endPvPFightWithLose()
        end
        
        
        local function ReadyComplete(event)
            local eventName = event.animation
            if eventName == "duiju1" or eventName == "duiju2" or eventName == "duiju3" or eventName == "duiju4" or eventName == "duiju5" then
                TimerQuest:Instance():AddDelayQuest(function() 
                    ready_title:setVisible(true)
                    ready_title:setToSetupPose()
                    ready_title:setAnimation(0,"daojishi",false)
                end, 1)
                ready_title:setVisible(false)
            elseif eventName == "daojishi" then
                ready_title:setVisible(false)
                
                GameManager.ResumeGameLogic()
                GameManager.setCarmeraFollowHero()
                GameControlLayer.startCountDown_pvp(endFight)
                
            elseif eventName == "ko" then
                ready_title:setVisible(false)
                GameManager.gotoNextRound()
            end
            
        end
        
        
        ready_title:registerSpineEventHandler(function (event)
            ReadyComplete(event)
        end, sp.EventType.ANIMATION_COMPLETE)
    end

    local function pressNAttackButon(sender,eventType)
        
        if eventType == ccui.TouchEventType.ended or eventType == ccui.TouchEventType.canceled then
            hero:normalAttack_release()
            GameControlLayer.enumTouchEvent.AttackTouch = 0
            
        elseif eventType== ccui.TouchEventType.began then
            hero:normalAttack()
            GameControlLayer.enumTouchEvent.AttackTouch = 1
            --tempRange=tempRange+1
            --LableString.addHurtString(hero:getPositionX(),hero:getPositionY(),"range = "..tempRange)
        end
        --GameManager.PauseGame()
    end
    
    local function pressDrinkButon(sender,eventType)
        if hero.drink_count == 0 then
            return 
        end
        if eventType == ccui.TouchEventType.ended or eventType == ccui.TouchEventType.canceled then
            GameControlLayer.enumTouchEvent.DrinkTouch = 0
        elseif eventType== ccui.TouchEventType.began then
            -- hero.drink_count = hero.drink_count - 1
            
            hero:Drink_release()
            GameRecorder.StorageChange(1, hero.drink_count)
            GameRecorder.SaveBasicData()
            GameControlLayer.enumTouchEvent.DrinkTouch = 1
            --gameScene:creatShock(0.1,tempRange)
        end
        --GameManager.ResumeGame()
    end
    
    local function pressSkillButon(sender,eventType)
        
        if eventType == ccui.TouchEventType.ended or eventType == ccui.TouchEventType.canceled then
            GameControlLayer.enumTouchEvent.Skill1Touch = 0
            hero:specialAttackRelease(1)
        elseif eventType== ccui.TouchEventType.began then
            hero:specialAttack1()
            GameControlLayer.enumTouchEvent.Skill1Touch = 1
            --gameScene:creatShock(0.1,tempRange)
        end
        --GameManager.ResumeGame()
    end

    local function pressSkill2Buton(sender,eventType)
        
        if eventType == ccui.TouchEventType.ended or eventType == ccui.TouchEventType.canceled then
            GameControlLayer.enumTouchEvent.Skill2Touch = 0
            hero:specialAttackRelease(2)
        elseif eventType== ccui.TouchEventType.began then
            hero:specialAttack2()
            GameControlLayer.enumTouchEvent.Skill2Touch = 1
            --hero:specialAttack1()
            --gameScene:creatShock(0.2,tempRange)
        end

    end
    
    local function pressSkill3Buton(sender,eventType)
        
        if eventType == ccui.TouchEventType.ended or eventType == ccui.TouchEventType.canceled then
            GameControlLayer.enumTouchEvent.Skill3Touch = 0
            hero:specialAttackRelease(3)
        elseif eventType== ccui.TouchEventType.began then
            hero:specialAttack3()
            GameControlLayer.enumTouchEvent.Skill3Touch = 1
            --gameScene:creatShock(0.3,tempRange)
        end

    end
    
    local function pressSkill4Buton(sender,eventType)

        if eventType == ccui.TouchEventType.ended or eventType == ccui.TouchEventType.canceled then
            GameControlLayer.enumTouchEvent.Skill4Touch = 0
            hero:specialAttackRelease(4)
            cclog("按钮4 松开")
        elseif eventType== ccui.TouchEventType.began then
            hero:specialAttack4()
            GameControlLayer.enumTouchEvent.Skill4Touch = 1
            cclog("按钮4 按下")
            --gameScene:creatShock(0.3,tempRange)
        end

    end
    
    local function PauseGame(sender,eventType)
        if eventType == ccui.TouchEventType.ended or eventType == ccui.TouchEventType.canceled then
        
            
            
        elseif eventType== ccui.TouchEventType.began then
            GameManager.PauseGame()
            pauseMenu:setVisible(true)
            GameControlLayer.enumTouchEvent.PauseGame = 1
            
        end
    end
    
    local function continueGame(sender,eventType)
        if eventType == ccui.TouchEventType.ended  then
            
            pauseMenu:setVisible(false)
            GameManager.ResumeGame()
            GameControlLayer.enumTouchEvent.PauseGame = 0
           

        elseif eventType== ccui.TouchEventType.began then

            

        end
    end
    
    local function exitGame(sender,eventType)
        if eventType == ccui.TouchEventType.ended  then
            
           GameManager.ExitFB()
            
            
           

        elseif eventType== ccui.TouchEventType.began then

            

        end
    end

    local function pressRollButon(sender,eventType)
        
        if eventType == ccui.TouchEventType.ended or eventType == ccui.TouchEventType.canceled then
            GameControlLayer.enumTouchEvent.RollTouch = 0
        elseif eventType== ccui.TouchEventType.began then 
            hero:specialRoll()
            GameControlLayer.enumTouchEvent.RollTouch = 1
            
        end
    end

    

    local button_node = node_ui:getChildByTag(GameControlLayer.NodeEnum.button)
    
    NAttack_button =  button_node:getChildByTag(1)
    NAttack_button:setPressedActionEnabled(true)
    
    
    Roll_button =  button_node:getChildByTag(6)
    Roll_button:setPressedActionEnabled(true)
    
    --button_node:getChildByTag(2):getChildByTag(0):setVisible(true)
    
--    local rollPath 
--    local Now_ultra_mode = 1
--    
--    Now_ultra_mode = GameManager.FB_Value.ultra_mode
--    
--    if Now_ultra_mode == 1 then
--        rollPath = "Image/icon/1002.jpg"
--    elseif Now_ultra_mode == 2 then
--        rollPath = "Image/icon/1003.jpg"
--    elseif Now_ultra_mode == 3 then
--        rollPath = "Image/icon/1007.jpg"
--    end
--    GameControlLayer.setIcon(Roll_button,rollPath,"3-FBZD/FBJN0.png",3)
--    GameControlLayer.setProgress(Roll_button,"3-FBZD/FBJN0.png",4)
    
    
    drink_button:setPressedActionEnabled(true)
    GameControlLayer.setIcon(drink_button,"Image/icon/1501.png","4-ZD/z.png",1)
    GameControlLayer.setProgress(drink_button,"4-ZD/z.png",4)
    drink_button:reorderChild(drink_button:getChildByTag(1),2)
    
    skill_button =  button_node:getChildByTag(2):getChildByTag(1)
    --skill_button:setPressedActionEnabled(true)
    GameControlLayer.setIcon(skill_button,"Image/icon/1001.jpg","4-ZD/z.png",1)
    GameControlLayer.setProgress(skill_button,"4-ZD/z.png",4)
    
    
    
    skill2_button =  button_node:getChildByTag(3):getChildByTag(1)
    --skill2_button:setPressedActionEnabled(true)
    GameControlLayer.setIcon(skill2_button,"Image/icon/1001.jpg","4-ZD/z.png",1)
    GameControlLayer.setProgress(skill2_button,"4-ZD/z.png",4)
    
    skill3_button =  button_node:getChildByTag(4):getChildByTag(1)
    --skill3_button:setPressedActionEnabled(true)
    GameControlLayer.setIcon(skill3_button,"Image/icon/1001.jpg","4-ZD/z.png",1)
    GameControlLayer.setProgress(skill3_button,"4-ZD/z.png",4)
    
    skill4_button =  button_node:getChildByTag(5):getChildByTag(1)
    --skill3_button:setPressedActionEnabled(true)
    GameControlLayer.setIcon(skill4_button,"Image/icon/1001.jpg","4-ZD/z.png",1)
    GameControlLayer.setProgress(skill4_button,"4-ZD/z.png",4)
    
    
    skill_button:setVisible(false)
    skill2_button:setVisible(false)
    skill3_button:setVisible(false)
    skill4_button:setVisible(false)

    
    NAttack_button:addTouchEventListener(pressNAttackButon)
    skill_button:addTouchEventListener(pressSkillButon)
    skill2_button:addTouchEventListener(pressSkill2Buton)
    skill3_button:addTouchEventListener(pressSkill3Buton)
    skill4_button:addTouchEventListener(pressSkill4Buton)
    drink_button:addTouchEventListener(pressDrinkButon)
    
    
    Roll_button:addTouchEventListener(pressRollButon)
    Time_Pause_button:addTouchEventListener(PauseGame)
    
    continueGameButton:addTouchEventListener(continueGame)
    exitGameButton:addTouchEventListener(exitGame)
    
    layerFarm:addMoveButton()
    --layerFarm:addStrike()
    --GameControlLayer.setSkillEffect(node_ui)  --增加技能按钮特效
    node_ui=nil
    return layerFarm
end

function GameControlLayer.pressPause()
    GameManager.PauseGame()
    pauseMenu:setVisible(true)
    GameControlLayer.enumTouchEvent.PauseGame = 1
end

function GameControlLayer.refreshSpeacilButton()
    local Now_ultra_mode = 1
    local rollPath
    Now_ultra_mode = GameManager.FB_Value.ultra_mode
    
    if Now_ultra_mode == 1 then
        rollPath = "Image/icon/1002.jpg"
    elseif Now_ultra_mode == 2 then
        rollPath = "Image/icon/1003.jpg"
    elseif Now_ultra_mode == 3 then
        rollPath = "Image/icon/1007.jpg"
    end
    local now_icon = Roll_button:getChildByTag(3)
    local now_iconTexture = now_icon:getChildByTag(1)
    local tScaleX=now_iconTexture:getScaleX()
    local tScaleY=now_iconTexture:getScaleY()
    local tX=now_iconTexture:getPositionX()
    local tY=now_iconTexture:getPositionY()
    now_icon:removeChildByTag(1,true)

    local backIcon =cc.Sprite:create(rollPath)  --底板图片
    now_icon:addChild(backIcon,1,1)
    backIcon:setPositionX(tX)
    backIcon:setPositionY(tY)
    backIcon:setScale(tScaleX,tScaleY)

    Roll_button:setVisible(true)
end

function GameControlLayer:replaceTPB(r_node)
    local t_node = r_node:getChildByTag(0)
    local bar_node = t_node:getChildByTag(2)
    
    local backImg = cc.Sprite:create()   --模板图片
    backImg:setSpriteFrame("3-FBZD/cjd1.png")

    local tempProgessBar = cc.ProgressTimer:create(backImg)
    tempProgessBar:setType(cc.PROGRESS_TIMER_TYPE_BAR)
    
    tempProgessBar:setPercentage(100)
    tempProgessBar:setMidpoint(cc.p(0,0.5))
    tempProgessBar:setBarChangeRate(cc.p(1, 0))
    
    bar_node:removeFromParent()
    t_node:addChild(tempProgessBar,2,2)
    
    --tempProgessBar:runAction(cc.RepeatForever:create(cc.ProgressFromTo:create(4,0,100)))
    --tempProgessBar:setScale(-1,1)
    tempProgessBar:setPosition({x = -203 , y = -73 })
    
end

local TouchArean = {x=0,y=0,width=500,height=180}

function GameControlLayer:addStrike()

    local layerFarm =  self
    local strikeNode = cc.Node:create()
    
    local bcakDrop = cc.Sprite:create()
    bcakDrop:setSpriteFrame("3-FBZD/BOSSTX-d1.png")
    bcakDrop:setPosition({x = 0 , y = -80 })
    
    strikeNode:addChild(bcakDrop,0,1)
    bcakDrop:setScale(-1,1)
    
    local backImg = cc.Sprite:create()   --模板图片
    backImg:setSpriteFrame("3-FBZD/BOSSTX-d1-5.png")
    
    local tempProgessBar = cc.ProgressTimer:create(backImg)
    tempProgessBar:setType(cc.PROGRESS_TIMER_TYPE_BAR)

    tempProgessBar:setPercentage(100)
    tempProgessBar:setMidpoint(cc.p(0,0.5))
    tempProgessBar:setBarChangeRate(cc.p(1, 0))
    --tempProgessBar:setReverseDirection(true)
    strikeNode:addChild(tempProgessBar,1,2)
    
    --tempProgessBar:setScale(-1,1)
    tempProgessBar:setPosition({x = 0 , y = -80 })
    tempProgessBar:setVisible(true)
    --tempProgessBar:runAction(cc.RepeatForever:create(cc.ProgressFromTo:create(4,0,100)))
    
    local fightText = CreateSpineRes("effect/cut")
    
    
    strikeNode:addChild(fightText,2,3)
    
    fightText:registerSpineEventHandler(function (event)
        GameManager.finishCounter(true)
    end, sp.EventType.ANIMATION_COMPLETE)
    
    fightText:setPosition({x = 100 , y = 120 })
    
    local countNum = cc.LabelAtlas:_create("1","Number/Number-lj1.png",936/12,126,46)
    strikeNode:addChild(countNum,3,4)
    countNum:setPosition({x = -180 , y = 10 })
    
    layerFarm:addChild(strikeNode,7,888)
    strikeNode:setPosition({x = 640 , y = 300 })
    strikeNode:setVisible(false)
end

function GameControlLayer:addMoveButton()

    local layerFarm =  self
    local touchBeginPoint = nil
    --local hero = nowPlayer[1]
    local offsetNode = joystick_node:getParent()
    
    local function onTouchBegan(touch, event)
        if GameManager.FB_Value.GameUI_isShow ~= true then return true end
        local location = touch:getLocation()
        
        if cc.rectContainsPoint(TouchArean,location) == true then
            touchBeginPoint = {x = location.x, y = location.y}
            
            if location.x <= 166 and GameControlLayer.enumTouchEvent.isLockLeft == false then
                if GameControlLayer.enumTouchEvent.shoulePressLeft == 1 then
                    GameControlLayer.enumTouchEvent.LeftButtonTouch = 1
                else
                    GameControlLayer.enumTouchEvent.LeftButtonTouch = 0
                end
                
            elseif GameControlLayer.enumTouchEvent.isLockRight == false then
                if GameControlLayer.enumTouchEvent.shoulePressRight == 1 then
                    GameControlLayer.enumTouchEvent.RightButtonTouch = 1
                else
                    GameControlLayer.enumTouchEvent.RightButtonTouch = 0
                end
                
            end
            
        end
        return true
    end

    local function onTouchMoved(touch, event)
        if GameManager.FB_Value.GameUI_isShow ~= true then return true end
        local location = touch:getLocation()
        --cclog("onTouchMoved: %0.2f, %0.2f", location.x, location.y)
        if touchBeginPoint then
              
            if location.x >= 166 and GameControlLayer.enumTouchEvent.isLockRight == false then
              
                if GameControlLayer.enumTouchEvent.shoulePressRight == 1 then
                    GameControlLayer.enumTouchEvent.RightButtonTouch = 1
                else
                    GameControlLayer.enumTouchEvent.RightButtonTouch = 0
                end
                GameControlLayer.enumTouchEvent.LeftButtonTouch = 0
                
              elseif location.x < 166 and GameControlLayer.enumTouchEvent.isLockLeft == false then
              
                if GameControlLayer.enumTouchEvent.shoulePressLeft == 1 then
                    GameControlLayer.enumTouchEvent.LeftButtonTouch = 1
                else
                    GameControlLayer.enumTouchEvent.LeftButtonTouch = 0
                end
                GameControlLayer.enumTouchEvent.RightButtonTouch = 0
              end
            
            --joystick_node:setPositionX(location.x)
            
            --touchBeginPoint = {x = location.x, y = location.y}
        end
    end

    local function onTouchEnded(touch, event)
        
        --cclog("onTouchEnded: %0.2f, %0.2f", location.x, location.y)
        touchBeginPoint = nil
        GameControlLayer.enumTouchEvent.LeftButtonTouch = 0
        GameControlLayer.enumTouchEvent.RightButtonTouch = 0
        --joystick_node:runAction(cc.MoveTo:create(0.15,{x = 240,y = 84}))
    end
    
    local listener = cc.EventListenerTouchOneByOne:create()
    listener:registerScriptHandler(onTouchBegan,cc.Handler.EVENT_TOUCH_BEGAN )
    listener:registerScriptHandler(onTouchMoved,cc.Handler.EVENT_TOUCH_MOVED )
    listener:registerScriptHandler(onTouchEnded,cc.Handler.EVENT_TOUCH_ENDED )
    local eventDispatcher = layerFarm:getEventDispatcher()
    
    eventDispatcher:addEventListenerWithSceneGraphPriority(listener, layerFarm)
    
    local function update(delta)
        if GameControlLayer.enumTouchEvent.RightButtonTouch == 1 then
            joystick_right_button:setVisible(true)
            joystick_left_button:setVisible(false)
            hero:movingX(1)
        elseif GameControlLayer.enumTouchEvent.LeftButtonTouch == 1 then
            joystick_left_button:setVisible(true)
            joystick_right_button:setVisible(false)
            hero:movingX(-1)
        elseif GameControlLayer.enumTouchEvent.RightButtonTouch == 0 and GameControlLayer.enumTouchEvent.LeftButtonTouch == 0 then
            joystick_right_button:setVisible(false)
            joystick_left_button:setVisible(false)
            hero:stand()
        end
    end
    
    layerFarm:scheduleUpdateWithPriorityLua(update, 0)
    
        if USEKEYBOARD == 1 then
        
        local allLine = string.split(GameDataReader.readFromAppFile("KeyConfig"),"\r\n")
        
        for key, var in pairs(allLine) do
            local _,_,newValue = string.find(var,"=%s*(.+)")
            local nowKeyValue = string.byte(newValue)
            if nowKeyValue <=63 then 
                var = nowKeyValue+28
            else
                var = nowKeyValue+27
            end
            allLine[key] = var
        end
        
                
        local function keyboardMove(keyCode,pressed)
            --cclog(" now cc.KeyCode = %d ",keyCode)

            if keyCode == allLine[1] then
                if pressed == true and GameControlLayer.enumTouchEvent.isLockLeft == false and GameControlLayer.enumTouchEvent.shoulePressLeft == 1 then
                    GameControlLayer.enumTouchEvent.RightButtonTouch = 0
                    GameControlLayer.enumTouchEvent.LeftButtonTouch = 1
                else
                    
                    GameControlLayer.enumTouchEvent.LeftButtonTouch = 0
                end
            elseif keyCode == allLine[2] and GameControlLayer.enumTouchEvent.isLockRight == false and GameControlLayer.enumTouchEvent.shoulePressRight == 1 then
                if pressed == true then
                    GameControlLayer.enumTouchEvent.RightButtonTouch = 1
                    GameControlLayer.enumTouchEvent.LeftButtonTouch = 0
                else
                    GameControlLayer.enumTouchEvent.RightButtonTouch = 0
                    
                end
            elseif keyCode == allLine[3] then
                if Roll_button:isVisible() == true then
                    hero:specialRoll()
                end
            elseif keyCode == allLine[4] then
                if skill_button:isVisible() == true then
                    hero:specialAttack1()
                end
            elseif keyCode == allLine[5] then
                if NAttack_button:isVisible() == true then
                    if pressed == true then hero:normalAttack() else hero:normalAttack_release() end
                end
            elseif keyCode == allLine[6] then
                if skill2_button:isVisible() == true then
                    hero:specialAttack2()
                end
            elseif keyCode == allLine[7] then
                if skill3_button:isVisible() == true then
                    hero:specialAttack3()
                end
            elseif keyCode == allLine[8] then
                if skill4_button:isVisible() == true then
                    hero:specialAttack4()
                end
            end
        end
        local listener = cc.EventListenerKeyboard:create()
        listener:registerScriptHandler(function(keyCode, event)
            keyboardMove(keyCode,true)
        end, cc.Handler.EVENT_KEYBOARD_PRESSED)
        listener:registerScriptHandler(function(keyCode, event)
            keyboardMove(keyCode,false)
        end, cc.Handler.EVENT_KEYBOARD_RELEASED)
        local eventDispatcher = self:getEventDispatcher()
        eventDispatcher:addEventListenerWithSceneGraphPriority(listener,self)
    end

end

function GameControlLayer.setMoveButtonState(LoR,isLock)
    if LoR == 1 then
        GameControlLayer.enumTouchEvent.isLockLeft = isLock
    elseif LoR == 2 then
        GameControlLayer.enumTouchEvent.isLockRight = isLock
    end
end
--function GameControlLayer:addMoveButton22(gameScene)
--
--    local menuTools = cc.Menu:create()
--    menuTools:setPosition(274, 80)
--
-- 
--    local TLB =cc.Sprite:create()   --模板图片
--    TLB:setSpriteFrame("2-zhandou/bt_right.png")
--    local LB = TLB:getSpriteFrame()
--    local menuLeft = cc.MenuItemImage:create()
--    
--    local TLB2 =cc.Sprite:create()   --模板图片
--    TLB2:setSpriteFrame("2-zhandou/bt_kb.png")
--    local LB2 = TLB2:getSpriteFrame()
--    LB:setOffset(cc.vertex2F(26,3))
--    
--    local menuLeft = cc.MenuItemImage:create()
--    
--    menuLeft:setNormalSpriteFrame(LB2)
--    menuLeft:setSelectedSpriteFrame(LB)
--    
--    menuLeft:setPosition(-148,40)
--    menuTools:addChild(menuLeft,2,1)
--    
--    local TRB =cc.Sprite:create()   --模板图片
--    TRB:setSpriteFrame("2-zhandou/bt_left.png")
--    local RB = TRB:getSpriteFrame()
--    RB:setOffset(cc.vertex2F(-192,4))
--
--    local TRB2 =cc.Sprite:create()   --模板图片
--    TRB2:setSpriteFrame("2-zhandou/bt_kb.png")
--    local RB2 = TRB2:getSpriteFrame()
--
--    local menuRight = cc.MenuItemImage:create() --cc.MenuItemImage:create("2-zhandou/bt_right.png","2-zhandou/bt_right.png")
--    menuRight:setNormalSpriteFrame(RB2)
--    menuRight:setSelectedSpriteFrame(RB)
--    
--    menuRight:setPosition(101,40)
--    menuTools:addChild(menuRight,2,2)
--    
--    
--    self:addChild(menuTools,2,GameControlLayer.NodeEnum.moveButton)
--    
--	local menuLeft_isSelected=false
--	local menuRight_isSelected=false
--
--    local hero = nowPlayer[1]
--    local function menuCallback()
--        if menuLeft:isSelected() or menuLeft_isSelected then
--            if GameControlLayer.enumTouchEvent.shoulePressLeft == 1 then
--                GameControlLayer.enumTouchEvent.LeftButtonTouch = 1
--                hero:movingX(-1)
--            else
--                GameControlLayer.enumTouchEvent.LeftButtonTouch = 0
--                GameControlLayer.enumTouchEvent.RightButtonTouch = 0
--                hero:stand()
--            end
--        elseif menuRight:isSelected() or menuRight_isSelected then
--            if GameControlLayer.enumTouchEvent.shoulePressRight == 1 then
--                GameControlLayer.enumTouchEvent.RightButtonTouch = 1
--                hero:movingX(1)
--            else
--                GameControlLayer.enumTouchEvent.LeftButtonTouch = 0
--                GameControlLayer.enumTouchEvent.RightButtonTouch = 0
--                hero:stand()
--            end
--        else
--            GameControlLayer.enumTouchEvent.LeftButtonTouch = 0
--            GameControlLayer.enumTouchEvent.RightButtonTouch = 0
--            hero:stand()
--        end
--    end
--    
--    local function update(delta)
--        menuCallback()
--    end
--    
--    menuTools:scheduleUpdateWithPriorityLua(update, 0)
--    
--    if USEKEYBOARD == 1 then
--        
--        local allLine = string.split(GameDataReader.readFromAppFile("KeyConfig"),"\r\n")
--        
--        for key, var in pairs(allLine) do
--            local _,_,newValue = string.find(var,"=%s*(.+)")
--            local nowKeyValue = string.byte(newValue)
--            if nowKeyValue <=63 then 
--                var = nowKeyValue+28
--            else
--                var = nowKeyValue+27
--            end
--            allLine[key] = var
--        end
--        
--                
--        local function keyboardMove(keyCode,pressed)
--            --cclog(" now cc.KeyCode = %d ",keyCode)
--
--            if keyCode == allLine[1] then
--                menuLeft_isSelected=pressed
--            elseif keyCode == allLine[2] then
--                menuRight_isSelected=pressed
--            elseif keyCode == allLine[3] then
--                if Roll_button:isVisible() == true then
--                    hero:specialRoll()
--                end
--            elseif keyCode == allLine[4] then
--                if skill_button:isVisible() == true then
--                    hero:specialAttack1()
--                end
--            elseif keyCode == allLine[5] then
--                if NAttack_button:isVisible() == true then
--                    if pressed == true then hero:normalAttack() else hero:normalAttack_release() end
--                end
--            elseif keyCode == allLine[6] then
--                if skill2_button:isVisible() == true then
--                    hero:specialAttack2()
--                end
--            elseif keyCode == allLine[7] then
--                if skill3_button:isVisible() == true then
--                    hero:specialAttack3()
--                end
--            elseif keyCode == allLine[8] then
--                if skill4_button:isVisible() == true then
--                    hero:specialAttack4()
--                end
--            elseif keyCode == allLine[9] then
--                if skill5_button:isVisible() == true then
--                    hero:specialAttack5()
--                end
--            elseif keyCode == allLine[10] then
--                if skill6_button:isVisible() == true then
--                    hero:specialAttack6()
--                end
--            elseif keyCode == allLine[11] then
--                if skill7_button:isVisible() == true then
--                    hero:specialAttack7()
--                end
--            end
--        end
--        local listener = cc.EventListenerKeyboard:create()
--        listener:registerScriptHandler(function(keyCode, event)
--            keyboardMove(keyCode,true)
--        end, cc.Handler.EVENT_KEYBOARD_PRESSED)
--        listener:registerScriptHandler(function(keyCode, event)
--            keyboardMove(keyCode,false)
--        end, cc.Handler.EVENT_KEYBOARD_RELEASED)
--        local eventDispatcher = self:getEventDispatcher()
--        eventDispatcher:addEventListenerWithSceneGraphPriority(listener,self)
--	end
--end

return GameControlLayer