GameTeachManager = {}

local GameLessonQueue = List.new()


function GameTeachManager.Shutdown()
    --outputString("GameEventManager.Shutdown()")

    GameTeachManager.Stop()
    GameTeachManager.ResetDatas()
end

function GameTeachManager.Run()

    GameTeachManager.Stop()

    local function tick(dt)
        GameTeachManager.UpdateProcess(dt)
    end
    GameTeachManager.schedulerID = cc.Director:getInstance():getScheduler():scheduleScriptFunc(tick, 0, false)
end

function GameTeachManager.Stop()

    if GameTeachManager.schedulerID then
        cc.Director:getInstance():getScheduler():unscheduleScriptEntry(GameTeachManager.schedulerID)
    end
end

function GameTeachManager.ResetDatas()
   
    List.removeAll(GameLessonQueue)
    GameLessonQueue = List.new()
end

function GameTeachManager.AddLesson(path_Name)


    local function AL()
        local now_Path = string.format("Lesson/%s",path_Name)
        local lesson = require(now_Path)
        lesson.init()
        List.pushlast(GameLessonQueue,lesson)

    end
    
    local function errortoGo(msg)
        local nowMsg = msg

        GameTeachManager.Shutdown()

        local tempscene = NowSceneReplace(GameMainScene,true)
        
        local function showError()
            __G__TRACKBACK__(nowMsg)
        end
        tempscene:runAction(cc.Sequence:create(cc.DelayTime:create(1),cc.CallFunc:create(showError)))
    end
    
    try_catch(AL,errortoGo)

end

function GameTeachManager.UpdateProcess(dt)
    if GameLessonQueue ~= nil and List.getSize(GameLessonQueue)> 0 then
        if false == TeachAssistor.NodeIsRunning(TeachAssistor.clippingNodeTag2) 
        and false == TeachAssistor.NodeIsRunning(TeachAssistor.transparentMaskTipTag)
        and false == TeachAssistor.NodeIsRunning(TeachAssistor.transparentMaskTip2Tag)
        and false == TeachAssistor.NodeIsRunning(TeachAssistor.bottomSpriteTagTip)
        and false ==TeachAssistor.NodeIsRunning(TeachAssistor.topSpriteTagTip)
        then 
            GameLessonQueue[1]:Update(dt)
        end
        
        if GameLessonQueue[1].isDone == true then
            List.remove(GameLessonQueue,1)
        end
        
    end
end