
LableString = {}

 --初始化
LableString.m_delayTime31=nil
LableString.m_delayTime32=nil
LableString.m_fadeIn=nil
LableString.m_fadeOut=nil
LableString.m_delayTime5=nil
local mRandom = Random
local HurtString={}

function LableString.setLayer(layer)
    LableString.layer=layer
    --
    LableString.release() --习惯性初始化,防止上一个的对象未释放
    
    --提前把字体文理放入缓存中，提高需要时的效率
    cc.Director:getInstance():getTextureCache():addImage("Number/yishuzi_1.png")
    cc.Director:getInstance():getTextureCache():addImage("CocosStudio/Images/BJ.png")
    cc.Director:getInstance():getTextureCache():addImage("CocosStudio/Images/GD.png")
    
    cc.LabelAtlas:_create("0","Number/yishuzi_1.png",390/15,36,43)
    
    --保存对象的引用对象
    LableString.m_delayTime31 = cc.DelayTime:create(0.3)
    LableString.m_delayTime32 = cc.DelayTime:create(0.3)
    LableString.m_fadeIn = cc.FadeIn:create(0.3)
    LableString.m_fadeOut = cc.FadeOut:create(0.3)
    LableString.m_fadeOut2 = cc.FadeOut:create(0.5)
    LableString.m_delayTime5 = cc.DelayTime:create(0.5)
    
    --retain 对象，人为控制对象的生命期
    LableString.m_delayTime31:retain()
    LableString.m_delayTime32:retain()
    LableString.m_fadeIn:retain()
    LableString.m_fadeOut:retain()
    LableString.m_fadeOut2:retain()
    LableString.m_delayTime5:retain()
    
    
    
end

function LableString.setPar()
    ParticleManager:getInstance():AddPlistData("effect/ball.plist", "ball")
    ParticleManager:getInstance():AddPlistData("effect/ball1.plist", "ball1")
    ParticleManager:getInstance():AddPlistData("effect/bom_0.plist", "bom_0")
    ParticleManager:getInstance():AddPlistData("effect/pet_par_1.plist", "pet_par_1")
    ParticleManager:getInstance():AddPlistData("effect/pet_par_2.plist", "pet_par_2")
    ParticleManager:getInstance():AddPlistData("effect/pet_par_3.plist", "pet_par_3")
    ParticleManager:getInstance():AddPlistData("effect/pet_par_4.plist", "pet_par_4")
    ParticleManager:getInstance():AddPlistData("effect/pet_par_5.plist", "pet_par_5")
    ParticleManager:getInstance():AddPlistData("effect/pet_par_6.plist", "pet_par_6")

    
    ParticleManager:getInstance():AddPlistData("effect/bom.plist", "bom")

    local particle_1 = cc.ParticleSystemQuad:create(ParticleManager:getInstance():getPlistData("bom_0"))
    particle_1 = cc.ParticleSystemQuad:create(ParticleManager:getInstance():getPlistData("bom_1"))
    particle_1 = cc.ParticleSystemQuad:create(ParticleManager:getInstance():getPlistData("ball"))
    particle_1 = cc.ParticleSystemQuad:create(ParticleManager:getInstance():getPlistData("ball1"))
    particle_1 = cc.ParticleSystemQuad:create(ParticleManager:getInstance():getPlistData("bom"))
end

--释放 人为控制生命周期的 对象
function LableString.release()
    if nil ~= LableString.m_delayTime31 then
        LableString.m_delayTime31:release()
        LableString.m_delayTime31 = nil
    end
    if nil ~= LableString.m_delayTime32 then
        LableString.m_delayTime32:release()
        LableString.m_delayTime32 = nil
    end
    if nil ~= LableString.m_fadeIn then
        LableString.m_fadeIn:release()
        LableString.m_fadeIn = nil
    end
    if nil ~= LableString.m_fadeOut then
         LableString.m_fadeOut:release()
         LableString.m_fadeOut = nil
    end
    if nil ~= LableString.m_fadeOut2 then
        LableString.m_fadeOut2:release()
        LableString.m_fadeOut2 = nil
    end
    if nil ~= LableString.m_delayTime5 then
        LableString.m_delayTime5:release()
        LableString.m_delayTime5 = nil
    end
end

function LableString.resetData()
    LableString.release()
    table.clear(HurtString)
end

function LableString.update(m_cameraX)
    
    LableString.updateHurtString(m_cameraX)
end

function LableString.addGDString(x,y,m_cx,m_dir)
    local hurt =  cc.Sprite:create("CocosStudio/images/GD.png")
    local dir = 1
    
    hurt.RealX = x + Random(-30,30)
    hurt:setPosition(hurt.RealX,y)
    

    if m_dir and m_dir < 1 then  dir = -1 end

    
    hurt:setScaleX(0.2)
    hurt:setScaleY(0.2)


    --克隆已创建的对象，降低此时的消耗
    local delayTime31 = LableString.m_delayTime31:clone()

    local fadeIn =LableString.m_fadeIn:clone()
    local fadeOut = LableString.m_fadeOut:clone()
    local actionBy = cc.EaseInOut:create(cc.ScaleBy:create(0.4, 6, 6),1.5)
    hurt:runAction(cc.Spawn:create(
        cc.Sequence:create(cc.MoveBy:create(0.3,cc.p(0,mRandom(140,200))),delayTime31,cc.MoveBy:create(mRandom(0.2,0.4),cc.p(mRandom(50,150)*dir,mRandom(80,120)))),
        cc.Sequence:create(fadeIn,delayTime31,fadeOut),
        cc.Sequence:create(actionBy,delayTime31,actionBy:reverse()))
    )


    LableString.layer:addChild(hurt,res_gameLayer.LAYER_FG) 
    table.insert(HurtString,hurt)
end

function LableString.addHurtString(x,y,m_cx,value,color,m_dir,isheal)
    
    --local hurt= cc.Label:createWithTTF(res_font.hurt,value) --2015-2-6注释，原因:效率低
    local hurt 
    
    hurt =  cc.LabelAtlas:_create(value*-1,"Number/yishuzi_1.png",390/15,36,43)
   
    
    local dir = 1
    
    if m_dir and m_dir < 1 then  dir = -1 end
    
    hurt.RealX = x + Random(-30,30)
    hurt:setPosition(hurt.RealX,y)
    hurt.type = 2
    hurt:setColor(res_color.RED)
    
	if color and color~= nil then
	   if isheal and isheal == true then
            local BJ = cc.Sprite:create("CocosStudio/Images/HF.png")
            hurt:addChild(BJ)
            BJ:setPositionX(-45)
            BJ:setPositionY(20)
            
	   else
            local BJ = cc.Sprite:create("CocosStudio/Images/BJ.png")
            hurt:addChild(BJ)
            BJ:setPositionX(-45)
            BJ:setPositionY(20)
            
       end
        hurt:setColor(color) 
    end
    
    
	
    hurt:setScaleX(0.2)
    hurt:setScaleY(0.2)
	--local duration=2.5
	
	--克隆已创建的对象，降低此时的消耗
    local delayTime31 = LableString.m_delayTime31:clone()
   
    local fadeIn =LableString.m_fadeIn:clone()
    local fadeOut = LableString.m_fadeOut:clone()
    local actionBy = cc.EaseInOut:create(cc.ScaleBy:create(0.4, 6, 6),1.5)
    hurt:runAction(cc.Spawn:create(
        cc.Sequence:create(cc.MoveBy:create(0.3,cc.p(0,mRandom(140,200))),delayTime31,cc.MoveBy:create(mRandom(0.2,0.4),cc.p(mRandom(50,150)*dir,mRandom(80,120)))),
        cc.Sequence:create(fadeIn,delayTime31,fadeOut),
        cc.Sequence:create(actionBy,delayTime31,actionBy:reverse()))
        )
   
   
    --[[ 2015-2-6 注释,尽量提前创建对象，避免在战斗中创建
    local actionBy = cc.ScaleBy:create(0.2, 6, 6)    
    hurt:runAction(cc.Spawn:create(
        cc.Sequence:create(cc.MoveBy:create(0.3,cc.p(0,Random(140,200))),cc.DelayTime:create(0.3),cc.MoveBy:create(Random(0.2,0.4),cc.p(0,Random(80,120)))),
        cc.Sequence:create(cc.FadeIn:create(0.3),cc.DelayTime:create(0.3),cc.FadeOut:create(0.3)),
        cc.Sequence:create(actionBy,cc.DelayTime:create(0.5),actionBy:reverse())
    ))
   --]]
   
   LableString.layer:addChild(hurt,res_gameLayer.LAYER_FG) 
   table.insert(HurtString,hurt)
   
end

function LableString.addHurtStringText(x,y,m_cx,text_value,color)

    --local hurt= cc.Label:createWithTTF(res_font.hurt,value) --2015-2-6注释，原因:效率低
    local hurt =  cc.LabelAtlas:_create(value,"Number/yishuzi_1.png",390/15,36,43)

    hurt.RealX = x + Random(-30,30)
    hurt:setPosition(hurt.RealX,y)
    hurt.type = 2
    hurt:setColor(res_color.GREEN)
    if color and color~= nil then hurt:setColor(color) end



    hurt:setScaleX(0.2)
    hurt:setScaleY(0.2)
    --local duration=2.5

    --克隆已创建的对象，降低此时的消耗
    local delayTime31 = LableString.m_delayTime31:clone()
    local delayTime32 = LableString.m_delayTime32:clone()
    local delayTime51 = LableString.m_delayTime5:clone()
    local fadeIn =LableString.m_fadeIn:clone()
    local fadeOut = LableString.m_fadeOut:clone()
    local actionBy = cc.ScaleBy:create(0.4, 6, 6)
    hurt:runAction(cc.Spawn:create(
        cc.Sequence:create(cc.MoveBy:create(0.3,cc.p(0,mRandom(140,200))),delayTime31,cc.MoveBy:create(mRandom(0.2,0.4),cc.p(0,mRandom(80,120)))),
        cc.Sequence:create(fadeIn,delayTime32,fadeOut),
        cc.Sequence:create(actionBy,delayTime32,actionBy:reverse()))
    )


    --[[ 2015-2-6 注释,尽量提前创建对象，避免在战斗中创建
    local actionBy = cc.ScaleBy:create(0.2, 6, 6)    
    hurt:runAction(cc.Spawn:create(
    cc.Sequence:create(cc.MoveBy:create(0.3,cc.p(0,Random(140,200))),cc.DelayTime:create(0.3),cc.MoveBy:create(Random(0.2,0.4),cc.p(0,Random(80,120)))),
    cc.Sequence:create(cc.FadeIn:create(0.3),cc.DelayTime:create(0.3),cc.FadeOut:create(0.3)),
    cc.Sequence:create(actionBy,cc.DelayTime:create(0.5),actionBy:reverse())
    ))
    --]]

    LableString.layer:addChild(hurt,res_gameLayer.LAYER_FG) 
    table.insert(HurtString,hurt)

end

function LableString.addTraceString(x,y,value)

    local hurt=cc.Label:createWithTTF(res_font.hurt,value)
    hurt:setAlignment(cc.TEXT_ALIGNMENT_LEFT,cc.TEXT_ALIGNMENT_CENTER)
    hurt:setWidth(cc.Director:getInstance():getWinSize().width)
    hurt:setHeight(cc.Director:getInstance():getWinSize().height)
    hurt:setPosition(x,y)

    LableString.layer:addChild(hurt,res_gameLayer.LAYER_FG)

    table.insert(HurtString,hurt)
end

function LableString.addEnergyUseEffect(x,y)
    local hurt = cc.ParticleSystemQuad:create(ParticleManager:getInstance():getPlistData("bom"))
   
    hurt:setPosition(x,y)
    
    local action1 =LableString.m_fadeOut2:clone()
    
    
    hurt.outLayer = 1 
    
    
    hurt:runAction(action1)
    
    
    
    LableString.layer:getParent():getParent():getParent():addChild(hurt,100) 
    
    table.insert(HurtString,hurt)
    
end

function LableString.addEnergyGetEffect(x,y)
    local hurt = cc.ParticleSystemQuad:create(ParticleManager:getInstance():getPlistData("bom_0"))
    local hurt2 = cc.ParticleSystemQuad:create(ParticleManager:getInstance():getPlistData("bom_1"))
    hurt:setPosition(x,y)
    hurt2:setPosition(x,y)
    local action1 =LableString.m_fadeOut2:clone()
    local action2 =LableString.m_fadeOut2:clone()

    hurt.outLayer = 1 
    hurt2.outLayer = 1 

    hurt:runAction(action1)
    hurt2:runAction(action2)

    LableString.layer:getParent():getParent():getParent():addChild(hurt2,100)
    LableString.layer:getParent():getParent():getParent():addChild(hurt,100) 
    table.insert(HurtString,hurt2)
    table.insert(HurtString,hurt)

end
function LableString.addTraceEnergy(x,y,offsetX,dir,value,m_type)

    local myParticleMg=ParticleManager:getInstance()
    local name1=myParticleMg:getPlistData("ball")
    local name2=myParticleMg:getPlistData("ball1")

    local hurt = cc.ParticleSystemQuad:create(name1)
    local hurt2 = cc.ParticleSystemQuad:create(name2)
    
    hurt.RealX = (x-offsetX) + Random(-30,30)
    hurt:setPosition(hurt.RealX,y)
    hurt2.RealX = hurt.RealX
    hurt2:setPosition(hurt.RealX,y)
    
    hurt.outLayer = 0 
    hurt.value = value
    hurt.role_type = m_type
    hurt2.outLayer = 0 
    hurt:setScale(0.5)
    hurt2:setScale(0.5)
    hurt:setPositionType(cc.POSITION_TYPE_GROUPED)
    
    hurt2:setPositionType(cc.POSITION_TYPE_FREE)
    
    local dX,dY = GameManager.getEnergyXY(m_type)
    --local streak = cc.MotionStreak:create(2, 3, 32, cc.c3b(255, 0, 0), hurt)
    local bezier
    if dir == -1 then 
        bezier = {
            cc.p(1280, 360-Random(0,100)),
            cc.p(640 - Random(0,200), 720 - Random(0,200)),
            cc.p(dX, dY),
        }
    else 
        bezier = {
            cc.p(0, 360-Random(0,100)),
            cc.p(640 + Random(0,200), 720 - Random(0,200)),
            cc.p(dX, dY),
        }
    end
    
    local bezierTo1 = cc.BezierTo:create(0.8, bezier)
    local bezierTo2 = cc.BezierTo:create(0.8, bezier)
    
    
    local newAction = cc.Sequence:create(bezierTo1,cc.FadeOut:create(0.1))
    local newAction2 = cc.Sequence:create(bezierTo2,cc.FadeOut:create(0.1))
    hurt:runAction(newAction)
    hurt2:runAction(newAction2)
    LableString.layer:getParent():addChild(hurt2,res_gameLayer.LAYER_CONTROL)
    LableString.layer:getParent():addChild(hurt,res_gameLayer.LAYER_CONTROL) 
    table.insert(HurtString,hurt2)
    table.insert(HurtString,hurt)
end

function LableString.updateHurtString(m_cameraX)
    --cclog("LableString .HurtString length = %d ",#HurtString)
    
    for key, var in pairs(HurtString) do
       
		if var:getOpacity()==0 then
            if var.outLayer and var.outLayer== 0 then
                local dX,dY = var:getPosition()
                dY = dY - 20
                
                if var.value and var.value ~= 0 then
                    if var.role_type == 1 then
                        GameManager.checkEnergyAdd(nowPlayer[1],var.value)
                    else
                        GameManager.checkEnergyAdd(nowmonster[1],var.value)
                    end
                end
                LableString.layer:getParent():removeChild(var)
                
            elseif var.outLayer and var.outLayer== 1 then
                LableString.layer:getParent():getParent():getParent():removeChild(var)
		    else
                LableString.layer:removeChild(var)
            end
            
            table.remove(HurtString,key)
        end
    end
end