AchievementScene = {}

AchievementScene = class("AchievementScene",function()
    return cc.Scene:create()
end)

local children={}
local select_task_tag=1

local type_task=enum{
    "PVP_RANK=1",
    "LEVEL",
    "PETLV_SUM",
    "STAR_SUM",
    "FB_CLEAR"
}
AchievementScene.type_task=type_task

function AchievementScene:sceneEnter()
    outputString("AchievementScene:sceneEnter()")
end

function AchievementScene:sceneExit()
    AchievementScene.RemoveAllChildren(self)
end

function AchievementScene.RemoveAllChildren(scene)
    table.clear(children)
    GameAssistor.RemoveUnusedSceneResource(scene)
end

function AchievementScene.create()

    local scene = AchievementScene.new()

    Sence_Init(scene)

    local layerFarm = cc.Layer:create()

    scene.getMainLayer=function()
        return layerFarm
    end
    children.mainLayerFarm = layerFarm

    local background = GameAssistor.CreateBackMaskLayout(180)
    layerFarm:addChild(background)

    scene.AddMainChildren()

    scene:addChild(layerFarm)

    return scene
end

function AchievementScene.Refresh()
    AchievementScene.ChooseTypeTag(select_task_tag) 
end

function AchievementScene.QuickOpenTypeStore(type)
    select_task_tag=type
    return GameMainScene.AddSceneToSubFuncPage(GameMainScene.pageZOrder.SUBPAGE_ACHIEVEMENT)
end

function AchievementScene.AddMainChildren()

    local layerFarm = children.mainLayerFarm

    local page_layer = cc.CSLoader:createNode("RW.csb")
    layerFarm:addChild(page_layer)

    children.sc_storeList=page_layer:getChildByTag(1):getChildByTag(1)

    local nd_tags=page_layer:getChildByTag(2)
    for i=1,5 do
        local button=nd_tags:getChildByTag(i)
        button:addTouchEventListener(
            function(sender,eventType)
                if eventType== ccui.TouchEventType.ended then
                    return AchievementScene.ChooseTypeTag(i)
                end
            end)
        GameAssistor.SetButtonTitleBlackOutline(button)
    end
    children.nd_typeTags=nd_tags
end

function AchievementScene.CangetReward()
    for i=1,5 do
        local taskList=GameDataTransfer.GetTypeAchievementList(i)
        for _,data in pairs(taskList) do
            local isGot,isDone=AchievementScene.CheckTaskDatas(data.ID)
            if not isGot and isDone then
                return true
            end
        end
    end

    return false
end

function AchievementScene.ChooseTypeTag(tag)
    for key,node in pairs(children.nd_typeTags:getChildren()) do
        GameAssistor.SetButtonBright(node,tag~=node:getTag())
    end
    select_task_tag=tag
    
    local sc_storeList = children.sc_storeList
    
    sc_storeList:removeAllChildren()

    local taskList=GameDataTransfer.GetTypeAchievementList(tag)
    --table.print(taskList,"----ChooseTag taskList--------")
    
    for index,data in pairs(taskList) do
        local page_layer = cc.CSLoader:createNode("RW-T.csb")
        local node = page_layer:getChildByTag(1)
        node:removeFromParent() 
        node.ID=data.ID
        sc_storeList:addChild(node)
        
        --[[
        local nd_icon=node:getChildByTag(1):getChildByTag(1)
        local icon,quality=nd_icon:getChildByTag(1),nd_icon:getChildByTag(0)
        icon:loadTexture(GameDataTransfer.GetIconPath(data.icon))--]]
        RoleScene.SetEquipItem(node:getChildByTag(1),data.icon,true)
        
        local tx_info=node:getChildByTag(2):getChildByTag(3)
        --tx_info:setString(GameDataTransfer.GetGameString(data.string))
        GameAssistor.SetSCRichText(GameDataTransfer.GetGameString(data.string),tx_info)
        
        local awardList=GameDataTransfer.GetAwardStringData(data.reward)
        local iData=GameDataTransfer.GetItemData(awardList[1].ID)
        local isCoin=iData.Type==res_item_type.COINS
        
        local nd_awards=node:getChildByTag(3)
        local ndCoins,ndGems=nd_awards:getChildByTag(2),nd_awards:getChildByTag(1)
        ndCoins:setVisible(isCoin) ndGems:setVisible(not isCoin)
        local awardS="+"..awardList[1].qty
        ndCoins:getChildByTag(1):setString(awardS) 
        ndGems:getChildByTag(1):setString(awardS)

        local nd_button=node:getChildByTag(4)
        local bt_get,nd_got=nd_button:getChildByTag(1),nd_button:getChildByTag(2)
        GameAssistor.SetButtonTitleBlackOutline(bt_get)

        CommonAssistor.AddSimpleTouchEvent(bt_get,function()
            --table.print(data,"--------")
            if node.ID>0 then
                return AchievementScene.GetTaskAward(node.ID)
            end
        end)
        
        node.Refresh=function()         
            local isGot,isDone=AchievementScene.CheckTaskDatas(data.ID)
            bt_get:setVisible(not isGot) 
            nd_got:setVisible(isGot)
            GameAssistor.SetButtonBright(bt_get,isDone or false)
            node.isGot=isGot
        end
    end

    local h=120
    local innerWidth = sc_storeList:getContentSize().width
    local innerHeight = math.max(sc_storeList:getContentSize().height,math.floor(#sc_storeList:getChildren())*h)
    sc_storeList:setInnerContainerSize(cc.size(innerWidth, innerHeight))
    local x,y = 430,innerHeight-h/2
    --[[for key, var in pairs(sc_storeList:getChildren()) do
        var:setPosition(x,y-(key-1)*h)
    end--]]
    sc_storeList:jumpToTop()
    
    AchievementScene.RefreshTaskList=function()
        local count=0
        for key, node in pairs(sc_storeList:getChildren()) do
            node.Refresh()
            if not node.isGot then
                node:setPosition(x,y-count*h) count=count+1
            end
        end
        for key, node in pairs(sc_storeList:getChildren()) do
            if node.isGot then
                node:setPosition(x,y-count*h) count=count+1
            end
        end
    end
    return AchievementScene.RefreshTaskList()
end

function AchievementScene.CheckTaskDatas(ID)
    -- PlayerDataList.Tasks = {}
    -- GameRecorder.SaveBasicData()
    local isGot=GameRecorder.GetTaskData(ID) and true or false
    if isGot then return true end
    local aData=GameDataTransfer.GetGameAchievementData(ID)
    local Type=aData.tape
    if Type==type_task.PVP_RANK then
        return isGot,ArenaScene.GetUserData("rankMax")<=aData.rank
    elseif Type==type_task.LEVEL then
        return isGot,GameRecorder.GetBasicData("level")>=aData.level
    elseif Type==type_task.PETLV_SUM then
        local petlvSum=0
        for roleID=1,3 do
            local role=GameRecorder.GetRole(roleID)
            if role.unlock>0 then petlvSum=petlvSum+role.petlv end
        end
        return isGot,petlvSum>=aData.level_1
    elseif Type==type_task.STAR_SUM then
        local starSum=0
        for roleID=1,3 do
            local role=GameRecorder.GetRole(roleID)
            if role.unlock>0 then starSum=starSum+role.star end
        end
        return isGot,starSum>=aData.level_2
    elseif Type==type_task.FB_CLEAR then
        return isGot,GameRecorder.GetFBStar(aData.clearance)>0
    end
    return isGot
end

function AchievementScene.GetTaskAward(ID)
    if GameRecorder.GetTaskData(ID) then return end
    GameRecorder.SetTaskData(ID)
    local aData=GameDataTransfer.GetGameAchievementData(ID)
    StageScene.AddAwardStrings(aData.reward)
    AchievementScene.RefreshTaskList()
    GameMainScene.RefreshPlayerStateBar()
    if not AchievementScene.CangetReward() then
        if red_point then
            red_point:removeFromParent()
            red_point = nil
        end
    end
    return GameRecorder.SaveBasicData()
end
