ChargeScene = {}

ChargeScene = class("ChargeScene",function()
    return cc.Scene:create()
end)

local children={}

function ChargeScene:sceneEnter()
    outputString("ChargeScene:sceneEnter()")
end

function ChargeScene:sceneExit()
    ChargeScene.RemoveAllChildren(self)
end

function ChargeScene.RemoveAllChildren(scene)
    table.clear(children)
    GameAssistor.RemoveUnusedSceneResource(scene)
end

function ChargeScene.create()

    local scene = ChargeScene.new()

    Sence_Init(scene)

    local layerFarm = cc.Layer:create()

    scene.getMainLayer=function()
        return layerFarm
    end
    children.mainLayerFarm = layerFarm

    local background = GameAssistor.CreateBackMaskLayout(180)
    layerFarm:addChild(background)

    scene.AddMainChildren()

    scene:addChild(layerFarm)
    
    if PINGTEST then Ping_AddTestButtons(scene) end

    return scene
end

function ChargeScene.Refresh()
    
end

function ChargeScene.AddMainChildren()

    local layerFarm = children.mainLayerFarm

    local page_layer = cc.CSLoader:createNode("CZ.csb")
    GameAssistor.SetToSceneCenter(page_layer)
    layerFarm:addChild(page_layer)

    local sc_storeList=page_layer:getChildByTag(31):getChildByTag(1)
    children.sc_storeList=sc_storeList

    local goodsList=GameDataTransfer.GetTypeStoreList(res_store_type.DIAMOND)
    --table.print(goodsList,"----ChooseTag goodsList--------")

    sc_storeList:removeAllChildren()
    
    local x,y,w,h,count = 250,330,250,230,0
    for index,data in pairs(goodsList) do
        local page_layer = cc.CSLoader:createNode("CZ-k.csb")
        local button = page_layer:getChildByTag(1)
        button:removeFromParent() button.ID=data.ID
        sc_storeList:addChild(button)
        
        local row,col = math.floor(count/3) ,count%3
        button:setPosition(x+col*w-row*30,y-row*h) count=count+1        
        
        local tx_get=button:getChildByTag(1):getChildByTag(1)
        local tx_RMB=button:getChildByTag(2):getChildByTag(1)
        GameAssistor.SetBlackOutlineNoSpaces{tx_RMB,tx_get}
        tx_RMB:setString((data.Rate / 10)..GameDataTransfer.GetSysString(str_system.STRING_TIPS_YUAN))

        local awardList=GameDataTransfer.GetAwardStringData(data.ResId)
        tx_get:setString("x"..awardList[1].qty)        
        local mark=button:getChildByTag(3) mark:setVisible(data.recommend>0)
        
        button:addTouchEventListener(
            function(sender,eventType)
                StageScene.SetNodeTouchScale(sender,eventType)
                if eventType== ccui.TouchEventType.ended then
                    return StoreScene.ExchangeItems(data)
                end
            end)
            
        CommonAssistor.PlayTimelineEffect("e-BOX-cz.csb",button:getChildByTag(4),true)
    end
end



