
CommonAssistor={}

function CommonAssistor.CreateCommonButtonMessageLayout(tips, alignment)

    local layerFarm = GameAssistor.GetRunningScene()
    local background = GameAssistor.CreateBackMaskLayout(180)

    local zOrder=GameMainScene.pageZOrder.PAGE_WARNING
    layerFarm:addChild(background,99999,zOrder)

    local obstructLayout = GameAssistor.CreateBackMaskLayout()
    background:addChild(obstructLayout)
    background.obstructLayout=obstructLayout

    obstructLayout:setAnchorPoint(cc.p(0.5,0.5))
    GameAssistor.SetToSceneCenter(obstructLayout)

    local function RemovePage()
        layerFarm:removeChild(background)
    end
    GameMainScene.SetObstructLayoutTouchEvent(obstructLayout,RemovePage)
    
    local function HidePage()
        GameMainScene.HidePageScaleToAction(obstructLayout,RemovePage)
    end

    local page_layer = cc.CSLoader:createNode("WG-2ck.csb")
    GameAssistor.SetToSceneCenter(page_layer)
    obstructLayout:addChild(page_layer)

    local tx_warning=page_layer:getChildByTag(1)
    tx_warning:setString(tips)

    tx_warning:setTextHorizontalAlignment(1)
    
    page_layer.setStyle=function(isConfirm)
        page_layer:getChildByTag(2):setVisible(not isConfirm)
        page_layer:getChildByTag(3):setVisible(isConfirm)
    end

    GameMainScene.PlayPageScaleToAction(obstructLayout)
    
    return page_layer,HidePage,background
end

function CommonAssistor.ShowWinBox(rewarid)

    local get_count = cc.UserDefault:getInstance():getIntegerForKey("get_count",0)

    if get_count > 2 then
        rewarid = 2
    end

    local layerFarm = GameAssistor.GetRunningScene()
    local background = GameAssistor.CreateBackMaskLayout(180)

    -- local zOrder=GameMainScene.pageZOrder.PAGE_WARNING
    layerFarm:addChild(background,10000,10000)

    local obstructLayout = GameAssistor.CreateBackMaskLayout()
    background:addChild(obstructLayout)
    background.obstructLayout=obstructLayout

    obstructLayout:setAnchorPoint(cc.p(0.5,0.5))
    GameAssistor.SetToSceneCenter(obstructLayout)

   
    
    local function HidePage()
        GameMainScene.HidePageScaleToAction(obstructLayout,RemovePage)
    end

    local page_layer = cc.CSLoader:createNode("UI_tankuang.csb")
    GameAssistor.SetToSceneCenter(page_layer)
    obstructLayout:addChild(page_layer)

    
    local items = {}
    local itemString = GameData_List.Game_box[rewarid]
    local ResetItem = function()
        itemString = GameData_List.Game_box[rewarid]
        if not itemString then 
            return
        end

        items = {}
        local oneItem = string.split(itemString.item,"|")
        for _,v in pairs(oneItem) do
            local it = string.split(v, ",")
            local index = #items + 1
            items[index] = {}
            items[index].item = it[1]
            items[index].num  = it[2]
            items[index].use  = false
        end

    end

    local closeBox = function()
        GameMainScene.HidePageScaleToAction(obstructLayout, function()
            layerFarm:removeChild(background)
        end)
    end


    ResetItem()
    local btns = {}
    btns[1] = false
    btns[2] = false
    btns[3] = false
    btns[4] = false
    btns[5] = false

    local can_click = true

    for i = 1, 5 do 
        local item = page_layer:getChildByName("baoxiang"..i)
        local icon = item:getChildByTag(1):getChildByTag(1)
        local btnIcon = item:getChildByTag(1)
        btnIcon:addTouchEventListener(
        function(sender,eventType)
            if not can_click then
                return 
            end
            if eventType== ccui.TouchEventType.ended then
                local index = 0
                while index == 0 do
                    local ix = math.random(1, #items)
                    cclog(ix)
                    if not items[ix].use then
                        items[ix].use = true
                        index = ix
                        break
                    end
                end
                local itemData = GameDataTransfer.GetItemData(tonumber(items[index].item))
                local icont = item:getChildByTag(1):getChildByTag(1)
                icont:loadTexture(GameDataTransfer.GetIconPath(itemData.IconID))
                btns[i] = true
                btnIcon:addTouchEventListener(function() end)

                local texNum = item:getChildByTag(1):getChildByTag(3)
                texNum:setString("x" .. items[index].num)
                local txName=item:getChildByTag(1):getChildByTag(2)
                local name=GameDataTransfer.GetGameString(itemData.Equip_Name)
                StageScene.SetQualityNameText(txName,name,itemData.Quality)
                txName:setVisible(true)
                texNum:setVisible(true)
                can_click = false
            end
        end)       
        icon:loadTexture("Image/icon/FB-box1.png")

    end

    local useGold = false
    local btnAll = page_layer:getChildByName("anniu_lingqu")
    local textJinE = page_layer:getChildByName("jine")
    local hasGained = false
    textJinE:setString("" .. itemString.gold)
    btnAll:addTouchEventListener(
        function(sender,eventType)
            if eventType== ccui.TouchEventType.ended then
                if hasGained or PlayerDataList.Basic.diamond < itemString.gold then
                    CommonAssistor.AddConfirmBox("金币不足，无法领取", function() 
                        closeBox()
                    end,999999)
                    return
                end

                rewarid = 1
                ResetItem()

                useGold = true
                for i = 1, 5 do
                    if not btns[i] then
                        local item = page_layer:getChildByName("baoxiang"..i)
                        local icon = item:getChildByTag(1):getChildByTag(1)
                        local btnIcon = item:getChildByTag(1)
                        local index = 0
                        while index == 0 do
                            local ix = math.random(1, #items)
                            cclog(ix)
                            if not items[ix].use then
                                items[ix].use = true
                                index = ix
                                break
                            end
                        end
                        local itemData = GameDataTransfer.GetItemData(tonumber(items[index].item))
                        local icont = item:getChildByTag(1):getChildByTag(1)
                        icont:loadTexture(GameDataTransfer.GetIconPath(itemData.IconID))
                        btns[i] = true
                        btnIcon:addTouchEventListener(function() end)

                        local texNum = item:getChildByTag(1):getChildByTag(3)
                        texNum:setString("x" .. items[index].num)
                        local txName=item:getChildByTag(1):getChildByTag(2)
                        local name=GameDataTransfer.GetGameString(itemData.Equip_Name)
                        StageScene.SetQualityNameText(txName,name,itemData.Quality)
                        txName:setVisible(true)
                        texNum:setVisible(true)
                    end
                end
                hasGained = true
                -- btnAll:setVisible(false)
                -- textJinE:setVisible(false)
                PlayerDataList.Basic.diamond = PlayerDataList.Basic.diamond - itemString.gold
                GameRecorder.SaveBasicData()
                GameMainScene.RefreshPlayerStateBar()
                btnAll:setTitleText("确定")
                btnAll:addTouchEventListener(
                    function(sender,eventType)
                        if eventType== ccui.TouchEventType.ended then
                            closeBox()
                        end
                    end)
            end
        end)


    local btnBack = page_layer:getChildByName("anniu_fanhui")
     btnBack:addTouchEventListener(
        function(sender,eventType)
            if eventType== ccui.TouchEventType.ended then
                GameMainScene.HidePageScaleToAction(obstructLayout, function()
                    if useGold then
                        cc.UserDefault:getInstance():setIntegerForKey("get_count",0)
                    else
                        cc.UserDefault:getInstance():setIntegerForKey("get_count",get_count + 1)
                    end

                    for _, v in pairs(items) do
                        if v.use then 
                            GameRecorder.ItemGain(tonumber(v.item), tonumber(v.num))
                        end
                    end
                    layerFarm:removeChild(background)
                    -- CommonAssistor.ShowWinBox(1)
                end)

            end
        end)

    GameMainScene.PlayPageScaleToAction(obstructLayout)

end


function CommonAssistor.ShowEquipmentDetail(equip_id, position, inbug)

    if equip_id <= 0 then
        return
    end

    local id = equip_id

    if inbug then
        equip_id = GameRecorder.GetEquipItemID(equip_id)
    end
    local layerFarm = GameAssistor.GetRunningScene()
    local background = GameAssistor.CreateBackMaskLayout(180)

    -- local zOrder=GameMainScene.pageZOrder.PAGE_WARNING
    layerFarm:addChild(background,10000,10000)

    local obstructLayout = GameAssistor.CreateBackMaskLayout()
    background:addChild(obstructLayout)
    background.obstructLayout=obstructLayout

    obstructLayout:setAnchorPoint(cc.p(0.5,0.5))
    GameAssistor.SetToSceneCenter(obstructLayout)

   
    
    local function HidePage()
        GameMainScene.HidePageScaleToAction(obstructLayout,RemovePage)
    end

    local page_layer = cc.CSLoader:createNode("UI_tips_yichuandaizhuangbei.csb")
    GameAssistor.SetToSceneCenter(page_layer)
    obstructLayout:addChild(page_layer)

    if inbug then
        page_layer:setPositionX(200)
    end


    local itemData = GameDataTransfer.GetItemData(equip_id)
    local itemNode = page_layer:getChildByName("zhuangbeikuang")



    local icon = itemNode:getChildByTag(1):getChildByTag(1)
    icon:loadTexture(GameDataTransfer.GetIconPath(itemData.IconID))
    local name=GameDataTransfer.GetGameString(itemData.Equip_Name)
    local textName = page_layer:getChildByName("zhuangbeimingcheng")
    -- textName:setAlignment(cc.TEXT_ALIGNMENT_CENTER)
    StageScene.SetQualityNameText(textName,name,itemData.Quality)

    print_lua_table(itemData)
    if itemData.Quality > 1 then
        itemNode:getChildByTag(1):getChildByTag(0):setColor(quality_color[itemData.Quality])

        -- local effect=CommonAssistor.AddEffectLayer("e-ICON.csb",true)
        local ef = itemNode:getChildByTag(1):getChildByTag(4)
        ef:setVisible(true)
        local effect = ef:getChildByTag(1)
        for i = 2 , 5 do
            effect:getChildByTag(i):setVisible(i == itemData.Quality)
        end
    end

    CommonAssistor.select_role_id = CommonAssistor.select_role_id or 1
    local dataList = GameRecorder.GetRoleEquipments(CommonAssistor.select_role_id)
    -- print_lua_table(dataList)
    local itemLv = 0
    for _, v in pairs(dataList) do
        if v.ID == equip_id then
            itemLv = v.lv 
        end
    end

    if itemLv > 0 and not inbug then
        local textLv = itemNode:getChildByTag(1):getChildByTag(3)
        textLv:setString("+" .. itemLv)
        textLv:setPosition(105,83)
        textLv:setVisible(true)
    end


    local itemAtrri = page_layer:getChildByName("text_zhushuxing")
    local str = ""
    if itemData.power > 0 then
        str = str .. "攻击  +" .. itemData.power .. "\n"
    end

    if itemData.defence > 0 then
        str = str .. "防御  +" .. itemData.defence .. "\n"
    end

    if itemData.blood > 0 then
        str = str .. "血量  +" .. itemData.blood .. "\n"
    end

    itemAtrri:setString(str)
    local extItemAtrri = page_layer:getChildByName("text_fujiashuxing")
    if itemLv > 0 and not inbug then
        local lvData = GameDataTransfer.GetItemLevelData(equip_id,itemLv)
        local power,defence,blood = 0,0,0
        if lvData then
            str = "物攻  +" .. lvData.power .. "\n防御  +" .. lvData.defence .. "\n血量  +" .. lvData.blood
            
            extItemAtrri:setString(str)
        end
    else
        extItemAtrri:setVisible(false)
        page_layer:getChildByName("text_extAttr"):setVisible(false)
    end


    local closeWindow = function()
        GameMainScene.HidePageScaleToAction(obstructLayout, function()
            layerFarm:removeChild(background)
        end)
    end
    
    obstructLayout:addTouchEventListener(
        function(sender,eventType)
            if eventType== ccui.TouchEventType.ended then
                closeWindow()
            end
        end
    )

    

    local btn_tuoxie = page_layer:getChildByName("anniu_tuoxie")
    btn_tuoxie:addTouchEventListener(
         function(sender,eventType)
            if eventType== ccui.TouchEventType.ended then
                if inbug then
                    -- 出售
                    GameRecorder.RemoveEquip(id)
                    PlayerDataList.Basic.coin = PlayerDataList.Basic.coin + itemData.getmoney
                else
                    GameRecorder.ItemGain(equip_id)
                    local role=GameRecorder.GetRole(CommonAssistor.select_role_id or 1)
                    role.equip_ids[position] = 0
                    RoleScene.ChooseRoleButton(CommonAssistor.select_role_id or 1)
                    CombatPowerUnit.CheckRoleCombatPowers()
                end
                GameRecorder.SaveBasicData()
                GameMainScene.RefreshPlayerStateBar()
                RoleScene.ChooseTypeButton(true)
                closeWindow()
            end
        end)

    local btn_qianghua = page_layer:getChildByName("anniu_qianghua")


    if inbug then
        btn_qianghua:setTitleText("装备")
        btn_tuoxie:setTitleText("出售")
        btn_tuoxie:setVisible(false)
    end

    btn_qianghua:addTouchEventListener(
         function(sender,eventType)
            if eventType== ccui.TouchEventType.ended then
                if not inbug then
                    GameMainScene.AddSceneToSubFuncPage(main_buttons.INTENSIFY - 1)
                    GameMainScene.SetSubMenuActive(4)
                    IntensifyScene.ChooseRoleButton(CommonAssistor.select_role_id)
                    IntensifyScene.ChoosePositionButton(position)
                else
                    RoleScene.EquipItem(id)
                    -- closeWindow()
                end
                closeWindow()
            end
        end)
    


    GameMainScene.PlayPageScaleToAction(obstructLayout)
end

function CommonAssistor.ShowItemDetail(item_id)
    local layerFarm = GameAssistor.GetRunningScene()
    local background = GameAssistor.CreateBackMaskLayout(180)

    -- local zOrder=GameMainScene.pageZOrder.PAGE_WARNING
    layerFarm:addChild(background,10000,10000)

    local obstructLayout = GameAssistor.CreateBackMaskLayout()
    background:addChild(obstructLayout)
    background.obstructLayout=obstructLayout

    obstructLayout:setAnchorPoint(cc.p(0.5,0.5))
    GameAssistor.SetToSceneCenter(obstructLayout)

   
    
    local function HidePage()
        GameMainScene.HidePageScaleToAction(obstructLayout,RemovePage)
    end

    local page_layer = cc.CSLoader:createNode("UI_tips_wupinmiaoshu.csb")
    GameAssistor.SetToSceneCenter(page_layer)
    obstructLayout:addChild(page_layer)


    local itemData = GameDataTransfer.GetItemData(item_id)
    local itemNode = page_layer:getChildByName("Item")
    local icon = itemNode:getChildByTag(1):getChildByTag(1)
    icon:loadTexture(GameDataTransfer.GetIconPath(itemData.IconID))
    local name=GameDataTransfer.GetGameString(itemData.Equip_Name)
    local textName = page_layer:getChildByName("text_name")
    -- textName:setAlignment(cc.TEXT_ALIGNMENT_CENTER)
    StageScene.SetQualityNameText(textName,name,itemData.Quality)

    if itemData.Quality > 1 then
        itemNode:getChildByTag(1):getChildByTag(0):setColor(quality_color[itemData.Quality])

        local ef = itemNode:getChildByTag(1):getChildByTag(4)
        ef:setVisible(true)
        local effect = ef:getChildByTag(1)
        for i = 2 , 5 do
            effect:getChildByTag(i):setVisible(i == itemData.Quality)
        end
    end

    local textDetail = page_layer:getChildByName("text_detail")
    textDetail:setString(GameDataTransfer.GetGameString(itemData.Equip_Description))

    obstructLayout:addTouchEventListener(
        function(sender,eventType)
            if eventType== ccui.TouchEventType.ended then
                GameMainScene.HidePageScaleToAction(obstructLayout, function()
                    layerFarm:removeChild(background)
                end)
            end
        end
    )

    GameMainScene.PlayPageScaleToAction(obstructLayout)
end


function CommonAssistor.ShowJieSuan()
    local layerFarm = GameAssistor.GetRunningScene()
    local background = GameAssistor.CreateBackMaskLayout(180)

    local zOrder=GameMainScene.pageZOrder.PAGE_WARNING
    layerFarm:addChild(background,zOrder,zOrder)

    local obstructLayout = GameAssistor.CreateBackMaskLayout()
    background:addChild(obstructLayout)
    background.obstructLayout=obstructLayout

    obstructLayout:setAnchorPoint(cc.p(0.5,0.5))
    GameAssistor.SetToSceneCenter(obstructLayout)

   
    
    local function HidePage()
        GameMainScene.HidePageScaleToAction(obstructLayout,RemovePage)
    end

    local page_layer = cc.CSLoader:createNode("UI_tankuangjiesuan.csb")
    GameAssistor.SetToSceneCenter(page_layer)
    obstructLayout:addChild(page_layer)

end


function CommonAssistor.ShowQuMingBox()
    local layerFarm = GameAssistor.GetRunningScene()
    local background = GameAssistor.CreateBackMaskLayout(180)

    local zOrder=GameMainScene.pageZOrder.PAGE_WARNING
    layerFarm:addChild(background,zOrder,zOrder)

    local obstructLayout = GameAssistor.CreateBackMaskLayout()
    background:addChild(obstructLayout)
    background.obstructLayout=obstructLayout

    obstructLayout:setAnchorPoint(cc.p(0.5,0.5))
    GameAssistor.SetToSceneCenter(obstructLayout)

   
    
    local function HidePage()
        GameMainScene.HidePageScaleToAction(obstructLayout,RemovePage)
    end

    local page_layer = cc.CSLoader:createNode("UI_quming.csb")
    GameAssistor.SetToSceneCenter(page_layer)
    obstructLayout:addChild(page_layer)

    local textField = page_layer:getChildByName("TextField_1")

    textField:addEventListener(function() 
        local str = LanguageFilter.FilterMsg(textField:getString())
        textField:setString(str)
    end)
    
    local function RemovePage()
        layerFarm:removeChild(background)
    end

    local checkInput = function()
        if textField:getString() ~= "" then
            user_name = textField:getString() 
            cc.UserDefault:getInstance():setStringForKey("user_name", textField:getString())
            ArenaScene.Refresh()
            GameMainScene.HidePageScaleToAction(obstructLayout,RemovePage)
        end
    end

    local btnOk = page_layer:getChildByName("Button_2")
    -- local bt_ok=page_layer:getChildByTag(2)
    btnOk:addTouchEventListener(
        function(sender,eventType)
            if eventType== ccui.TouchEventType.ended then
                checkInput()
            end
        end)       

    local btnRandomName =  page_layer:getChildByName("Button_1")
    btnRandomName:addTouchEventListener(
        function(sender,eventType)
            if eventType== ccui.TouchEventType.ended then
                local lastName=Random(str_system.STRING_GAME_LASTNAMEBEGIN,str_system.STRING_GAME_LASTNAMEEND)
                local firstName=Random(str_system.STRING_GAME_FIRSTNAMEBEGIN,str_system.STRING_GAME_FIRSTNAMEEND)
                local fullName=GameDataTransfer.GetGameString(lastName)..GameDataTransfer.GetGameString(firstName)
                textField:setString(fullName)
            end
        end)     

    GameMainScene.PlayPageScaleToAction(obstructLayout)
end

function CommonAssistor.AddWarningBox(tips)

    local page_layer,HidePage = CommonAssistor.CreateCommonButtonMessageLayout(tips)
    page_layer.setStyle(false)
    
    local bt_ok=page_layer:getChildByTag(2)
    bt_ok:addTouchEventListener(
        function(sender,eventType)
            if eventType== ccui.TouchEventType.ended then
                return HidePage()
            end
        end)
end

function CommonAssistor.AddConfirmBox(tips,btFunction,TAG, alignment)

    local page_layer,HidePage,background = CommonAssistor.CreateCommonButtonMessageLayout(tips,alignment)
    page_layer.setStyle(true)
    
    local button=page_layer:getChildByTag(3)
    local bt_cancel=button:getChildByTag(1)
    bt_cancel:addTouchEventListener(
        function(sender,eventType)
            if eventType== ccui.TouchEventType.ended then
                return HidePage()
            end
        end)
    local bt_ok=button:getChildByTag(2)
    bt_ok:addTouchEventListener(
        function(sender,eventType)
            if eventType== ccui.TouchEventType.ended then
                HidePage()
                if btFunction then
                    btFunction() 
                end
                return 
            end
        end)        
    background.bt_ok=bt_ok
    if TAG then
        GameAssistor.GetRunningScene():reorderChild(background,TAG)
        background:setTag(TAG)
    end
    return bt_ok
end

function CommonAssistor.AddSimpleTouchEvent(button,funcListener)
    button:addTouchEventListener(
        function(sender,eventType)
            if eventType==ccui.TouchEventType.ended then
                return funcListener()
            end
        end)
    button:setPressedActionEnabled(true) 
end

function CommonAssistor.GetPageVisible(background)
    return (background or false) and background:isVisible()
end

function CommonAssistor.GetBackgroundObstructLayoutShowing(background)
    local visible=CommonAssistor.GetPageVisible(background)
    return visible and (background.obstructLayout.isDone or false)
end

CONFIRMBOX_TAG=enum{
    "DIGESTION_ITEM=50",
    "UPGRADE_STAR"
}

function CommonAssistor.GetConfirmTagPageShowing(TAG)
    local confirmPage=GameAssistor.GetRunningScene():getChildByTag(TAG)
    if confirmPage then
        return CommonAssistor.GetBackgroundObstructLayoutShowing(confirmPage)
    end
    return false
end

function CommonAssistor.GetConfirmTagPageOkButton(TAG)
    local confirmPage=GameAssistor.GetRunningScene():getChildByTag(TAG)
    if confirmPage then
        return confirmPage.bt_ok
    end
end

function CommonAssistor.AddEffectLayer(csb_path,loop,x,y)
    local effect = cc.CSLoader:createNode(csb_path)
    local timeline = cc.CSLoader:createTimeline(csb_path)
    effect:runAction(timeline)
    effect:setPosition(x or 0,y or 0)
    timeline:gotoFrameAndPlay(0,loop or false)
    effect.timeline=timeline
    return effect,timeline
end

function CommonAssistor.PlayTimelineEffect(csb_path,node,loop)
    local timeline = cc.CSLoader:createTimeline(csb_path)
    timeline:gotoFrameAndPlay(0,loop or false)
    node:runAction(timeline)
end



























