FirstCharge = {}

FirstCharge = class("FirstCharge",function()
    return cc.Scene:create()
end)

local children={}

function FirstCharge:sceneEnter()
    outputString("FirstCharge:sceneEnter()")
end

function FirstCharge:sceneExit()
    FirstCharge.RemoveAllChildren(self)
end

function FirstCharge.RemoveAllChildren(scene)
    table.clear(children)
    GameAssistor.RemoveUnusedSceneResource(scene)
end

function FirstCharge.create()
    
    local scene = FirstCharge.new()

    Sence_Init(scene)

    local layerFarm = cc.Layer:create()

    scene.getMainLayer=function()
        return layerFarm
    end
    children.mainLayerFarm = layerFarm

    local background = GameAssistor.CreateBackMaskLayout(180)
    layerFarm:addChild(background)

    scene.AddMainChildren()

    scene:addChild(layerFarm)

    return scene
end

function FirstCharge.Refresh()
    GameAssistor.SetButtonBright(children.bt_charge,GameRecorder.GetBasicData("charge")>0 and GameRecorder.GetBasicData("first")==0)
end

function FirstCharge.AddMainChildren()

    local layerFarm = children.mainLayerFarm
    
    local page_layer = cc.CSLoader:createNode("SC.csb")
    GameAssistor.SetToSceneCenter(page_layer)
    layerFarm:addChild(page_layer)

    local nd_awards = page_layer:getChildByTag(1)
    
    local function GetAwardString()
        for _,data in pairs(GameDataTransfer.GetTypeStoreList(res_store_type.FIRST)) do
            return data.ResId
        end
    end
    
    local awardString=GetAwardString() children.awardString=awardString
    local awardList=GameDataTransfer.GetAwardStringData(awardString)
    for key,data in pairs(awardList) do
        local ndItem=nd_awards:getChildByTag(key)
        local iData=GameDataTransfer.GetItemData(data.ID)
        if ndItem and iData then
            RoleScene.SetEquipItem(ndItem,iData.Equip_Id)
            local txName=ndItem:getChildByTag(1):getChildByTag(2)
            local name=GameDataTransfer.GetGameString(iData.Equip_Name).."x"..data.qty
            StageScene.SetQualityNameText(txName,name,iData.Quality)
            txName:setVisible(true)
        end
    end
    
    local bt_charge = page_layer:getChildByTag(2)
    CommonAssistor.AddSimpleTouchEvent(bt_charge,function()
        if GameRecorder.GetBasicData("charge")>0 then
            return FirstCharge.GetAwards()
        end
        --return GameMainScene.AddSceneToSubFuncPage(GameMainScene.pageZOrder.SUBPAGE_STORE)
    end)   
    children.bt_charge=bt_charge
end

function FirstCharge.GetAwards()
    
    if GameRecorder.GetBasicData("first")>0 then return end
    GameRecorder.SetBasicData("first",1)
    StageScene.AddAwardStrings(children.awardString)
    FirstCharge.Refresh()
    GameMainScene.RefreshPlayerStateBar()
    return GameRecorder.SaveBasicData()
end































