PetScene = {}

PetScene = class("PetScene",function()
    return cc.Scene:create()
end)

local children={}
local select_role_id=1
local ready_total=6

function PetScene:sceneEnter()
    outputString("PetScene:sceneEnter()")
end

function PetScene:sceneExit()
    PetScene.RemoveAllChildren(self)
end

function PetScene.RemoveAllChildren(scene)
    table.clear(children)
    GameAssistor.RemoveUnusedSceneResource(scene)
end

function PetScene.create()

    local scene = PetScene.new()

    Sence_Init(scene)

    local layerFarm = cc.Layer:create()

    scene.getMainLayer=function()
        return layerFarm
    end
    children.mainLayerFarm = layerFarm

    local background = GameAssistor.CreateBackMaskLayout(180)
    layerFarm:addChild(background)

    scene.AddMainChildren()

    scene:addChild(layerFarm)

    return scene
end

function PetScene.Refresh()
    PetScene.ChooseRoleButton(select_role_id)
    PetScene.RefreshStorages()
end

function PetScene.AddMainChildren()

    local layerFarm = children.mainLayerFarm

    local page_layer = cc.CSLoader:createNode("ND.csb")
    layerFarm:addChild(page_layer)

    local nd_center=page_layer:getChildByTag(1)
    
    local nd_effect=nd_center:getChildByTag(1)
    children.bg_roles=nd_effect:getChildByTag(3)
    children.skillIcon=SkillScene.SetCircleClipping(nd_effect:getChildByTag(5))
    
    local main_node=nd_effect:getChildByTag(6)
    PetScene.PlaySuccessEffects=function()
        local duration=1.3 main_node:stopAllActions()
        local effect=CommonAssistor.AddEffectLayer("e-ND-2.csb")
        main_node:addChild(effect)
        local function Remove() main_node:removeChild(effect) end
        local actionTo = cc.Sequence:create(cc.DelayTime:create(duration),cc.CallFunc:create(Remove))
        main_node:runAction(actionTo)
        GameMainScene.SetProtectMaskTimer(duration)
    end
    
    children.tx_combatPower=nd_center:getChildByTag(2):getChildByTag(1)
    local nd_equipments=nd_center:getChildByTag(3):getChildByTag(1)
    for i=1,ready_total do
        local button=nd_equipments:getChildByTag(i):getChildByTag(1)
        button:addTouchEventListener(
            function(sender,eventType)
                if eventType==ccui.TouchEventType.began then
                    return PetScene.UnsetEquipment(i)
                end
            end)
    end
    children.nd_equipments=nd_equipments

    children.nd_attributes={}
    local nd_attributes=nd_center:getChildByTag(4)
    for i=1,4 do
        children.nd_attributes[i]=nd_attributes:getChildByTag(i):getChildByTag(1)
    end
    
    local nd_storages=page_layer:getChildByTag(2)
    children.sc_storages=nd_storages:getChildByTag(2)
    PetScene.ExpandStorageSize(true)

    local pageView=children.sc_storages
    local pagePoints = nd_storages:getChildByTag(4)
    for key, var in ipairs(pagePoints:getChildren()) do
        local button=var:getChildByTag(1)
        button:addTouchEventListener(
            function(sender,eventType)
                if eventType==ccui.TouchEventType.began then
                    pageView:scrollToPage(key-1)
                end
            end)
        GameAssistor.SetButtonBright(button,(pageView:getCurPageIndex()+1~=key))
    end
    local function pageViewEvent(sender,eventType)
        if eventType == ccui.PageViewEventType.turning then
            for key, var in ipairs(pagePoints:getChildren()) do
                GameAssistor.SetButtonBright(var:getChildByTag(1),(pageView:getCurPageIndex()+1~=key))
            end
        end
    end
    pageView:addEventListener(pageViewEvent)

    local nd_button = nd_storages:getChildByTag(1)
    local bt_auto=nd_button:getChildByTag(1)
    bt_auto:addTouchEventListener(
        function(sender,eventType)
            if eventType== ccui.TouchEventType.ended then
                return PetScene.AutoSetEquipments()
            end
        end)
    children.bt_auto=bt_auto
    
    local bt_eat=nd_button:getChildByTag(2)
    bt_eat:addTouchEventListener(
        function(sender,eventType)
            if eventType== ccui.TouchEventType.ended then
                for i=1,ready_total do
                    if children.readyEquipmentList[i]>0 then
                        return CommonAssistor.AddConfirmBox(GameDataTransfer.GetSysStrings(str_system.STRING_TIPS_DIGESTIONEQUIPMENTS),function()
                            return PetScene.DigestionEquipments()
                        end,CONFIRMBOX_TAG.DIGESTION_ITEM, 1)
                    end
                end
            end
        end)
    children.bt_eat=bt_eat

    local nd_button=page_layer:getChildByTag(3)
    children.nd_role_buttons=RoleScene.AddChooseRoleButtons(nd_button,PetScene.ChooseRoleButton)

    local nd_starBar=page_layer:getChildByTag(4)
    local bt_upgradeStar=nd_starBar:getChildByTag(0)
    children.ic_need_items=bt_upgradeStar:getChildByTag(1)
    children.tx_need_items=bt_upgradeStar:getChildByTag(2)
    children.bt_upgradeStar=bt_upgradeStar
    children.nd_starts=nd_starBar:getChildByTag(2)
    local nd_costBar=nd_starBar:getChildByTag(3)
    children.nd_costBar=nd_costBar
    children.tx_pet_lv=nd_costBar:getChildByTag(1)
    children.lb_need_exp=nd_costBar:getChildByTag(3)
    children.tx_need_exp=nd_costBar:getChildByTag(4)
    children.lb_need_exp2=nd_costBar:getChildByTag(5)
    
    GameAssistor.SetBlackOutlineNoSpaces{children.tx_pet_lv,children.tx_need_exp,children.tx_need_items}
    
    bt_upgradeStar:addTouchEventListener(
        function(sender,eventType)
            if eventType== ccui.TouchEventType.ended then
                return CommonAssistor.AddConfirmBox(GameDataTransfer.GetSysStrings(str_system.STRING_TIPS_UPGRADESTAR),function()
                    return PetScene.UpgradeStar()
                end,CONFIRMBOX_TAG.UPGRADE_STAR)
            end
        end)
    bt_upgradeStar:setPressedActionEnabled(true)
end

function PetScene.ChooseRoleButton(roleID)
    
    select_role_id=roleID
    children.nd_role_buttons.refreshStates(roleID)
    
    local role=GameRecorder.GetRole(roleID)
    local rData=GameDataTransfer.GetRoleData(roleID)
    --outputString("star:"..role.star.." petlv:"..role.petlv)
    
    for key,var in pairs(children.bg_roles:getChildren()) do
        var:setVisible(var:getTag()==roleID)
    end
    --local sData=GameDataTransfer.GetSkillData(rData.petSkill)
    children.skillIcon:setTexture(GameDataTransfer.GetIconPath(rData.petSkill,true))
    
    local nd_starts=children.nd_starts
    for key,var in pairs(nd_starts:getChildren()) do
        var:setVisible(var:getTag()<=role.star)
    end
    children.tx_pet_lv:setString("Lv."..role.petlv)

    local starData=GameDataTransfer.GetPetStarData(roleID,role.star)
    local power,defence,blood,crit=0,0,0,0
    if starData then
        power,defence,blood,crit=starData.power,starData.defence,starData.blood,starData.crit
    end
    
    local canUpgradeStar=true
    local starData=GameDataTransfer.GetPetStarData(roleID,role.star+1)
    if starData then
        local count,need = GameRecorder.GetItemQuantity(starData.cost),starData.number
        children.tx_need_items:setString(count.."/"..need)
        --children.lb_need_items:setPercent(100*count/need)
        local iData=GameDataTransfer.GetItemData(starData.cost)
        children.ic_need_items:loadTexture(GameDataTransfer.GetIconPath(iData.IconID))
        --outputString("cost item:"..GameDataTransfer.GetGameString(iData.Equip_Name))
    else
        canUpgradeStar=false outputString("Star Max")
    end
    children.bt_upgradeStar:setVisible(canUpgradeStar)
    
    local lvData=GameDataTransfer.GetPetLevelData(role.petlv)
    if lvData then
        power,defence,blood,crit=power+lvData.power,defence+lvData.defence,blood+lvData.blood,crit+lvData.crit
    end
    --outputString("-----Now power:"..power.." defence:"..defence.." blood:"..blood.." crit:"..crit)
    local nd_attributes=children.nd_attributes
    nd_attributes[1]:setString(power)  nd_attributes[2]:setString(blood)
    nd_attributes[3]:setString(defence) nd_attributes[4]:setString(crit.."%")
    children.tx_combatPower:setString(GameRecorder.GetRoleCombatPower(roleID))
    
    local count,need = role.petexp,lvData and lvData.petexp or 0
    local lvData2=GameDataTransfer.GetPetLevelData(role.petlv+1)
    if lvData2 then need=lvData2.petexp
    else count=need outputString("Level Max") end
    children.tx_need_exp:setString(count.."/"..need)
    children.lb_need_exp:setPercent(100*count/need)
    --children.nd_costBar:setVisible(canUpgradeLv)
    
    PetScene.RefreshReadyEquipmentList(true)
end

function PetScene.RefreshReadyEquipmentList(isClear)
    if isClear then children.readyEquipmentList={} end
    local list=children.readyEquipmentList
    for i=1,ready_total do
        if isClear then list[i]=0 end
        local equipID=GameRecorder.GetEquipItemID(list[i])
        RoleScene.SetEquipItem(children.nd_equipments:getChildByTag(i),equipID)
    end
    local percent=0
    if not isClear then
        local role=GameRecorder.GetRole(select_role_id)
        local lvData2=GameDataTransfer.GetPetLevelData(role.petlv+1)
        if lvData2 then
            local GetExp=0
            for i=1,ready_total do
                if list[i]>0 then
                    local equipID=GameRecorder.GetEquipItemID(list[i])
                    local gData=GameDataTransfer.GetItemData(equipID)
                    if gData then
                        GetExp=GetExp+gData.petExp
                    end
                end
            end
            percent=100*(role.petexp+GetExp)/lvData2.petexp
        end
    end
    children.lb_need_exp2:setPercent(percent)
    return PetScene.RefreshStorageChooses()
end

function PetScene.ExpandStorageSize(isClear,itemList)

    local sc_storages=children.sc_storages   
    if isClear then sc_storages:removeAllPages() end

    local pageMax,pageCount,itemCount = 16,0,0

    local function getPage(index)

        for key, var in pairs(sc_storages:getChildren()) do
            if index==key then return var end
        end

        local layout = ccui.Layout:create()
        layout:setContentSize(sc_storages:getContentSize())
        layout.pageIdx=index-1
        sc_storages:addPage(layout)

        for i=0,pageMax-1 do
            PetScene.AddItemToPage(nil,layout,i)
        end
        return layout 
    end

    for key, var in pairs(itemList or {}) do
        pageCount=math.floor(itemCount/pageMax)
        local layout = getPage(pageCount+1)
        itemCount=itemCount+1
    end

    if #sc_storages:getPages()==0 then 
        for i=1,3 do getPage(i) end
    end
end

function PetScene.AddItemToPage(gData,layout,index)

    local button = layout:getChildByTag(index)

    if not button then
        local page_layer = cc.CSLoader:createNode("Icon-zb.csb")
        button = page_layer:getChildByTag(0)
        button:removeFromParent()

        RoleScene.SetStorageItemEvent(button)

        local icon=button:getChildByTag(1)
        local quality=button:getChildByTag(2)
        button.setSelected=function(select)
            if select then
                greyNodeWithCCUI(icon,false,false) quality:setVisible(false)
            else
                defaultNodeWithCCUI(icon,false,false) quality:setVisible(button.ID>0)
            end
        end
        button:addTouchEventListener(
            function(sender,eventType)
                if eventType== ccui.TouchEventType.ended then
                    --outputString("Use Item:"..button.ID)
                    return PetScene.SetEquipment(button.ID,true)
                end
            end)
        layout:addChild(button,1,index)
    end

    local x,y,w,h = 140,340,104,96
    local row,col = math.floor(index/4),index%4
    button:setPosition(x+col*w-row*12,y-row*h)

    local able=(gData~=nil)

    button.setEmpty()
    ---[[
    if able then
        button.setItem(gData) button.setQty(gData.qty)
    end
    button:setTouchEnabled(able)--]]
end

function PetScene.RefreshStorages()

    local sc_storages=children.sc_storages
    local itemList={}
    for key,data in pairs(GameRecorder.GetEquipList()) do
        local gData=GameDataTransfer.GetItemData(data.equipID)
        local rData=table.copy(gData,{})
        table.insert(itemList,table.copy(data,rData))
    end
    table.sort(itemList, function(a,b) return (a.Quality or 0)<(b.Quality or 0) end)
    
    if PINGTEST then PetScene.ExpandStorageSize(false,itemList) end
    
    local pageView = children.sc_storages
    local pageMax,pageCount,itemCount = 16,0,0
    local function getPage(index)
        for key, var in pairs(pageView:getChildren()) do
            if index==key then return var end
        end
        local layout = ccui.Layout:create()
        layout:setContentSize(pageView:getContentSize())
        layout.pageIdx=index-1
        pageView:addPage(layout)
        return layout
    end

    for i=itemCount,#pageView:getPages()*pageMax-1 do
        pageCount=math.floor(itemCount/pageMax)
        local layout = getPage(pageCount+1)
        PetScene.AddItemToPage(itemList[itemCount+1],layout,itemCount%pageMax)
        itemCount=itemCount+1
    end
    pageView:scrollToPage(0)
end

function PetScene.RefreshStorageChooses()
    
    local list=children.readyEquipmentList
    local function IsExist(ID)
        if ID==0 then return false end
        for i=1,ready_total do
            if ID==list[i] then return true end
        end
        return false
    end
    local pageView=children.sc_storages
    for key, layout in pairs(pageView:getChildren()) do
        for key, button in pairs(layout:getChildren()) do
            button.setSelected(IsExist(button.ID))
        end
    end
end

function PetScene.UpgradeStar(roleID)
    
    roleID = roleID or select_role_id    
    local role=GameRecorder.GetRole(roleID)
    local level=role.star+1
    local starData=GameDataTransfer.GetPetStarData(roleID,level)
    if not starData then return outputString("Star Max") end
    
    local have=GameRecorder.GetItemQuantity(starData.cost)-starData.number
    if have<0 then
        return GameMainScene.AddGoToConfirmBox(str_system.STRING_TIPS_NO_ENOUGH_ITEM)
    end
    PetScene.PlaySuccessEffects()
    
    role.star=level
    GameRecorder.StorageChange(starData.cost,have)
    GameRecorder.SaveBasicData()
    
    return PetScene.ChooseRoleButton(roleID)
end

function PetScene.SetEquipment(ID,refresh)
    local list=children.readyEquipmentList
    for i=1,ready_total do
        if list[i]==ID then return PetScene.UnsetEquipment(i) end
    end
    for i=1,ready_total do
        if list[i]==0 then list[i]=ID
            if refresh then PetScene.RefreshReadyEquipmentList() end
            return true 
        end
    end
    return outputString("Full")
end

function PetScene.UnsetEquipment(index)
    local ID=children.readyEquipmentList[index] or 0
    if ID>0 then 
        outputString("UnsetEquipment:"..ID) 
        children.readyEquipmentList[index]=0
        PetScene.RefreshReadyEquipmentList()
    end
end

function PetScene.AutoSetEquipments()
    local isFull=true
    local list=children.readyEquipmentList
    for i=1,ready_total do
        if list[i]==0 then isFull=false break end
    end
    if isFull then return outputString("Full") end
    
    local readyList={}
    for key,data in pairs(GameRecorder.GetEquipList()) do
        local isExist=false
        for i=1,ready_total do
            if list[i]==data.ID then isExist=true break end
        end
        if not isExist then
            local gData=GameDataTransfer.GetItemData(data.equipID)
            data.Quality=gData.Quality
            if gData.Quality<5 then table.insert(readyList,data) end
        end
    end
    table.sort(readyList, function(a,b) return (a.Quality or 0)<(b.Quality or 0) end)
    
    for i=1,ready_total do
        if list[i]==0 then
            if #readyList>0 then
                PetScene.SetEquipment(readyList[1].ID)
                table.remove(readyList,1)
            end
        end
    end
    --table.print(readyList,"readyList")
    --table.print(children.readyEquipmentList,"children.readyEquipmentList")
    return PetScene.RefreshReadyEquipmentList()
end

function PetScene.GetExpAndCheckLevel(GetExp,roleID)
    if not GetExp or GetExp<=0 then return end
    outputString("GetExp:"..GetExp)
    
    roleID = roleID or select_role_id
    local role=GameRecorder.GetRole(roleID)
    
    if role.petlv>GameRecorder.GetBasicData("level") then 
        local newLevel=role.petlv
        local lvData=GameDataTransfer.GetPetLevelData(newLevel)
        role.petlv=newLevel-1 role.petexp=lvData.petexp+GetExp
        return
    end
    
    local newLevel=role.petlv+1
    local lvData=GameDataTransfer.GetPetLevelData(newLevel)
    if not lvData then return outputString("Level Max "..newLevel) end
    
    if role.petexp+GetExp>=lvData.petexp then
        role.petlv=newLevel role.petexp=0
        local lvData2=GameDataTransfer.GetRoleLevelData(newLevel+1)
        if lvData2 then
            return PetScene.GetExpAndCheckLevel(role.petexp+GetExp-lvData.petexp)
        end
        return outputString("Level Max "..newLevel)
    else
        role.petexp=(role.petexp+GetExp)
    end
    
    outputString("Lv."..role.petlv,"myExp:"..role.petexp.."/"..lvData.petexp)
end

function PetScene.DigestionEquipments()
    
    local role=GameRecorder.GetRole(select_role_id)
    if role.petlv>=GameRecorder.GetBasicData("level") then
        local lvData=GameDataTransfer.GetPetLevelData(role.petlv+1)
        if (not lvData) or role.petexp>=lvData.petexp then
            return CommonAssistor.AddWarningBox(GameDataTransfer.GetSysString(str_system.STRING_TIPS_ERROR_UPGRADELV))
        end
    end
    
    local list=children.readyEquipmentList
    local GetExp=0
    for i=1,ready_total do
        if list[i]>0 then
            local equipID=GameRecorder.GetEquipItemID(list[i])
            local gData=GameDataTransfer.GetItemData(equipID)
            if gData then
                GetExp=GetExp+gData.petExp
            end
            GameRecorder.RemoveEquip(list[i]) list[i]=0
        end
    end
    if GetExp>0 then
        local levelBak=role.petlv
        PetScene.GetExpAndCheckLevel(GetExp)
        PetScene.RefreshReadyEquipmentList()
        PetScene.Refresh()
        
        if role.petlv>levelBak then
            PetScene.PlaySuccessEffects()
        end

        CombatPowerUnit.CheckRoleCombatPowers()
        
        return GameRecorder.SaveBasicData()
    end
    return outputString("Empty")
end



------Toutorial-----------------
function PetScene.GetAutoAddButton()
    return children.bt_auto
end

function PetScene.GetDigestionButton()
    return children.bt_eat
end

function PetScene.GetUpgradeStarButton()
    return children.bt_upgradeStar
end

