RoleScene = {}

RoleScene = class("RoleScene",function()
    return cc.Scene:create()
end)

local children={}
local select_role_id=1
local select_isEquipment=true

function RoleScene:sceneEnter()
    outputString("RoleScene:sceneEnter()")
end

function RoleScene:sceneExit()
    RoleScene.RemoveAllChildren(self)
end

function RoleScene.RemoveAllChildren(scene)
    table.clear(children)
    GameAssistor.RemoveUnusedSceneResource(scene)
end

function RoleScene.create()

    local scene = RoleScene.new()

    Sence_Init(scene)

    local layerFarm = cc.Layer:create()

    scene.getMainLayer=function()
        return layerFarm
    end
    children.mainLayerFarm = layerFarm

    local background = GameAssistor.CreateBackMaskLayout(180)
    layerFarm:addChild(background)

    scene.AddMainChildren()

    scene:addChild(layerFarm)
    select_role_id = select_role_id or 1
    RoleScene.Refresh()

    return scene
end

function RoleScene.Refresh()
    RoleScene.ChooseRoleButton(select_role_id)
end

function RoleScene.RefreshPage()
    
end

function RoleScene.AddMainChildren()
    
    local layerFarm = children.mainLayerFarm
    
    local page_layer = cc.CSLoader:createNode("ZJ.csb")
    -- cclog("===================")
    -- print_lua_table(GameRecorder.GetStorageList())
    -- GameRecorder.ItemGain(1,100)
    -- GameRecorder.SaveBasicData()

    -- for i = 9 , 100 do 
    --     PlayerDataList.FBs[i] = {}
    --     PlayerDataList.FBs[i].stars = 111
    --     PlayerDataList.FBs[i].star = 3
    --     PlayerDataList.FBs[i].ID = i
    -- end
    -- GameRecorder.SaveBasicData()
    -- print_lua_table(PlayerDataList)

    local nd_left=page_layer:getChildByTag(1)
    
    children.nd_spine=nd_left:getChildByTag(1)
    children.tx_combatPower=nd_left:getChildByTag(2):getChildByTag(1)
    children.nd_equipments=nd_left:getChildByTag(3)
    
    children.nd_attributes={}
    local nd_attributes=nd_left:getChildByTag(4)
    for i=1,4 do
        children.nd_attributes[i]=nd_attributes:getChildByTag(i):getChildByTag(1)
    end
    
    local nd_storages=page_layer:getChildByTag(2)
    children.bt_storages={}
    for i=1,2 do
        local button=nd_storages:getChildByTag(1):getChildByTag(i)
        button:addTouchEventListener(
            function(sender,eventType)
                if eventType== ccui.TouchEventType.began then
                    return RoleScene.ChooseTypeButton(i==1)
                end
            end)
        children.bt_storages[i]=button
    end
    children.sc_storages=nd_storages:getChildByTag(2)
    RoleScene.ExpandStorageSize(true)
    
    local pageView=children.sc_storages
    local pagePoints = nd_storages:getChildByTag(4)
    for key, var in ipairs(pagePoints:getChildren()) do
        local button=var:getChildByTag(1)
        button:addTouchEventListener(
            function(sender,eventType)
                if eventType==ccui.TouchEventType.began then
                    pageView:scrollToPage(key-1)
                end
            end)
        GameAssistor.SetButtonBright(button,(pageView:getCurPageIndex()+1~=key))
    end
    local function pageViewEvent(sender,eventType)
        if eventType == ccui.PageViewEventType.turning then
            for key, var in ipairs(pagePoints:getChildren()) do
                GameAssistor.SetButtonBright(var:getChildByTag(1),(pageView:getCurPageIndex()+1~=key))
            end
        end
    end
    pageView:addEventListener(pageViewEvent)

    local bt_oneKeySell=nd_storages:getChildByTag(3)
    bt_oneKeySell:setVisible(false)
    bt_oneKeySell:addTouchEventListener(
        function(sender,eventType)
            if eventType== ccui.TouchEventType.began then
                return CommonAssistor.AddConfirmBox(GameDataTransfer.GetSysStrings(str_system.STRING_TIPS_ONEKEYTOSELL),function()
                    return RoleScene.OneKeyToSell()
                end)
            end
        end)
    
    local nd_button=page_layer:getChildByTag(3)

    children.nd_role_buttons=RoleScene.AddChooseRoleButtons(nd_button,RoleScene.ChooseRoleButton)
    
    layerFarm:addChild(page_layer)
end

function RoleScene.AddChooseRoleButtons(nd_button,bgFunc)
    for i=1,3 do
        local button=nd_button:getChildByTag(i)
        button:addTouchEventListener(
            function(sender,eventType)
                if eventType== ccui.TouchEventType.began then
                    return bgFunc(i)
                end
            end)
    end
    nd_button.refreshStates=function(roleID)
        for i=1,3 do
            local button=nd_button:getChildByTag(i)
            button:setScale(roleID==i and 1 or 0.8)
            local unlock=StoreScene.CheckRoleUnlock(i)
            GameAssistor.SetButtonBright(button,unlock)
            --[[if unlock then
                defaultWithCCButton(button,false,true)
            else
                greyWithCCButton(button,false)
            end--]]
            button:setTouchEnabled(roleID~=i and unlock)
        end
    end
    return nd_button
end

function RoleScene.SetEquipItem(csb,equipID,reset)--FB100
    local node=csb:getChildByTag(1)
    local icon,quality=node:getChildByTag(1),node:getChildByTag(0)
    local nd_effects=node:getChildByTag(4)
    if nd_effects then nd_effects:setVisible(false) end
    local isEquiped=equipID and equipID>0
    if isEquiped then
        local iData=GameDataTransfer.GetItemData(equipID)
        icon:loadTexture(GameDataTransfer.GetIconPath(iData.IconID))
        quality:setColor(quality_color[iData.Quality])
        if nd_effects then
            nd_effects:setVisible(true)
            if reset and not nd_effects.reset then
                nd_effects:removeChildByTag(1) nd_effects.reset=reset
            end
            if not nd_effects:getChildByTag(1) then
                local effect=CommonAssistor.AddEffectLayer("e-ICON.csb",true)
                nd_effects:addChild(effect,1,1)
            end
            for key,node in pairs(nd_effects:getChildByTag(1):getChildren()) do
                node:setVisible(node:getTag()==iData.Quality)
            end
        end
    end
    icon:setVisible(isEquiped)
    quality:setVisible(isEquiped)
end

function RoleScene.ChooseRoleButton(roleID)
    select_role_id=roleID
    CommonAssistor.select_role_id = roleID
    children.nd_role_buttons.refreshStates(roleID)

    local role=GameRecorder.GetRole(select_role_id)
    local equipList=role.equip_ids
    local nd_equipments=children.nd_equipments
    for i=1,3 do
        local equipID=equipList[i]
        RoleScene.SetEquipItem(nd_equipments:getChildByTag(i),equipID)
        nd_equipments:getChildByTag(i):getChildByTag(1):addTouchEventListener(
        function(sender,eventType)
            if eventType== ccui.TouchEventType.ended then
                -- cclog("bbbbbbbbbbbbbbbbbb    " .. equipID)
                CommonAssistor.ShowEquipmentDetail(equipID,i)
            end
        end
    )
    end



    ArenaScene.SetRoleSpine(roleID,children.nd_spine,1.5)
    
    --outputString("combatPower:"..GameRecorder.GetRoleCombatPower(roleID))
    children.tx_combatPower:setString(GameRecorder.GetRoleCombatPower(roleID))
    
    local Attack,Defence,Blood,Crit = GameRecorder.GetRoleAttributes(roleID)
    --outputString("Attack,Defence,Blood,Crit:"..Attack,Defence,Blood,Crit)
    local nd_attributes=children.nd_attributes
    nd_attributes[1]:setString(Attack)  nd_attributes[2]:setString(Blood)
    nd_attributes[3]:setString(Defence) nd_attributes[4]:setString(Crit.."%")

    return RoleScene.ChooseTypeButton(select_isEquipment)    
end

function RoleScene.ChooseTypeButton(isEquipment)
    select_isEquipment=isEquipment
    for i=1,2 do
        GameAssistor.SetButtonBright(children.bt_storages[i],({not isEquipment,isEquipment})[i])
    end
    
    local sc_storages=children.sc_storages
    
    local itemList={}
    if isEquipment then
        for key,data in pairs(GameRecorder.GetEquipList()) do
            local gData=GameDataTransfer.GetItemData(data.equipID)
            if gData.Role_id==select_role_id then
                local rData=table.copy(gData,{})
                table.insert(itemList,table.copy(data,rData))
            end
        end
    else
        for key,data in pairs(GameRecorder.GetStorageList()) do
            if data.qty>0 then
                local gData=GameDataTransfer.GetItemData(data.ID)
                local rData=table.copy(gData,{})
                table.insert(itemList,table.copy(data,rData))
            end
        end
    end
    table.sort(itemList, function(a,b) return (a.Quality or 0)>(b.Quality or 0) end)
    --table.print(itemList,"RoleScene.ChooseTypeButton itemList")
    
    if PINGTEST then RoleScene.ExpandStorageSize(false,itemList) end

    local pageView = children.sc_storages
    local pageMax,pageCount,itemCount = 20,0,0
    local function getPage(index)
        for key, var in pairs(pageView:getChildren()) do
            if index==key then return var end
        end
        local layout = ccui.Layout:create()
        layout:setContentSize(pageView:getContentSize())
        layout.pageIdx=index-1
        pageView:addPage(layout)
        return layout
    end

    for i=itemCount,#pageView:getPages()*pageMax-1 do
        pageCount=math.floor(itemCount/pageMax)
        local layout = getPage(pageCount+1)
        RoleScene.AddItemToPage(itemList[itemCount+1],layout,itemCount%pageMax)
        itemCount=itemCount+1
    end
    pageView:scrollToPage(0)
end

function RoleScene.ExpandStorageSize(isClear,itemList)
    
    local sc_storages=children.sc_storages   
    if isClear then sc_storages:removeAllPages() end

    local pageMax,pageCount,itemCount = 20,0,0

    local function getPage(index)

        for key, var in pairs(sc_storages:getChildren()) do
            if index==key then return var end
        end

        local layout = ccui.Layout:create()
        layout:setContentSize(sc_storages:getContentSize())
        layout.pageIdx=index-1
        sc_storages:addPage(layout)

        for i=0,pageMax-1 do
            RoleScene.AddItemToPage(nil,layout,i)
        end
        return layout 
    end

    for key, var in pairs(itemList or {}) do
        pageCount=math.floor(itemCount/pageMax)
        local layout = getPage(pageCount+1)
        itemCount=itemCount+1
    end

    if #sc_storages:getPages()==0 then 
        for i=1,3 do getPage(i) end
    end
end

function RoleScene.SetStorageItemEvent(button)
    local icon=button:getChildByTag(1)
    local quality=button:getChildByTag(2)
    local tx_qty=button:getChildByTag(3)
    
    local nd_effects=button:getChildByTag(4)      
    local effect=CommonAssistor.AddEffectLayer("e-ICON.csb",true)
    nd_effects:addChild(effect)

    button.setEmpty=function()
        button.ID=0 tx_qty:setVisible(false)
        icon:setVisible(false) quality:setVisible(false)
        effect:setVisible(false)
    end
    button.setQty=function(count)
        tx_qty:setString(count) tx_qty:setVisible(true)
    end
    button.setItem=function(iData)
        icon:loadTexture(GameDataTransfer.GetIconPath(iData.IconID))
        quality:setColor(quality_color[iData.Quality])
        icon:setVisible(true) quality:setVisible(true)
        button.ID=iData.ID

        effect:setVisible(true)
        for key,node in pairs(effect:getChildren()) do
            node:setVisible(node:getTag()==iData.Quality)
        end
    end
end

function RoleScene.AddItemToPage(gData,layout,index)

    local button = layout:getChildByTag(index)

    if not button then
        local page_layer = cc.CSLoader:createNode("Icon-zb.csb")
        button = page_layer:getChildByTag(0)
        button:removeFromParent()
        RoleScene.SetStorageItemEvent(button)
        button:addTouchEventListener(
            function(sender,eventType)
                if eventType== ccui.TouchEventType.ended then
                    if select_isEquipment then
                        -- cclog("aaaaaaaaaaaaaaaaaaaaaaaaaaaaaa    " .. button.ID)
                        CommonAssistor.ShowEquipmentDetail(button.ID, 1, true)
                        --return RoleScene.EquipItem(button.ID)
                    else
                        --return cclog("Use Item:"..button.ID)
                        CommonAssistor.ShowItemDetail(button.ID)
                    end
                end
            end)
        layout:addChild(button,1,index)
    end

    local x,y,w,h = 108,340,104,96
    local row,col = math.floor(index/5),index%5
    button:setPosition(x+col*w-row*12,y-row*h)

    local able=(gData~=nil)

    button.setEmpty()
---[[
    if able then
        button.setItem(gData)
        if not select_isEquipment then button.setQty(gData.qty) end
    end
    button:setTouchEnabled(able)--]]
end

function RoleScene.EquipItem(ID)
    
    local equipID=GameRecorder.GetEquipItemID(ID)
    local gData=GameDataTransfer.GetItemData(equipID)
    if not gData then return end
    
    local type,index=gData.Type
    if type==res_item_type.WEAPON then index=1
    elseif type==res_item_type.EQUIP then index=2
    elseif type==res_item_type.JEWELRY then index=3 end
    
    if index then
        local role=GameRecorder.GetRole(select_role_id)
        local itemID=role.equip_ids[index]
        role.equip_ids[index]=equipID
        
        GameRecorder.RemoveEquip(ID)
        GameRecorder.EquipGain(itemID)        
        GameRecorder.SaveBasicData()

        CombatPowerUnit.CheckRoleCombatPowers()
        
        return RoleScene.ChooseRoleButton(select_role_id)
    end
end

function RoleScene.OneKeyToSell()
    
    local sc_storages=children.sc_storages
    
    local getCoins=0
    if select_isEquipment then
        for key,data in pairs(GameRecorder.GetEquipList()) do
            local gData=GameDataTransfer.GetItemData(data.equipID)
            if gData.Role_id==select_role_id and gData.Quality<5 then
                getCoins=getCoins+gData.getmoney
                GameRecorder.RemoveEquip(data.ID)
            end
        end
    else
        for key,data in pairs(GameRecorder.GetStorageList()) do
            if data.qty>0 then
                local gData=GameDataTransfer.GetItemData(data.ID)
                getCoins=getCoins+gData.getmoney*data.qty
                data.qty=0
            end
        end
    end
    if getCoins>0 then
        GameRecorder.AddQuantity("coin",getCoins)
        GameRecorder.SaveBasicData()
        
        local iData=GameDataTransfer.GetTypeItemData(res_item_type.COINS)
        StageScene.AddAwardStrings(iData.Equip_Id..","..getCoins)
        
        GameMainScene.RefreshPlayerStateBar()
        return RoleScene.ChooseTypeButton(select_isEquipment)
    end
end



------Toutorial-----------------
function RoleScene.GetStorageButtonWithIndex(idx)
    local pageView = children.sc_storages
    for key, layout in ipairs(pageView:getChildren()) do
        for key, button in pairs(layout:getChildren()) do
            if idx==key then 
                return button 
            end
        end
    end
end

function RoleScene.GetStorageButtonValidity(idx)
    local button=RoleScene.GetStorageButtonWithIndex(idx)
    if button then return (button.ID and button.ID>0) end
    return false
end



