RuinExplorers = {}

RuinExplorers = class("RuinExplorers",function()
    return cc.Scene:create()
end)

local children={}

local type_fb=enum{
    "COINS=1",
    "EXP",
    "ENDLESS",
}

function RuinExplorers:sceneEnter()
    outputString("RuinExplorers:sceneEnter()")
end

function RuinExplorers:sceneExit()
    RuinExplorers.RemoveAllChildren(self)
end

function RuinExplorers.RemoveAllChildren(scene)
    table.clear(children)
    GameAssistor.RemoveUnusedSceneResource(scene)
end

function RuinExplorers.create()

    local scene = RuinExplorers.new()

    Sence_Init(scene)

    local layerFarm = cc.Layer:create()

    scene.getMainLayer=function()
        return layerFarm
    end
    children.mainLayerFarm = layerFarm

    local background = GameAssistor.CreateBackMaskLayout(180)
    layerFarm:addChild(background)

    scene.AddMainChildren()

    scene:addChild(layerFarm)

    return scene
end

function RuinExplorers.Refresh()
    RuinExplorers.RefreshExplorerRecord()
    RuinExplorers.RefreshList()
end

function RuinExplorers.RefreshExplorerRecord()

    local datas=PlayerDataList.Explorers
    if os.time()>datas.nextRefreshTime then
        datas.nextRefreshTime=StoreScene.GetNewDeadline(1)
        datas.used1=0 datas.used2=0 datas.used3=0
    end
    --table.print(datas,"----datas----")
end

function RuinExplorers.RefreshList()
    local nd_buttons=children.nd_gateList
    for i=1,3 do
        local node=nd_buttons:getChildByTag(i)
        node.Refresh()
    end
end

function RuinExplorers.GetExplorerData(key)
    return PlayerDataList.Explorers[key] or 0
end

function RuinExplorers.SetExplorerData(key,value)
    PlayerDataList.Explorers[key]=value
end

function RuinExplorers.AddMainChildren()

    local layerFarm = children.mainLayerFarm

    local page_layer = cc.CSLoader:createNode("MJ.csb")
    GameAssistor.SetToSceneCenter(page_layer)
    layerFarm:addChild(page_layer)
    
    local nd_buttons = page_layer:getChildByTag(1)
    children.nd_gateList=nd_buttons
    children.xy_buttons={}
    
    local types={type_fb.ENDLESS,type_fb.EXP,type_fb.COINS}



-- TOUCH_EVENT_BEGAN                      = ccui.TouchEventType.began
-- TOUCH_EVENT_MOVED                      = ccui.TouchEventType.moved
-- TOUCH_EVENT_ENDED                      = ccui.TouchEventType.ended
-- TOUCH_EVENT_CANCELED                   = ccui.TouchEventType.canceled


-- [2016-12-10 00:07:29] Engine (Info): [LUA-print] button ....1  x:-218  y:42
-- [2016-12-10 00:07:29] Engine (Info): [LUA-print] button ....2  x:-12.573399543762  y:-26
-- [2016-12-10 00:07:29] Engine (Info): [LUA-print] button ....3  x:153  y:42

    function setButtonZorder(b, x)
        if x > -90 and x < 30 then
            b.btn:setLocalZOrder(2)
            b.btn:setOpacity(255)
            b.btnChallenge:setTouchEnabled(true)
        else
            b.btn:setLocalZOrder(1)
            b.btn:setOpacity(255 * 0.7)
            b.btnChallenge:setTouchEnabled(false)
        end
    end


    function doMoveButton(dir)
        for i, b in pairs(RuinExplorers.buttons) do
            -- local x = b:getPositionX()
            local k = 136 / 360
            local y = 42 
            local x = RuinExplorers.startPos[i] + dir
            if x < -210 then 
                local xx = (x + 210) * -1
                local d = xx - math.floor(xx/540)*540
                d = d * -1
                -- cclog("xx:" .. xx .. " d:" .. d)
                if d <= 0 and d > -180 then
                    x = -210 - d * 2
                    b.btn:setLocalZOrder(0)
                    b.btnChallenge:setTouchEnabled(false)
                else
                    x = 150 + (d + 180)
                    y = math.abs(k * (x + 210) - 68) - 26
                    setButtonZorder(b, x)
                end
            elseif x > 150 then
                local xx = x - 150
                local d = xx - math.floor(xx/540) * 540
                if d >= 0 and d < 180 then
                    x = 150 - d * 2
                    b.btn:setLocalZOrder(0)
                    b.btnChallenge:setTouchEnabled(false)
                else
                    x = -210 + d - 180
                    y = math.abs(k * (x + 210) - 68) - 26
                    setButtonZorder(b, x)
                end
                
            else 
                y = math.abs(k * (x + 210) - 68) - 26
                setButtonZorder(b, x)
            end
            b.btn:setPosition(x,y)
        end
    end

    RuinExplorers.totalTime = 0.2
    function onTouch(sender, eventType)

        if eventType== ccui.TouchEventType.began then
            if RuinExplorers.startScroll then
                return
            end
            RuinExplorers.startScroll = true
            RuinExplorers.beginP = sender:getTouchBeganPosition()
            RuinExplorers.startPos = {}
            for i, b in pairs(RuinExplorers.buttons) do
                local x = b.btn:getPositionX()
                RuinExplorers.startPos[i] = x
            end
            RuinExplorers.lastP = sender:getTouchBeganPosition()
        elseif eventType== ccui.TouchEventType.moved then
            
            RuinExplorers.touchP = sender:getTouchMovePosition()
            RuinExplorers.lastP = RuinExplorers.touchP
            RuinExplorers.dir = RuinExplorers.touchP.x - RuinExplorers.beginP.x
            doMoveButton(RuinExplorers.dir)
        elseif ccui.TouchEventType.canceled == eventType or ccui.TouchEventType.ended == eventType then
            RuinExplorers.passTime = 0
            RuinExplorers.touchP = sender:getTouchEndPosition()
            RuinExplorers.lastP = RuinExplorers.touchP
            RuinExplorers.dir = RuinExplorers.touchP.x - RuinExplorers.beginP.x
            RuinExplorers.bindPosStart = RuinExplorers.dir
            -- if RuinExplorers.dir < 0 then
            local dd = math.abs(RuinExplorers.dir)
            d = dd - math.floor(dd / 360) * 360
            cclog("d=" .. d .. "  dir=" .. RuinExplorers.dir)
            if d < 120 then
                RuinExplorers.desDir = math.floor(dd / 360) * 360
            elseif d < 240 then
                RuinExplorers.desDir = math.floor(dd / 360) * 360 + 180
            else
                RuinExplorers.desDir = math.floor(dd / 360) * 360 + 360
            end




            function updateFunc(dt)
                RuinExplorers.passTime = RuinExplorers.passTime + dt
                if RuinExplorers.passTime > RuinExplorers.totalTime then
                    -- cclog("last update desDir:" .. RuinExplorers.desDir)
                    doMoveButton(RuinExplorers.desDir)
                    RuinExplorers.Root:unscheduleUpdate()
                    RuinExplorers.startScroll = false

                    for i, b in pairs(RuinExplorers.buttons) do
                        local node=nd_buttons:getChildByTag(i)
                        node.Refresh()
                    end

                    return
                end

                doMoveButton(RuinExplorers.passTime / RuinExplorers.totalTime  * (RuinExplorers.desDir - RuinExplorers.bindPosStart) + RuinExplorers.bindPosStart )

            end

            if RuinExplorers.dir < 0 then
                -- RuinExplorers.bindPosStart = d * -1
                RuinExplorers.desDir = RuinExplorers.desDir * -1
            end

            -- if math.abs(RuinExplorers.desDir - RuinExplorers.bindPosStart) < 2 then
            --     RuinExplorers.totalTime = 0
            -- end

            RuinExplorers.Root:scheduleUpdateWithPriorityLua(updateFunc,0)
        end
    end
    -- require('mobdebug').start('localhost')

    RuinExplorers.buttons = {}
    for i=1, 3 do --3 do
        local node=nd_buttons:getChildByTag(i)
        node.index=i node.type=types[node:getTag()]
        children.xy_buttons[i]={node:getPosition()}
        local button=node:getChildByTag(1)
        button:addTouchEventListener(onTouch)
        RuinExplorers.buttons[i] = {}
        RuinExplorers.buttons[i].btn = button:getParent()
        RuinExplorers.buttons[i].btn:setPositionX(-210 + 180 * ( i - 1))
        RuinExplorers.Root = button:getParent():getParent()
        local nd_bottom=button:getChildByTag(2)
        local bt_challenge=nd_bottom:getChildByTag(3)
        if i == 2 then
            bt_challenge:setTouchEnabled(true)
        else
            bt_challenge:setTouchEnabled(false)
        end

        RuinExplorers.buttons[i].btnChallenge = bt_challenge
        CommonAssistor.AddSimpleTouchEvent(bt_challenge,function()
            local gData=GameDataTransfer.GetGameExplorersData(node.type)
            if GameRecorder.GetBasicData("level")<gData.open then 
                local displayStr = string.gsub(GameDataTransfer.GetSysString(str_system.STRING_TIPS_ERROR_ROLELV2),"X",gData.open)
                return CommonAssistor.AddWarningBox(displayStr)
            end
            if type_fb.ENDLESS==node.type then
                return RuinExplorers.ShowChallengePage(true,node.type)
            end
            return RuinExplorers.Challenge(node.type)
        end)
        local tx_times=nd_bottom:getChildByTag(1)
        local node2=nd_bottom:getChildByTag(2)
        GameAssistor.SetBlackOutlineNoSpace(tx_times)
        node.Refresh=function()
            -- bt_challenge:setTouchEnabled(node.index==2)
            local gData=GameDataTransfer.GetGameExplorersData(node.type)
            if type_fb.ENDLESS==node.type then
                GameAssistor.SetBlackOutlineNoSpace(node2)
                tx_times:setString(RuinExplorers.GetExplorerData("maxNum"))
            else
                local used,max=RuinExplorers.GetExplorerData("used"..node.type),gData.free
                local isLimit=used>=max
                tx_times:setString(used.."/"..max)
                tx_times:setVisible(not isLimit) node2:setVisible(isLimit)
                local tx_cost=node2:getChildByTag(3)
                GameAssistor.SetBlackOutlineNoSpaces{tx_cost,node2:getChildByTag(1)}
                local cost=math.min(gData.consume_toplimit,(gData.consume+gData.increase*(used-max)))
                tx_cost:setString(GameRecorder.GetItemQuantity(gData.item).."/"..cost)
            end
        end
        node.Refresh()
    end
end

function RuinExplorers.CardMoveTo(index)

    if index==2 then return end    
    local xy_buttons,nd_buttons=children.xy_buttons,children.nd_gateList
    
    local function GetNextIndex(idx)
        if index==1 then return (idx%3)+1 end
        if index==3 then return ((idx+1)%3)+1 end
        return idx
    end
    
    GameMainScene.SetProtectMaskTimer(0.2)
    
    for i=1,3 do
        local node=nd_buttons:getChildByTag(i)
        local idx=GetNextIndex(node.index) node.index=idx
        local function Finish() node.Refresh() end
        node:setOpacity(idx==2 and 255 or 180)
        nd_buttons:reorderChild(node,idx==2 and 1 or 0)
        local actionTo = cc.Sequence:create(cc.MoveTo:create(0.2,cc.p(xy_buttons[idx][1],xy_buttons[idx][2])),cc.CallFunc:create(Finish))
        node:runAction(actionTo)        
    end
end

function RuinExplorers.AddChallengePage(type)

    local background,obstructLayout=GameMainScene.AddBasicSubPageBackgroundPage()    
    children.pg_challengePage=background

    local function HidePage()
        return RuinExplorers.ShowChallengePage(false)
    end

    GameMainScene.SetObstructLayoutTouchEvent(obstructLayout,HidePage)

    local page_layer = cc.CSLoader:createNode("MJ-sl.csb")
    obstructLayout:addChild(page_layer)
    GameAssistor.SetToSceneCenter(page_layer)

    local bt_close = page_layer:getChildByTag(5)
    CommonAssistor.AddSimpleTouchEvent(bt_close,function()
        GameMainScene.HidePageScaleToAction(obstructLayout,HidePage)
    end)    
    
    local bt_challenge=page_layer:getChildByTag(1):getChildByTag(3)
    CommonAssistor.AddSimpleTouchEvent(bt_challenge,function()
        RuinExplorers.ShowChallengePage(false)
        return RuinExplorers.Challenge(type)
    end)

    local gData=GameDataTransfer.GetGameExplorersData(type)

    local nd_storey=page_layer:getChildByTag(2)
    local bt_reset = page_layer:getChildByTag(4)
    
    background.Refresh=function()
        local datas=PlayerDataList.Explorers
        for i,value in ipairs{datas.playNum,datas.maxNum} do
            local tx_play=nd_storey:getChildByTag(i):getChildByTag(1)
            tx_play:setString((string.gsub(GameDataTransfer.GetSysString(str_system.STRING_TIPS_STOREY),"X",value)))
        end
        GameAssistor.SetButtonBright(bt_reset,datas["used"..type]<gData.free)
    end
    
    CommonAssistor.AddSimpleTouchEvent(bt_reset,function()
        RuinExplorers.ChallengeCost(type)
        RuinExplorers.SetExplorerData("playNum",1)
        background.Refresh()
        return GameRecorder.SaveBasicData()
    end)   

    local nd_award=page_layer:getChildByTag(3)
    local awards=string.split(gData.output,",")

    for i,ID in pairs(awards) do
        local ndItem=nd_award:getChildByTag(i):getChildByTag(1)
        local iData=GameDataTransfer.GetItemData(tonumber(ID))
        if ndItem and iData then
            local icon,quality=ndItem:getChildByTag(1),ndItem:getChildByTag(0)
            icon:loadTexture(GameDataTransfer.GetIconPath(iData.IconID))
            quality:setColor(quality_color[iData.Quality])
            --[[local txName=ndItem:getChildByTag(2) txName:setVisible(true)
            StageScene.SetQualityNameText(txName,GameDataTransfer.GetGameString(iData.Equip_Name),iData.Quality)
            --txName:setString(GameDataTransfer.GetGameString(iData.Equip_Name))--]]
        end
    end
end

function RuinExplorers.ShowChallengePage(show,type)

    if not children.pg_challengePage then 
        if show then
            RuinExplorers.AddChallengePage(type)
        else return
        end
    end

    local page=children.pg_challengePage  

    if show then
        page.Refresh()

        GameMainScene.PlayPageScaleToAction(page.obstructLayout)
    end
    page:setVisible(show)
end

function RuinExplorers.Challenge(type)
    local gData=GameDataTransfer.GetGameExplorersData(type)
    if PINGTEST then return Ping_TestRuinExplorerChallenge(type) end    
    
    if type_fb.ENDLESS==type then
        outputString("Challenge storey:"..RuinExplorers.GetExplorerData("playNum"))
        return GameManager.startInfiniteFB(type,RuinExplorers.GetExplorerData("playNum"))
    else
        local used,max=RuinExplorers.GetExplorerData("used"..type),gData.free
        local isLimit=used>=max
        if isLimit then
            local cost=math.min(gData.consume_toplimit,(gData.consume+gData.increase*(used-max)))
            if GameRecorder.GetItemQuantity(gData.item)<cost then                
                return GameMainScene.AddGoToConfirmBox(str_system.STRING_TIPS_RUINEXPLORER_ERROR)
            end
        end
    end
    if type_fb.COINS==type then
        return GameManager.startTreasureFB(type)
    elseif type_fb.EXP==type then
        return GameManager.startExpFB(type)
    end
    CommonAssistor.AddWarningBox(GameDataTransfer.GetSysString(str_system.STRING_TIPS_COMINGSOON))
end

function RuinExplorers.ChallengeCost(type)
    local key="used"..type
    local gData=GameDataTransfer.GetGameExplorersData(type)
    local used,max=RuinExplorers.GetExplorerData(key),gData.free
    if gData.item>0 and used>=max then
        local cost=math.min(gData.consume_toplimit,(gData.consume+gData.increase*(used-max)))
        GameRecorder.StorageChange(gData.item,GameRecorder.GetItemQuantity(gData.item)-cost)
    end
    RuinExplorers.SetExplorerData(key,used+1)
end

function RuinExplorers.ChallengeEndlessFinish(storey)
    RuinExplorers.SetExplorerData("playNum",storey)
    RuinExplorers.SetExplorerData("maxNum",math.max(storey-1,RuinExplorers.GetExplorerData("maxNum")))
    return GameRecorder.SaveBasicData()
end

function RuinExplorers.ChallengeWinner_WithExp(GetExp)
    RuinExplorers.ChallengeCost(type_fb.EXP)
    StageScene.GetExpAndCheckLevel(GetExp)
    return GameRecorder.SaveBasicData()
end

function RuinExplorers.ChallengeWinner_WithCoins(GetCoins)
    RuinExplorers.ChallengeCost(type_fb.COINS)
    GameRecorder.AddQuantity("coin",GetCoins)
    return GameRecorder.SaveBasicData()
end




