
GameDataTransfer = {}
GameData_Type={}
GameData_List={}

function GameDataTransfer.LoadServerData()
	
    GameDataTransfer.LoadGameData()    
    GameRecorder.LoadRecords()	
	GameSound.PreloadAllEffects()	
    preLoadResource()
    
    GameSound.setupSoundMap()
    
    if PINGTEST then return NowSceneReplaceChecker(GameMainScene) end
    
    if GameManager.isNewPlayer() then return end
    
    LoadingScene.setNextScene(GameMainScene)    
    NowSceneReplaceChecker(LoadingScene)
    
    TeachAssistor.runTeachAssistor(true)
end

function GameDataTransfer.LoadGameData()
    
    local skip,length=1
    
    local packetContentBytes=GameDataReader.readDataFromAppFile("Data/Game_Data.dat")

    skip, length = GameDataReader.readShort(packetContentBytes,skip)

    for i=1,length do
        local table_name,row,col

        skip,table_name = GameDataReader.readString(packetContentBytes,skip)
        outputString("table name: "..table_name)
        
        skip, col=GameDataReader.readInt(packetContentBytes,skip)
        skip, row=GameDataReader.readInt(packetContentBytes,skip)
        
        local tabal_type={}
        local tabal_list={}
        
        local type,key
        --outputString("count type:"..col)
        for j=1,col do
            skip,type = GameDataReader.readByte(packetContentBytes,skip)
            skip,key = GameDataReader.readString(packetContentBytes,skip)
            table.insert(tabal_type,{key=key,type=type})
        end
        
        GameData_Type[table_name]=tabal_type
        
        outputString("count data: "..row)
        for j=1,row do
            local table_data={}
            for index=1,col do
                type = tabal_type[index].type
                key = tabal_type[index].key
                skip,table_data[key]=GameDataReader.readTypeValue(packetContentBytes,skip,type)
            end
            table.replace(tabal_list,table_data[tabal_type[1].key],table_data)
        end
        
        --if table_name == "skill" then
       --     print_lua_table(tabal_list)
       -- end


        GameData_List[table_name]=tabal_list
    end
    

    LoadStore()

    return GameDataTransfer.TransferDataList()
end


function LoadStore()
    GameData_List["Game_Shop"] = {
    -- local tb = {}
        [1] = {
            ["recommend"] = 1,
            ["Type"] = 1,
            ["Price"] = 180,
            ["Charge_ID"] = 4,
            ["Rate"] = 18,
            ["ResId"] = "2",
            ["ID"] = 1,
            ["Icon"] = "2",
            ["time"] = 0,
            ["name"] = 110001,
            ["zw"] = "购买英雄王小虎",
            ["CurrencyType"] = 1,
            ["order_id"] = "TOOL7",
        },
        [2] = {
            ["recommend"] = 1,
            ["Type"] = 1,
            ["Price"] = 180,
            ["Charge_ID"] = 5,
            ["Rate"] = 18,
            ["ResId"] = "3",
            ["ID"] = 2,
            ["Icon"] = "3",
            ["time"] = 0,
            ["name"] = 110002,
            ["zw"] = "购买英雄石黑龙",
            ["CurrencyType"] = 1,
            ["order_id"] = "TOOL8",
        },
        [3] = {
            ["recommend"] = 1,
            ["Type"] = 2,
            ["Price"] = 290,
            ["Charge_ID"] = 6,
            ["Rate"] = 29,
            ["ResId"] = "105,1,110,1,115,1",
            ["ID"] = 3,
            ["Icon"] = "121,124,127",
            ["time"] = 0,
            ["name"] = 110003,
            ["zw"] = "龙吟神话套装",
            ["CurrencyType"] = 1,
            ["order_id"] = "TOOL12",
        },
        [4] = {
            ["recommend"] = 1,
            ["Type"] = 2,
            ["Price"] = 290,
            ["Charge_ID"] = 7,
            ["Rate"] = 29,
            ["ResId"] = "205,1,210,1,215,1",
            ["ID"] = 4,
            ["Icon"] = "112,115,118",
            ["time"] = 0,
            ["name"] = 110004,
            ["zw"] = "虎啸神话套装",
            ["CurrencyType"] = 1,
            ["order_id"] = "TOOL13",
        },
        [5] = {
            ["recommend"] = 1,
            ["Type"] = 2,
            ["Price"] = 290,
            ["Charge_ID"] = 8,
            ["Rate"] = 29,
			["ResId"] = "305,1,310,1,315,1",
            ["ID"] = 5,
            ["Icon"] = "103,106,106",
            ["time"] = 0,
            ["name"] = 110005,
            ["zw"] = "追魂神话套装",
            ["CurrencyType"] = 1,
            ["order_id"] = "TOOL14",
        },
        [6] = {
            ["recommend"] = 0,
            ["Type"] = 3,
            ["Price"] = 0,
            ["Charge_ID"] = 16,
            ["Rate"] = 100,
            ["ResId"] = "3,100000",
            ["ID"] = 6,
            ["Icon"] = "2506",
            ["time"] = 0,
            ["name"] = 110006,
            ["zw"] = "少量银币",
            ["CurrencyType"] = 2,
            ["order_id"] = "",
        },
        [7] = {
            ["recommend"] = 0,
            ["Type"] = 3,
            ["Price"] = 0,
            ["Charge_ID"] = 17,
            ["Rate"] = 180,
            ["ResId"] = "3,200000",
            ["ID"] = 7,
            ["Icon"] = "2506",
            ["time"] = 0,
            ["name"] = 110007,
            ["zw"] = "一堆银币",
            ["CurrencyType"] = 2,
            ["order_id"] = "",
        },
        [8] = {
            ["recommend"] = 1,
            ["Type"] = 3,
            ["Price"] = 0,
            ["Charge_ID"] = 18,
            ["Rate"] = 290,
            ["ResId"] = "3,400000",
            ["ID"] = 8,
            ["Icon"] = "2506",
            ["time"] = 0,
            ["name"] = 110008,
            ["zw"] = "大量银币",
            ["CurrencyType"] = 2,
            ["order_id"] = "",
        },
        [9] = {
            ["recommend"] = 0,
            ["Type"] = 4,
            ["Price"] = 0,
            ["Charge_ID"] = 19,
            ["Rate"] = 20,
            ["ResId"] = "1,1",
            ["ID"] = 9,
            ["Icon"] = "1001",
            ["time"] = 0,
            ["name"] = 110009,
            ["zw"] = "药水",
            ["CurrencyType"] = 2,
            ["order_id"] = "",
        },
        [10] = {
            ["recommend"] = 1,
            ["Type"] = 4,
            ["Price"] = 0,
            ["Charge_ID"] = 20,
            ["Rate"] = 50,
            ["ResId"] = "5,1",
            ["ID"] = 10,
            ["Icon"] = "2501",
            ["time"] = 0,
            ["name"] = 110010,
            ["zw"] = "王小龙丹元",
            ["CurrencyType"] = 2,
            ["order_id"] = "",
        },
        [11] = {
            ["recommend"] = 1,
            ["Type"] = 4,
            ["Price"] = 0,
            ["Charge_ID"] = 21,
            ["Rate"] = 50,
            ["ResId"] = "6,1",
            ["ID"] = 11,
            ["Icon"] = "2502",
            ["time"] = 0,
            ["name"] = 110011,
            ["zw"] = "王小虎丹元",
            ["CurrencyType"] = 2,
            ["order_id"] = "",
        },
        [12] = {
            ["recommend"] = 1,
            ["Type"] = 4,
            ["Price"] = 0,
            ["Charge_ID"] = 22,
            ["Rate"] = 50,
            ["ResId"] = "7,1",
            ["ID"] = 12,
            ["Icon"] = "2503",
            ["time"] = 0,
            ["name"] = 110012,
            ["zw"] = "石黑龙丹元",
            ["CurrencyType"] = 2,
            ["order_id"] = "",
        },
        [13] = {
            ["recommend"] = 1,
            ["Type"] = 4,
            ["Price"] = 0,
            ["Charge_ID"] = 23,
            ["Rate"] = 50,
            ["ResId"] = "2,1",
            ["ID"] = 13,
            ["Icon"] = "2504",
            ["time"] = 0,
            ["name"] = 110013,
            ["zw"] = "刷新券",
            ["CurrencyType"] = 2,
            ["order_id"] = "",
        },
        [14] = {
            ["recommend"] = 1,
            ["Type"] = 5,
            ["Price"] = 1,
            ["Charge_ID"] = 10,
            ["Rate"] = 1,
            ["ResId"] = "4,1",
            ["ID"] = 14,
            ["Icon"] = "2508",
            ["time"] = 0,
            ["name"] = 110014,
            ["zw"] = "0.1元充值礼包",
            ["CurrencyType"] = 1,
            ["order_id"] = "TOOL1",
        },
        [15] = {
            ["recommend"] = 1,
            ["Type"] = 5,
            ["Price"] = 50,
            ["Charge_ID"] = 11,
            ["Rate"] = 50,
            ["ResId"] = "4,51",
            ["ID"] = 15,
            ["Icon"] = "2508",
            ["time"] = 0,
            ["name"] = 110015,
            ["zw"] = "5元充值礼包",
            ["CurrencyType"] = 1,
            ["order_id"] = "TOOL3",
        },
        [16] = {
            ["recommend"] = 1,
            ["Type"] = 5,
            ["Price"] = 100,
            ["Charge_ID"] = 12,
            ["Rate"] = 100,
            ["ResId"] = "4,110",
            ["ID"] = 16,
            ["Icon"] = "2508",
            ["time"] = 0,
            ["name"] = 110016,
            ["zw"] = "10元充值礼包",
            ["CurrencyType"] = 1,
            ["order_id"] = "TOOL5",
        },
        [17] = {
            ["recommend"] = 1,
            ["Type"] = 5,
            ["Price"] = 160,
            ["Charge_ID"] = 13,
            ["Rate"] = 160,
            ["ResId"] = "4,180",
            ["ID"] = 17,
            ["Icon"] = "2508",
            ["time"] = 0,
            ["name"] = 110017,
            ["zw"] = "16元充值礼包",
            ["CurrencyType"] = 1,
            ["order_id"] = "TOOL6",
        },
        [18] = {
            ["recommend"] = 1,
            ["Type"] = 5,
            ["Price"] = 220,
            ["Charge_ID"] = 14,
            ["Rate"] = 220,
            ["ResId"] = "4,250",
            ["ID"] = 18,
            ["Icon"] = "2508",
            ["time"] = 0,
            ["name"] = 110018,
            ["zw"] = "22元充值礼包",
            ["CurrencyType"] = 1,
            ["order_id"] = "TOOL10",
        },
        [19] = {
            ["recommend"] = 1,
            ["Type"] = 5,
            ["Price"] = 290,
            ["Charge_ID"] = 15,
            ["Rate"] = 290,
            ["ResId"] = "4,335",
            ["ID"] = 19,
            ["Icon"] = "2508",
            ["time"] = 0,
            ["name"] = 110019,
            ["zw"] = "29元充值礼包",
            ["CurrencyType"] = 1,
            ["order_id"] = "TOOL15",
        },
        [20] = {
            ["recommend"] = 1,
            ["Type"] = 6,
            ["Price"] = 0,
            ["Charge_ID"] = 24,
            ["Rate"] = 0,
            ["ResId"] = "105,1,2,10,3,100000",
            ["ID"] = 20,
            ["Icon"] = "103,2504,2506",
            ["time"] = 0,
            ["name"] = 110020,
            ["zw"] = "首冲礼包",
            ["CurrencyType"] = 1,
            ["order_id"] = "",
        },
        [21] = {
            ["recommend"] = 0,
            ["Type"] = 7,
            ["Price"] = 100,
            ["Charge_ID"] = 1,
            ["Rate"] = 10,
            ["ResId"] = "3,50000,2,1,5,5,6,5,7,5",
            ["ID"] = 21,
            ["Icon"] = "2506,2504,2501,2502,2503",
            ["time"] = 7,
            ["name"] = 110021,
            ["zw"] = "荣耀白金会员礼包",
            ["CurrencyType"] = 1,
            ["order_id"] = "TOOL4",
        },
        [22] = {
            ["recommend"] = 0,
            ["Type"] = 7,
            ["Price"] = 200,
            ["Charge_ID"] = 2,
            ["Rate"] = 20,
            ["ResId"] = "3,50000,2,3,5,5,6,5,7,5",
            ["ID"] = 22,
            ["Icon"] = "2506,2504,2501,2502,2503",
            ["time"] = 30,
            ["name"] = 110022,
            ["zw"] = "闪耀黄金会员礼包",
            ["CurrencyType"] = 1,
            ["order_id"] = "TOOL9",
        },
        [23] = {
            ["recommend"] = 1,
            ["Type"] = 7,
            ["Price"] = 290,
            ["Charge_ID"] = 3,
            ["Rate"] = 29,
            ["ResId"] = "3,100000,2,9,5,5,6,5,7,5",
            ["ID"] = 23,
            ["Icon"] = "2506,2504,2501,2502,2503",
            ["time"] = 0,
            ["name"] = 110023,
            ["zw"] = "永恒钻石会员礼包",
            ["CurrencyType"] = 1,
            ["order_id"] = "TOOL11",
        },
        [24] = {
            ["recommend"] = 0,
            ["Type"] = 8,
            ["Price"] = 30,
            ["Charge_ID"] = 9,
            ["Rate"] = 99,
            ["ResId"] = "3,1",
            ["ID"] = 24,
            ["Icon"] = "3",
            ["time"] = 0,
            ["name"] = 110024,
            ["zw"] = "复活",
            ["CurrencyType"] = 1,
            ["order_id"] = "TOOL2",
        },
    }


end


function GameDataTransfer.TransferDataList()

    GameDataTransfer.SysString = GameDataTransfer.GetSysStringList()
    GameDataTransfer.GameString = GameDataTransfer.GetGameStringList()
    GameDataTransfer.SkillValue = GameDataTransfer.GetSkillValueList() 
    GameDataTransfer.TypeItems = GameDataTransfer.GetTypeItemList()
    GameDataTransfer.ActiveSkillValue = GameDataTransfer.GetActiveSkillValueList()   
    GameDataTransfer.ItemLevelValue = GameDataTransfer.GetItemLevelValueList()
    GameDataTransfer.FBChapter = GameDataTransfer.GetFBChapterTypeList()
    GameDataTransfer.FBChapterAward = GameDataTransfer.GetFBChapterAwardList()
    GameDataTransfer.RoleStars = GameDataTransfer.GetRoleStarsList()
    GameDataTransfer.BulletValue = GameDataTransfer.GetBulletValueList()
    GameDataTransfer.GameTips = GameDataTransfer.GetGameTipList()
    GameDataTransfer.GameArenas = GameDataTransfer.GetGameArenaRankList()
end    

function GameDataTransfer.GetGameStringList()
    local result_table={}
    for key,value in pairs(GameData_List.String) do
        table.replace(result_table,value.ID,value.Content)
    end
    return result_table
end

function GameDataTransfer.GetGameTipList()
    local Rusult_Value={}
    for key,value in pairs(GameData_List.Game_Tips) do
        Rusult_Value[value.Tips_Type_1] = Rusult_Value[value.Tips_Type_1]or{}
        table.replace(Rusult_Value[value.Tips_Type_1],value.Tip_ID,value)
        --table.insert(Rusult_Value[value.Tips_Type_1],value)
    end
    return Rusult_Value
end

function GameDataTransfer.GetFBChapterTypeList()
    local Rusult_ChapterQuality={}
    for key,value in pairs(GameData_List.Game_fb) do
        Rusult_ChapterQuality[value.type] = Rusult_ChapterQuality[value.type]or{}
        local result_table=Rusult_ChapterQuality[value.type]
        result_table[value.Chapter] = result_table[value.Chapter]or{}
        table.insert(result_table[value.Chapter],value)
    end
    return Rusult_ChapterQuality
end

function GameDataTransfer.GetFBChapterAwardList()
    local Rusult={}
    for key,value in pairs(GameData_List.Chapteraward) do
        Rusult[value.type] = Rusult[value.type]or{}
        table.replace(Rusult[value.type],value.Chapter,value)
    end
    return Rusult
end

function GameDataTransfer.GetRoleStarsList()
    local Rusult={}
    for key,value in pairs(GameData_List.petstar) do
        Rusult[value.type] = Rusult[value.type]or{}
        table.replace(Rusult[value.type],value.starlevel,value)
    end
    return Rusult
end

function GameDataTransfer.GetSkillValueList()
    local Rusult={}
    for key,value in pairs(GameData_List.skill_value) do
        Rusult[value.skillid] = Rusult[value.skillid]or{}
        table.replace(Rusult[value.skillid],value.Lv,value)
    end
    return Rusult
end

function GameDataTransfer.GetActiveSkillValueList()
    local Rusult={}
    for key,value in pairs(GameData_List.Active_Skill) do
        Rusult[value.skillid] = Rusult[value.skillid]or{}
        table.replace(Rusult[value.skillid],value.Lv,value)
    end
    return Rusult
end

function GameDataTransfer.GetItemLevelValueList()
    local Rusult={}
    for key,value in pairs(GameData_List.Game_Itemlevel) do
        Rusult[value.itemID] = Rusult[value.itemID]or{}
        table.replace(Rusult[value.itemID],value.itmelevel,value)
    end
    return Rusult
end

function GameDataTransfer.GetTypeItemList()
    local Rusult={}
    for key,value in pairs(GameData_List.Game_Item) do
        Rusult[value.Type] = Rusult[value.Type]or{}
        table.replace(Rusult[value.Type],value.Equip_Id,value)
    end
    return Rusult
end

function GameDataTransfer.GetBulletValueList()
    local Rusult_Value={}
    for key,value in pairs(GameData_List.Bullet_value) do
        Rusult_Value[value.BULLETID] = Rusult_Value[value.BULLETID]or{}
        table.replace(Rusult_Value[value.BULLETID],value.BULLETLV,value)
    end
    return Rusult_Value
end

function GameDataTransfer.GetGameArenaRankList()
    -- local result_table={}
    -- for key,value in pairs(GameData_List.Game_Arena) do
    --     table.replace(result_table,value.ranking_up,value)
    -- end
    -- print_lua_table(GameData_List.Game_Arena)
    return GameData_List.Game_Arena
end






function GameDataTransfer.GetGameDataList()
	return GameData_List
end

function GameDataTransfer.GetGameDataListWithKey(tableName)
    return GameData_List[tableName] or {}
end

function GameDataTransfer.GetSysStringList()
	local filedata = GameDataReader.readFromAppFile("systems")
    return string.split(filedata,"\r\n")
end

function GameDataTransfer.GetGameString(sid)
    return GameDataTransfer.GameString[sid] or "Nothing!"
end

function GameDataTransfer.GetGameStrings(sid)
    return (string.gsub(GameDataTransfer.GetGameString(sid),"\\n","\n"))
end

function GameDataTransfer.GetSysString(sid)
	if not GameDataTransfer.SysString then GameDataTransfer.SysString = GameDataTransfer.GetSysStringList() end
    return GameDataTransfer.SysString[sid] or "Nothing!"
end

function GameDataTransfer.GetSysStrings(sid)
    return (string.gsub(GameDataTransfer.GetSysString(sid),"\\n","\n"))
end

function GameDataTransfer.GetChineseNumber(index)
	if not GameDataTransfer.chineseNumbers then
		GameDataTransfer.chineseNumbers = string.split(GameDataTransfer.GetSysString(str_system.STRING_TIPS_CHINESECOUNT),",")
	end
	return GameDataTransfer.chineseNumbers[index]
end

function GameDataTransfer.GetAttributeString(type,value,blank)
	local index = blank and str_system.STRING_EQUIP_ATTRIBUTE_BLANK or str_system.STRING_EQUIP_ATTRIBUTE
	return GameDataTransfer.GetSysString(type+index).."+"..value
end

function GameDataTransfer.GetAwardStringData(awardString)
    if not awardString then return {} end
    local result={}
    local stringData = string.split(awardString,",")

    for i=1,#stringData,2 do
        if tonumber(stringData[i])>0 then
            table.insert(result,{ID=tonumber(stringData[i]),qty=tonumber(stringData[i+1])})
        end 
    end
    return result
end

function GameDataTransfer.GetIconPath(iconID,isJPG)
    local filename="Image/icon/"..iconID
    if isJPG then return filename..".jpg" end
    return filename..".png"
end

function GameDataTransfer.GetCardPath(iconID)
    return "Image/card/"..iconID..".png"
end

function GameDataTransfer.GetGameFB(fb_id)
    return GameData_List.Game_fb[fb_id]
end

function GameDataTransfer.GetGameChapter(type)
    return GameDataTransfer.FBChapter[type] or {}
end

function GameDataTransfer.GetGameChapterSections(type,chapter)
    local chapterList=GameDataTransfer.GetGameChapter(type)
    return chapterList[chapter] or {}
end

function GameDataTransfer.GetChapterAwards(type,chapter)
    local chapterList=GameDataTransfer.FBChapterAward[type] or {}
    return chapterList[chapter]
end

function GameDataTransfer.GetNPC(RoleID)
    return GameData_List.Game_NPC[RoleID]
end

function GameDataTransfer.GetSkillData(ID)
    return GameData_List.skill[ID]
end

function GameDataTransfer.GetSkillValue(SkillID,Lv)
    if not GameDataTransfer.SkillValue[SkillID] then return end
    return GameDataTransfer.SkillValue[SkillID][Lv]
end

function GameDataTransfer.GetActiveSkillValue(SkillID,Lv)
    if not GameDataTransfer.ActiveSkillValue[SkillID] then return end
    return GameDataTransfer.ActiveSkillValue[SkillID][Lv]
end

function GameDataTransfer.GetActiveSkillData(ID,level)
    local activeSkillValue=GameDataTransfer.GetActiveSkillValue(ID,math.max(1,level))
    if activeSkillValue then
        return GameData_List.skill[activeSkillValue.skillrefid]
    end
end

function GameDataTransfer.GetRoleData(RoleID)
    return GameData_List.Role[RoleID]
end

function GameDataTransfer.GetRoleLevelData(lv)
    return GameData_List.Role_level[lv]
end

function GameDataTransfer.GetItemData(ID)
    return GameData_List.Game_Item[ID]
end

function GameDataTransfer.GetItemLevelData(ID,Lv)
    return GameDataTransfer.ItemLevelValue[ID][Lv]
end

function GameDataTransfer.GetTypeItemData(Type)
    local list=GameDataTransfer.TypeItems[Type] or {}
    for ID,data in pairs(list) do
        return data
    end 
end

function GameDataTransfer.GetPetLevelData(Lv)
    return GameData_List.pet[Lv]
end

function GameDataTransfer.GetPetStarData(type,Lv)
    return GameDataTransfer.RoleStars[type][Lv]
end

function GameDataTransfer.GetBulletValueDataList(BulletId)
    return GameDataTransfer.BulletValue[BulletId]
end

function GameDataTransfer.GetBulletValue(BulletId,Lv)
    return GameDataTransfer.BulletValue[BulletId][Lv]
end

function GameDataTransfer.GetTypeAchievementList(Type)
    local result={}
    for ID,data in pairs(GameData_List.Game_Achievement) do
        if data.tape==Type then
            table.insert(result,data)
        end
    end 
    return result
end

function GameDataTransfer.GetGameAchievementData(ID)
    return GameData_List.Game_Achievement[ID]
end

function GameDataTransfer.GetTypeStoreList(Type)
    local result={}
    for i = 0, #GameData_List.Game_Shop do
        data = GameData_List.Game_Shop[i]
        if data and data.Type==Type then
            table.insert(result,data)
        end
    end 
    return result
end

function GameDataTransfer.GetStoreData(ID)
    return GameData_List.Game_Shop[ID]
end

function GameDataTransfer.GetGameExplorersData(ID)
    return GameData_List.GameExplorers[ID]
end

function GameDataTransfer.GetGameArenaData(ID)
    return GameData_List.Game_Arena[ID]
end

function GameDataTransfer.GetArenaRankData(rank)
    return GameDataTransfer.GameArenas[rank]
end

function GameDataTransfer.GetTipsData(Tip_ID)
    return GameData_List.Game_Tips[Tip_ID]
end

function GameDataTransfer.GetTipsDataList(Type_1)
    return GameDataTransfer.GameTips[Type_1] or {}
end
