
res_color={
	FULL=cc.c3b(255,255,255),
	WHITE=cc.c3b(227,227,227),
	GREEN=cc.c3b(92,216,58),
	BLUE=cc.c3b(41,122,244),
	PURPLE=cc.c3b(202,56,238),
	GOLDEN=cc.c3b(243,177,46),
	RED=cc.c3b(248,48,26),
	YELLOW=cc.c3b(255,255,0),
	MAGENTA=cc.c3b(255,0,255),
	ORANGE=cc.c3b(255,127,0),
	GRAY=cc.c3b(166,166,166),
	BLACK=cc.c3b(0,0,0),
	BROWN=cc.c3b(66,52,31),
	GRAY=cc.c3b(163,163,163),
	OTHER=cc.c3b(156,103,80),
	BROWN2=cc.c3b(202,160,112),
	AZURE=cc.c3b(53,242,249),
    PINK=cc.c3b(241,38,219),
	
	GOLDEN2=cc.c3b(216,146,36),
	PURPLE2=cc.c3b(177,57,178),
	BLUE2=cc.c3b(15,66,211),
	GREEN2=cc.c3b(44,155,19),
	WHITE2=cc.c3b(175,175,161),
	BLACK2=cc.c3b(79,65,48),
}

quality_color={
	res_color.WHITE,
	res_color.GREEN,
	res_color.BLUE,
	res_color.PURPLE,
    res_color.GOLDEN,
    res_color.RED,
}

res_attribute={
    "NONE",
    "POWER",
    "DEFENCE",
    "BLOOD",
    "CRIT",
}
res_attribute=table.enum(res_attribute)

res_item_type=enum{
    "WEAPON=1",
    "EQUIP",
    "JEWELRY",
    "MEDICINE",
    "TICKET",
    "COINS",
    "DIAMOND",
    "OTHERS",
}

res_store_type=enum{
    "ROLE=1",
    "EQUIP_SET",
    "COINS",
    "OTHERS",
    "DIAMOND",
    "FIRST",
    "VIP",
}

res_currency=enum{
    "RMB=1",
    "DIAMOND",
    "COINS",
}

local default_font="Fonts/Number-ty3.ttf"
res_font={
	default = default_font,
	attribute = {outlineSize=3,fontSize=20,fontFilePath=default_font},
}

str_system = enum{
    "STRING_ATTRIBUTE=1",
    "STRING_TIPS_NOTHING=7",
    "STRING_TIPS_NO_ENOUGH",
    "STRING_TIPS_COIN_NO_ENOUGH",
    "STRING_TIPS_DIAMOND_NO_ENOUGH",
    "STRING_TIPS_SKILLINFO1",
    "STRING_TIPS_SKILLINFO2",
    "STRING_TIPS_FB_CONDITION2",
    "STRING_TIPS_FB_CONDITION3",
    "STRING_TIPS_ERROR_ROLELV",
    "STRING_TIPS_ERROR_UPGRADELV",
    "STRING_TIPS_CHINESECOUNT",
    "STRING_TIPS_DAMAGE",
    "STRING_TIPS_ONEKEYTOSELL",
    "STRING_TIPS_DIGESTIONEQUIPMENTS",
    "STRING_TIPS_UPGRADESTAR",
    "STRING_TIPS_NO_ENOUGH_ITEM",
    "STRING_TIPS_YUAN",
    "STRING_TIPS_DAY",
    "STRING_TIPS_FOREVER",
    "STRING_TIPS_COMINGSOON",
    "STRING_TIPS_STOREY",
    "STRING_TIPS_RUINEXPLORER_ERROR",
    "STRING_TIPS_GOTO",
    "STRING_TIPS_ERROR_ROLELV2",

    "STRING_GAME_CHAPTERNAME1=400",
    "STRING_GAME_CHAPTERNAME2=410",
    "STRING_GAME_CHAPTERNAME3=420",

    "STRING_GAME_LASTNAMEBEGIN=80001",
    "STRING_GAME_LASTNAMEEND=80733",
    "STRING_GAME_FIRSTNAMEBEGIN=81001",
    "STRING_GAME_FIRSTNAMEEND=83877",
}

res_gameLayer={
    ["LAYER_BG"] = 1,
    ["LAYER_BG_EFFECT"] = 2,
    ["LAYER_PLAYER1"] = 100,
    ["LAYER_PLAYER2"] = 200,
    ["LAYER_HITEFFECT"] = 300,
    ["LAYER_EFFECT"] = 310,
    ["LAYER_FG"] = 320,
    ["LAYER_CONTROL"] = 330,
}

print_lua_table(res_gameLayer)
-- res_gameLayer=table.enum(res_gameLayer)

res_spine={}

table.weak(res_spine,"kv")

PreloadSpineRes = function(json,atlas)

    if not atlas then atlas=json end

    ---[[   
    if (not cc.FileUtils:getInstance():isFileExist(json..".json")) or (not cc.FileUtils:getInstance():isFileExist(atlas..".atlas")) then
        res_spine[atlas] = sp.SkeletonAnimation:pushBackData(GetSpineName(1)..".json", GetSpineName(1)..".atlas")
        -- screenAddPrint("PreloadSpineRes Error!! "..atlas)
        return res_spine[atlas]
    end
    --]]

    res_spine[atlas] = sp.SkeletonAnimation:pushBackData(json..".json", atlas..".atlas")
    return res_spine[atlas]
end

LoadSpineRes = function(key)
    return res_spine[key]
end

CreateSpineRes = function(json,atlas,scale)
    local index = res_spine[atlas or json]
    if not index then
        index = PreloadSpineRes(json,atlas)
    end
    local spine=sp.SkeletonAnimation:createDataIndex(index)
    if scale and scale then
        spine:setScale(scale)
    end
    return spine,index
end

RemoveAllSpineRes = function()
    table.clear(res_spine)
    sp.SkeletonAnimation:removeAllSPData()
end

function GetSpineName(key)
    return ("Spine/ROLE_"..key)
end

function CreateSpineWithModelID(modelID,scale)
    local spine = CreateSpineRes(GetSpineName(modelID))
    if scale then spine:setScale(scale) end
    return spine
end

function GetNPCSpinePairs(modelID)
    local jsonID=modelID-(modelID%10)+1
    return GetSpineName(jsonID),GetSpineName(modelID)
end

function GetNPCSpineName(npcID)
    local npc=GameDataTransfer.GetNPC(npcID)
    if not npc then
        screenAddPrint("npc is null : ",npcID)
    end
    return GetNPCSpinePairs(npc.model_id)
end

function CreatePreloadSpine(modelID,scale)
    local jsonName,atlasName = GetNPCSpinePairs(modelID)
    return CreateSpineRes(jsonName,atlasName,scale)
end

function PreloadGameEnemyRes()
    local enemys = GameEventManager.GetEnemyIDList()
    for key, var in pairs(enemys) do
        local npc=GameDataTransfer.GetNPC(var)
        if npc then
            PreloadSpineRes(GetNPCSpineName(var))
            GameSound.initGamesoundWithSkill_IDS(npc.npc_skill)
            if npc.reward_money then
                local tempExtraSound = string.split(npc.reward_money,",")
                for i=1,#tempExtraSound do
                    local tesId = tonumber(tempExtraSound[i])
                    if tesId > 0 then
                        GameSound.initGamesoundWithMapId(tesId)
                    end
                end
            end
        end 
    end
end
