
-- cclog
function cclog(...)
    print(string.format(...))
end

function outputString(...)
    print(...)
end

function childrenTags(node)
	for key, var in pairs(node:getChildren()) do
		outputString("tag: "..var:getTag(),"name: "..var:getName())
	end
end

function checkVisible(child)
	return child and child:isVisible()
end

SCREEN_STRING_LABLE_TAG=2888

function screenString(msg,addAble,exchangeAble)

    local nowScene=cc.Director:getInstance():getRunningScene()
    local strLable=nowScene:getChildByTag(SCREEN_STRING_LABLE_TAG)
    
    if strLable then
        if addAble then
            strLable:setString(strLable:getString().."\n"..msg)
        elseif exchangeAble then
            strLable:setString(msg)
        end
        return
    end

    local screenSize = cc.Director:getInstance():getWinSize()
    local fontConfig = {outlineSize=1,fontSize=20,fontFilePath="Fonts/Marker Felt.ttf"}

    strLable=cc.Label:createWithTTF(fontConfig,msg)
    strLable:setAlignment(cc.TEXT_ALIGNMENT_LEFT,cc.TEXT_ALIGNMENT_CENTER)
    strLable:setWidth(screenSize.width)
    strLable:setAnchorPoint(cc.p(0,1))
	strLable:setPosition(0,screenSize.height)
	--strLable:setColor(color or cc.c3b(255,0,0))
    nowScene:addChild(strLable,SCREEN_STRING_LABLE_TAG,SCREEN_STRING_LABLE_TAG)
end

function screenCleanPrint()
    local nowScene=cc.Director:getInstance():getRunningScene()
    local strLable=nowScene:getChildByTag(SCREEN_STRING_LABLE_TAG)    
    if strLable then
        strLable:setString("")
    end
end

function screenSetFontConfig(fontConfig)
    local nowScene=cc.Director:getInstance():getRunningScene()
    local strLable=nowScene:getChildByTag(SCREEN_STRING_LABLE_TAG)    
    if strLable then
        strLable:setTTFConfig(fontConfig)
    end
end

function errorString(msg)
    screenString(msg)
end

function screenAddPrint(...)
    local msg = string.format(...)
    screenString(msg,true)
end

function screenExchangePrint(...)
    local msg = string.format(...)
    screenString(msg,false,true)
end

function reload(moduleName)
	package.loaded[moduleName] = nil  
	return require(moduleName)  
end 

function try_catch(function_do,function_go)

	local success,errMessage

	if function_go then
		local function catchToDo(msg)
			function_go(msg)
			--__G__TRACKBACK__(msg)
		end
		success,errMessage=xpcall(function_do,catchToDo)
	else
		success,errMessage=pcall(function_do)
	end
	
	if not success then
		outputString(errMessage)
	end
	
	--outputString("ret:" .. (success and "true" or "false" )  .. " \nerrMessage:" .. (errMessage or "null"))
end 