local mathRad = math.rad
local ccP = cc.p
local ccPForAngle = cc.pForAngle
local ccPAdd = cc.pAdd
local ccPRotate = cc.pRotate
local ccPForAngle = cc.pForAngle

NowSceneReplace = function(Scene,now)

    SoundMG_StopAllEffects()
    local gameScene = Scene.create()
    if now then
        cc.Director:getInstance():replaceScene(gameScene)return gameScene
    end
    cc.Director:getInstance():replaceScene(cc.TransitionFadeBL : create(1,gameScene))
    return gameScene
end

NowSceneReplaceChecker = function(Scene)

	local nowScene = cc.Director:getInstance():getRunningScene()
	if nowScene.__cname==Scene.__cname then
		return outputString("Error repetition scene!")
	end
	
	return NowSceneReplace(Scene,true)
end

local TRANSITIONTIME = 0.8
Transitions = {
    ProgressInOut=function(scene)
        return cc.TransitionProgressInOut:create(TRANSITIONTIME,scene)
    end,
    ProgressOutIn=function(scene)
        return cc.TransitionProgressOutIn:create(TRANSITIONTIME,scene)
    end,
}

NowSceneTransition = function(Scene,effect)
    SoundMG_StopAllEffects()
    local gameScene = Scene.create()
    if not effect then
        cc.Director:getInstance():replaceScene(gameScene)return
    end
    cc.Director:getInstance():replaceScene(effect(gameScene))
end

Sence_Init = function(Scene)

    Scene.visibleSize = cc.Director:getInstance():getVisibleSize()
    Scene.origin = cc.Director:getInstance():getVisibleOrigin()

    local function onNodeEvent(event)
        if event == "enter" then
            Scene:sceneEnter()
        elseif event=="exit" then
            Scene:sceneExit()
        end
    end

    Scene:registerScriptHandler(onNodeEvent)
end

function pointNextPos(startPoint,angle,speed,dir)
    
    local randian=math.rad(angle)
    local vecAngle = cc.pForAngle(randian)
    local nextPointOffset = cc.pMul(vecAngle,speed)
    
    if dir == -1 then 
        return cc.pSub(startPoint,cc.p(nextPointOffset.x,-1*nextPointOffset.y))
    end
    
    return cc.pAdd(startPoint,nextPointOffset)
        --cc.pIsSegmentIntersect(point,point,point,point)
        --cc.pGetIntersectPoint(point,point,point,point)
end

function boundingPointTLR(boundingBox,dir,angle,position)
    local box_x=boundingBox.x
    local box_y=boundingBox.y
    local box_width=boundingBox.width
    local box_hieght=boundingBox.height
 
    local newLB =nil
    local newLT = nil
    local newRB = nil
    local newRT = nil
    local nowRad= mathRad(angle)


    local rectLeftTop=cc.p(box_x,box_y+box_hieght)
    local rectRightTop=cc.p(box_x+box_width,box_y+box_hieght)
    
    local tempP = cc.pForAngle(nowRad)
    
    newLT = cc.p( 
        position.x + (rectLeftTop.x * tempP.x - rectLeftTop.y * tempP.y ),
        position.y + (rectLeftTop.x * tempP.y + rectLeftTop.y * tempP.x )
    )
    
    newRT = cc.p( 
        position.x + (rectRightTop.x * tempP.x - rectRightTop.y * tempP.y ),
        position.y + (rectRightTop.x * tempP.y + rectRightTop.y * tempP.x )
    )
    
    return newLT,newRT   
end

function boundingPoint(boundingBox,dir,angle,position)
    local box_x = boundingBox.x
    local box_y = boundingBox.y
    local box_width = boundingBox.width
    local box_hieght = boundingBox.height
    
    local newLB =nil
    local newLT = nil
    local newRB = nil
    local newRT = nil
  
    --if box_width<2 then return newLT,newRT,newLB,newRB end
    
    if  angle ~=0 then
        local nowRad= mathRad(angle)

        local rectLeftBottom = ccP(box_x,box_y)
        local rectLeftTop = ccP(box_x,box_y+box_hieght)

        local rectRightBottom = ccP(box_x+box_width,box_y)
        local rectRightTop = ccP(box_x+box_width,box_y+box_hieght)

        newLT = ccPAdd(position,ccPRotate(rectLeftTop,ccPForAngle(nowRad)))
        newRT = ccPAdd(position, ccPRotate(rectRightTop,ccPForAngle(nowRad)))
        newLB = ccPAdd(position,ccPRotate(rectLeftBottom,ccPForAngle(nowRad)))
        newRB = ccPAdd(position, ccPRotate(rectRightBottom,ccPForAngle(nowRad)))

    else 
        newLT = ccP(box_x,box_y+box_hieght)
        newRT = ccP(box_x+box_width,box_y+box_hieght)
        newLB = ccP(box_x,box_y)
        newRB = ccP(box_x+box_width,box_y)

    end
    
    if dir == -1 then
        local left = newRB.x * -1 
        local right = newLB.x * -1 
        newLB.x = left
        newLT.x = left
        newRB.x = right
        newRT.x = right
    end
    
    return newLT,newRT,newLB,newRB
end

dirEnum ={
    "tl",
    "bl",
    "br",
    "tr",
}
dirEnum = CreateEnumTable(dirEnum,0)

function getCenterPoint(orginPoint,half_width,half_height,angle,dir)
    local orginAngle
    local radian=math.rad(angle)
    if dir == dirEnum.tl then
        return cc.pAdd(orginPoint, cc.pRotateByAngle(cc.p(half_width,-1*half_height),cc.p(0,0),radian))
    elseif dir == dirEnum.bl then
        return cc.pAdd(orginPoint, cc.pRotateByAngle(cc.p(half_width,half_height),cc.p(0,0),radian))
    elseif dir == dirEnum.tr then
        return cc.pAdd(orginPoint, cc.pRotateByAngle(cc.p(-1*half_width,-1*half_height),cc.p(0,0),radian))
    elseif dir == dirEnum.br then
        return cc.pAdd(orginPoint, cc.pRotateByAngle(cc.p(-1*half_width,half_height),cc.p(0,0),radian))
    end
    
    return cc.p(0,0)
end

function pointOffserPos(startPoint,offsetHeight)
    local degress= math.deg(cc.pGetAngle(cc.p(0,0),startPoint))
    local pointARadian=math.rad(degress+90)
    local pointBRadian=math.rad(degress-90)
    local vecAngleA = cc.pForAngle(pointARadian)
    local vecAngleB = cc.pForAngle(pointBRadian)
    
    local nextPointAOffset = cc.pMul(vecAngleA,offsetHeight)
    local nextPointBOffset = cc.pMul(vecAngleB,offsetHeight)
    
    return cc.pAdd(startPoint,nextPointAOffset),cc.pAdd(startPoint,nextPointBOffset)
        --cc.pIsSegmentIntersect(point,point,point,point)
        --cc.pGetIntersectPoint(point,point,point,point)
end

function LineIntersectionRect(pointA,pointB,rectA)

    local rectLeftBottom=cc.p(rectA.x,rectA.y)
    local rectLeftTop=cc.p(rectA.x,rectA.y+rectA.height)
    
    local rectRightBottom=cc.p(rectA.x+rectA.width,rectA.y)
    local rectRightTop=cc.p(rectA.x+rectA.width,rectA.y+rectA.height)
    local tempP=nil
    
    if cc.pIsSegmentIntersect(pointA,pointB,rectLeftTop,rectLeftBottom)== true then 
        tempP = cc.pGetIntersectPoint(pointA,pointB,rectLeftTop,rectLeftBottom)
        return true,tempP.x,tempP.y
    elseif cc.pIsSegmentIntersect(pointA,pointB,rectLeftTop,rectRightTop)== true then
        tempP = cc.pGetIntersectPoint(pointA,pointB,rectLeftTop,rectRightTop)
        return true,tempP.x,tempP.y
    elseif cc.pIsSegmentIntersect(pointA,pointB,rectRightTop,rectRightBottom)== true then 
        tempP = cc.pGetIntersectPoint(pointA,pointB,rectRightTop,rectRightBottom)
        return true,tempP.x,tempP.y
    elseif cc.pIsSegmentIntersect(pointA,pointB,rectLeftBottom,rectRightBottom)== true then 
        tempP = cc.pGetIntersectPoint(pointA,pointB,rectLeftBottom,rectRightBottom)
        return true,tempP.x,tempP.y
    end
    
    return false,0,0

end

function LineIntersectionGround(pointA,pointB,rectA)

    local rectLeftBottom=cc.p(rectA.x,rectA.y)
    local rectLeftTop=cc.p(rectA.x,rectA.y+rectA.height)

    local rectRightBottom=cc.p(rectA.x+rectA.width,rectA.y)
    local rectRightTop=cc.p(rectA.x+rectA.width,rectA.y+rectA.height)
    local tempP=nil

    
    if cc.pIsSegmentIntersect(pointA,pointB,rectLeftTop,rectRightTop)== true then
        tempP = cc.pGetIntersectPoint(pointA,pointB,rectLeftTop,rectRightTop)
        return true,tempP.x,tempP.y
    end

    return false,0,0

end

