module(..., package.seeall)

socket = require "socket"

packetDispatcher = {}

function addPacketHandler(packetId, packetHandler)

    if packetDispatcher[packetId] ~= nil then
        print("there is a same packetId handler")
    end
    packetDispatcher[packetId] = packetHandler

end

function removePacketHandler(packetId)
    packetDispatcher[packetId] = nil
end

function dispatchPacket(packet)
    local packetHandler = packetDispatcher[packet.packetId]

    if packetHandler ~= nil then 
        packetHandler(packet)
    else
        --print("this is no a handler for packet: "..tostring(packet.packetId))
    end
end

PACKETLENGTH_BYTE = 4

--等待发送的包
packetsSend = {}

local client

connect = socket.protect(
    function(address, port)
        -- connect somewhere
        client = socket.try(socket.tcp())
        --finally
        local tryTimeout = socket.newtry(
            function() 
                client:close() 
                return false
            end)

        local tryConnect = socket.newtry(
            function () end)

        --毫秒
        --tryTimeout(client:settimeout(5000))

        tryConnect(client:connect(address, port))

        tryTimeout(client:settimeout(0))
        return true
    end
)

close = socket.protect(
    function ()
        socket.try(client:close())
    end
)

disconnect = socket.protect(
    function()
        socket.try(client:shutdown("both"))
    end
)

function processPacket()

    if (client == nil) then
        return true
    end
    
    local function lostconnect(error_msg)
    	local param1, param2 = string.find(error_msg,"client")
		if (param1 and param2) then
			client=nil
		end
    end
    
    --[[
	if PINGTEST then
		sendPacket() receivePacket()
		return
    end--]]
	
	try_catch(sendPacket,lostconnect)
	try_catch(receivePacket,lostconnect)
	
end

--收包的两种状态
receiveStateLength = 0
receiveStateContent = 1

receiveState = receiveStateLength

function createEmptyPacket()

    local packet = {packetLen = 0, --包长度(int 类型)
        packetLenByteNum = 0, --包长度字节数
        packetLenBytes = "",  --包长度字节
        packetContentByteNum = 0, --包内容字节数
        packetContentBytes = "",  --包内容字节
        packetId = 0,--解析得到的包id
        packetContent = nil --解析得到的包表
    }

    return packet
end

local curPacket = nil

function resetNetwork()
    close()
    client = nil
    curPacket = nil

    packetsSend = {}
end

local percent_loading=0

function GetLoadingPercent()
	return percent_loading
end

--json = require("Json")

--不停的收，收到一个包就dispatch

receivePacket = socket.protect(
    function ()
        --print("receivePacket-------------------?")

        if receiveState == receiveStateLength then

            if curPacket == nil then
                curPacket = createEmptyPacket()
            end

			local data,next
            local buffer, status, overflow = client:receive(PACKETLENGTH_BYTE - curPacket.packetLenByteNum)

            if (buffer == nil) then
                if status == "closed" then
                    resetNetwork()
                    print(status.." length")
                    return
                end
                data = overflow
            else
                data = buffer
            end

            if data ~= nil then
                if string.len(data) ~= 0 then
                    curPacket.packetLenBytes = string.pack("AA", curPacket.packetLenBytes, data)
                end
            end

            curPacket.packetLenByteNum = string.len(curPacket.packetLenBytes)

            if (curPacket.packetLenByteNum == PACKETLENGTH_BYTE) then
                next, curPacket.packetLen = string.unpack(curPacket.packetLenBytes, "i")

                print("packetLen : "..tostring(curPacket.packetLen))
                
				percent_loading=0

                receiveState = receiveStateContent
            end

        elseif receiveState == receiveStateContent then
            local data
            local buffer, status, overflow = client:receive(curPacket.packetLen - 4 - curPacket.packetContentByteNum)

            if (buffer == nil) then
                if status == "closed" then
                    resetNetwork()
                    print(status.." content")
                    return
                end
                data = overflow
            else
                data = buffer
            end

            if data ~= nil then
                if string.len(data) ~= 0 then
                    curPacket.packetContentBytes = string.pack("AA", curPacket.packetContentBytes, data)
                end
            end

            curPacket.packetContentByteNum = string.len(curPacket.packetContentBytes)
            
			percent_loading = math.floor(100*curPacket.packetContentByteNum/(curPacket.packetLen-4))
            if data ~= nil then
			     print("Red ------------------ percent_loading: "..percent_loading)
			end

            if curPacket.packetContentByteNum == curPacket.packetLen - 4 then
                
				percent_loading=100
                --[[
                local skip,request_id,okay,length
                
                skip, curPacket.packetId = string.unpack(curPacket.packetContentBytes, "i")
                
                skip, request_id = string.unpack(curPacket.packetContentBytes, "i", skip)

                skip, okay = string.unpack(curPacket.packetContentBytes, "b", skip)
                
                skip, length = string.unpack(curPacket.packetContentBytes, "h", skip)

                print(string.format("%X", curPacket.packetId),request_id)

                local sub_data = string.sub(curPacket.packetContentBytes,skip,skip+length-1)
                
                local next2, packetContentStr = string.unpack(sub_data, "z")

                --local __ba1 = ByteArray.new():writeBuf(curPacket.packetContentBytes):setPos(skip)
                --packetContentStr = __ba1:readStringUShort(length)
                
                skip = skip+length
                   
                local value
                skip, value = string.unpack(curPacket.packetContentBytes, "i", skip)
                
                print("value: ",value)

                if packetContentStr ~= nil then
                    print("packetContentStr: "..packetContentStr)
                    --curPacket.packetContent = json.Decode(packetContentStr)
                    curPacket.packetContent = packetContentStr
                end
                --]]
                
                ConvertPacket(curPacket)

                receiveState = receiveStateLength

                dispatchPacket(curPacket)

                curPacket = nil

            end

        end
    end)

function ConvertPacket(curPacket)
    --nothing
end

--每次发一个包
function sendPacket()
    --print("sendPacket-------------------?")
    
    if (client == nil) then
        return
    end

    if #packetsSend == 0 then
        return
    end
    
    local packet = packetsSend[1]

    local packetLen = string.len(packet)

    local result
    local error
    local posSend
    local posStart = 1

    result, error, posSend = client:send(packet, posStart)

    local packetLenSend = 0

    while true do

        if result == nil then
            if (error == "closed") then
                resetNetwork()
                print("lost connection")
                return
            end

            packetLenSend = packetLenSend + posSend - posStart + 1

            if packetLenSend == packetLen then
                table.remove(packetsSend, 1)
                return
            end

            posStart = posSend + 1

            result, error, posSend = client:send(packet, posStart)
        else

            packetLenSend = packetLenSend + result - posStart + 1

            if packetLenSend == packetLen then
                table.remove(packetsSend, 1)
                --print("packets send...")
                return
            end

            posStart = result + 1

            result, error, posSend = client:send(packet, posStart)
        end
    end
end

function addPacket(packet)
    local packetLen = string.len(packet)
    local send_data = string.pack("iA",packetLen,packet)
    table.insert(packetsSend,1,send_data)
end





