--Music

local SimpleEngine = cc.SimpleAudioEngine:getInstance()

function SoundMG_GetPath(filename)
	return cc.FileUtils:getInstance():fullPathForFilename(filename) 
end

function SoundMG_PreloadMusic(filename)
	SimpleEngine:preloadMusic(SoundMG_GetPath(filename))
end

function SoundMG_PlayMusic(filename,loop)
	SimpleEngine:playMusic(SoundMG_GetPath(filename),loop)
end

function SoundMG_PauseMusic()
	SimpleEngine:pauseMusic()
end

function SoundMG_ResumeMusic()
	SimpleEngine:resumeMusic()
end

function SoundMG_RewindMusic()
	SimpleEngine:rewindMusic()
end

function SoundMG_StopMusic(release)
	SimpleEngine:stopMusic(release)
end

function SoundMG_SetMusicVolume(volume)
	SimpleEngine:setMusicVolume(volume)
end

function SoundMG_GetMusicVolume()
	return SimpleEngine:getMusicVolume()
end

function SoundMG_IsMusicPlaying()
	return SimpleEngine:isMusicPlaying()
end

--Effect

function SoundMG_PreloadEffect(filename)
	SimpleEngine:preloadEffect(SoundMG_GetPath(filename))
end

function SoundMG_UnloadEffect(filename)
	SimpleEngine:unloadEffect(SoundMG_GetPath(filename))
end

function SoundMG_PlayEffect(filename,loop)
    local effectID = SimpleEngine:playEffect(SoundMG_GetPath(filename),loop)
	return effectID
end

function SoundMG_ResumeEffect(effectID)
	SimpleEngine:resumeEffect(effectID)
end

function SoundMG_StopEffect(effectID)
	SimpleEngine:stopEffect(effectID)
end

function SoundMG_PauseAllEffects()
	SimpleEngine:pauseAllEffects()
end

function SoundMG_ResumeAllEffects()
	SimpleEngine:resumeAllEffects()
end

function SoundMG_StopAllEffects()
	SimpleEngine:stopAllEffects()
end

function SoundMG_SetEffectsVolume(volume)
	SimpleEngine:setEffectsVolume(volume)
end

function SoundMG_GetEffectsVolume()
	return SimpleEngine:getEffectsVolume()
end


