﻿
require "tools.language_mask"
Language = Language or {} 
Language.NameWeightMask = {
	["系.{0,9}统"] = 1,
	["G.{0,13}M"] = 1,
	["客.{0,9}服"] = 1,
	["官.{0,9}方"] = 1,
	["管.{0,6}理.{0,6}员"] = 1,
}

Language.NameInputWeightMask = {
"'",
"\"",
"<",
">",
"%.",
"\n",
",",
";",
"/",
"\\",
"|",
"&",
"%*",
"%?",
}

LanguageFilter = LanguageFilter or {}
LanguageFilter.server_filters = nil

function LanguageFilter.ConvPartten(partten_str)
	partten_str = string.gsub(partten_str, "%.", "%%.")
	partten_str = string.gsub(partten_str, "%(", "%%(")
	partten_str = string.gsub(partten_str, "%)", "%%)")
	partten_str = string.gsub(partten_str, "%+", "%%+")
	partten_str = string.gsub(partten_str, "%-", "%%-")
	partten_str = string.gsub(partten_str, "%?", "%%?")
	partten_str = string.gsub(partten_str, "%[", "%%[")
	partten_str = string.gsub(partten_str, "%^", "%%^")
	partten_str = string.gsub(partten_str, "%&", "%%&")
	return partten_str
end

function LanguageFilter.InitMaskData()
	for index, partten in pairs(Language.Mask) do
		local conv_partten = LanguageFilter.ConvPartten(partten)
		Language.Mask[index] = conv_partten
	end
end

function LanguageFilter.FilterMsg(message)
	local index_table = {}	
	
	local function replace_filter(start_index, end_index)
		if #index_table == 0 then
			table.insert(index_table, {start_index = start_index, end_index = end_index})
			return
		end
		local replace = false
		for i,v in pairs(index_table) do
			if v.start_index>=start_index and end_index>=v.end_index then
				table.remove(index_table,i)
				table.insert(index_table, {start_index = start_index, end_index = end_index})
				replace = true
				break
			end			
			if start_index>=v.start_index and v.end_index>=	end_index then		
				replace = true
			end	
		end
		if not replace then
			table.insert(index_table, {start_index = start_index, end_index = end_index})
		end
	end		

	for _, partten in pairs(Language.Mask) do
		local cur_start_index, cur_end_index = string.find(message, partten)
		if cur_start_index and cur_end_index then
		    --print("replace_filter ", partten, cur_start_index, cur_end_index)
		    -- result_str = ""
		    -- for i = 1, string.len(partten) do 
            --    result_str = result_str .. " " .. string.byte(partten, i)
            -- end
              --print("ChatCtrl:SendText partten byte ", result_str)	
			replace_filter(cur_start_index, cur_end_index)
		end
	end

	if LanguageFilter.server_filters ~= nil then
		for _, partten in pairs(LanguageFilter.server_filters) do		
			local cur_start_index, cur_end_index = string.find(message, partten)
			if cur_start_index and cur_end_index then
			    --print("server_filters ", partten)			
				replace_filter(cur_start_index,cur_end_index)
			end
		end
	end

	i = 2
	local default_message = message
	for _, index_pair in pairs(index_table) do	
		message_start = index_pair.start_index == 0 and "" or string.sub(default_message, 0, index_pair.start_index - 1)
		message_end = string.sub(default_message, index_pair.end_index + 1)
		message = message_start .. string.rep("*" , 1).. message_end
		i = i + 1
	end		
	return message, #index_table == 0
end

function LanguageFilter.NameFilter(message)
	if not message then
		return
	end

	local now_weight = 0
	for partten, weight in pairs(Language.NameWeightMask) do
		local start_index, _ = string.find(message, partten)
		if start_index then
			now_weight = now_weight + weight
		end
	end

	for partten, weight in pairs(Language.NameWeightMask) do
		local start_index, _ = string.find(message, partten)
		if start_index then
			now_weight = now_weight + weight
		end
	end

	if now_weight >= 1 then
		return nil
	end

	local now_message, is_pass = LanguageFilter.FilterMsg(message)
	if not is_pass then
		return nil
	end

	return now_message

end


