
CombatPowerUnit={}

local combatPower_display=0
local combatPower_target=0

function CombatPowerUnit.Reset()
    combatPower_display,combatPower_target=0,0
end

function CombatPowerUnit.CheckRoleCombatPowers()

    CombatPowerUnit.RefreshCombatPowers()
    
    if combatPower_display==combatPower_target then return end
    
    CombatPowerUnit.AddToPage()
    --GameMainScene.RefreshPlayerStateBar()
end

function CombatPowerUnit.RefreshCombatPowers(isSet)
    local combatPower=GameRecorder.GetAmountCombatPower()
    combatPower_target=combatPower
    if isSet then
        combatPower_display=combatPower_target
    end
    return combatPower
end

function CombatPowerUnit.BackupCombatPowers()
    CombatPowerUnit.RefreshCombatPowers(true)
end

function CombatPowerUnit.TEST()
    combatPower_target=combatPower_target+1000
    CombatPowerUnit.AddToPage()
end

function CombatPowerUnit.GetRollSpeed(numberDisplay,numberTarget)
    local speed,space=1,math.abs(numberTarget-numberDisplay)
    for key, var in pairs({1,100,10000}) do
        if space>var then speed=speed+var end
    end
    return speed
end

function CombatPowerUnit.AddToPage()
    
    local layerFarm = GameAssistor.GetRunningScene()

    if layerFarm:getChildByTag(SCREEN_COMBATPOWERUNIT_TAG) then return end
    
    local page_layer = cc.CSLoader:createNode("ZL.csb")
    layerFarm:addChild(page_layer,2010,SCREEN_COMBATPOWERUNIT_TAG)
    
    local screenSize = cc.Director:getInstance():getWinSize()
    page_layer:setPosition(screenSize.width/2,534)
    
    local function RemovePage()
        SoundMG_StopAllEffects()
        layerFarm:removeChild(page_layer)
    end
    local function HidePage()
        local action_hide = cc.Sequence:create(cc.EaseBackIn:create(cc.ScaleTo:create(0.3,0)),cc.CallFunc:create(RemovePage))
        page_layer:runAction(action_hide)
        
        --GameSound.PlayEffect(SoundEffect.UI_PAGE_CLOSE)
    end
    local function CheckPower()
        if (combatPower_display==combatPower_target) then 
            return HidePage()
        end
        CombatPowerUnit.Restart()
    end

    local nd_markArrow=page_layer:getChildByTag(2)
    local markAdd = nd_markArrow:getChildByTag(1)
    local markMinus = nd_markArrow:getChildByTag(2)
    
    local nd_combatPower=page_layer:getChildByTag(3)
    local combatPower = nd_combatPower:getChildByTag(1)
    local combatPowerAdd = nd_combatPower:getChildByTag(2)
    local combatPowerMinus = nd_combatPower:getChildByTag(3)

    for key, var in pairs(nd_markArrow:getChildren()) do
        var:setVisible(false)
    end
    
    local loop_effect_id
    local function StopEffect()
        if loop_effect_id then SoundMG_StopEffect(loop_effect_id) loop_effect_id=nil end
    end
    local function PlayEffect(loop)
        StopEffect()
        loop_effect_id=GameSound.PlayEffect(SoundEffect.UI_COMBATPOWER_COUNT,loop)
    end
    
    local isWaiting=true
    local speed,space=1,1
    local function RefreshCombatPower()
        if (combatPower_display==combatPower_target) then 
            nd_combatPower:unscheduleUpdate()
            StopEffect()
            
            local action_hide = cc.Sequence:create(cc.DelayTime:create(1),cc.CallFunc:create(CheckPower))
            page_layer:runAction(action_hide)
        end
        speed=CombatPowerUnit.GetRollSpeed(combatPower_display,combatPower_target)
        for key, var in pairs(nd_combatPower:getChildren()) do
            var:setVisible(false)
        end
        local tx_number,tx_scale=combatPower,1
        if isWaiting then
        elseif combatPower_display < combatPower_target then
            combatPower_display=math.min(combatPower_display+speed,combatPower_target)
            tx_number=combatPowerAdd tx_scale=1.2
            markMinus:setVisible(false) markAdd:setVisible(true) 
        elseif combatPower_display > combatPower_target then
            combatPower_display=math.max(combatPower_display-speed,combatPower_target)
            tx_number=combatPowerMinus tx_scale=1.2
            markAdd:setVisible(false) markMinus:setVisible(true) 
        end
        tx_number:setVisible(true) tx_number:setScale(tx_scale)
        tx_number:setString(combatPower_display)
    end
    CombatPowerUnit.Restart=function()
        PlayEffect(true)
        nd_combatPower:scheduleUpdateWithPriorityLua(RefreshCombatPower,0)
    end
    
    local function Start()
        isWaiting=false PlayEffect(true)
    end
    nd_combatPower:scheduleUpdateWithPriorityLua(RefreshCombatPower,0)
    
    page_layer:setScale(3)
    local action_hide = cc.Sequence:create(cc.EaseBackIn:create(cc.ScaleTo:create(0.3,1.5)),cc.DelayTime:create(0.3),cc.CallFunc:create(Start))
    page_layer:runAction(action_hide)
    
    GameSound.PlayEffect(SoundEffect.UI_COMBATPOWER_OPEN)
end



